C***********************************************************************
C
C  PROGRAM: OBE00.F                  
C
C  updated december 2000, from YNRMP2k2.f , introducing mass               
C  differences in meson propagators in the OBE-potentials, 
C  according to Macke-Klein
C
C  updated june 2004, from obe00.f, introducing a zero in AXIAL-EXCH.  
C  updated oct  2004, introducing diffractive singlet+nonet  
C *********************************************************************
C *********************************************************************
C
      SUBROUTINE PSSCAL(XA,ICSB,NLOC,LC) 
C
C**********************************************************************
C  updated december 2000, from YNRMP2k2.f , introducing mass               
C  differences in meson propagators in the OBE-potentials, 
C  according to Macke-Klein 
C----------------------------------------------------------------------
C
C     PSEUDO-SCALAR MESONS : CALCULATION POTENTIALS ON ISOSPIN BASIS
C
      IMPLICIT REAL *8(A-H,O-Z)
      COMMON/MODEL/IMODEL,INRS,ICNSTR,IRET,IDAM,IGERST,IGRTST
      COMMON/ZEROS/IZPS,IZVC,IZSC,IZAX,IZTEN
      COMMON/ALLPS/AME,AMX,AMK,BMK
      COMMON/MASSES/PIM,AM(3),AMY(3),REDM(3),PLAB,AK(3),AKS(3),TEM(3)
      COMMON/DYNMAS/REDMM,AMLN,AMSN,AMH,AMSS,AMLS,AMNN
      COMMON/FRMFAC/ALMOBE,ALMNN,ALMLL,ALMSS,ALMLS,ALMLK,ALMSK
      COMMON/FORMF/ALAMH,ALMP8,ALMV8,ALMS8,ALMP1,ALMV1,ALMS1,
     .             ALMKA,ALMKS,ALMKP
*     COMMON/AMAT/XA(300),A(9,6,300)
      COMMON/POTF/VCLL  ,VCSS  ,VCLS  ,VCDR,
     .            VSIGLL,VSIGSS,VSIGLS,VSIGDR,
     .            VTENLL,VTENSS,VTENLS,VTENDR,
     .            VSOLL ,VSOSS ,VSOLS ,VSODR,
     .            VSO2LL,VSO2SS,VSO2LS,VSO2DR,
     .            VASOLL,VASOSS,VASOLS,VASODR,
     .            VCNN  ,VSIGNN,VTENNN,VSONN ,
     .            FILL  ,FISS  ,FILS  ,FIDR,
     .            DFILL ,DFISS ,DFILS ,DFIDR,
     .            FISLL ,FISSS ,FISLS ,FISDR,
     .            DFISLL,DFISSS,DFISLS,DFISDR,
     .            FITLL ,FITSS ,FITLS ,FITDR,
     .            DFITLL,DFITSS,DFITLS,DFITDR
      COMMON/COUPL/ F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,F11,
     .              G1,G2,G3,G4,G5,G6,G7,G8,G9,G10,G11,
     .              FD1,FD2,FD3,FD4,FD5,FD6,FD7,FD8,FD9,FD10,FD11,
     .              FV1,FV2,FV3,FV4,FV5,FV6,FV7,FV8,FV9,FV10,FV11,
     .              GS1,GS2,GS3,GS4,GS5,GS6,GS7,GS8,GS9,GS10,GS11,
     .              GD1,GD2,GD3,GD4,GD5,GD6,GD7,GD8,GD9,GD10,GD11,P
      DIMENSION F(11),AMPS(5)
      EQUIVALENCE (F1,F(1))
      DATA SR3/1.732051D0/,SRPI/1.772454D0/
      DATA DAMLN/175.D0/,DAMSN/255.D0/,DAMSL/80.D0/
***   DATA DAMLN/0.D0/,DAMSN/0.D0/,DAMSL/0.D0/
      DATA ICALL/0/

      COMMON/UFUNC/UCLL0,UCLS0,UCSS0,UCLL1,UCLS1,UCSS1,
     .UCLl2,UCLS2,UCSS2
      DATA AMCRP/750.D0/,UMAS/1200.D0/
C
C   NOTE : PION(IN=1),ETA (IN=2),ETAP(IN=3),KAON(IN=4)               
C
C   NOTE : INDEX              1    ,    2    ,    3
C          REFERS TO       LN -> LN, SN -> SN, LN -> SN  REACTION
C
C   THE POTENTIAL FUNCTIONS
C
      FF0(ERATH,EXH,XH,EM,EP)=ERATH*(EM/EXH-EXH*EP)/(2.0D00*XH)
      FF3(ERATH,EXH,XH,XLAMH,EM,EP,EXLAM)=ERATH*(EM/EXH
     .  *(1.D00+XH+XH*XH/3.D00)-EXH*EP*(1.D00-XH+XH*XH/3.D00)
     .  -8.D00*XLAMH*(0.5D00+XLAMH*XLAMH/3.D00)*EXLAM/ERATH/
     .  1.7724538509D0)/(2.D00*XH*XH*XH)
C
C
      SR3 = DSQRT(3.D0)
      SRPI= DSQRT(DACOS(-1.D0))
      IF(LC.EQ.1) SIGN= 1.D0
      IF(LC.NE.1) SIGN=-1.D0
      DO 1040 IN=1,4
      GOTO(1051,1052,1053,1054),IN
1051  GPLL = -0.0271D0*ICSB*F1*F3
      GPSS= -2*F1*F2
      GPLS= -SR3*F1*F3                  
      GPDR=      F1*F2
      AMPS(1)=PIM
      GPLL = GPLL*(AMPS(1)/PIM)**2
      GPSS = GPSS*(AMPS(1)/PIM)**2
      GPLS = GPLS*(AMPS(1)/PIM)**2
      GPDR = GPDR*(AMPS(1)/PIM)**2
      IF(IMODEL.LE.3) ALAM=ALMOBE
      IF(IMODEL.GE.4) ALAM=ALMP8
      GOTO 1056
1052  GPLL=  F6*F7*(AME/PIM)**2
      GPSS=  F6*F8*(AME/PIM)**2
      GPLS=  0.
      GPDR=  F6*F8*(AME/PIM)**2
      AMPS(2)=AME
      IF(IMODEL.LE.3) ALAM=ALMOBE
      IF(IMODEL.GE.4) ALAM=ALMP8
      GOTO 1056
1053  GPLL=  F9*F10*(AMX/PIM)**2
      GPSS=  F9*F11*(AMX/PIM)**2
      GPLS=  0.
      GPDR=  F9*F11*(AMX/PIM)**2
      AMPS(3)=AMX
      IF(IMODEL.LE.3) ALAM=ALMOBE
      IF(IMODEL.GE.4) ALAM=ALMP1
      GOTO 1056
1054  GPLL=      F4*F4*P*(BMK/PIM)**2
      GPSS=     -F5*F5*P*(BMK/PIM)**2
      GPLS= -SR3*F4*F5*P*(BMK/PIM)**2
      GPDR=    2*F5*F5*P*(BMK/PIM)**2
      AMPS(4)=BMK
      IF(IMODEL.EQ.1) ALAM=ALMOBE
      IF(IMODEL.GE.2) ALAM=ALMKA
      GOTO 1056
C
1056  ALM1=ALAM
      ALM2=ALAM
      ALM3=ALAM
      RATM1=AMPS(IN)/ALM1
      RATM2=AMPS(IN)/ALM2
      RATM3=AMPS(IN)/ALM3
      FAC1=AMPS(IN)*AMPS(IN)/(AM(1)*AMY(1))
      FAC2=AMPS(IN)*AMPS(IN)/(AM(1)*AMY(2))
      FAC3=AMPS(IN)*AMPS(IN)/(AM(1)*AMH)
C
*     DO 104 I=2,NMAX
*     X = XA(I)
      X = XA    

C     PAGNAMENTA-LICHT FORM-FACTOR:
c     UFAC = 1.D0/(1.D0-(AMPS(IN)/UMAS)**2)
c     UFAC2= (UMAS/AMPS(IN))**2
c     CALL PLFORM(XA,UMAS,ALAM)           

      XLAM1=0.5D0*X*ALM1/PIM
      XLAM2=0.5D0*X*ALM2/PIM
      XLAM3=0.5D0*X*ALM3/PIM
      X =(AMPS(IN)/PIM)*X
      EX=FDEXP(X)
      VKULL=(ALM1/AMPS(IN))**3*FDEXP(-XLAM1*XLAM1)/(2.D0*SRPI)
      VKUSS=(ALM2/AMPS(IN))**3*FDEXP(-XLAM2*XLAM2)/(2.D0*SRPI)
      VKULS=(ALM3/AMPS(IN))**3*FDEXP(-XLAM3*XLAM3)/(2.D0*SRPI)
C
      EXPM=DEXP(RATM1*RATM1)
      ELAM=FDEXP(-XLAM1*XLAM1)
      DERFCM=FDERFC(-XLAM1+RATM1)
      DERFCP=FDERFC( XLAM1+RATM1)
      FCLL0  = FF0(EXPM,EX,X,DERFCM,DERFCP)*AMPS(IN)
      FTENLL = FF3(EXPM,EX,X,XLAM1,DERFCM,DERFCP,ELAM)*AMPS(IN)
C

      EXPM=DEXP(RATM2*RATM2)
      ELAM=FDEXP(-XLAM2*XLAM2)
      DERFCM=FDERFC(-XLAM2+RATM2)
      DERFCP=FDERFC( XLAM2+RATM2)
      FCSS0  = FF0(EXPM,EX,X,DERFCM,DERFCP)*AMPS(IN)
      FTENSS = FF3(EXPM,EX,X,XLAM2,DERFCM,DERFCP,ELAM)*AMPS(IN)
C
      EXPM=DEXP(RATM3*RATM3)
      ELAM=FDEXP(-XLAM3*XLAM3)
      DERFCM=FDERFC(-XLAM3+RATM3)
      DERFCP=FDERFC( XLAM3+RATM3)
      FCLS0  = FF0(EXPM,EX,X,DERFCM,DERFCP)*AMPS(IN)
      FTENLS = FF3(EXPM,EX,X,XLAM3,DERFCM,DERFCP,ELAM)*AMPS(IN)
C
      FCLL1  = FCLL0  - VKULL*AMPS(IN)
      FCSS1  = FCSS0  - VKUSS*AMPS(IN)
      FCLS1  = FCLS0  - VKULS*AMPS(IN)
C
C------------------------------------------------------------
C     THRESHOLD-DIFFERENCE MODIFICATION BASE FUNCTIONS:
      IF(IDAM.NE.0.AND.IN.NE.4) THEN
      CALL YMKFUN(XA,AMPS(IN),ALAM,SIGN,IDAM*DAMSL,
     .FXC0,FXC1,FXC2,FXTEN,FXTEN1,FXSO,FXSO1)
C------------------------------------------------------------
      IF(LC.EQ.1) THEN
      FCSS1 = AMPS(IN)*FXC1 
      FTENSS = AMPS(IN)*FXTEN             
      ENDIF
      IF(LC.NE.1) THEN
      FCLL1 = AMPS(IN)*FXC1 
      FTENLL = AMPS(IN)*FXTEN             
      ENDIF
      FCLS1  = 0.5D0*(FCLS1 + AMPS(IN)*FXC1 )     
      FTENLS = 0.5D0*(FTENLS+ AMPS(IN)*FXTEN)     
      ENDIF
C------------------------------------------------------------
C     PAGNAMENTA-LICHT EFFECT:
c     ufac =1.d0
c     ufac2=0.d0
c     FCLL1 = UFAC*(FCLL1-UFAC2*UCLL1)
c     FCLS1 = UFAC*(FCLS1-UFAC2*UCLS1)
c     FCSS1 = UFAC*(FCSS1-UFAC2*UCSS1)
C------------------------------------------------------------
C
        VSIGLL  = VSIGLL + GPLL*FCLL1/3.D0
        VTENLL  = VTENLL + GPLL*FTENLL
        VSIGDR  = VSIGDR + GPDR*FCSS1/3.D0
        VTENDR  = VTENDR + GPDR*FTENSS
        VSIGSS  = VSIGSS + GPSS*FCSS1/3.D0
        VTENSS  = VTENSS + GPSS*FTENSS
        VSIGLS  = VSIGLS + GPLS*FCLS1/3.D0
        VTENLS  = VTENLS + GPLS*FTENLS
C
C------------------------------------------------------------
C     ZERO IN FORM-FACTOR:
      IF(IZPS.EQ.1) THEN
      FZERO = (AMPS(IN)/AMCRP)**2
      FC2   = FCLL1 + (1.5D0-XLAM1*XLAM1)
     .              * VKULL*AMPS(IN)/RATM1/RATM1
      FT1   = FTENLL - XLAM1*XLAM1 * VKULL*AMPS(IN)
     .               /(3*RATM1*RATM1)
        VSIGLL  = VSIGLL + FZERO*GPLL*FC2/3.D0
        VTENLL  = VTENLL + FZERO*GPLL*FT1     
        VSIGDR  = VSIGDR + FZERO*GPDR*FC2/3.D0
        VTENDR  = VTENDR + FZERO*GPDR*FT1     
        VSIGSS  = VSIGSS + FZERO*GPSS*FC2/3.D0
        VTENSS  = VTENSS + FZERO*GPSS*FT1     
        VSIGLS  = VSIGLS + FZERO*GPLS*FC2/3.D0
        VTENLS  = VTENLS + FZERO*GPLS*FT1     
      ENDIF
C
  104 CONTINUE
C
 1040 CONTINUE
C
      ICALL = 1
      RETURN
      END
C**********************************************************************
C
      SUBROUTINE VECTOR(XA,ICSB,NLOC,LC) 
C
C**********************************************************************
C  updated december 2000, from YNRMP2k2.f , introducing mass               
C  differences in meson propagators in the OBE-potentials, 
C  according to Macke-Klein 
C----------------------------------------------------------------------
C
C     VECTOR MESONS : CALCULATION POTENTIALS ON ISOSPIN BASIS
C
      IMPLICIT REAL *8(A-H,O-Z)
      COMMON/MODEL/IMODEL,INRS,ICNSTR,IRET,IDAM,IGERST,IGRTST
      COMMON/ZEROS/IZPS,IZVC,IZSC,IZAX,IZTEN
      COMMON/ALLVC/ARO,BRO,AM1RO,AM2RO,AMOM,AMFI,AMKS,BMKS
      COMMON/MASSES/PIM,AM(3),AMY(3),REDM(3),PLAB,AK(3),AKS(3),TEM(3)
      COMMON/DYNMAS/REDMM,AMLN,AMSN,AMH,AMSS,AMLS,AMNN
      COMMON/FRMFAC/ALMOBE,ALMNN,ALMLL,ALMSS,ALMLS,ALMLK,ALMSK
      COMMON/FORMF/ALAMH,ALMP8,ALMV8,ALMS8,ALMP1,ALMV1,ALMS1,
     .             ALMKA,ALMKS,ALMKP
*     COMMON/AMAT/XA(300),A(9,6,300)
      COMMON/POTF/VCLL  ,VCSS  ,VCLS  ,VCDR,
     .            VSIGLL,VSIGSS,VSIGLS,VSIGDR,
     .            VTENLL,VTENSS,VTENLS,VTENDR,
     .            VSOLL ,VSOSS ,VSOLS ,VSODR,
     .            VSO2LL,VSO2SS,VSO2LS,VSO2DR,
     .            VASOLL,VASOSS,VASOLS,VASODR,
     .            VCNN  ,VSIGNN,VTENNN,VSONN ,
     .            FILL  ,FISS  ,FILS  ,FIDR,
     .            DFILL ,DFISS ,DFILS ,DFIDR,
     .            FISLL ,FISSS ,FISLS ,FISDR,
     .            DFISLL,DFISSS,DFISLS,DFISDR,
     .            FITLL ,FITSS ,FITLS ,FITDR,
     .            DFITLL,DFITSS,DFITLS,DFITDR
      COMMON/COUPL/ F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,F11,
     .              G1,G2,G3,G4,G5,G6,G7,G8,G9,G10,G11,
     .              FD1,FD2,FD3,FD4,FD5,FD6,FD7,FD8,FD9,FD10,FD11,
     .              FV1,FV2,FV3,FV4,FV5,FV6,FV7,FV8,FV9,FV10,FV11,
     .              GS1,GS2,GS3,GS4,GS5,GS6,GS7,GS8,GS9,GS10,GS11,
     .              GD1,GD2,GD3,GD4,GD5,GD6,GD7,GD8,GD9,GD10,GD11,P
      DIMENSION FD(11),FV(11)
      DIMENSION AMVC(5),FVC(5),XM1(3),XM2(3)
      EQUIVALENCE (FD1,FD(1)),(FV1,FV(1))
      DATA DAMLN/175.D0/,DAMSN/255.D0/,DAMSL/80.D0/
      DATA SR3/1.732050808D0/,SRPI/1.77245385D0/,AMPRO/938.2796D0/
     .,FMNL/1.D0/,AMCRV/750.D0/
C
C   NOTE : RHO1(IN=1),RHO2(IN=2),OME(IN=3),PHI(IN=4),KSTAR(IN=5)
C
C   NOTE : INDEX              1    ,    2    ,    3
C          REFERS TO       LN -> LN, SN -> SN, LN -> SN  REACTION
C
C-------------------------------------------------------------------
C   NOTE : FOR 'DIRECT POTENTIALS': INDEX 1,3 -> HYPERONS !
C                                 : INDEX 2,4 -> NUCLEONS !
C-------------------------------------------------------------------
C
C   THE POTENTIAL FUNCTIONS
C
      FF0(ERATH,EXH,XH,EM,EP)=ERATH*(EM/EXH-EXH*EP)/(2.0D00*XH)
      FF1(ERATH,EXH,XH,XLAMH,EM,EP,EXLAM)=ERATH*(EM/EXH
     . *(1.D00+XH)-EXH*EP*(1.D00-XH)-4.D00*XLAMH*EXLAM/ERATH/SRPI)
     .  /(2.D00*XH*XH*XH)
      FF3(ERATH,EXH,XH,XLAMH,EM,EP,EXLAM)=ERATH*(EM/EXH
     .  *(1.D00+XH+XH*XH/3.D00)-EXH*EP*(1.D00-XH+XH*XH/3.D00)
     .  -8.D00*XLAMH*(0.5D00+XLAMH*XLAMH/3.D00)*EXLAM/ERATH/SRPI)
     .  /(2.D00*XH*XH*XH)
C
      IF(LC.EQ.1) SIGN= 1.D0
      IF(LC.NE.1) SIGN=-1.D0
C
      PROSLL=-(AM(1)-AMY(1))*(AMY(1)-AM(1))/AMKS/AMKS
      PROSSS=-(AMNN -AMSS  )*(AMSS  -AMNN )/AMKS/AMKS
      PROSLS=-(AMNN -AMY(1))*(AMSS  -AM(1))/AMKS/AMKS
C
      IF(IRET.EQ.1) THEN
      WKIN1 = PIM**2*AKS(1)/(2*REDM(1))
      WKIN2 = PIM**2*AKS(3)/(2*REDM(3))
      WKIN3 = 0.5D0*(WKIN1+WKIN2)
      ENDIF
C
      DO 1040 IN=1,5
      IF(IN.EQ.1) THEN
      XM1(1)=AMY(1)
      XM1(2)=AMSS  
      XM1(3)=AMSS
***   XM1(3)=AMH
      XM2(1)=AM(1)
      XM2(2)=AMNN 
      XM2(3)=AM(1)
      ENDIF
      GOTO(1051,1051,1053,1054,1055),IN
1051  GDLL = -0.0271D0*ICSB*FD1*FD3
      GDFLL= -0.0271D0*ICSB*FD1*FV3
      GFDLL= -0.0271D0*ICSB*FV1*FD3
      GFLL = -0.0271D0*ICSB*FV1*FV3
      GDSS = -2*FD1*FD2
      GDFSS= -2*FD1*FV2
      GFDSS= -2*FV1*FD2
      GFSS = -2*FV1*FV2
      GDLS = -FD1*FD3*SR3
      GDFLS= -FD1*FV3*SR3
      GFDLS= -FV1*FD3*SR3
      GFLS = -FV1*FV3*SR3
      GDDR =  FD1*FD2
      GDFDR=  FD1*FV2
      GFDDR=  FV1*FD2
      GFDR =  FV1*FV2
      IF(IN.EQ.1) THEN
      FVC(1)=ARO
      AMVC(1)=AM1RO
      ELSE
      FVC(2)=BRO
      AMVC(2)=AM2RO
      ENDIF
      GOTO 1056
1053  GDLL =  FD6*FD7
      GDFLL=  FD6*FV7
      GFDLL=  FV6*FD7
      GFLL =  FV6*FV7
      GDSS =  FD6*FD8
      GDFSS=  FD6*FV8
      GFDSS=  FV6*FD8
      GFSS =  FV6*FV8
      GDLS =  0.D0
      GDFLS=  0.D0
      GFDLS=  0.D0
      GFLS =  0.D0
      GDDR =  GDSS
      GDFDR=  GDFSS
      GFDDR=  GFDSS
      GFDR =  GFSS
      FVC(3)=1.D0
      AMVC(3)=AMOM
      GOTO 1056
1054  GDLL =  FD9*FD10
      GDFLL=  FD9*FV10
      GFDLL=  FV9*FD10
      GFLL =  FV9*FV10
      GDSS =  FD9*FD11
      GDFSS=  FD9*FV11
      GFDSS=  FV9*FD11
      GFSS =  FV9*FV11
      GDLS =  0.D0
      GDFLS=  0.D0
      GFDLS=  0.D0
      GFLS =  0.D0
      GDDR =  GDSS
      GDFDR=  GDFSS
      GFDDR=  GFDSS
      GFDR =  GFSS
      FVC(4)=1.D0
      AMVC(4)=AMFI
      GOTO 1056
1055  GDLL =  FD4*FD4*P
      GDFLL=  FD4*FV4*P
      GFDLL=  FV4*FD4*P
      GFLL =  FV4*FV4*P
      GDSS = -FD5*FD5*P
      GDFSS= -FD5*FV5*P
      GFDSS= -FV5*FD5*P
      GFSS = -FV5*FV5*P
      GDLS = -FD4*FD5*P*SR3
      GDFLS= -FD4*FV5*P*SR3
      GFDLS= -FV4*FD5*P*SR3
      GFLS = -FV4*FV5*P*SR3
      GDDR = -2*GDSS
      GDFDR= -2*GDFSS
      GFDDR= -2*GFDSS
      GFDR = -2*GFSS
      FVC(5)=1.D0
      AMVC(5)=BMKS
C     CASE IN=5:
      XM1(1)=AMLN
      XM1(2)=AMSN
***   XM1(3)=(AMSN+AMLS)/2.D0
      XM1(3)=AMSN
      XM2(1)=AMLN
      XM2(2)=AMSN
***   XM2(3)=(AMSN+AMLS)/2.D0
      XM2(3)=AMSN
C
1056  AMVC2 = AMVC(IN)*AMVC(IN)
      IF(IMODEL.LE.3) ALAM=ALMOBE
      IF(IMODEL.GE.4) THEN
       ALAM = ALMV8
       IF(IN.EQ.3) ALAM=ALMV1
       IF(IN.EQ.5) ALAM=ALMKS
      ENDIF
      ALM1=ALAM
      ALM2=ALAM
      ALM3=ALAM

      RATM1=AMVC(IN)/ALM1
      RATM2=AMVC(IN)/ALM2
      RATM3=AMVC(IN)/ALM3
      FAC0=AMVC(IN)*AMVC(IN)/AMPRO/AMPRO
      FAC1=AMVC(IN)*AMVC(IN)/(XM1(1)*XM2(1))
      FAC2=AMVC(IN)*AMVC(IN)/(XM1(2)*XM2(2))
      FAC3=AMVC(IN)*AMVC(IN)/(XM1(3)*XM2(3))
      FFAC1 = XM2(1)/XM1(1)-XM1(1)/XM2(1)                 
      FFAC2 = XM2(2)/XM1(2)-XM1(2)/XM2(2)                 
      FFAC3 = XM2(3)/XM1(3)-XM1(3)/XM2(3)                 
C
c     23/4/2001: wrong:
c     CCLL1=0.5D0*GDLL*FAC1+(GFDLL/XM1(1)+GDFLL/XM2(1))*AMVC(IN)**2
c    .      /(4.*AMPRO)
c     CCSS1=0.5D0*GDSS*FAC2+(GFDSS/XM1(2)+GDFSS/XM2(2))*AMVC(IN)**2
c    .      /(4.*AMPRO)
c     CCLS1=0.5D0*GDLS*FAC3+(GFDLS/XM1(3)+GDFLS/XM2(3))*AMVC(IN)**2
c    .      /(4.*AMPRO)
c     CCDR1=0.5D0*GDDR*FAC2+(GFDDR/XM1(2)+GDFDR/XM2(2))*AMVC(IN)**2
c    .      /(4.*AMPRO)
c     CSLL1= GDLL+(GFDLL*XM1(1)+GDFLL*XM2(1)+GFLL*XM1(1)*XM2(1)/AMPRO)
c    .       /AMPRO
c     CSSS1= GDSS+(GFDSS*XM1(2)+GDFSS*XM2(2)+GFSS*XM1(2)*XM2(2)/AMPRO)
c    .       /AMPRO
c     CSLS1= GDLS+(GFDLS*XM1(3)+GDFLS*XM2(3)+GFLS*XM1(3)*XM2(3)/AMPRO)
c    .       /AMPRO
c     CSDR1= GDDR+(GFDDR*XM1(2)+GDFDR*XM2(2)+GFDR*XM1(2)*XM2(2)/AMPRO)
c    .       /AMPRO
 
c     23/4/2001: mass goes wth f-coupling: f13 -> 1/M_Y,f24 -> 1/M_N:
      CCLL1=0.5D0*GDLL*FAC1+(GFDLL/XM2(1)+GDFLL/XM1(1))*AMVC2           
     .      /(4.*AMPRO)
      CCSS1=0.5D0*GDSS*FAC2+(GFDSS/XM2(2)+GDFSS/XM1(2))*AMVC2       
     .      /(4.*AMPRO)
      CCLS1=0.5D0*GDLS*FAC3+(GFDLS/XM2(3)+GDFLS/XM1(3))*AMVC2        
     .      /(4.*AMPRO)
      CCDR1=0.5D0*GDDR*FAC2+(GFDDR/XM2(2)+GDFDR/XM1(2))*AMVC2        
     .      /(4.*AMPRO)
c     23/4/2001: mass goes wth f-coupling: f13 -> 1/M_Y,f24 -> 1/M_N:
      CSLL1= GDLL+(GFDLL*XM2(1)+GDFLL*XM1(1)+GFLL*XM1(1)*XM2(1)/AMPRO)
     .       /AMPRO
      CSSS1= GDSS+(GFDSS*XM2(2)+GDFSS*XM1(2)+GFSS*XM1(2)*XM2(2)/AMPRO)
     .       /AMPRO
      CSLS1= GDLS+(GFDLS*XM2(3)+GDFLS*XM1(3)+GFLS*XM1(3)*XM2(3)/AMPRO)
     .       /AMPRO
      CSDR1= GDDR+(GFDDR*XM2(2)+GDFDR*XM1(2)+GFDR*XM1(2)*XM2(2)/AMPRO)
     .       /AMPRO

      CTLL0= CSLL1
      CTSS0= CSSS1
      CTLS0= CSLS1
      CTDR0= CSDR1
      COLL0= 1.5D0*GDLL+(GDFLL+GFDLL)*DSQRT(XM1(1)*XM2(1))/AMPRO
      COSS0= 1.5D0*GDSS+(GDFSS+GFDSS)*DSQRT(XM1(2)*XM2(2))/AMPRO
      COLS0= 1.5D0*GDLS+(GDFLS+GFDLS)*DSQRT(XM1(3)*XM2(3))/AMPRO
      CODR0= 1.5D0*GDDR+(GDFDR+GFDDR)*DSQRT(XM1(2)*XM2(2))/AMPRO

      CALL0= 
     .GDLL*FFAC1/4D0-(GFDLL-GDFLL)*DSQRT(XM1(1)*XM2(1))/AMPRO
      CASS0= 
     .GDSS*FFAC2/4D0-(GFDSS-GDFSS)*DSQRT(XM1(2)*XM2(2))/AMPRO
      CALS0= 
     .GDLS*FFAC3/4D0-(GFDLS-GDFLS)*DSQRT(XM1(3)*XM2(3))/AMPRO
      CADR0= 
     .GDDR*FFAC2/4D0-(GFDDR-GDFDR)*DSQRT(XM1(2)*XM2(2))/AMPRO
      CALL1= GFLL*FFAC1*AMVC2/(16*AMPRO*AMPRO)
      CASS1= GFSS*FFAC2*AMVC2/(16*AMPRO*AMPRO)
      CALS1= GFLS*FFAC3*AMVC2/(16*AMPRO*AMPRO)
      CADR1= GFDR*FFAC2*AMVC2/(16*AMPRO*AMPRO)

      CO2LL= GDLL+4*(GDFLL+GFDLL)*DSQRT(XM1(1)*XM2(1))/AMPRO +
     +       8*GFLL*XM1(1)*XM2(1)/AMPRO/AMPRO
      CO2SS= GDSS+4*(GDFSS+GFDSS)*DSQRT(XM1(2)*XM2(2))/AMPRO +
     +       8*GFSS*XM1(2)*XM2(2)/AMPRO/AMPRO
      CO2LS= GDLS+4*(GDFLS+GFDLS)*DSQRT(XM1(3)*XM2(3))/AMPRO +
     +       8*GFLS*XM1(3)*XM2(3)/AMPRO/AMPRO
      CO2DR= GDDR+4*(GDFDR+GFDDR)*DSQRT(XM1(2)*XM2(2))/AMPRO +
     +       8*GFDR*XM1(2)*XM2(2)/AMPRO/AMPRO
C
*     DO 104 I=2,NMAX
*     X = XA(I)
      X = XA   
      XLAM1=0.5D0*X*ALM1/PIM
      XLAM2=0.5D0*X*ALM2/PIM
      XLAM3=0.5D0*X*ALM3/PIM
      X =(AMVC(IN)/PIM)*X
      EX=FDEXP(X)
      VKULL=(ALM1/AMVC(IN))**3*FDEXP(-XLAM1*XLAM1)/(2.D0*SRPI)
      VKUSS=(ALM2/AMVC(IN))**3*FDEXP(-XLAM2*XLAM2)/(2.D0*SRPI)
      VKULS=(ALM3/AMVC(IN))**3*FDEXP(-XLAM3*XLAM3)/(2.D0*SRPI)
C
      EXPM=DEXP(RATM1*RATM1)
      ELAM=FDEXP(-XLAM1*XLAM1)
      DERFCM=FDERFC(-XLAM1+RATM1)
      DERFCP=FDERFC( XLAM1+RATM1)
      FCLL0  = FVC(IN)*FF0(EXPM,EX,X,DERFCM,DERFCP)*AMVC(IN)
      FTENLL = FVC(IN)*FF3(EXPM,EX,X,XLAM1,DERFCM,DERFCP,ELAM)*AMVC(IN)
      FSOLL  = FVC(IN)*FF1(EXPM,EX,X,XLAM1,DERFCM,DERFCP,ELAM)*AMVC(IN)
      FSO2LL = 3*FTENLL/(X*X)
C

      EXPM=DEXP(RATM2*RATM2)
      ELAM=FDEXP(-XLAM2*XLAM2)
      DERFCM=FDERFC(-XLAM2+RATM2)
      DERFCP=FDERFC( XLAM2+RATM2)
      FCSS0  = FVC(IN)*FF0(EXPM,EX,X,DERFCM,DERFCP)*AMVC(IN)
      FTENSS = FVC(IN)*FF3(EXPM,EX,X,XLAM2,DERFCM,DERFCP,ELAM)*AMVC(IN)
      FSOSS  = FVC(IN)*FF1(EXPM,EX,X,XLAM2,DERFCM,DERFCP,ELAM)*AMVC(IN)
      FSO2SS = 3*FTENSS/(X*X)
C
      EXPM=DEXP(RATM3*RATM3)
      ELAM=FDEXP(-XLAM3*XLAM3)
      DERFCM=FDERFC(-XLAM3+RATM3)
      DERFCP=FDERFC( XLAM3+RATM3)
      FCLS0  = FVC(IN)*FF0(EXPM,EX,X,DERFCM,DERFCP)*AMVC(IN)
      FTENLS = FVC(IN)*FF3(EXPM,EX,X,XLAM3,DERFCM,DERFCP,ELAM)*AMVC(IN)
      FSOLS  = FVC(IN)*FF1(EXPM,EX,X,XLAM3,DERFCM,DERFCP,ELAM)*AMVC(IN)
      FSO2LS = 3*FTENLS/(X*X)
C
      FCLL1  = FCLL0  - FVC(IN)*VKULL*AMVC(IN)
      FCSS1  = FCSS0  - FVC(IN)*VKUSS*AMVC(IN)
      FCLS1  = FCLS0  - FVC(IN)*VKULS*AMVC(IN)
      FCLL2  = FCLL1+
     .         FVC(IN)*(1.5D0-XLAM1*XLAM1)*VKULL*AMVC(IN)/RATM1/RATM1
      FCSS2  = FCSS1+
     .         FVC(IN)*(1.5D0-XLAM2*XLAM2)*VKUSS*AMVC(IN)/RATM2/RATM2
      FCLS2  = FCLS1+
     .         FVC(IN)*(1.5D0-XLAM3*XLAM3)*VKULS*AMVC(IN)/RATM3/RATM3
      FTLL1  = FTENLL - FVC(IN)*XLAM1*XLAM1*VKULL*AMVC(IN)
     .                / (3*RATM1*RATM1)
      FTSS1  = FTENSS - FVC(IN)*XLAM2*XLAM2*VKUSS*AMVC(IN)
     .                / (3*RATM2*RATM2)
      FTLS1  = FTENLS - FVC(IN)*XLAM3*XLAM3*VKULS*AMVC(IN)
     .                / (3*RATM3*RATM3)
      FOLL1  = FSOLL  - FVC(IN)*VKULL*AMVC(IN)
     .                / (2*RATM1*RATM1)
      FOSS1  = FSOSS  - FVC(IN)*VKUSS*AMVC(IN)
     .                / (2*RATM2*RATM2)
      FOLS1  = FSOLS  - FVC(IN)*VKULS*AMVC(IN)
     .                / (2*RATM3*RATM3)
C
C------------------------------------------------------------
C     THRESHOLD-DIFFERENCE MODIFICATION BASE FUNCTIONS:
***   IF(IN.NE.5) THEN
      IF(IDAM.NE.0.AND.IN.NE.5) THEN
      CALL YMKFUN(XA,AMVC(IN),ALAM,SIGN,IDAM*DAMSL,
     .FXC0,FXC1,FXC2,FXTEN,FXTEN1,FXSO,FXSO1)
      FXSO2 = 3*FXTEN/(X*X)
C------------------------------------------------------------
      IF(LC.EQ.1) THEN
      FCSS0 = FVC(IN)*AMVC(IN)*FXC0 
      FTENSS= FVC(IN)*AMVC(IN)*FXTEN             
      FSOSS = FVC(IN)*AMVC(IN)*FXSO              
      FSO2SS= FVC(IN)*AMVC(IN)*FXSO2             
      FCSS1 = FVC(IN)*AMVC(IN)*FXC1 
      FCSS2 = FVC(IN)*AMVC(IN)*FXC2   
      FTSS1 = FVC(IN)*AMVC(IN)*FXTEN1
      FOSS1 = FVC(IN)*AMVC(IN)*FXSO1
      ENDIF
      IF(LC.NE.1) THEN
      FCLL0 = FVC(IN)*AMVC(IN)*FXC0 
      FTENLL= FVC(IN)*AMVC(IN)*FXTEN             
      FSOLL = FVC(IN)*AMVC(IN)*FXSO             
      FSO2LL= FVC(IN)*AMVC(IN)*FXSO2             
      FCLL1 = FVC(IN)*AMVC(IN)*FXC1 
      FCLL2 = FVC(IN)*AMVC(IN)*FXC2 
      FTLL1 = FVC(IN)*AMVC(IN)*FXTEN1
      FOLL1 = FVC(IN)*AMVC(IN)*FXSO1
      ENDIF
      FCLS0  = 0.5D0*(FCLS0  + FVC(IN)*AMVC(IN)*FXC0 )     
      FTENLS = 0.5D0*(FTENLS + FVC(IN)*AMVC(IN)*FXTEN)     
      FSOLS  = 0.5D0*(FSOLS  + FVC(IN)*AMVC(IN)*FXSO )      
      FSO2LS = 0.5D0*(FSO2LS + FVC(IN)*AMVC(IN)*FXSO2)      
      FCLS1  = 0.5D0*(FCLS1  + FVC(IN)*AMVC(IN)*FXC1 )     
      FCLS2  = 0.5D0*(FCLS2  + FVC(IN)*AMVC(IN)*FXC2 )     
      FTLS1  = 0.5D0*(FTLS1  + FVC(IN)*AMVC(IN)*FXTEN1)    
      FOLS1  = 0.5D0*(FOLS1  + FVC(IN)*AMVC(IN)*FXSO1)     
      ENDIF
C------------------------------------------------------------
C
      VCLL  = VCLL   + GDLL*FCLL0 + CCLL1*FCLL1 +
     .                       GFLL*FAC0*FAC1*FCLL2/16.D0
     .                     + (1-INRS)*FAC1*(GDLL*FAC1/64.D0+(GDFLL
     .                       +GFDLL)*DSQRT(FAC0*FAC1)/16.D0)*FCLL2
      VCSS  = VCSS   + GDSS*FCSS0 + CCSS1*FCSS1 +
     .                       GFSS*FAC0*FAC2*FCSS2/16.D0
     .                     + (1-INRS)*FAC2*(GDSS*FAC2/64.D0+(GDFSS
     .                       +GFDSS)*DSQRT(FAC0*FAC2)/16.D0)*FCSS2
      VCLS  = VCLS   + GDLS*FCLS0 + CCLS1*FCLS1 +
     .                       GFLS*FAC0*FAC3*FCLS2/16.D0
     .                     + (1-INRS)*FAC3*(GDLS*FAC3/64.D0+(GDFLS
     .                       +GFDLS)*DSQRT(FAC0*FAC3)/16.D0)*FCLS2
      VCDR  = VCDR   + GDDR*FCSS0 + CCDR1*FCSS1 +
     .                       GFDR*FAC0*FAC2*FCSS2/16.D0
     .                     + (1-INRS)*FAC2*(GDDR*FAC2/64.D0+(GDFDR
     .                       +GFDDR)*DSQRT(FAC0*FAC2)/16.D0)*FCSS2
C
      VSIGLL= VSIGLL + (CSLL1*FCLL1 + INRS*GFLL*FAC0*FCLL2/8.D0)
     .                     * FAC1/6.D0
      VSIGSS= VSIGSS + (CSSS1*FCSS1 + INRS*GFSS*FAC0*FCSS2/8.D0)
     .                     * FAC2/6.D0
      VSIGLS= VSIGLS + (CSLS1*FCLS1 + INRS*GFLS*FAC0*FCLS2/8.D0)
     .                     * FAC3/6.D0
      VSIGDR= VSIGDR + (CSDR1*FCSS1 + INRS*GFDR*FAC0*FCSS2/8.D0)
     .                     * FAC2/6.D0
C
      VTENLL= VTENLL - (CTLL0*FTENLL + INRS*GFLL*FAC0*FTLL1/8.D0)
     .                     * FAC1/4.D0
      VTENSS= VTENSS - (CTSS0*FTENSS + INRS*GFSS*FAC0*FTSS1/8.D0)
     .                     * FAC2/4.D0
      VTENLS= VTENLS - (CTLS0*FTENLS + INRS*GFLS*FAC0*FTSS1/8.D0)
     .                     * FAC3/4.D0
      VTENDR= VTENDR - (CTDR0*FTENSS + INRS*GFDR*FAC0*FTSS1/8.D0)
     .                     * FAC2/4.D0
C
      VSOLL = VSOLL  - (COLL0*FSOLL + GFLL*FAC0*FOLL1*3/8.D0)
     .                     * FAC1
      VSOSS = VSOSS  - (COSS0*FSOSS + GFSS*FAC0*FOSS1*3/8.D0)
     .                     * FAC2
      VSOLS = VSOLS  - (COLS0*FSOLS + GFLS*FAC0*FOLS1*3/8.D0)
     .                     * FAC3
      VSODR = VSODR  - (CODR0*FSOSS + GFDR*FAC0*FOSS1*3/8.D0)
     .                     * FAC2
C
      VASOLL= VASOLL - (CALL0*FSOLL-CALL1*FOLL1)*FAC1
      VASOSS= VASOSS - (CASS0*FSOSS-CASS1*FOSS1)*FAC2
      VASOLS= VASOLS - (CALS0*FSOLS-CALS1*FOLS1)*FAC3
      VASODR= VASODR - (CADR0*FSOSS-CADR1*FOSS1)*FAC2
C
      VSO2LL= VSO2LL + CO2LL*FSO2LL*FAC1*FAC1/16.D0
      VSO2SS= VSO2SS + CO2SS*FSO2SS*FAC2*FAC2/16.D0
      VSO2LS= VSO2LS + CO2LS*FSO2LS*FAC3*FAC3/16.D0
      VSO2DR= VSO2DR + CO2DR*FSO2SS*FAC2*FAC2/16.D0
C
      IF(IN.NE.5) GOTO 105

C     K-STAR: CONTRIBUTION SECOND TERM IN VECTOR PROPAGATOR
C    
      VCLL   = VCLL - GDLL*PROSLL*(FCLL0-0.25D0*FAC1*FCLL1)
      VCSS   = VCSS - GDSS*PROSSS*(FCSS0-0.25D0*FAC2*FCSS1)
      VCLS   = VCLS - GDLS*PROSLS*(FCLS0-0.25D0*FAC3*FCLS1)
      VCDR   = VCDR - GDDR*PROSSS*(FCSS0-0.25D0*FAC2*FCSS1)
C
      VSOLL   = VSOLL - GDLL*PROSLL*FSOLL*FAC1/2.D0   
      VSOSS   = VSOSS - GDSS*PROSSS*FSOSS*FAC2/2.D0   
      VSOLS   = VSOLS - GDLS*PROSLS*FSOLS*FAC3/2.D0   
      VSODR   = VSODR - GDDR*PROSSS*FSOSS*FAC2/2.D0   
C
      VASOLL  = VASOLL - GDLL*PROSLL*FSOLL*FFAC1*FAC1/4.D0   
      VASOSS  = VASOSS - GDSS*PROSSS*FSOSS*FFAC2*FAC2/4.D0   
      VASOLS  = VASOLS - GDLS*PROSLS*FSOLS*FFAC3*FAC3/4.D0   
      VASODR  = VASODr - GDDR*PROSSS*FSOSS*FFAC2*FAC2/4.D0   
C
      VSO2LL = VSO2LL - GDLL*PROSLL*FSO2LL*FAC1*FAC1/16.D0
      VSO2SS = VSO2SS - GDSS*PROSSS*FSO2SS*FAC2*FAC2/16.D0
      VSO2LS = VSO2LS - GDLS*PROSLS*FSO2LS*FAC3*FAC3/16.D0
      VSO2DR = VSO2DR - GDDR*PROSSS*FSO2SS*FAC2*FAC2/16.D0
C
      IF(NLOC.NE.0) THEN
      FILL = FILL  + 0.5D0*GDLL*PROSLL*FCLL0/(XM1(1)*XM2(1))
      FISS = FISS  + 0.5D0*GDSS*PROSSS*FCSS0/(XM1(2)*XM2(2))
      FILS = FILS  + 0.5D0*GDLS*PROSLS*FCLS0/(XM1(3)*XM2(3))
      FIDR = FIDR  + 0.5D0*GDDR*PROSSS*FCSS0/(XM1(2)*XM2(2))

      DFILL= DFILL - 0.5D0*GDLL*PROSLL*FSOLL*X*REDM(1)/      
     .                          (AMVC(IN)*XM1(1)*XM2(1))
      DFISS= DFISS - 0.5D0*GDSS*PROSSS*FSOSS*X*REDM(2)/      
     .                          (AMVC(IN)*XM1(2)*XM2(2))
      DFILS= DFILS - 0.5D0*GDLS*PROSLS*FSOLS*X*REDM(3)/      
     .                          (AMVC(IN)*XM1(3)*XM2(3))
      DFIDR= DFIDR - 0.5D0*GDLS*PROSSS*FSOSS*X*REDM(2)/      
     .                          (AMVC(IN)*XM1(2)*XM2(2))
*     DDFILL= DDFILL + 0.5D0*GDLL*PROSLL*(3*FTENLL-FSOLL)      
*    .                     *REDM(1)*AMVC(IN)**2/(XM1(1)*XM2(1))
*     DDFISS= DDFISS + 0.5D0*GDSS*PROSSS*(3*FTENSS-FSOSS)      
*    .                     *REDM(2)*AMVC(IN)**2/(XM1(2)*XM2(2))
*     DDFILS= DDFILS + 0.5D0*GDLS*PROSLS*(3*FTENLS-FSOLS)      
*    .                     *REDM(3)*AMVC(IN)**2/(XM1(3)*XM2(3))
*     DDFIDR= DDFIDR + 0.5D0*GDDR*PROSSS*(3*FTENSS-FSOSS)      
*    .                     *REDM(2)*AMVC(IN)**2/(XM1(2)*XM2(2))
      ENDIF
C
C     AUGUST 1998 ADDITIONS:
C     BEGIN RETARDATION
      IF(IRET.EQ.1) THEN      
      CALL FFUN(3,XA,AMVC(IN),ALM1,VARFI0,VARFI1,VARFI2,VARFI3)
      VCLL  = VCLL   - GDLL*PROSLL*WKIN1*VARFI0                     
      VCSS  = VCSS   - GDSS*PROSSS*WKIN2*VARFI0
      VCLS  = VCLS   - GDLS*PROSLS*WKIN3*VARFI0
      VCDR  = VCDR   - GDDR*PROSSS*WKIN2*VARFI0
C
      FILL  = FILL   + 0.5D0*GDLL*PROSLL*VARFI0
      FISS  = FISS   + 0.5D0*GDSS*PROSSS*VARFI0
      FILS  = FILS   + 0.5D0*GDLS*PROSLS*VARFI0
      FIDR  = FIDR   + 0.5D0*GDDR*PROSSS*VARFI0
C
      DFILL = DFILL  + 0.5D0*GDLL*PROSLL*VARFI1*PIM
      DFISS = DFISS  + 0.5D0*GDSS*PROSSS*VARFI1*PIM
      DFILS = DFILS  + 0.5D0*GDLS*PROSLS*VARFI1*PIM
      DFIDR = DFIDR  + 0.5D0*GDDR*PROSSS*VARFI1*PIM
      ENDIF
C     END RETARDATION
C
105   IF(NLOC.EQ.0) GOTO 106
      FILL  = FILL   + 1.5D0*REDMM*GDLL*FCLL0/(XM1(1)*XM2(1))
      FISS  = FISS   + 1.5D0*REDMM*GDSS*FCSS0/(XM1(2)*XM2(2))
      FILS  = FILS   + 1.5D0*REDMM*GDLS*FCLS0/(XM1(3)*XM2(3))
      FIDR  = FIDR   + 1.5D0*REDMM*GDDR*FCSS0/(XM1(2)*XM2(2))
C
      DFILL=DFILL-1.5D0*REDMM*GDLL*FSOLL*X*FAC1/AMVC(IN)
      DFISS=DFISS-1.5D0*REDMM*GDSS*FSOSS*X*FAC2/AMVC(IN)
      DFILS=DFILS-1.5D0*REDMM*GDLS*FSOLS*X*FAC3/AMVC(IN)
      DFIDR=DFIDR-1.5D0*REDMM*GDDR*FSOSS*X*FAC2/AMVC(IN)
C
C------------------------------------------------------------
C     AUGUST 1998 ADDITIONS:
C     BEGIN RETARDATION
      IF(IRET.EQ.1) THEN      
      CALL FFUN(3,XA,AMVC(IN),ALM1,VARFI0,VARFI1,VARFI2,VARFI3)
      VCLL  = VCLL   + GDLL*WKIN1*VARFI0                     
      VCSS  = VCSS   + GDSS*WKIN2*VARFI0
      VCLS  = VCLS   + GDLS*WKIN3*VARFI0
      VCDR  = VCDR   + GDDR*WKIN2*VARFI0
C
      FILL  = FILL   - 0.5D0*GDLL*VARFI0
      FISS  = FISS   - 0.5D0*GDSS*VARFI0
      FILS  = FILS   - 0.5D0*GDLS*VARFI0
      FIDR  = FIDR   - 0.5D0*GDDR*VARFI0
C
      DFILL = DFILL  - 0.5D0*GDLL*VARFI1*PIM
      DFISS = DFISS  - 0.5D0*GDSS*VARFI1*PIM
      DFILS = DFILS  - 0.5D0*GDLS*VARFI1*PIM
      DFIDR = DFIDR  - 0.5D0*GDDR*VARFI1*PIM
      ENDIF
C     END RETARDATION

C------------------------------------------------------------
C     BEGIN ZERO IN FORM-FACTOR:
  106 IF(IZVC.EQ.1) THEN
      FZERO = (AMVC(IN)/AMCRV)**2
      FC3   = FCLL2  - FVC(IN)*(3.75D0-5*XLAM1**2+XLAM1**4)        
     .               * VKULL*AMVC(IN)/(RATM1**4)
      FT2   = FTLL1  - FVC(IN)*(-7.D0+2*XLAM1**2)*XLAM1**2*VKULL
     .               * AMVC(IN)/(6*RATM1**4)
      FO2   = FOLL1  + FVC(IN)*(2.5D0-XLAM1**2)*VKULL*AMVC(IN)            
     .               / (2*RATM1**4)
      FO21  = 3*FTLL1/(X*X)                            

      VCLL  = VCLL   + FZERO*(GDLL*FCLL1+CCLL1*FCLL2+          
     .                        GFLL*FAC0*FAC1*FC3/16.D0)
      VCSS  = VCSS   + FZERO*(GDSS*FCSS1+CCSS1*FCSS2+          
     .                        GFSS*FAC0*FAC1*FC3/16.D0)
      VCLS  = VCLS   + FZERO*(GDLS*FCLS1+CCLS1*FCLS2+          
     .                        GFLS*FAC0*FAC1*FC3/16.D0)
      VCDR  = VCDR   + FZERO*(GDLL*FCSS1+CCDR1*FCSS2+          
     .                        GFDR*FAC0*FAC1*FC3/16.D0)

      VSIGLL= VSIGLL + FZERO*(CSLL1*FCLL2+GFLL*FAC0*FC3/8.D0)
     .                      * FAC1/6.D0                     
      VSIGSS= VSIGSS + FZERO*(CSSS1*FCSS2+GFSS*FAC0*FC3/8.D0)
     .                      * FAC1/6.D0                     
      VSIGLS= VSIGLS + FZERO*(CSLS1*FCLS2+GFLS*FAC0*FC3/8.D0)
     .                      * FAC1/6.D0                     
      VSIGDR= VSIGDR + FZERO*(CSDR1*FCSS2+GFDR*FAC0*FC3/8.D0)
     .                      * FAC1/6.D0                     

      VTENLL= VTENLL - FZERO*(CTLL0*FTLL1+GFLL*FAC0*FT2/8.D0)
     .                      * FAC1/4.D0                     
      VTENSS= VTENSS - FZERO*(CTSS0*FTSS1+GFSS*FAC0*FT2/8.D0)
     .                      * FAC1/4.D0                     
      VTENLS= VTENLS - FZERO*(CTLS0*FTLS1+GFLS*FAC0*FT2/8.D0)
     .                      * FAC1/4.D0                     
      VTENDR= VTENDR - FZERO*(CTDR0*FTSS1+GFDR*FAC0*FT2/8.D0)
     .                      * FAC1/4.D0                     

      VSOLL = VSOLL  - FZERO*(COLL0*FOLL1+GFLL*FAC0*FO2*3/8.D0)
     .                      * FAC1                          
      VSOSS = VSOSS  - FZERO*(COSS0*FOSS1+GFSS*FAC0*FO2*3/8.D0)
     .                      * FAC1                          
      VSOLS = VSOLS  - FZERO*(COLS0*FOLS1+GFLS*FAC0*FO2*3/8.D0)
     .                      * FAC1                          
      VSODR = VSODR  - FZERO*(CODR0*FOSS1+GFDR*FAC0*FO2*3/8.D0)
     .                      * FAC1                          
 
      VASOLL= VASOLL - FZERO*(CALL0*FOLL1-CALL1*FO2)*FAC1
      VASOSS= VASOSS - FZERO*(CASS0*FOSS1-CASS1*FO2)*FAC2
      VASOLS= VASOLS - FZERO*(CALS0*FOLS1-CALS1*FO2)*FAC3
      VASODR= VASODR - FZERO*(CADR0*FOSS1-CADR1*FO2)*FAC2

      VSO2LL= VSO2LL + FZERO* CO2LL*FO21*FAC1*FAC1/16.D0   
      VSO2SS= VSO2SS + FZERO* CO2SS*FO21*FAC2*FAC2/16.D0   
      VSO2LS= VSO2LS + FZERO* CO2LS*FO21*FAC3*FAC3/16.D0   
      VSO2DR= VSO2DR + FZERO* CO2DR*FO21*FAC2*FAC2/16.D0   
      IF(NLOC.NE.0) THEN
      FILL  = FILL   + FZERO*1.5D0*REDMM*GDLL*FCLL1/(XM1(1)*XM2(1))
      FISS  = FISS   + FZERO*1.5D0*REDMM*GDSS*FCSS1/(XM1(1)*XM2(1))
      FILS  = FILS   + FZERO*1.5D0*REDMM*GDLS*FCLS1/(XM1(1)*XM2(1))
      FIDR  = FIDR   + FZERO*1.5D0*REDMM*GDDR*FCSS1/(XM1(1)*XM2(1))

      DFILL = DFILL  - FZERO*1.5D0*REDMM*GDLL*FOLL1*X*FAC1/AMVC(IN)
      DFISS = DFISS  - FZERO*1.5D0*REDMM*GDSS*FOSS1*X*FAC2/AMVC(IN)
      DFILS = DFILS  - FZERO*1.5D0*REDMM*GDLS*FOLS1*X*FAC3/AMVC(IN)
      DFIDR = DFIDR  - FZERO*1.5D0*REDMM*GDDR*FOSS1*X*FAC2/AMVC(IN)
      ENDIF
      IF(IN.NE.5) GOTO 104
C     K-STAR: CONTRIBUTION SECOND TERM IN VECTOR PROPAGATOR
C    
      VCLL   = VCLL - FZERO*GDLL*PROSLL*(FCLL1-0.25D0*FAC1*FCLL2)
      VCSS   = VCSS - FZERO*GDSS*PROSSS*(FCSS1-0.25D0*FAC2*FCSS2)
      VCLS   = VCLS - FZERO*GDLS*PROSLS*(FCLS1-0.25D0*FAC3*FCLS2)
      VCDR   = VCDR - FZERO*GDDR*PROSSS*(FCSS1-0.25D0*FAC2*FCSS2)

      VSOLL  = VSOLL - FZERO*GDLL*PROSLL*FOLL1*FAC1/2.D0   
      VSOSS  = VSOSS - FZERO*GDSS*PROSSS*FOSS1*FAC2/2.D0   
      VSOLS  = VSOLS - FZERO*GDLS*PROSLS*FOLS1*FAC3/2.D0   
      VSODR  = VSODR - FZERO*GDDR*PROSSS*FOSS1*FAC2/2.D0   

      VASOLL = VASOLL - FZERO*GDLL*PROSLL*FOLL1*FFAC1*FAC1/4.D0   
      VASOSS = VASOSS - FZERO*GDSS*PROSSS*FOSS1*FFAC1*FAC2/4.D0   
      VASOLS = VASOLS - FZERO*GDLS*PROSLS*FOLS1*FFAC1*FAC3/4.D0   
      VASODR = VASODR - FZERO*GDDR*PROSSS*FOSS1*FFAC1*FAC2/4.D0   

      VSO2LL = VSO2LL - FZERO*GDLL*PROSLL*FO21*FAC1*FAC1/16.D0
      VSO2SS = VSO2SS - FZERO*GDSS*PROSSS*FO21*FAC2*FAC2/16.D0
      VSO2LS = VSO2LS - FZERO*GDLS*PROSLS*FO21*FAC3*FAC3/16.D0
      VSO2DR = VSO2DR - FZERO*GDDR*PROSDR*FO21*FAC2*FAC2/16.D0
      IF(NLOC.NE.0) THEN
      FILL = FILL  + FZERO* 0.5D0*GDLL*PROSLL*FCLL1/(XM1(1)*XM2(1))
      FISS = FISS  + FZERO* 0.5D0*GDSS*PROSSS*FCSS1/(XM1(2)*XM2(2))
      FILS = FILS  + FZERO* 0.5D0*GDLS*PROSLS*FCLS1/(XM1(3)*XM2(3))
      FIDR = FIDR  + FZERO* 0.5D0*GDDR*PROSSS*FCSS1/(XM1(2)*XM2(2))

      DFILL= DFILL - FZERO*0.5D0*GDLL*PROSLL*FOLL1*X*REDM(1)/      
     .                          (AMVC(IN)*XM1(1)*XM2(1))
      DFISS= DFISS - FZERO*0.5D0*GDSS*PROSSS*FOSS1*X*REDM(2)/      
     .                          (AMVC(IN)*XM1(2)*XM2(2))
      DFILS= DFILS - FZERO*0.5D0*GDLS*PROSLS*FOLS1*X*REDM(3)/      
     .                          (AMVC(IN)*XM1(3)*XM2(3))
      DFIDR= DFIDR - FZERO*0.5D0*GDDR*PROSSS*FOSS1*X*REDM(2)/      
     .                          (AMVC(IN)*XM1(2)*XM2(2))
      ENDIF
       ENDIF
C     END ZERO IN FORM-FACTOR. 
C------------------------------------------------------------

  104 CONTINUE
C
 1040 CONTINUE
C
      icall = 1
      RETURN
      END
C**********************************************************************
C
      SUBROUTINE SCALAR(XA,ICSB,NLOC,LC) 
C
C**********************************************************************
C
C     VERSION AUGUST 2000: FIRST SU3-NONET, ASSIGNMENTS CHOOSEN: 
C       EPS=f0(760), DEL=A0(962), S*=f0(993), KAPPA=K0(900)              
C**********************************************************************
C  updated december 2000, from YNRMP2k2.f , introducing mass               
C  differences in meson propagators in the OBE-potentials, 
C  according to Macke-Klein 
C----------------------------------------------------------------------

C
C     SCALAR MESONS : CALCULATION POTENTIALS ON ISOSPIN BASIS
C
      IMPLICIT REAL *8(A-H,O-Z)
      COMMON/MODEL/IMODEL,INRS,ICNSTR,IRET,IDAM,IGERST,IGRTST
      COMMON/ZEROS/IZPS,IZVC,IZSC,IZAX,IZTEN
      COMMON/ALLSC/ASI,BSI,AM1SI,AM2SI,ASST,BSST,AMSST,AM2ST,AMD,AMSCK
      COMMON/MASSES/PIM,AM(3),AMY(3),REDM(3),PLAB,AK(3),AKS(3),TEM(3)
      COMMON/DYNMAS/REDMM,AMLN,AMSN,AMH,AMSS,AMLS,AMNN
      COMMON/FRMFAC/ALMOBE,ALMNN,ALMLL,ALMSS,ALMLS,ALMLK,ALMSK
      COMMON/FORMF/ALAMH,ALMP8,ALMV8,ALMS8,ALMP1,ALMV1,ALMS1,
     .             ALMKA,ALMKS,ALMKP
*     COMMON/AMAT/XA(300),A(9,6,300)
      COMMON/POTF/VCLL  ,VCSS  ,VCLS  ,VCDR,
     .            VSIGLL,VSIGSS,VSIGLS,VSIGDR,
     .            VTENLL,VTENSS,VTENLS,VTENDR,
     .            VSOLL ,VSOSS ,VSOLS ,VSODR,
     .            VSO2LL,VSO2SS,VSO2LS,VSO2DR,
     .            VASOLL,VASOSS,VASOLS,VASODR,
     .            VCNN  ,VSIGNN,VTENNN,VSONN ,
     .            FILL  ,FISS  ,FILS  ,FIDR,
     .            DFILL ,DFISS ,DFILS ,DFIDR,
     .            FISLL ,FISSS ,FISLS ,FISDR,
     .            DFISLL,DFISSS,DFISLS,DFISDR,
     .            FITLL ,FITSS ,FITLS ,FITDR,
     .            DFITLL,DFITSS,DFITLS,DFITDR
      COMMON/COUPL/ F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,F11,
     .              G1,G2,G3,G4,G5,G6,G7,G8,G9,G10,G11,
     .              FD1,FD2,FD3,FD4,FD5,FD6,FD7,FD8,FD9,FD10,FD11,
     .              FV1,FV2,FV3,FV4,FV5,FV6,FV7,FV8,FV9,FV10,FV11,
     .              GS1,GS2,GS3,GS4,GS5,GS6,GS7,GS8,GS9,GS10,GS11,
     .              GD1,GD2,GD3,GD4,GD5,GD6,GD7,GD8,GD9,GD10,GD11,P
      COMMON/ALLSC2/XALLSC2(5),GSA(11),GSB(11),IOPTSC
      DIMENSION GS(11),AMSC(6),FSC(6),XM1(3),XM2(3)
      EQUIVALENCE (GS1,GS(1))
      EQUIVALENCE (GSA1,GSA(1))
      DATA SR3/1.732051D0/,SRPI/1.772454D0/,FMNL/1.D0/
      DATA DAMLN/175.D0/,DAMSN/255.D0/,DAMSL/80.D0/,AMCRS/750.D0/
***   DATA DAMLN/0.D0/,DAMSN/0.D0/,DAMSL/0.D0/
      data icall/0/
C
C   NOTE : DELTA(IN=1),EPS1(IN=2),EPS2(IN=3),SSTAR(IN=4),KAPPA(IN=5)
C
C   NOTE : INDEX              1    ,    2    ,    3
C          REFERS TO       LN -> LN, SN -> SN, LN -> SN  REACTION
C-------------------------------------------------------------------
C   NOTE : FOR 'DIRECT POTENTIALS': INDEX 1,3 -> NUCLEONS !
C                                 : INDEX 2,4 -> HYPERONS !
C-------------------------------------------------------------------
C
C   THE POTENTIAL FUNCTIONS
C
      FF0(ERATH,EXH,XH,EM,EP)=ERATH*(EM/EXH-EXH*EP)/(2.0D00*XH)
      FF1(ERATH,EXH,XH,XLAMH,EM,EP,EXLAM)=ERATH*(EM/EXH
     . *(1.D00+XH)-EXH*EP*(1.D00-XH)-4.D00*XLAMH*EXLAM/ERATH/SRPI)
     .  /(2.D00*XH*XH*XH)
      FF3(ERATH,EXH,XH,XLAMH,EM,EP,EXLAM)=ERATH*(EM/EXH
     .  *(1.D00+XH+XH*XH/3.D00)-EXH*EP*(1.D00-XH+XH*XH/3.D00)
     .  -8.D00*XLAMH*(0.5D00+XLAMH*XLAMH/3.D00)*EXLAM/ERATH/SRPI)
     .  /(2.D00*XH*XH*XH)
C
C
      IF(LC.EQ.1) SIGN= 1.D0
      IF(LC.NE.1) SIGN=-1.D0
      IF(IRET.EQ.1) THEN
      WKIN1 = PIM**2*AKS(1)/(2*REDM(1))
      WKIN2 = PIM**2*AKS(3)/(2*REDM(3))
      WKIN3 = 0.5D0*(WKIN1+WKIN2)
      ENDIF

      DO 1040 IN=1,5
      IF(IN.EQ.1) THEN
      XM1(1)=AMY(1)
      XM1(2)=AMSS  
      XM1(3)=AMH
      XM2(1)=AM(1)
      XM2(2)=AMNN 
      XM2(3)=AM(1)
      ENDIF
      GOTO(1051,1052,1053,1054,1055),IN
1051  GSLL = -0.0271D0*ICSB*GS1*GS3
      GSSS=  -2.*GS1*GS2
      GSLS= -SR3*GS1*GS3
      GSDR=      GS1*GS2
      FSC(1)=1.D0
      AMSC(1)=AMD
      GOTO 1056
1052  GSLL=  GS6*GS7
      GSSS=  GS6*GS8
      GSLS=  0.
      GSDR=  GS6*GS8
      FSC(2)=ASI
      AMSC(2)=AM1SI
      GOTO 1056
1053  GSLL=  GS6*GS7
      GSSS=  GS6*GS8
      GSLS=  0.D0
      GSDR=  GS6*GS8
      FSC(3)=BSI
      AMSC(3)=AM2SI
      GOTO 1056
1054  GSLL=  GS9*GS10
      GSSS=  GS9*GS11 
      GSLS=  0.D0
      GSDR=  GS9*GS11 
      FSC(4)=1.D0
      AMSC(4)=AMSST
      GOTO 1056
1055  GSLL=      GS4*GS4*P
      GSSS=     -GS5*GS5*P
      GSLS= -SR3*GS4*GS5*P
      GSDR=    2*GS5*GS5*P
      XM1(1)=AMLN
      XM1(2)=AMSN
      XM1(3)=AMLN
      XM2(1)=AMLN
      XM2(2)=AMSN
      XM2(3)=AMSN
      FSC(5)=1.D0
      AMSC(5)=AMSCK
C
1056  IF(IMODEL.LE.3) ALAM=ALMOBE
      IF(IMODEL.GE.4) THEN
       ALAM = ALMS8
       IF(IN.EQ.2.OR.IN.EQ.3) ALAM=ALMS1
       IF(IN.EQ.5) ALAM=ALMKP
      ENDIF

      ALM1=ALAM
      ALM2=ALAM
      ALM3=ALAM

      RATM1=AMSC(IN)/ALM1
      RATM2=AMSC(IN)/ALM2
      RATM3=AMSC(IN)/ALM3
      AMSC3=AMSC(IN)**3
      AMSC5=AMSC(IN)**5
      FAC1=AMSC(IN)*AMSC(IN)/(XM1(1)*XM2(1))
      FAC2=AMSC(IN)*AMSC(IN)/(XM1(2)*XM2(2))
      FAC3=AMSC(IN)*AMSC(IN)/(XM1(3)*XM2(3))
      FFAC1 = (1.D0/XM1(1)**2-1.D0/XM2(1)**2)
      FFAC2 = (1.D0/XM1(2)**2-1.D0/XM2(2)**2)
      FFAC3 = (1.D0/XM1(3)**2-1.D0/XM2(3)**2)
C
*     DO 104 I=2,NMAX
*     X = XA(I)
      X = XA    
      XLAM1=0.5D0*X*ALM1/PIM
      XLAM2=0.5D0*X*ALM2/PIM
      XLAM3=0.5D0*X*ALM3/PIM
      X =(AMSC(IN)/PIM)*X
      EX=FDEXP(X)
      VKULL=(ALM1/AMSC(IN))**3*FDEXP(-XLAM1*XLAM1)/(2.D0*SRPI)
      VKUSS=(ALM2/AMSC(IN))**3*FDEXP(-XLAM2*XLAM2)/(2.D0*SRPI)
      VKULS=(ALM3/AMSC(IN))**3*FDEXP(-XLAM3*XLAM3)/(2.D0*SRPI)
C
      EXPM=DEXP(RATM1*RATM1)
      ELAM=FDEXP(-XLAM1*XLAM1)
      DERFCM=FDERFC(-XLAM1+RATM1)
      DERFCP=FDERFC( XLAM1+RATM1)
      FCLL0  = FSC(IN)*FF0(EXPM,EX,X,DERFCM,DERFCP)*AMSC(IN)
      FSOLL  = FSC(IN)*FF1(EXPM,EX,X,XLAM1,DERFCM,DERFCP,ELAM)*AMSC3
      FSO2LL = 3*FSC(IN)*FF3(EXPM,EX,X,XLAM1,DERFCM,DERFCP,ELAM)*AMSC5/
     /         (X*X)
C

      EXPM=DEXP(RATM2*RATM2)
      ELAM=FDEXP(-XLAM2*XLAM2)
      DERFCM=FDERFC(-XLAM2+RATM2)
      DERFCP=FDERFC( XLAM2+RATM2)
      FCSS0  = FSC(IN)*FF0(EXPM,EX,X,DERFCM,DERFCP)*AMSC(IN)
      FSOSS  = FSC(IN)*FF1(EXPM,EX,X,XLAM2,DERFCM,DERFCP,ELAM)*AMSC3
      FSO2SS = 3*FSC(IN)*FF3(EXPM,EX,X,XLAM2,DERFCM,DERFCP,ELAM)*AMSC5/
     /         (X*X)
C
      EXPM=DEXP(RATM3*RATM3)
      ELAM=FDEXP(-XLAM3*XLAM3)
      DERFCM=FDERFC(-XLAM3+RATM3)
      DERFCP=FDERFC( XLAM3+RATM3)
      FCLS0  = FSC(IN)*FF0(EXPM,EX,X,DERFCM,DERFCP)*AMSC(IN)
      FSOLS  = FSC(IN)*FF1(EXPM,EX,X,XLAM3,DERFCM,DERFCP,ELAM)*AMSC3
      FSO2LS = 3*FSC(IN)*FF3(EXPM,EX,X,XLAM3,DERFCM,DERFCP,ELAM)*AMSC5/
     /         (X*X)
C
      FCLL1  = FCLL0  - FSC(IN)*VKULL*AMSC(IN)
      FCSS1  = FCSS0  - FSC(IN)*VKUSS*AMSC(IN)
      FCLS1  = FCLS0  - FSC(IN)*VKULS*AMSC(IN)
C
C------------------------------------------------------------
C     THRESHOLD-DIFFERENCE MODIFICATION BASE FUNCTIONS:
***   IF(IN.NE.5) THEN
      IF(IDAM.NE.0.AND.IN.NE.5) THEN
      CALL YMKFUN(XA,AMSC(IN),ALAM,SIGN,IDAM*DAMSL,
     .FXC0,FXC1,FXC2,FXTEN,FXTEN1,FXSO,FXSO1)
      FXSO2 = 3*FXTEN/(X*X)
C------------------------------------------------------------
      IF(LC.EQ.1) THEN
      FCSS0 = FSC(IN)*AMSC(IN)*FXC0 
      FCSS1 = FSC(IN)*AMSC(IN)*FXC1 
      FSOSS = FSC(IN)*AMSC3*FXSO              
      FSO2SS= FSC(IN)*AMSC5*FXSO2             
      ENDIF
      IF(LC.NE.1) THEN
      FCLL0 = FSC(IN)*AMSC(IN)*FXC0 
      FCLL1 = FSC(IN)*AMSC(IN)*FXC1 
      FSOLL = FSC(IN)*AMSC3*FXSO              
      FSO2LL= FSC(IN)*AMSC5*FXSO2             
      ENDIF
      FCLS0  = 0.5D0*(FCLS0  + FSC(IN)*AMSC(IN)*FXC0 )     
      FCLS1  = 0.5D0*(FCLS1  + FSC(IN)*AMSC(IN)*FXC1 )     
      FSOLS  = 0.5D0*(FSOLS  + FSC(IN)*AMSC3*FXSO )      
      FSO2LS = 0.5D0*(FSO2LS + FSC(IN)*AMSC5*FXSO2)      
      ENDIF
C------------------------------------------------------------
C
      VCLL  = VCLL   - GSLL*(FCLL0-0.25D0*FAC1*FCLL1)
      VCSS  = VCSS   - GSSS*(FCSS0-0.25D0*FAC2*FCSS1)
      VCLS  = VCLS   - GSLS*(FCLS0-0.25D0*FAC3*FCLS1)
      VCDR  = VCDR   - GSDR*(FCSS0-0.25D0*FAC2*FCSS1)
C
      VSOLL = VSOLL  - 0.5D0*GSLL*FSOLL/(XM1(1)*XM2(1))
      VSOSS = VSOSS  - 0.5D0*GSSS*FSOSS/(XM1(2)*XM2(2))
      VSOLS = VSOLS  - 0.5D0*GSLS*FSOLS/(XM1(3)*XM2(3))
      VSODR = VSODR  - 0.5D0*GSDR*FSOSS/(XM1(2)*XM2(2))
C
      VASOLL = VASOLL  - GSLL*FSOLL*FFAC1/4.D0
      VASOSS = VASOSS  - GSSS*FSOSS*FFAC2/4.D0
      VASOLS = VASOLS  - GSLS*FSOLS*FFAC3/4.D0
      VASODR = VASODR  - GSDR*FSOSS*FFAC2/4.D0
C
      VSO2LL= VSO2LL - GSLL*FSO2LL/(4*XM1(1)*XM2(1))**2
      VSO2SS= VSO2SS - GSSS*FSO2SS/(4*XM1(2)*XM2(2))**2          
      VSO2LS= VSO2LS - GSLS*FSO2LS/(4*XM1(3)*XM2(3))**2    
      VSO2DR= VSO2DR - GSDR*FSO2SS/(4*XM1(2)*XM2(2))**2           

c     if(icall.eq.0) then
c     dvcll = - GSLL*(FCLL0-0.25D0*FAC1*FCLL1)
c     write(*,*) ' in=',in,' amsc=',amsc(in),' gsll=',gsll  
c     write(*,*) ' in=',in,' fcll0=',fcll0,' fcll1=',fcll1
c     write(*,*) ' in=',in,' fsc=',fsc(in),' vcll=',dvcll
c     endif
      
C------------------------------------------------------------
C     ZERO IN FORM-FACTOR:
      IF(IZSC.NE.0) THEN
      FZERO = (AMSC(IN)/AMCRS)**2
      FC2   = FCLL1  + FSC(IN)*(1.5D0-XLAM1*XLAM1)
     .               * VKULL*AMSC(IN)/RATM1/RATM1
      FO1   = FSOLL  - FSC(IN)*(VKULL/(2*RATM1*RATM1))    
**    FO21  = FSO2LL - FSC(IN)*(VKULL/RATM1**2)/(X*X)
      FO21  = FSO2LL - FSC(IN)*(VKULL/(4*RATM1**4))*AMSC5

      VCLL  = VCLL   - FZERO*GSLL*(FCLL1-0.25D0*FAC1*FC2)      
      VCSS  = VCSS   - FZERO*GSSS*(FCSS1-0.25D0*FAC2*FC2)      
      VCLS  = VCLS   - FZERO*GSLS*(FCLS1-0.25D0*FAC3*FC2)      
      VCDR  = VCDR   - FZERO*GSDR*(FCSS1-0.25D0*FAC2*FC2)      

      VSOLL = VSOLL  - FZERO*0.5D0*GSLL*FO1/(XM1(1)*XM2(1))
      VSOSS = VSOSS  - FZERO*0.5D0*GSSS*FO1/(XM1(2)*XM2(2))
      VSOLS = VSOLS  - FZERO*0.5D0*GSLS*FO1/(XM1(3)*XM2(3))
      VSODR = VSODR  - FZERO*0.5D0*GSDR*FO1/(XM1(2)*XM2(2))
 
      VASOLL = VASOLL  - FZERO*GSLL*FO1*FFAC1/4.D0
      VASOSS = VASOSS  - FZERO*GSSS*FO1*FFAC2/4.D0
      VASOLS = VASOLS  - FZERO*GSLS*FO1*FFAC3/4.D0
      VASODR = VASODR  - FZERO*GSDR*FO1*FFAC2/4.D0
 
      VSO2LL= VSO2LL - FZERO*GSLL*FO21/(4*XM1(1)*XM2(1))**2
      VSO2SS= VSO2SS - FZERO*GSSS*FO21/(4*XM1(2)*XM2(2))**2
      VSO2LS= VSO2LS - FZERO*GSLS*FO21/(4*XM1(3)*XM2(3))**2
      VSO2DR= VSO2DR - FZERO*GSDR*FO21/(4*XM1(2)*XM2(2))**2

c     if(icall.eq.0) then
c     write(*,*)
c     dvcll2= - FZERO*GSLL*(FCLL1-0.25D0*FAC1*FC2)      
c     write(*,*) ' in=',in,' fcll1=',fcll1,' fc2  =',fc2   
c     write(*,*) ' in=',in,' dvcll=',dvcll,' dvcll2=',dvcll2,
c    .' vcll=dvcll+dvcll2=',dvcll+dvcll2
c     write(*,*)
c     endif

      IF(NLOC.NE.0) THEN
      IF(IZSC.EQ.2) THEN
      FILL  = FILL   + FZERO*0.5D0*REDMM*GSLL*FCLL1/(XM1(1)*XM2(1))
      FISS  = FISS   + FZERO*0.5D0*REDMM*GSSS*FCSS1/(XM1(2)*XM2(2))
      FILS  = FILS   + FZERO*0.5D0*REDMM*GSLS*FCLS1/(XM1(3)*XM2(3))
      FIDR  = FIDR   + FZERO*0.5D0*REDMM*GSDR*FCSS1/(XM1(2)*XM2(2))

      DFILL =DFILL   - FZERO*0.5*REDMM*GSLL*FO1*X/
     .                 (AMSC(IN)*XM1(1)*XM2(1))
      DFISS =DFISS   - FZERO*0.5*REDMM*GSSS*FO1*X/
     .                 (AMSC(IN)*XM1(2)*XM2(2))
      DFILS =DFILS   - FZERO*0.5*REDMM*GSLS*FO1*X/
     .                 (AMSC(IN)*XM1(3)*XM2(3))
      DFIDR =DFIDR   - FZERO*0.5*REDMM*GSDR*FO1*X/
     .                 (AMSC(IN)*XM1(2)*XM2(2))
      ENDIF
      ENDIF
       ENDIF
C------------------------------------------------------------
C
      IF(NLOC.NE.0) THEN         
      FILL  = FILL   + 0.5D0*REDMM*GSLL*FCLL0/(XM1(1)*XM2(1))
      FISS  = FISS   + 0.5D0*REDMM*GSSS*FCSS0/(XM1(2)*XM2(2))
      FILS  = FILS   + 0.5D0*REDMM*GSLS*FCLS0/(XM1(3)*XM2(3))
      FIDR  = FIDR   + 0.5D0*REDMM*GSDR*FCSS0/(XM1(2)*XM2(2))
C
      DFILL=DFILL-0.5*REDMM*GSLL*FSOLL*X/(AMSC(IN)*XM1(1)*XM2(1))
      DFISS=DFISS-0.5*REDMM*GSSS*FSOSS*X/(AMSC(IN)*XM1(2)*XM2(2))
      DFILS=DFILS-0.5*REDMM*GSLS*FSOLS*X/(AMSC(IN)*XM1(3)*XM2(3))
      DFIDR=DFIDR-0.5*REDMM*GSDR*FSOSS*X/(AMSC(IN)*XM1(2)*XM2(2))
      ENDIF
C
C     AUGUST 1998 ADDITIONS:
C     BEGIN RETARDATION
      IF(IRET.EQ.1) THEN      
      CALL FFUN(3,XA,AMSC(IN),ALM1,VARFI0,VARFI1,VARFI2,VARFI3)
      VCLL  = VCLL   - GSLL*WKIN1*VARFI0                     
      VCSS  = VCSS   - GSSS*WKIN2*VARFI0
      VCLS  = VCLS   - GSLS*WKIN3*VARFI0
      VCDR  = VCDR   - GSDR*WKIN2*VARFI0
C
      FILL  = FILL   + 0.5D0*GSLL*VARFI0
      FISS  = FISS   + 0.5D0*GSSS*VARFI0
      FILS  = FILS   + 0.5D0*GSLS*VARFI0
      FIDR  = FIDR   + 0.5D0*GSDR*VARFI0
C
      DFILL = DFILL  + 0.5D0*GSLL*VARFI1*PIM
      DFISS = DFISS  + 0.5D0*GSSS*VARFI1*PIM
      DFILS = DFILS  + 0.5D0*GSLS*VARFI1*PIM
      DFIDR = DFIDR  + 0.5D0*GSDR*VARFI1*PIM
      ENDIF
C     END RETARDATION

  104 CONTINUE
C
 1040 CONTINUE
C
      icall=1
      RETURN
      END
C**********************************************************************
C
      SUBROUTINE SCALAR2(XA,ICSB,NLOC,LC) 
C
C**********************************************************************
C
C     VERSION AUGUST 2000: SECOND SU3-NONET, ASSIGNMENTS CHOOSEN:
C       DEL2=A0(1450), EPS2=F0(1370), S*2=f0(1580), KAPPA2=K*(1430)
C**********************************************************************
C  updated december 2000, from YNRMP2k2.f , introducing mass               
C  differences in meson propagators in the OBE-potentials, 
C  according to Macke-Klein 
C----------------------------------------------------------------------

C
C     SCALAR MESONS : CALCULATION POTENTIALS ON ISOSPIN BASIS
C
      IMPLICIT REAL *8(A-H,O-Z)
      COMMON/MODEL/IMODEL,INRS,ICNSTR,IRET,IDAM,IGERST,IGRTST
      COMMON/ALLSC/ASI,BSI,AM1SI,AM2SI,ASST,BSST,AMSST,AM2ST,AMD,AMSCK
      COMMON/MASSES/PIM,AM(3),AMY(3),REDM(3),PLAB,AK(3),AKS(3),TEM(3)
      COMMON/DYNMAS/REDMM,AMLN,AMSN,AMH,AMSS,AMLS,AMNN
      COMMON/FRMFAC/ALMOBE,ALMNN,ALMLL,ALMSS,ALMLS,ALMLK,ALMSK
      COMMON/FORMF/ALAMH,ALMP8,ALMV8,ALMS8,ALMP1,ALMV1,ALMS1,
     .             ALMKA,ALMKS,ALMKP
*     COMMON/AMAT/XA(300),A(9,6,300)
      COMMON/POTF/VCLL  ,VCSS  ,VCLS  ,VCDR,
     .            VSIGLL,VSIGSS,VSIGLS,VSIGDR,
     .            VTENLL,VTENSS,VTENLS,VTENDR,
     .            VSOLL ,VSOSS ,VSOLS ,VSODR,
     .            VSO2LL,VSO2SS,VSO2LS,VSO2DR,
     .            VASOLL,VASOSS,VASOLS,VASODR,
     .            VCNN  ,VSIGNN,VTENNN,VSONN ,
     .            FILL  ,FISS  ,FILS  ,FIDR,
     .            DFILL ,DFISS ,DFILS ,DFIDR,
     .            FISLL ,FISSS ,FISLS ,FISDR,
     .            DFISLL,DFISSS,DFISLS,DFISDR,
     .            FITLL ,FITSS ,FITLS ,FITDR,
     .            DFITLL,DFITSS,DFITLS,DFITDR
      COMMON/COUPL/ F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,F11,
     .              G1,G2,G3,G4,G5,G6,G7,G8,G9,G10,G11,
     .              FD1,FD2,FD3,FD4,FD5,FD6,FD7,FD8,FD9,FD10,FD11,
     .              FV1,FV2,FV3,FV4,FV5,FV6,FV7,FV8,FV9,FV10,FV11,
     .              GS1,GS2,GS3,GS4,GS5,GS6,GS7,GS8,GS9,GS10,GS11,
     .              GD1,GD2,GD3,GD4,GD5,GD6,GD7,GD8,GD9,GD10,GD11,P

      DIMENSION GSA(11),AMSC(4),FSC(4),XM1(3),XM2(3)
      COMMON/ALLSC2/XALLSC2(5),                
     .GSA1,GSA2,GSA3,GSA4,GSA5,GSA6,GSA7,GSA8,GSA9,GSA10,GSA11,
     .GSB1,GSB2,GSB3,GSB4,GSB5,GSB6,GSB7,GSB8,GSB9,GSB10,GSB11,
     .IOPTSC
      EQUIVALENCE (GSA1,GSA(1))
      DATA SR3/1.732051D0/,SRPI/1.772454D0/,FMNL/1.D0/
      DATA AMDEL2/1450.D0/,AMEPS2/1370.D0/,AMST2/1580.D0/,
     .     AMSCK2/1430.D0/
      DATA DAMLN/175.D0/,DAMSN/255.D0/,DAMSL/80.D0/
C
C   NOTE : DELTA2(IN=1),EPS2(IN=2),SSTAR2(IN=3),KAPPA2(IN=4)
C          EPS(1300)(IN=6)
C
C   NOTE : INDEX              1    ,    2    ,    3
C          REFERS TO       LN -> LN, SN -> SN, LN -> SN  REACTION
C-------------------------------------------------------------------
C   NOTE : FOR 'DIRECT POTENTIALS': INDEX 1,3 -> NUCLEONS !
C                                 : INDEX 2,4 -> HYPERONS !
C-------------------------------------------------------------------
C
C   THE POTENTIAL FUNCTIONS
C
      FF0(ERATH,EXH,XH,EM,EP)=ERATH*(EM/EXH-EXH*EP)/(2.0D00*XH)
      FF1(ERATH,EXH,XH,XLAMH,EM,EP,EXLAM)=ERATH*(EM/EXH
     . *(1.D00+XH)-EXH*EP*(1.D00-XH)-4.D00*XLAMH*EXLAM/ERATH/SRPI)
     .  /(2.D00*XH*XH*XH)
      FF3(ERATH,EXH,XH,XLAMH,EM,EP,EXLAM)=ERATH*(EM/EXH
     .  *(1.D00+XH+XH*XH/3.D00)-EXH*EP*(1.D00-XH+XH*XH/3.D00)
     .  -8.D00*XLAMH*(0.5D00+XLAMH*XLAMH/3.D00)*EXLAM/ERATH/SRPI)
     .  /(2.D00*XH*XH*XH)
C
C
      IF(LC.EQ.1) SIGN= 1.D0
      IF(LC.NE.1) SIGN=-1.D0
      IF(IRET.EQ.1) THEN
      WKIN1 = PIM**2*AKS(1)/(2*REDM(1))
      WKIN2 = PIM**2*AKS(3)/(2*REDM(3))
      WKIN3 = 0.5D0*(WKIN1+WKIN2)
      ENDIF

      DO 1040 IN=1,4
      IF(IN.EQ.1) THEN
      XM1(1)=AMY(1)
      XM1(2)=AMSS  
      XM1(3)=AMH
      XM2(1)=AM(1)
      XM2(2)=AMNN 
      XM2(3)=AM(1)
      ENDIF
      GOTO(1051,1052,1053,1054),IN
1051  GSLL = 0.D0                   
      GSSS=  -2*GSA1*GSA2
      GSLS= -SR3*GSA1*GSA3
      GSDR=      GSA1*GSA2
      FSC(1)=1.D0
      AMSC(1)=AMDEL2
      GOTO 1055
1052  GSLL=  GSA6*GSA7
      GSSS=  GSA6*GSA8
      GSLS=  0.D0
      GSDR=  GSA6*GSA8
      FSC(2)=1.D0 
      AMSC(2)=AMEPS2
      GOTO 1055
1053  GSLL=  GSA9*GSA10
      GSSS=  GSA9*GSA11
      GSLS=  0.D0
      GSDR=  GSA9*GSA11
      FSC(3)=1.D0 
      AMSC(3)=AMST2
      GOTO 1055
1054  GSLL=      GSA4*GSA4*P
      GSSS=     -GSA5*GSA5*P
      GSLS= -SR3*GSA4*GSA5*P
      GSDR=    2*GSA5*GSA5*P
      XM1(1)=AMLN
      XM1(2)=AMSN
      XM1(3)=AMLN
      XM2(1)=AMLN
      XM2(2)=AMSN
      XM2(3)=AMSN
      FSC(4)=1.D0
      AMSC(4)=AMSCK2
C
1055  IF(IMODEL.LE.3) ALAM=ALMOBE
      IF(IMODEL.GE.4) THEN
       ALAM = ALMS8
       IF(IN.EQ.2.OR.IN.EQ.3) ALAM=ALMS1
       IF(IN.EQ.5) ALAM=ALMKP
       IF(IN.EQ.6) ALAM=ALMS1
      ENDIF

      ALM1=ALAM
      ALM2=ALAM
      ALM3=ALAM

      RATM1=AMSC(IN)/ALM1
      RATM2=AMSC(IN)/ALM2
      RATM3=AMSC(IN)/ALM3
      AMSC3=AMSC(IN)**3
      AMSC5=AMSC(IN)**5
      FAC1=AMSC(IN)*AMSC(IN)/(XM1(1)*XM2(1))
      FAC2=AMSC(IN)*AMSC(IN)/(XM1(2)*XM2(2))
      FAC3=AMSC(IN)*AMSC(IN)/(XM1(3)*XM2(3))
      FFAC1 = (1.D0/XM1(1)**2-1.D0/XM2(1)**2)
      FFAC2 = (1.D0/XM1(2)**2-1.D0/XM2(2)**2)
      FFAC3 = (1.D0/XM1(3)**2-1.D0/XM2(3)**2)
C
*     DO 104 I=2,NMAX
*     X = XA(I)
      X = XA    
      XLAM1=0.5D0*X*ALM1/PIM
      XLAM2=0.5D0*X*ALM2/PIM
      XLAM3=0.5D0*X*ALM3/PIM
      X =(AMSC(IN)/PIM)*X
      EX=FDEXP(X)
      VKULL=(ALM1/AMSC(IN))**3*FDEXP(-XLAM1*XLAM1)/(2.D0*SRPI)
      VKUSS=(ALM2/AMSC(IN))**3*FDEXP(-XLAM2*XLAM2)/(2.D0*SRPI)
      VKULS=(ALM3/AMSC(IN))**3*FDEXP(-XLAM3*XLAM3)/(2.D0*SRPI)
C
      EXPM=DEXP(RATM1*RATM1)
      ELAM=FDEXP(-XLAM1*XLAM1)
      DERFCM=FDERFC(-XLAM1+RATM1)
      DERFCP=FDERFC( XLAM1+RATM1)
      FCLL0  = FSC(IN)*FF0(EXPM,EX,X,DERFCM,DERFCP)*AMSC(IN)
      FSOLL  = FSC(IN)*FF1(EXPM,EX,X,XLAM1,DERFCM,DERFCP,ELAM)*AMSC3
      FSO2LL = 3*FSC(IN)*FF3(EXPM,EX,X,XLAM1,DERFCM,DERFCP,ELAM)*AMSC5/
     /         (X*X)
C

      EXPM=DEXP(RATM2*RATM2)
      ELAM=FDEXP(-XLAM2*XLAM2)
      DERFCM=FDERFC(-XLAM2+RATM2)
      DERFCP=FDERFC( XLAM2+RATM2)
      FCSS0  = FSC(IN)*FF0(EXPM,EX,X,DERFCM,DERFCP)*AMSC(IN)
      FSOSS  = FSC(IN)*FF1(EXPM,EX,X,XLAM2,DERFCM,DERFCP,ELAM)*AMSC3
      FSO2SS = 3*FSC(IN)*FF3(EXPM,EX,X,XLAM2,DERFCM,DERFCP,ELAM)*AMSC5/
     /         (X*X)
C
      EXPM=DEXP(RATM3*RATM3)
      ELAM=FDEXP(-XLAM3*XLAM3)
      DERFCM=FDERFC(-XLAM3+RATM3)
      DERFCP=FDERFC( XLAM3+RATM3)
      FCLS0  = FSC(IN)*FF0(EXPM,EX,X,DERFCM,DERFCP)*AMSC(IN)
      FSOLS  = FSC(IN)*FF1(EXPM,EX,X,XLAM3,DERFCM,DERFCP,ELAM)*AMSC3
      FSO2LS = 3*FSC(IN)*FF3(EXPM,EX,X,XLAM3,DERFCM,DERFCP,ELAM)*AMSC5/
     /         (X*X)
C
      FCLL1  = FCLL0  - FSC(IN)*VKULL*AMSC(IN)
      FCSS1  = FCSS0  - FSC(IN)*VKUSS*AMSC(IN)
      FCLS1  = FCLS0  - FSC(IN)*VKULS*AMSC(IN)
C
      VCLL  = VCLL   - GSLL*(FCLL0-0.25D0*FAC1*FCLL1)
      VCSS  = VCSS   - GSSS*(FCSS0-0.25D0*FAC2*FCSS1)
      VCLS  = VCLS   - GSLS*(FCLS0-0.25D0*FAC3*FCLS1)
      VCDR  = VCDR   - GSDR*(FCSS0-0.25D0*FAC2*FCSS1)
C
      VSOLL = VSOLL  - 0.5D0*GSLL*FSOLL/(XM1(1)*XM2(1))
      VSOSS = VSOSS  - 0.5D0*GSSS*FSOSS/(XM1(2)*XM2(2))
      VSOLS = VSOLS  - 0.5D0*GSLS*FSOLS/(XM1(3)*XM2(3))
      VSODR = VSODR  - 0.5D0*GSDR*FSOSS/(XM1(2)*XM2(2))
C
      VASOLL = VASOLL  - GSLL*FSOLL*FFAC1/4.D0
      VASOSS = VASOSS  - GSSS*FSOSS*FFAC2/4.D0
      VASOLS = VASOLS  - GSLS*FSOLS*FFAC3/4.D0
      VASODR = VASODR  - GSDR*FSOSS*FFAC2/4.D0
C
      VSO2LL= VSO2LL - GSLL*FSO2LL/(4*XM1(1)*XM2(1))**2
      VSO2SS= VSO2SS - GSSS*FSO2SS/(4*XM1(2)*XM2(2))**2          
      VSO2LS= VSO2LS - GSLS*FSO2LS/(4*XM1(3)*XM2(3))**2    
      VSO2DR= VSO2DR - GSDR*FSO2SS/(4*XM1(2)*XM2(2))**2           
C
C------------------------------------------------------------
C     THRESHOLD-DIFFERENCE MODIFICATION BASE FUNCTIONS:
      IF(IN.NE.5) THEN
      CALL YMKFUN(XA,AMSC(IN),ALAM,SIGN,IDAM*DAMSL,
     .FXC0,FXC1,FXC2,FXTEN,FXTEN1,FXSO,FXSO1)
      FXSO2 = 3*FXTEN/(X*X)
C------------------------------------------------------------
      IF(LC.EQ.1) THEN
      FCSS0 = FSC(IN)*AMSC(IN)*FXC0 
      FCSS1 = FSC(IN)*AMSC(IN)*FXC1 
      FSOSS = FSC(IN)*AMSC3*FXSO              
      FSO2SS= FSC(IN)*AMSC5*FXSO2             
      ENDIF
      IF(LC.NE.1) THEN
      FCLL0 = FSC(IN)*AMSC(IN)*FXC0 
      FCLL1 = FSC(IN)*AMSC(IN)*FXC1 
      FSOLL = FSC(IN)*AMSC3*FXSO              
      FSO2LL= FSC(IN)*AMSC5*FXSO2             
      ENDIF
      FCLS0  = 0.5D0*(FCLS0  + FSC(IN)*AMSC(IN)*FXC0 )     
      FCLS1  = 0.5D0*(FCLS1  + FSC(IN)*AMSC(IN)*FXC1 )     
      FSOLS  = 0.5D0*(FSOLS  + FSC(IN)*AMSC3*FXSO )      
      FSO2LS = 0.5D0*(FSO2LS + FSC(IN)*AMSC5*FXSO2)      
      ENDIF
C------------------------------------------------------------
C
      IF(NLOC.EQ.0) GOTO 104
      FILL  = FILL   + 0.5D0*REDMM*GSLL*FCLL0/(XM1(1)*XM2(1))
      FISS  = FISS   + 0.5D0*REDMM*GSSS*FCSS0/(XM1(2)*XM2(2))
      FILS  = FILS   + 0.5D0*REDMM*GSLS*FCLS0/(XM1(3)*XM2(3))
      FIDR  = FIDR   + 0.5D0*REDMM*GSDR*FCSS0/(XM1(2)*XM2(2))
C
      DFILL=DFILL-0.5*REDMM*GSLL*FSOLL*X/(AMSC(IN)*XM1(1)*XM2(1))
      DFISS=DFISS-0.5*REDMM*GSSS*FSOSS*X/(AMSC(IN)*XM1(2)*XM2(2))
      DFILS=DFILS-0.5*REDMM*GSLS*FSOLS*X/(AMSC(IN)*XM1(3)*XM2(3))
      DFIDR=DFIDR-0.5*REDMM*GSDR*FSOSS*X/(AMSC(IN)*XM1(2)*XM2(2))
C
C     AUGUST 1998 ADDITIONS:
C     BEGIN RETARDATION
      IF(IRET.EQ.1) THEN      
      CALL FFUN(3,XA,AMSC(IN),ALM1,VARFI0,VARFI1,VARFI2,VARFI3)
      VCLL  = VCLL   - GSLL*WKIN1*VARFI0                     
      VCSS  = VCSS   - GSSS*WKIN2*VARFI0
      VCLS  = VCLS   - GSLS*WKIN3*VARFI0
      VCDR  = VCDR   - GSDR*WKIN2*VARFI0
C
      FILL  = FILL   + 0.5D0*GSLL*VARFI0
      FISS  = FISS   + 0.5D0*GSSS*VARFI0
      FILS  = FILS   + 0.5D0*GSLS*VARFI0
      FIDR  = FIDR   + 0.5D0*GSDR*VARFI0
C
      DFILL = DFILL  + 0.5D0*GSLL*VARFI1*PIM
      DFISS = DFISS  + 0.5D0*GSSS*VARFI1*PIM
      DFILS = DFILS  + 0.5D0*GSLS*VARFI1*PIM
      DFIDR = DFIDR  + 0.5D0*GSDR*VARFI1*PIM
      ENDIF
C     END RETARDATION
      
  104 CONTINUE
C
 1040 CONTINUE
C
      RETURN
      END



C**********************************************************************
C
      SUBROUTINE DIFRAC(XA,ICSB,NLOC,LC)       
C
C**********************************************************************
C     VERSION OCTOBER 2004: SU3-SINGLET POMERON + SU3-NONET (A2, F2, FP2, K2)
C**********************************************************************
C
C     "DIFFRACTIVE MESONS" : CALCULATION POTENTIALS ON ISOSPIN BASIS
C
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/MODEL/IMODEL,INRS,ICNSTR,IRET,IDAM,IGERST,IGRTST
      COMMON/ALLDF/AMPOM,AMF2,AMA2,AMKSS,GDA(11)
      COMMON/MASSES/PIM,AM(3),AMY(3),REDM(3),PLAB,AK(3),AKS(3),TEM(3)
      COMMON/DYNMAS/REDMM,AMLN,AMSN,AMH,AMSS,AMLS,AMNN
      COMMON/FRMFAC/ALMOBE,ALMNN,ALMLL,ALMSS,ALMLS,ALMLK,ALMSK
*     COMMON/AMAT/XA(300),A(9,6,300)
      COMMON/POTF/VCLL  ,VCSS  ,VCLS  ,VCDR,
     .            VSIGLL,VSIGSS,VSIGLS,VSIGDR,
     .            VTENLL,VTENSS,VTENLS,VTENDR,
     .            VSOLL ,VSOSS ,VSOLS ,VSODR,
     .            VSO2LL,VSO2SS,VSO2LS,VSO2DR,
     .            VASOLL,VASOSS,VASOLS,VASODR,
     .            VCNN  ,VSIGNN,VTENNN,VSONN ,
     .            FILL  ,FISS  ,FILS  ,FIDR,
     .            DFILL ,DFISS ,DFILS ,DFIDR,
     .            FISLL ,FISSS ,FISLS ,FISDR,
     .            DFISLL,DFISSS,DFISLS,DFISDR,
     .            FITLL ,FITSS ,FITLS ,FITDR,
     .            DFITLL,DFITSS,DFITLS,DFITDR
      COMMON/COUPL/ F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,F11,
     .              G1,G2,G3,G4,G5,G6,G7,G8,G9,G10,G11,
     .              FD1,FD2,FD3,FD4,FD5,FD6,FD7,FD8,FD9,FD10,FD11,
     .              FV1,FV2,FV3,FV4,FV5,FV6,FV7,FV8,FV9,FV10,FV11,
     .              GS1,GS2,GS3,GS4,GS5,GS6,GS7,GS8,GS9,GS10,GS11,
     .              GD1,GD2,GD3,GD4,GD5,GD6,GD7,GD8,GD9,GD10,GD11,P
**    DIMENSION GD(11),AMDF(5),FDC(5),XM1(3),XM2(3)
**    EQUIVALENCE (GD1,GD(1))
      DIMENSION AMDF(5),FDC(5),XM1(3),XM2(3)
      DATA SR3/1.732051D0/,SRPI/1.772454D0/,FMNL/1.D0/
     .     AMPRO/938.2796D0/
C
C   NOTE : POM(IN=1),A2(IN=2),F2(IN=3),POMP(IN=4),K**(IN=5)
C
C   NOTE : INDEX              1    ,    2    ,    3
C          REFERS TO       LN -> LN, SN -> SN, LN -> SN  REACTION
C
C-------------------------------------------------------------------
C   NOTE : FOR 'DIRECT POTENTIALS': INDEX 1,3 -> NUCLEONS !
C                                 : INDEX 2,4 -> HYPERONS !
C-------------------------------------------------------------------
C
C     WRITE(6,*) GD9,GD10,GD11,AMH,AMSS,AM(1),AMLS,AMY(1),AMY(2)
C     WRITE(6,*) ' GDA=',GDA                                              
C
      IF(IRET.EQ.1) THEN
      WKIN1 = PIM**2*AKS(1)/(2*REDM(1))
      WKIN2 = PIM**2*AKS(3)/(2*REDM(3))
      WKIN3 = 0.5D0*(WKIN1+WKIN2)
      ENDIF

      DO 1040 IN=1,5
      IF(IN.EQ.1) THEN
      XM1(1)=AMY(1)
      XM1(2)=AMSS  
      XM1(3)=AMH
      XM2(1)=AM(1)
      XM2(2)=AMNN 
      XM2(3)=AM(1)
      ENDIF
      GOTO(1051,1052,1053,1054,1055),IN
1051  GDLL = GD9*GD10
      GDSS=  GD9*GD11
      GDLS=  0D0
      GDDR=  GD9*GD11
      FDC(1)=1.D0
      AMDF(1)=AMPOM
      GOTO 1056
1052  GDLL = -0.0271D0*ICSB*GDA(1)*GDA(3)
      GDSS=      -2.*GDA(1)*GDA(2)
      GDLS=     -SR3*GDA(1)*GDA(3)
      GDDR=          GDA(1)*GDA(2)
      FDC(2)=1.D0
      AMDF(2)=AMA2
      GOTO 1056
1053  GDLL=  GDA(6)*GDA(7)
      GDSS=  GDA(6)*GDA(8)
      GDLS=  0.D0
      GDDR=  GDA(6)*GDA(8)
      FDC(3)=1.D0
      AMDF(3)=AMPOM
      GOTO 1056
1054  GDLL=  GDA(9)*GDA(10)
      GDSS=  GDA(9)*GDA(11)
      GDLS=  0.D0
      GDDR=  GDA(9)*GDA(11)
      FDC(4)=1.D0
      AMDF(4)=AMF2
      GOTO 1056
1055  GDLL=      GDA(4)*GDA(4)*P
      GDSS=     -GDA(5)*GDA(5)*P
      GDLS= -SR3*GDA(4)*GDA(5)*P
      GDDR=    2*GDA(5)*GDA(5)*P
      XM1(1)=AMLN
      XM1(2)=AMSN
      XM1(3)=AMLN
      XM2(1)=AMLN
      XM2(2)=AMSN
      XM2(3)=AMSN
      FDC(5)=1.D0
      AMDF(5)=AMKSS
C
1056  AMDF2=AMDF(IN)*AMDF(IN)
      FAC1=AMDF2/(XM1(1)*XM2(1))
      FAC2=AMDF2/(XM1(2)*XM2(2))
      FAC3=AMDF2/(XM1(3)*XM2(3))
      FFAC1 = AMDF2*(1.D0/XM1(1)**2-1.D0/XM2(1)**2)
      FFAC2 = AMDF2*(1.D0/XM1(2)**2-1.D0/XM2(2)**2)
      FFAC3 = AMDF2*(1.D0/XM1(3)**2-1.D0/XM2(3)**2)
      FAC12=FAC1*FAC1
      FAC22=FAC2*FAC2
      FAC32=FAC3*FAC3
      FLLDF=4*GDLL*AMDF2/(SRPI*AMPRO**2)
      FSSDF=4*GDSS*AMDF2/(SRPI*AMPRO**2)
      FLSDF=4*GDLS*AMDF2/(SRPI*AMPRO**2)
      FDRDF=4*GDDR*AMDF2/(SRPI*AMPRO**2)
C
*     DO 104 I=2,NMAX
*     X =(AMDF(IN)/PIM)*XA(I)
      X =(AMDF(IN)/PIM)*XA   
      X2=X*X
      VGSSX=AMDF(IN)*FDEXP(-X2)
      FCLL=1.D0+0.5D0*FAC1*(3.D0-2*X2)
      FCSS=1.D0+0.5D0*FAC2*(3.D0-2*X2)
      FCLS=1.D0+0.5D0*FAC3*(3.D0-2*X2)
      FCDR=1.D0+0.5D0*FAC2*(3.D0-2*X2)
C
      VCLL  = VCLL   + FLLDF*FCLL*VGSSX
      VCSS  = VCSS   + FSSDF*FCSS*VGSSX
      VCLS  = VCLS   + FLSDF*FCLS*VGSSX
      VCDR  = VCDR   + FDRDF*FCDR*VGSSX
C
      VSOLL = VSOLL  + FAC1*FLLDF*VGSSX
      VSOSS = VSOSS  + FAC2*FSSDF*VGSSX
      VSOLS = VSOLS  + FAC3*FLSDF*VGSSX
      VSODR = VSODR  + FAC2*FDRDF*VGSSX
C
      VASOLL = VASOLL  + FFAC1*FLLDF*VGSSX/4.D0
      VASOSS = VASOSS  + FFAC2*FSSDF*VGSSX/4.D0
      VASOLS = VASOLS  + FFAC3*FLSDF*VGSSX/4.D0
      VASODR = VASODR  + FFAC2*FDRDF*VGSSX/4.D0
C
      VSO2LL= VSO2LL + FAC12*FLLDF*VGSSX/4
      VSO2SS= VSO2SS + FAC22*FSSDF*VGSSX/4
      VSO2LS= VSO2LS + FAC32*FLSDF*VGSSX/4
      VSO2DR= VSO2DR + FAC22*FDRDF*VGSSX/4
C
      IF(NLOC.EQ.0) GOTO 104
      FILL  = FILL  - 0.5D0*REDMM*FLLDF*VGSSX/(XM1(1)*XM2(1))
      FISS  = FISS  - 0.5D0*REDMM*FSSDF*VGSSX/(XM1(2)*XM2(2))
      FILS  = FILS  - 0.5D0*REDMM*FLSDF*VGSSX/(XM1(3)*XM2(3))
      FIDR  = FIDR  - 0.5D0*REDMM*FDRDF*VGSSX/(XM1(2)*XM2(2))
C
      DFILL = DFILL+ 0.5D0*REDMM*FLLDF*AMDF(IN)*X*VGSSX
     .                     /(AM(1)*AMY(1))
      DFISS = DFISS+ 0.5D0*REDMM*FSSDF*AMDF(IN)*X*VGSSX
     .                     /(AM(1)*AMSS)
      DFILS = DFILS+ 0.5D0*REDMM*FLSDF*AMDF(IN)*X*VGSSX
     .                     /(AM(1)*AMH)
      DFIDR = DFIDR+ 0.5D0*REDMM*FDRDF*AMDF(IN)*X*VGSSX
     .                     /(AM(1)*AMSS)
C
C     AUGUST 1998 ADDITIONS:
C     BEGIN RETARDATION
      IF(IRET.EQ.1) THEN      
      VARFI0 = FDEXP(-X2)
      VARFI1 = -2*X*VARFI0 
      VCLL  = VCLL   + FLLDF*WKIN1*VARFI0                     
      VCSS  = VCSS   + FSSDF*WKIN2*VARFI0
      VCLS  = VCLS   + FLSDF*WKIN3*VARFI0
      VCDR  = VCDR   + FDRDF*WKIN2*VARFI0
C
      FILL  = FILL   - 0.5D0*FLLDF*VARFI0
      FISS  = FISS   - 0.5D0*FSSDF*VARFI0
      FILS  = FILS   - 0.5D0*FLSDF*VARFI0
      FIDR  = FIDR   - 0.5D0*FDRDF*VARFI0
C
      DFILL = DFILL  - 0.5D0*FLLDF*VARFI1*PIM
      DFISS = DFISS  - 0.5D0*FSSDF*VARFI1*PIM
      DFILS = DFILS  - 0.5D0*FLSDF*VARFI1*PIM
      DFIDR = DFIDR  - 0.5D0*FDRDF*VARFI1*PIM
      ENDIF
C     END RETARDATION
C
  104 CONTINUE
C
 1040 CONTINUE
C
      RETURN
      END
C**********************************************************************
      SUBROUTINE AXIAL1(XA,NLOC,ICSB,LC,P)
C     SUBROUTINE AXIAL1(NMAX,NLOC,ICSB,P)
C**********************************************************************
C
C     AXIAL MESONS : CALCULATION POTENTIALS ON ISOSPIN BASIS
C
C     IN MOMENTUM SPACE AXIAL-EXCHANGE:                         
C
C     FIRST TERM PROPAGATOR:
C     V_A^(1) = -GA2*[[(1+(Q2+K2/4)/(6M'M)](SIGMA1.SIGMA2)+
C                     +(2/M'M)[(SIGMA1.Q)(SIGMA2.Q)-Q2(SIGMA1.SIGMA2)/3]
C                     -(1/4M'M)[(SIGMA1.K)(SIGMA2.K)-K2(SIGMA1.SIGMA2)/3]
C                     +(i/4M'M)(SIGMA1+SIGMA2).QXK ]]/(K2+MA2)
C
C     APPROXIMATION: FROM Q-TENSOR TERM: ONLY LOCAL CONTRIBUTION KEPT!
C                    ------------------------------------------------
C
C   NOTE : A1(1270)(IN=1),D=F1(1285)(IN=2),E=F1(1420)(IN=3)
C
C   ONLY PSEUDO-VECTOR COUPLING INCLUDED !
C
C   PROPAGATOR OPTIONS: A) PROCA,IBFLD=0, B) B-FIELD FORMALISM, IBFLD=1
C**********************************************************************
C
C   THE POTENTIAL FUNCTIONS
C
      IMPLICIT REAL *8(A-H,O-Z)
      COMMON/MODEL/IMODEL,INRS,ICNSTR,IRET,IDAM,IGERST,IGRTST         
      COMMON/ZEROS/IZPS,IZVC,IZSC,IZAX,IZTEN
      COMMON/ALLAX/FA(11),FB(11),ALMAX
      COMMON/MASSES/ PIM,AM(3),AMY(3),REDM(3),PLAB,AK(3),AKS(3),TEM(3)
      COMMON/DYNMAS/REDMM,AMLN,AMSN,AMH,AMSS,AMLS,AMNN
      COMMON/FORMF/ALAMH,ALMP8,ALMV8,ALMS8,ALMP1,ALMV1,ALMS1,
     .             ALMKA,ALMKS,ALMKP
      COMMON/FRMFAC/ALMOBE,ALMNN,ALMLL,ALMSS,ALMLS,ALMLK,ALMSK
*     COMMON/AMAT/XA(300),A(9,6,300)
      COMMON/POTF/VCLL  ,VCSS  ,VCLS  ,VCDR,
     .            VSIGLL,VSIGSS,VSIGLS,VSIGDR,
     .            VTENLL,VTENSS,VTENLS,VTENDR,
     .            VSOLL ,VSOSS ,VSOLS ,VSODR,
     .            VSO2LL,VSO2SS,VSO2LS,VSO2DR,
     .            VASOLL,VASOSS,VASOLS,VASODR,
     .            VCNN  ,VSIGNN,VTENNN,VSONN ,
     .            FILL  ,FISS  ,FILS  ,FIDR,
     .            DFILL ,DFISS ,DFILS ,DFIDR,
     .            FISLL ,FISSS ,FISLS ,FISDR,
     .            DFISLL,DFISSS,DFISLS,DFISDR,
     .            FITLL ,FITSS ,FITLS ,FITDR,
     .            DFITLL,DFITSS,DFITLS,DFITDR
      DIMENSION AMAX(4),XM1(3),XM2(3)
      DATA SR3/1.732051D0/,SRPI/1.772454D0/
      DATA AMA1,AMD1,AME1,AMK1/1270.D0,1285.D0,1420.D0,1273.D0/
      DATA IBFLD/0/,ICALL/0/,FZERO/0.D0/,AMCRA/750.D0/

      FF0(ERATH,EXH,XH,EM,EP)=ERATH*(EM/EXH-EXH*EP)/(2.0D00*XH)
      FF1(ERATH,EXH,XH,XLAMH,EM,EP,EXLAM)=ERATH*(EM/EXH
     . *(1.D00+XH)-EXH*EP*(1.D00-XH)-4.D00*XLAMH*EXLAM/ERATH/SRPI)
     .  /(2.D00*XH*XH*XH)
      FF3(ERATH,EXH,XH,XLAMH,EM,EP,EXLAM)=ERATH*(EM/EXH
     .  *(1.D00+XH+XH*XH/3.D00)-EXH*EP*(1.D00-XH+XH*XH/3.D00)
     .  -8.D00*XLAMH*(0.5D00+XLAMH*XLAMH/3.D00)*EXLAM/ERATH/
     .  1.7724538509D0)/(2.D00*XH*XH*XH)
C
      IF(ICALL.EQ.0) THEN
      WRITE(*,*) ' AXIAL.02: IBFLD=',IBFLD
      ICALL=1
      ENDIF
C
      DIV1 =1.D0/(AM(1)*AMY(1))
      DIV2 =1.D0/(AM(1)*AMY(2))
      DIV3 =1.D0/(AM(1)*AMH   )
      DO 1040 IN=1,4
      IF(IN.EQ.1) THEN
      XM1(1)=AMY(1)
      XM1(2)=AMSS  
      XM1(3)=AMH
      XM2(1)=AM(1)
      XM2(2)=AMNN 
      XM2(3)=AM(1)
      ENDIF
      GOTO(1051,1052,1053,1054),IN
1051  GALL= 0.D0   
      GASS= -2*FA(1)*FA(2)
      GALS= -SR3*FA(1)*FA(3)
      GADR= FA(1)*FA(2)
      AMAX(1)=AMA1
      GOTO 1055
1052  GALL=  FA(6)*FA(7)
      GASS=  FA(6)*FA(8)  
      GALS=  0.D0
      GADR=  FA(6)*FA(8)  
      AMAX(2)=AME1
      GOTO 1055
1053  GALL=  FA(9)*FA(10)
      GASS=  FA(9)*FA(11)
      GALS=  0.D0
      GADR=  FA(9)*FA(11)
      AMAX(3)=AMD1
      GOTO 1055
1054  GALL=  FA(4)*FA(4)*P
      GASS= -FA(5)*FA(5)*P
      GALS= -SR3*FA(4)*FA(5)*P
      GADR= 2*FA(5)*FA(5)*P
      AMAX(4)=AMK1
      XM1(1)=AMLN
      XM1(2)=AMSN
      XM1(3)=AMLN
      XM2(1)=AMLN
      XM2(2)=AMSN
      XM2(3)=AMSN
C
1055  IF(IMODEL.LE.3) ALAM=ALMOBE
      IF(IMODEL.GE.4) THEN      
      ALAM = ALMAX
      IF(ALAM.EQ.0.D0) ALAM=ALMP8
      IF(IN.EQ.2.AND.ALAM.EQ.0.D0) ALAM=ALMP1
      IF(IN.EQ.4.AND.ALAM.EQ.0.D0) ALAM=ALMKA
      ENDIF

      ALM1=ALAM
      ALM2=ALAM
      ALM3=ALAM
      AMAX2=AMAX(IN)*AMAX(IN)
      RATM1=AMAX(IN)/ALM1
      RATM2=AMAX(IN)/ALM2
      RATM3=AMAX(IN)/ALM3
      FAC1 =AMAX(IN)**2/(AM(1)*AMY(1))
      FAC2 =AMAX(IN)**2/(AM(1)*AMY(2))
      FAC3 =AMAX(IN)**2/(AM(1)*AMH   )
      FFAC1 = AMAX2*(1.D0/XM1(1)**2-1.D0/XM2(1)**2)
      FFAC2 = AMAX2*(1.D0/XM1(2)**2-1.D0/XM2(2)**2)
      FFAC3 = AMAX2*(1.D0/XM1(3)**2-1.D0/XM2(3)**2)

      IF(IZAX.NE.0) FZERO = (AMAX(IN)/AMCRA)**2
C
C     DO 104 I=2,NMAX
      XLAM1=0.5D0*XA*ALM1/PIM
      XLAM2=0.5D0*XA*ALM2/PIM
      XLAM3=0.5D0*XA*ALM3/PIM
      X =(AMAX(IN)/PIM)*XA
      EX=FDEXP(X)
      VKULL=(ALM1/AMAX(IN))**3*FDEXP(-XLAM1*XLAM1)/(2.D0*SRPI)
      VKUSS=(ALM2/AMAX(IN))**3*FDEXP(-XLAM2*XLAM2)/(2.D0*SRPI)
      VKULS=(ALM3/AMAX(IN))**3*FDEXP(-XLAM3*XLAM3)/(2.D0*SRPI)
C
      EXPM=DEXP(RATM1*RATM1)
      ELAM=FDEXP(-XLAM1*XLAM1)
      DERFCM=FDERFC(-XLAM1+RATM1)
      DERFCP=FDERFC( XLAM1+RATM1)
      FCLL0  = FF0(EXPM,EX,X,DERFCM,DERFCP)*AMAX(IN)
      FTLL0  = FF3(EXPM,EX,X,XLAM1,DERFCM,DERFCP,ELAM)*AMAX(IN)
      FSOLL0 = FF1(EXPM,EX,X,XLAM1,DERFCM,DERFCP,ELAM)*AMAX(IN)
      FCLL1  = FCLL0  - VKULL*AMAX(IN)
      DFCLL0 = -XA*(AMAX(IN)/PIM)**2*FSOLL0
      DFCLL1 =  DFCLL0 + ALM1*XLAM1*VKULL*AMAX(IN)/PIM
      DFTLL0 =  DFCLL1/3.D0-3*FTLL0/X
C
      EXPM=DEXP(RATM2*RATM2)
      ELAM=FDEXP(-XLAM2*XLAM2)
      DERFCM=FDERFC(-XLAM2+RATM2)
      DERFCP=FDERFC( XLAM2+RATM2)
      FCSS0  = FF0(EXPM,EX,X,DERFCM,DERFCP)*AMAX(IN)
      FTSS0  = FF3(EXPM,EX,X,XLAM2,DERFCM,DERFCP,ELAM)*AMAX(IN)
      FSOSS0 = FF1(EXPM,EX,X,XLAM2,DERFCM,DERFCP,ELAM)*AMAX(IN)
      FCSS1  = FCSS0  - VKUSS*AMAX(IN)
      DFCSS0 = -XA*(AMAX(IN)/PIM)**2*FSOSS0
      DFCSS1 =  DFCSS0 + ALM2*XLAM2*VKUSS*AMAX(IN)/PIM
      DFTSS0 =  DFCSS1/3.D0-3*FTSS0/X
C
      EXPM=DEXP(RATM3*RATM3)
      ELAM=FDEXP(-XLAM3*XLAM3)
      DERFCM=FDERFC(-XLAM3+RATM3)
      DERFCP=FDERFC( XLAM3+RATM3)
      FCLS0  = FF0(EXPM,EX,X,DERFCM,DERFCP)*AMAX(IN)
      FTLS0  = FF3(EXPM,EX,X,XLAM3,DERFCM,DERFCP,ELAM)*AMAX(IN)
      FSOLS0 = FF1(EXPM,EX,X,XLAM3,DERFCM,DERFCP,ELAM)*AMAX(IN)
      FCLS1  = FCLS0  - VKULS*AMAX(IN)
      DFCLS0 = -XA*(AMAX(IN)/PIM)**2*FSOLS0
      DFCLS1 =  DFCLS0 + ALM3*XLAM3*VKULS*AMAX(IN)/PIM
      DFTLS0 =  DFCLS1/3.D0-3*FTLS0/X

      IF(IZAX.NE.0) THEN
      FCLL2  = FCLL1 + (1.5D0-XLAM1*XLAM1)
     .               * VKULL*AMAX(IN)/RATM1/RATM1
      DFCLL2 = DFCLL1 -ALM1*XLAM1*(2.5D0-XLAM1*XLAM1)
     .               * VKULL*AMAX(IN)/RATM1/RATM1
      FTLL1  = FTLL0 - XLAM1*XLAM1*VKULL*AMAX(IN)/(3*RATM1*RATM1)
      DFTLL1 = DFTLL0- ALM1*XLAM1*(1D0-XLAM1*XLAM1)
     .               * VKULL*AMAX(IN)/(3*RATM1*RATM1)
      FSOLL1 = FSOLL0 - 0.5D0*(ALM1/AMAX(IN))**2*VKULL*AMAX(IN)

      FCSS2  = FCSS1 + (1.5D0-XLAM2*XLAM2)
     .               * VKUSS*AMAX(IN)/RATM2/RATM2
      DFCSS2 = DFCSS1 -ALM2*XLAM2*(2.5D0-XLAM2*XLAM2)
     .               * VKUSS*AMAX(IN)/RATM2/RATM2
      FTSS1  = FTSS0 - XLAM2*XLAM2*VKUSS*AMAX(IN)/(3*RATM2*RATM2)
      DFTSS1 = DFTSS0- ALM2*XLAM2*(1D0-XLAM2*XLAM2)
     .               * VKUSS*AMAX(IN)/(3*RATM2*RATM2)
      FSOSS1 = FSOSS0 - 0.5D0*(ALM2/AMAX(IN))**2*VKUSS*AMAX(IN)

      FCLS2  = FCLS1 + (1.5D0-XLAM3*XLAM3)
     .               * VKULS*AMAX(IN)/RATM3/RATM3
      DFCLS2 = DFCLS1 -ALM3*XLAM3*(2.5D0-XLAM3*XLAM3)
     .               * VKULS*AMAX(IN)/RATM3/RATM3
      FTLS1  = FTLS0 - XLAM3*XLAM3*VKUSS*AMAX(IN)/(3*RATM3*RATM3)
      DFTLS1 = DFTLS0- ALM3*XLAM3*(1D0-XLAM3*XLAM3)
     .               * VKULS*AMAX(IN)/(3*RATM3*RATM3)
      FSOLS1 = FSOLS0 - 0.5D0*(ALM3/AMAX(IN))**2*VKULS*AMAX(IN)
      
C*    neglecting k^4-terms:
      fcll2 = 0d0
      fcss2 = 0d0
      fcls2 = 0d0
      dfcll2 = 0d0
      dfcss2 = 0d0
      dfcls2 = 0d0
      ENDIF
C---------------------------------------------------------------
C
C     FIRST TERM AXIAL PROPAGATOR:
C
C---------------------------------------------------------------
      VSIGLL = VSIGLL - GALL*FCLL0 
      VSIGSS = VSIGSS - GASS*FCSS0 
      VSIGLS = VSIGLS - GALS*FCLS0 
      VSIGDR = VSIGDR - GADR*FCSS0 

      VTENLL = VTENLL - 0.75D0*GALL*FAC1 *FTLL0
      VTENSS = VTENSS - 0.75D0*GASS*FAC2 *FTSS0
      VTENLS = VTENLS - 0.75D0*GALS*FAC3 *FTLS0
      VTENDR = VTENDR - 0.75D0*GADR*FAC2 *FTSS0

      VSOLL  = VSOLL  - 0.5D0*GALL*FAC1 *FSOLL0
      VSOSS  = VSOSS  - 0.5D0*GASS*FAC2 *FSOSS0
      VSOLS  = VSOLS  - 0.5D0*GALS*FAC3 *FSOLS0
      VSODR  = VSODR  - 0.5D0*GADR*FAC2 *FSOSS0
 
      VASOLL = VASOLL + 0.25D0*GALL*FSOLL0*FFAC1
      VASOSS = VASOSS + 0.25D0*GASS*FSOSS0*FFAC2
      VASOLS = VASOLS + 0.25D0*GALS*FSOLS0*FFAC3
      VASODR = VASODR + 0.25D0*GADR*FSOSS0*FFAC2

      FISLL  = FISLL  - GALL*FCLL0*DIV1*REDM(1)/6.D0
      FISSS  = FISSS  - GASS*FCSS0*DIV2*REDM(2)/6.D0
      FISLS  = FISLS  - GALS*FCLS0*DIV3*REDM(3)/6.D0
      FISDR  = FISDR  - GADR*FCSS0*DIV2*REDM(2)/6.D0

      DFISLL = DFISLL - GALL*DFCLL0*DIV1*REDM(1)/6.D0
      DFISSS = DFISSS - GASS*DFCSS0*DIV2*REDM(2)/6.D0
      DFISLS = DFISLS - GALS*DFCLS0*DIV3*REDM(3)/6.D0
      DFISDR = DFISDR - GADR*DFCSS0*DIV2*REDM(2)/6.D0

      IF(IZAX.NE.0) THEN
      VSIGLL = VSIGLL - FZERO*GALL*(FCLL1 + 2*FAC1*FCLL2/3D0)
      VSIGSS = VSIGSS - FZERO*GASS*(FCSS1 + 2*FAC2*FCSS2/3D0)
      VSIGLS = VSIGLS - FZERO*GALS*(FCLS1 + 2*FAC3*FCLS2/3D0)
      VSIGDR = VSIGDR - FZERO*GADR*(FCSS1 + 2*FAC2*FCSS2/3D0)

      VTENLL = VTENLL + 0.25D0*FZERO*GALL*FAC1 *FTLL1
      VTENSS = VTENSS + 0.25D0*FZERO*GASS*FAC2 *FTSS1
      VTENLS = VTENLS + 0.25D0*FZERO*GALS*FAC3 *FTLS1
      VTENDR = VTENDR + 0.25D0*FZERO*GADR*FAC2 *FTSS1

      VSOLL  = VSOLL  - 0.5D0*FZERO*GALL*FAC1 *FSOLL1
      VSOSS  = VSOSS  - 0.5D0*FZERO*GASS*FAC2 *FSOSS1
      VSOLS  = VSOLS  - 0.5D0*FZERO*GALS*FAC3 *FSOLS1
      VSODR  = VSODR  - 0.5D0*FZERO*GADR*FAC2 *FSOSS1

      FISLL  = FISLL  - FZERO*3*GALL*FCLL1*DIV1*REDM(1)/2.D0
      FISSS  = FISSS  - FZERO*3*GASS*FCSS1*DIV2*REDM(2)/2.D0
      FISLS  = FISLS  - FZERO*3*GALS*FCLS1*DIV3*REDM(3)/2.D0
      FISDR  = FISDR  - FZERO*3*GADR*FCSS1*DIV2*REDM(2)/2.D0

      DFISLL = DFISLL - FZERO*3*GALL*DFCLL1*DIV1*REDM(1)/2.D0
      DFISSS = DFISSS - FZERO*3*GASS*DFCSS1*DIV2*REDM(2)/2.D0
      DFISLS = DFISLS - FZERO*3*GALS*DFCLS1*DIV3*REDM(3)/2.D0
      DFISDR = DFISDR - FZERO*3*GADR*DFCSS1*DIV2*REDM(2)/2.D0
      ENDIF
C---------------------------------------------------------------
C
C     SECOND TERM AXIAL PROPAGATOR:
C
C---------------------------------------------------------------
      IF(IBFLD.EQ.0) THEN
C---------------------------------------------------------------
      VSIGLL = VSIGLL + GALL*FCLL1/3
      VSIGSS = VSIGSS + GASS*FCSS1/3
      VSIGLS = VSIGLS + GALS*FCLS1/3
      VSIGDR = VSIGDR + GADR*FCSS1/3

      VTENLL = VTENLL + GALL*FTLL0
      VTENSS = VTENSS + GASS*FTSS0
      VTENLS = VTENLS + GALS*FTLS0
      VTENDR = VTENDR + GADR*FTSS0

      FISLL  = FISLL  - GALL*REDM(1)*FCLL1*DIV1/6.D0
      FISSS  = FISSS  - GASS*REDM(2)*FCSS1*DIV2/6.D0
      FISLS  = FISLS  - GALS*REDM(3)*FCLS1*DIV3/6.D0
      FISDR  = FISDR  - GADR*REDM(2)*FCSS1*DIV2/6.D0

      DFISLL = DFISLL - GALL*REDM(1)*DFCLL1*DIV1/6.D0
      DFISSS = DFISSS - GASS*REDM(2)*DFCSS1*DIV2/6.D0
      DFISLS = DFISLS - GALS*REDM(3)*DFCLS1*DIV3/6.D0
      DFISDR = DFISDR - GADR*REDM(2)*DFCSS1*DIV2/6.D0

*     FITEN     = FITEN  - GAX2*REDM*FT0 *DIV/2.D0
*     DFITEN    = DFITEN - GAX2*REDM*DFT0*DIV/2.D0

      IF(IZAX.NE.0) THEN
      VSIGLL = VSIGLL + FZERO*GALL*FCLL2/3D0
      VSIGSS = VSIGSS + FZERO*GASS*FCSS2/3D0
      VSIGLS = VSIGLS + FZERO*GALS*FCLS2/3D0
      VSIGDR = VSIGDR + FZERO*GADR*FCSS2/3D0

      VTENLL = VTENLL + FZERO*GALL*FTLL1
      VTENSS = VTENSS + FZERO*GASS*FTSS1
      VTENLS = VTENLS + FZERO*GALS*FTLS1
      VTENDR = VTENDR + FZERO*GADR*FTSS1

      FISLL  = FISLL  - FZERO*GALL*REDM(1)*FCLL2*DIV1/6.D0
      FISSS  = FISSS  - FZERO*GASS*REDM(2)*FCSS2*DIV2/6.D0
      FISLS  = FISLS  - FZERO*GALS*REDM(3)*FCLS2*DIV3/6.D0
      FISDR  = FISDR  - FZERO*GADR*REDM(2)*FCSS2*DIV2/6.D0

      DFISLL = DFISLL - FZERO*GALL*REDM(1)*DFCLL2*DIV1/6.D0
      DFISSS = DFISSS - FZERO*GASS*REDM(2)*DFCSS2*DIV2/6.D0
      DFISLS = DFISLS - FZERO*GALS*REDM(3)*DFCLS2*DIV3/6.D0
      DFISDR = DFISDR - FZERO*GADR*REDM(2)*DFCSS2*DIV2/6.D0
      ENDIF
      ENDIF
C---------------------------------------------------------------
      IF(IBFLD.EQ.1) THEN
      write(*,*)'warning:in axial.02: ibfld=1: not yet implemented'
      return
      ENDIF
C---------------------------------------------------------------
C
C     GAUSSIAN CONTRIBUTION (ANN.PHYS. 208, EQN. (7.16)):
C
C---------------------------------------------------------------
c     UPSC0 =   VKULL*AMAX(IN)
c     UPSC1 =  -(1.5D0-XLAM1**2)*UPSC0
c     UPST0 =  + XLAM1**2*UPSC0/3.D0
c     DUPSC0=  -ALM1*XLAM1*UPSC0/PIM
c     FIC1 = -VKULL*AMAX(IN)
c     DFIC1= -ALM1*XLAM1*FIC1/PIM

c     VSIGLL(I) = VSIGLL(I) + 5*GALL*UPSC1*ALM1**2*DIV1/12.D0
c     VTENLL(I) = VTENLL(I) - GALL*UPST0*ALM1**2*DIV1/4.D0
c     FISLL(I)  = FISLL(I)  - GALL*REDM(1)*(UPSC0-FIC1/3.D0)*DIV1
c     DFISLL(I) = DFISLL(I) - GALL*REDM(1)*(DUPSC0-DFIC1/3.D0)*DIV1
C
c     UPSC0 =   VKULS*AMAX(IN)
c     UPSC1 =  -(1.5D0-XLAM3**2)*UPSC0
c     UPST0 =  + XLAM3**2*UPSC0/3.D0
c     DUPSC0=  -ALM3*XLAM3*UPSC0/PIM
c     FIC1 = -VKULS*AMAX(IN)
c     DFIC1= -ALM3*XLAM3*FIC1/PIM

c     VSIGLS(I) = VSIGLS(I) + 5*GALS*UPSC1*ALM3**2*DIV3/12.D0
c     VTENLS(I) = VTENLS(I) - GALS*UPST0*ALM3**2*DIV3/4.D0
c     FISLS(I)  = FISLS(I)  - GALS*REDM(3)*(UPSC0-FIC1/3.D0)*DIV3
c     DFISLS(I) = DFISLS(I) - GALS*REDM(3)*(DUPSC0-DFIC1/3.D0)*DIV3
C
c     UPSC0 =   VKUSS*AMAX(IN)
c     UPSC1 =  -(1.5D0-XLAM2**2)*UPSC0
c     UPST0 =  + XLAM2**2*UPSC0/3.D0
c     DUPSC0=  -ALM2*XLAM2*UPSC0/PIM
c     FIC1 = -VKUSS*AMAX(IN)
c     DFIC1= -ALM2*XLAM2*FIC1/PIM

c     VSIGSS(I) = VSIGSS(I) + 5*GASS*UPSC1*ALM2**2*DIV2/12.D0
c     VTENSS(I) = VTENSS(I) - GASS*UPST0*ALM2**2*DIV2/4.D0
c     FISSS(I)  = FISSS(I)  - GASS*REDM(2)*(UPSC0-FIC1/3.D0)*DIV2
c     DFISSS(I) = DFISSS(I) - GASS*REDM(2)*(DUPSC0-DFIC1/3.D0)*DIV2

c     VSIGDR(I) = VSIGDR(I) + 5*GADR*UPSC1*ALM2**2*DIV2/12.D0
c     VTENDR(I) = VTENDR(I) - GADR*UPST0*ALM2**2*DIV2/4.D0
c     FISDR(I)  = FISDR(I)  - GADR*REDM(2)*(UPSC0-FIC1/3.D0)*DIV2
c     DFISDR(I) = DFISDR(I) - GADR*REDM(2)*(DUPSC0-DFIC1/3.D0)*DIV2

  104 CONTINUE
 1040 CONTINUE
*     fiss = 0.d0
*     dfiss=0.d0
*     fiten=0.d0
*     dfiten=0.d0
C
      RETURN
      END
C**********************************************************************
C
      SUBROUTINE AXIALU1(XA,NLOC,ICSB,LC,P)
C
C**********************************************************************
C
C     AXIAL MESONS (UNNATURAL PARITY) POTENTIALS ON ISOSPIN BASIS
C
      IMPLICIT REAL *8(A-H,O-Z)
      COMMON/MODEL/IMODEL,INRS,ICNSTR,IRET,IDAM,IGERST,IGRTST
      COMMON/ALLAX/FA(11),FB(11),ALMAX
      COMMON/MASSES/ PIM,AM(3),AMY(3),REDM(3),PLAB,AK(3),AKS(3),TEM(3)
      COMMON/DYNMAS/REDMM,AMLN,AMSN,AMH,AMSS,AMLS,AMNN
      COMMON/FORMF/ALAMH,ALMP8,ALMV8,ALMS8,ALMP1,ALMV1,ALMS1,
     .             ALMKA,ALMKS,ALMKP
      COMMON/FRMFAC/ALMOBE,ALMNN,ALMLL,ALMSS,ALMLS,ALMLK,ALMSK
*     COMMON/AMAT/XA(300),A(9,6,300)
      COMMON/POTF/VCLL  ,VCSS  ,VCLS  ,VCDR,
     .            VSIGLL,VSIGSS,VSIGLS,VSIGDR,
     .            VTENLL,VTENSS,VTENLS,VTENDR,
     .            VSOLL ,VSOSS ,VSOLS ,VSODR,
     .            VSO2LL,VSO2SS,VSO2LS,VSO2DR,
     .            VASOLL,VASOSS,VASOLS,VASODR,
     .            VCNN  ,VSIGNN,VTENNN,VSONN ,
     .            FILL  ,FISS  ,FILS  ,FIDR,
     .            DFILL ,DFISS ,DFILS ,DFIDR,
     .            FISLL ,FISSS ,FISLS ,FISDR,
     .            DFISLL,DFISSS,DFISLS,DFISDR,
     .            FITLL ,FITSS ,FITLS ,FITDR,
     .            DFITLL,DFITSS,DFITLS,DFITDR
      DIMENSION AMAX(4)
      DATA SR3/1.732051D0/,SRPI/1.7724538509D0/,IPV/1/
      DATA AMB1,AMH1,AMH2,AMK1/1235.D0,1170.D0,1380.D0,1273.D0/
C
C   NOTE : B1(IN=1),H11 (IN=2),H11'(IN=3),K1B(IN=4)
C
C   THE POTENTIAL FUNCTIONS
C
      FF0(ERATH,EXH,XH,EM,EP)=ERATH*(EM/EXH-EXH*EP)/(2.0D00*XH)
      FF1(ERATH,EXH,XH,XLAMH,EM,EP,EXLAM)=ERATH*(EM/EXH
     . *(1.D00+XH)-EXH*EP*(1.D00-XH)-4.D00*XLAMH*EXLAM/ERATH/SRPI)
     .  /(2.D00*XH*XH*XH)
      FF3(ERATH,EXH,XH,XLAMH,EM,EP,EXLAM)=ERATH*(EM/EXH
     .  *(1.D00+XH+XH*XH/3.D00)-EXH*EP*(1.D00-XH+XH*XH/3.D00)
     .  -8.D00*XLAMH*(0.5D00+XLAMH*XLAMH/3.D00)*EXLAM/ERATH/
     .  1.7724538509D0)/(2.D00*XH*XH*XH)
C
      DIV1 =1.D0/(AM(1)*AMY(1))
      DIV2 =1.D0/(AM(1)*AMY(2))
      DIV3 =1.D0/(AM(1)*AMH   )
      DO 1040 IN=1,4
      GOTO(1051,1052,1053,1054),IN
1051  GALL= 0.D0   
      GASS= -2*FB(1)*FB(2)
      GALS= -SR3*FB(1)*FB(3)
      GADR= FB(1)*FB(2)
      AMAX(1)=AMB1
      GOTO 1055
1052  GALL=  FB(6)*FB(7)
      GASS=  FB(6)*FB(8)  
      GALS=  0.D0
      GADR=  FB(6)*FB(8)  
      AMAX(2)=AMH1
      GOTO 1055
1053  GALL=  FB(9)*FB(10)
      GASS=  FB(9)*FB(11)
      GALS=  0.D0
      GADR=  FB(9)*FB(11)
      AMAX(3)=AMH2
      GOTO 1055
1054  GALL=  FB(4)*FB(4)*P
      GASS= -FB(5)*FB(5)*P
      GALS= -SR3*FB(4)*FB(5)*P
      GADR= 2*FB(5)*FB(5)*P
      AMAX(4)=AMK1
C
1055  IF(IMODEL.LE.3) ALAM=ALMOBE
      IF(IMODEL.GE.4) THEN      
      ALAM = ALMP8
      IF(IN.EQ.2) ALAM=ALMP1
      IF(IN.EQ.4) ALAM=ALMKA
      ENDIF
C
      ALM1 = ALAM
      ALM2 = ALAM
      ALM3 = ALAM
      RATM1=AMAX(IN)/ALM1
      RATM2=AMAX(IN)/ALM2
      RATM3=AMAX(IN)/ALM3
      FAC1=AMAX(IN)**2/(4*AM(1)*AMY(1))
      FAC2=AMAX(IN)**2/(4*AM(1)*AMY(2))
      FAC3=AMAX(IN)**2/(4*AM(1)*AMH   )
C
C     DO 104 I=2,NMAX
      X = XA
      XLAM1=0.5D0*X*ALM1/PIM
      XLAM2=0.5D0*X*ALM2/PIM
      XLAM3=0.5D0*X*ALM3/PIM
      X =(AMAX(IN)/PIM)*X
      EX=FDEXP(X)
      VKULL=(ALM1/AMAX(IN))**3*FDEXP(-XLAM1*XLAM1)/(2.D0*SRPI)
      VKUSS=(ALM2/AMAX(IN))**3*FDEXP(-XLAM2*XLAM2)/(2.D0*SRPI)
      VKULS=(ALM3/AMAX(IN))**3*FDEXP(-XLAM3*XLAM3)/(2.D0*SRPI)
C
      EXPM=DEXP(RATM1*RATM1)
      ELAM=FDEXP(-XLAM1*XLAM1)
      DERFCM=FDERFC(-XLAM1+RATM1)
      DERFCP=FDERFC( XLAM1+RATM1)
      FCLL0  = FF0(EXPM,EX,X,DERFCM,DERFCP)*AMAX(IN)
      FTLL0  = FF3(EXPM,EX,X,XLAM1,DERFCM,DERFCP,ELAM)*AMAX(IN)
      FSOLL0 = FF1(EXPM,EX,X,XLAM1,DERFCM,DERFCP,ELAM)*AMAX(IN)
      FCLL1  = FCLL0  - VKULL*AMAX(IN)
      DFCLL0 = -X*FSOLL0
      DFCLL1 =  DFCLL0 + ALM1*XLAM1*VKULL
      DFTLL0 =  DFCLL1/3.D0-3*FTLL0/X
C
      EXPM=DEXP(RATM2*RATM2)
      ELAM=FDEXP(-XLAM2*XLAM2)
      DERFCM=FDERFC(-XLAM2+RATM2)
      DERFCP=FDERFC( XLAM2+RATM2)
      FCSS0  = FF0(EXPM,EX,X,DERFCM,DERFCP)*AMAX(IN)
      FTSS0  = FF3(EXPM,EX,X,XLAM2,DERFCM,DERFCP,ELAM)*AMAX(IN)
      FSOSS0 = FF1(EXPM,EX,X,XLAM2,DERFCM,DERFCP,ELAM)*AMAX(IN)
      FCSS1  = FCSS0  - VKUSS*AMAX(IN)
      DFCSS0 = -X*FSOSS0
      DFCSS1 =  DFCSS0 + ALM2*XLAM2*VKUSS
      DFTSS0 =  DFCSS1/3.D0-3*FTSS0/X
C
      EXPM=DEXP(RATM3*RATM3)
      ELAM=FDEXP(-XLAM3*XLAM3)
      DERFCM=FDERFC(-XLAM3+RATM3)
      DERFCP=FDERFC( XLAM3+RATM3)
      FCLS0  = FF0(EXPM,EX,X,DERFCM,DERFCP)*AMAX(IN)
      FTLS0  = FF3(EXPM,EX,X,XLAM3,DERFCM,DERFCP,ELAM)*AMAX(IN)
      FSOLS0 = FF1(EXPM,EX,X,XLAM3,DERFCM,DERFCP,ELAM)*AMAX(IN)
      FCLS1  = FCLS0  - VKULS*AMAX(IN)
      DFCLS0 = -X*FSOLS0
      DFCLS1 =  DFCLS0 + ALM3*XLAM3*VKULS
      DFTLS0 =  DFCLS1/3.D0-3*FTLS0/X
C
1041   VSIGLL  = VSIGLL - GALL*FAC1*FCLL1/3.D0
       VSIGSS  = VSIGSS - GASS*FAC2*FCSS1/3.D0
       VSIGLS  = VSIGLS - GALS*FAC3*FCLS1/3.D0
       VSIGDR  = VSIGDR - GADR*FAC2*FCSS1/3.D0

       VTENLL  = VTENLL - GALL*FAC1*FTLL0
       VTENSS  = VTENSS - GASS*FAC2*FTSS0
       VTENLS  = VTENLS - GALS*FAC3*FTLS0
       VTENDR  = VTENDR - GADR*FAC2*FTSS0

      IF(NLOC.EQ.0) GO TO 104
       FISLL   = FISLL + GALL*FAC1*REDMM*FCLL1 *DIV1/6.D0
       FISSS   = FISSS + GASS*FAC2*REDMM*FCSS1 *DIV2/6.D0
       FISLS   = FISLS + GALS*FAC3*REDMM*FCLS1 *DIV3/6.D0
       FISDR   = FISDR + GADR*FAC2*REDMM*FCSS1 *DIV2/6.D0

       DFISLL  = DFISLL+ GALL*FAC1*REDMM*DFCLL1*DIV1/6.D0
       DFISSS  = DFISSS+ GASS*FAC2*REDMM*DFCSS1*DIV2/6.D0
       DFISLS  = DFISLS+ GALS*FAC3*REDMM*DFCLS1*DIV3/6.D0
       DFISDR  = DFISDR+ GADR*FAC2*REDMM*DFCSS1*DIV2/6.D0

*      FITLL   = FITLL + GALL*FAC1*REDMM*FTLL0 *DIV1/2.D0
*      DFITLL  = DFITLL+ GALL*FAC1*REDMM*DFTLL0*DIV1/2.D0
C
  104 CONTINUE
C
 1040 CONTINUE
C
      RETURN
      END

C *********************************************************************
C
      SUBROUTINE PSSCAL02(XA,ICSB,NLOC,LC) 
C
C**********************************************************************
C  updated august 2002, from PSSCAL98.F + YNRMP00.f , introducing GRAZ terms.        
C----------------------------------------------------------------------
C
C     PSEUDO-SCALAR MESONS : CALCULATION POTENTIALS ON ISOSPIN BASIS
C
      IMPLICIT REAL *8(A-H,O-Z)
      COMMON/MODEL/IMODEL,INRS,ICNSTR,IRET,IDAM,IGERST,IGRTST
      COMMON/ALLPS/AME,AMX,AMK,BMK
      COMMON/MASSES/PIM,AM(3),AMY(3),REDM(3),PLAB,AK(3),AKS(3),TEM(3)
      COMMON/DYNMAS/REDMM,AMLN,AMSN,AMH,AMSS,AMLS,AMNN
      COMMON/FRMFAC/ALMOBE,ALMNN,ALMLL,ALMSS,ALMLS,ALMLK,ALMSK
      COMMON/FORMF/ALAMH,ALMP8,ALMV8,ALMS8,ALMP1,ALMV1,ALMS1,
     .             ALMKA,ALMKS,ALMKP
*     COMMON/AMAT/XA(300),A(9,6,300)
      COMMON/POTF/VCLL  ,VCSS  ,VCLS  ,VCDR,
     .            VSIGLL,VSIGSS,VSIGLS,VSIGDR,
     .            VTENLL,VTENSS,VTENLS,VTENDR,
     .            VSOLL ,VSOSS ,VSOLS ,VSODR,
     .            VSO2LL,VSO2SS,VSO2LS,VSO2DR,
     .            VASOLL,VASOSS,VASOLS,VASODR,
     .            VCNN  ,VSIGNN,VTENNN,VSONN ,
     .            FILL  ,FISS  ,FILS  ,FIDR,
     .            DFILL ,DFISS ,DFILS ,DFIDR,
     .            FISLL ,FISSS ,FISLS ,FISDR,
     .            DFISLL,DFISSS,DFISLS,DFISDR,
     .            FITLL ,FITSS ,FITLS ,FITDR,
     .            DFITLL,DFITSS,DFITLS,DFITDR
      COMMON/COUPL/ F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,F11,
     .              G1,G2,G3,G4,G5,G6,G7,G8,G9,G10,G11,
     .              FD1,FD2,FD3,FD4,FD5,FD6,FD7,FD8,FD9,FD10,FD11,
     .              FV1,FV2,FV3,FV4,FV5,FV6,FV7,FV8,FV9,FV10,FV11,
     .              GS1,GS2,GS3,GS4,GS5,GS6,GS7,GS8,GS9,GS10,GS11,
     .              GD1,GD2,GD3,GD4,GD5,GD6,GD7,GD8,GD9,GD10,GD11,P
      DIMENSION F(11),AMPS(5)
      EQUIVALENCE (F1,F(1))
      DATA SR3/1.732051D0/,SRPI/1.772454D0/
      DATA DAMLN/175.D0/,DAMSN/255.D0/,DAMSL/80.D0/
***   DATA DAMLN/0.D0/,DAMSN/0.D0/,DAMSL/0.D0/
      DATA PIMC/138.041D0/,ICALL/0/
      data napion/1/
C
C   NOTE : PION(IN=1),ETA (IN=2),ETAP(IN=3),KAON(IN=4)               
C
C   NOTE : INDEX              1    ,    2    ,    3
C          REFERS TO       LN -> LN, SN -> SN, LN -> SN  REACTION
C
C   THE POTENTIAL FUNCTIONS
C
      FF0(ERATH,EXH,XH,EM,EP)=ERATH*(EM/EXH-EXH*EP)/(2.D0*XH)
      FF3(ERATH,EXH,XH,XLAMH,EM,EP,EXLAM)=ERATH*(EM/EXH
     .  *(1.D0+XH+XH*XH/3.D0)-EXH*EP*(1.D0-XH+XH*XH/3.D0)
     .  -8.D0*XLAMH*(0.5D0+XLAMH*XLAMH/3.D0)*EXLAM/ERATH/
     .  SRPI)/(2.D0*XH*XH*XH)
      FH0(ERATH,EXH,XH,EMH,EPH)=ERATH*(EMH/EXH+EXH*EPH)/(2*XH)
C
C
      SR3 = DSQRT(3.D0)
      SRPI= DSQRT(DACOS(-1.D0))
      IF(LC.EQ.1) SIGN= 1.D0
      IF(LC.NE.1) SIGN=-1.D0
      DIV1 =1.D0/(AM(1)*AMY(1))
      DIV2 =1.D0/(AM(1)*AMY(2))
      DIV3 =1.D0/(AM(1)*AMH   )
      DO 1040 IN=1,4
      GOTO(1051,1052,1053,1054),IN
1051  GPLL = -0.0271D0*ICSB*F1*F3
      GPSS= -2*F1*F2
      GPLS= -SR3*F1*F3                  
      GPDR=      F1*F2
      AMPS(1)=PIM
      IF(IMODEL.LE.3) ALAM=ALMOBE
      IF(IMODEL.GE.4) ALAM=ALMP8
      GOTO 1056
1052  GPLL=  F6*F7                 
      GPSS=  F6*F8                
      GPLS=  0.D0
      GPDR=  F6*F8                
      AMPS(2)=AME
      IF(IMODEL.LE.3) ALAM=ALMOBE
      IF(IMODEL.GE.4) ALAM=ALMP8
      GOTO 1056
1053  GPLL=  F9*F10                 
      GPSS=  F9*F11                 
      GPLS=  0.D0
      GPDR=  F9*F11                       
      AMPS(3)=AMX
      IF(IMODEL.LE.3) ALAM=ALMOBE
      IF(IMODEL.GE.4) ALAM=ALMP1
      GOTO 1056
1054  GPLL=      F4*F4*P                  
      GPSS=     -F5*F5*P                 
      GPLS= -SR3*F4*F5*P                
      GPDR=    2*F5*F5*P                  
      AMPS(4)=BMK
      IF(IMODEL.EQ.1) ALAM=ALMOBE
      IF(IMODEL.GE.2) ALAM=ALMKA
      GOTO 1056
C
1056  FACPS=(AMPS(IN)/PIMC)**2
      ALM1=ALAM
      ALM2=ALAM
      ALM3=ALAM
C
*     DO 104 I=2,NMAX
*     X = XA(I)

      XLAM1=0.5D0*XA*ALM1/PIM
      XLAM2=0.5D0*XA*ALM2/PIM 
      XLAM3=0.5D0*XA*ALM3/PIM
      VKULL=(ALM1/AMPS(IN))**3*FDEXP(-XLAM1*XLAM1)/(2.D0*SRPI)
      VKUSS=(ALM2/AMPS(IN))**3*FDEXP(-XLAM2*XLAM2)/(2.D0*SRPI)
      VKULS=(ALM3/AMPS(IN))**3*FDEXP(-XLAM3*XLAM3)/(2.D0*SRPI)

      X =XA*(AMPS(IN)/PIM)
      EX=FDEXP(X)
C
      RATM1=AMPS(IN)/ALM1
      EXPM1=DEXP(RATM1*RATM1)
      ELAM1=FDEXP(-XLAM1*XLAM1)
      DERFCM1=FDERFC(-XLAM1+RATM1)
      DERFCP1=FDERFC( XLAM1+RATM1)
      FCLL0  = FF0(EXPM1,EX,X,DERFCM1,DERFCP1)*AMPS(IN) 
      FTENLL = FF3(EXPM1,EX,X,XLAM1,DERFCM1,DERFCP1,ELAM1)*AMPS(IN)  
C
      RATM2=AMPS(IN)/ALM2
      EXPM2=DEXP(RATM2*RATM2)
      ELAM2=FDEXP(-XLAM2*XLAM2)
      DERFCM2=FDERFC(-XLAM2+RATM2)
      DERFCP2=FDERFC( XLAM2+RATM2)
      FCSS0  = FF0(EXPM2,EX,X,DERFCM2,DERFCP2)*AMPS(IN)  
      FTENSS = FF3(EXPM2,EX,X,XLAM2,DERFCM2,DERFCP2,ELAM2)*AMPS(IN) 
C
      RATM3=AMPS(IN)/ALM3
      EXPM3=DEXP(RATM3*RATM3)
      ELAM3=FDEXP(-XLAM3*XLAM3)
      DERFCM3=FDERFC(-XLAM3+RATM3)
      DERFCP3=FDERFC( XLAM3+RATM3)
      FCLS0  = FF0(EXPM3,EX,X,DERFCM3,DERFCP3)*AMPS(IN)
      FTENLS = FF3(EXPM3,EX,X,XLAM3,DERFCM3,DERFCP3,ELAM3)*AMPS(IN)  
C
      FCLL1  = FCLL0  - VKULL*AMPS(IN)   
      FCSS1  = FCSS0  - VKUSS*AMPS(IN)  
      FCLS1  = FCLS0  - VKULS*AMPS(IN)     
C
C------------------------------------------------------------
C     THRESHOLD-DIFFERENCE MODIFICATION BASE FUNCTIONS:
      IF(IDAM.NE.0.AND.IN.NE.4) THEN
      CALL YMKFUN(XA,AMPS(IN),ALAM,SIGN,IDAM*DAMSL,
     .FXC0,FXC1,FXC2,FXTEN,FXTEN1,FXSO,FXSO1)
                                                                
      IF(LC.EQ.1) THEN
      FCSS1 = AMPS(IN)*FXC1 
      FTENSS = AMPS(IN)*FXTEN             
      ENDIF
      IF(LC.NE.1) THEN
      FCLL1 = AMPS(IN)*FXC1 
      FTENLL= AMPS(IN)*FXTEN             
      ENDIF
      FCLS1  = 0.5D0*(FCLS1 + AMPS(IN)*FXC1 )     
      FTENLS = 0.5D0*(FTENLS+ AMPS(IN)*FXTEN)     
      ENDIF
C------------------------------------------------------------
C
        VSIGLL     = VSIGLL    + FACPS*GPLL*FCLL1/3.D0
        VTENLL     = VTENLL    + FACPS*GPLL*FTENLL
        VSIGDR     = VSIGDR    + FACPS*GPDR*FCSS1/3.D0
        VTENDR     = VTENDR    + FACPS*GPDR*FTENSS
        VSIGSS     = VSIGSS    + FACPS*GPSS*FCSS1/3.D0
        VTENSS     = VTENSS    + FACPS*GPSS*FTENSS
        VSIGLS     = VSIGLS    + FACPS*GPLS*FCLS1/3.D0
        VTENLS     = VTENLS    + FACPS*GPLS*FTENLS
C-----------------------------------------------------------------
C
C     NONLOCAL TERMS PSEUDOSCALAR MESONS:
C
C------------------------------------------------------------
      IF(NAPION.EQ.1) THEN
C------------------------------------------------------------
C     GRAZ 1978:
CC
      X  = XA
      X1 = 1.D0/X  
      X2 = X1*X1     
      X3 = X1*X2     
      AMES=AMPS(IN)

      VKU1 =(ALM1/AMPS(IN))*FDEXP(-XLAM1*XLAM1)/(2.D0*SRPI)
      VKU2 =(ALM2/AMPS(IN))*FDEXP(-XLAM2*XLAM2)/(2.D0*SRPI)
      VKU3 =(ALM3/AMPS(IN))*FDEXP(-XLAM3*XLAM3)/(2.D0*SRPI)
      DVKU1 =-0.5D0*(ALM1/PIM)**2*X*VKU1 
      DDVKU1=-0.5D0*(ALM1/PIM)**2*(X*DVKU1+VKU1)
      D3VKU1=-0.5D0*(ALM1/PIM)**2*(X*DDVKU1+2*DVKU1)
      DVKU2 =-0.5D0*(ALM2/PIM)**2*X*VKU2 
      DDVKU2=-0.5D0*(ALM2/PIM)**2*(X*DVKU2+VKU2)
      D3VKU2=-0.5D0*(ALM2/PIM)**2*(X*DDVKU2+2*DVKU2)
      DVKU3 =-0.5D0*(ALM3/PIM)**2*X*VKU3 
      DDVKU3=-0.5D0*(ALM3/PIM)**2*(X*DVKU3+VKU3)
      D3VKU3=-0.5D0*(ALM3/PIM)**2*(X*DDVKU3+2*DVKU3)
C
      FI1    = FF0(EXPM1,EX,X,DERFCM1,DERFCP1)           
      HI1    = FH0(EXPM1,EX,X,DERFCM1,DERFCP1)           
      DFI1 =-(FI1 -2*VKU1)*X1-(AMES/PIM)*HI1
      DHI1  =-(AMES/PIM)*FI1 -HI1 *X1
      DDFI1 =-(DFI1-2*DVKU1)*X1+(FI1-2*VKU1)*X2-(AMES/PIM)*DHI1
      DDHI1 =-(AMES/PIM)*DFI1-DHI1*X1+HI1*X2
      D3FI1 =-(DDFI1-2*DDVKU1)*X1+(DFI1-2*DVKU1)*X2-(AMES/PIM)*DDHI1
     .       +(DFI1-2*DVKU1)*X2-2*(FI1-2*VKU1)*X3
      FC11  = (DDFI1+2*DFI1*X1)
      FT01  = (DDFI1-DFI1*X1)/3.D0
      DFC11 = (D3FI1+2*DDFI1*X1-2*DFI1*X2)
      DFT01 = (D3FI1-DDFI1*X1+DFI1*X2)/3.D0               
C
      FI2    = FF0(EXPM2,EX,X,DERFCM2,DERFCP2)           
      HI2    = FH0(EXPM2,EX,X,DERFCM2,DERFCP2)           
      DFI2 =-(FI2 -2*VKU2)*X1-(AMES/PIM)*HI2
      DHI2  =-(AMES/PIM)*FI2 -HI2 *X1
      DDFI2 =-(DFI2-2*DVKU2)*X1+(FI2-2*VKU2)*X2-(AMES/PIM)*DHI2
      DDHI2 =-(AMES/PIM)*DFI2-DHI2*X1+HI2*X2
      D3FI2 =-(DDFI2-2*DDVKU2)*X1+(DFI2-2*DVKU2)*X2-(AMES/PIM)*DDHI2
     .       +(DFI2-2*DVKU2)*X2-2*(FI2-2*VKU2)*X3
      FC12  = (DDFI2+2*DFI2*X1)
      FT02  = (DDFI2-DFI2*X1)/3.D0
      DFC12 = (D3FI2+2*DDFI2*X1-2*DFI2*X2)
      DFT02 = (D3FI2-DDFI2*X1+DFI2*X2)/3.D0               
C
      FI3    = FF0(EXPM3,EX,X,DERFCM3,DERFCP3)           
      HI3    = FH0(EXPM3,EX,X,DERFCM3,DERFCP3)           
      DFI3 =-(FI3 -2*VKU3)*X1-(AMES/PIM)*HI3
      DHI3  =-(AMES/PIM)*FI3 -HI3 *X1
      DDFI3 =-(DFI3-2*DVKU3)*X1+(FI3-2*VKU3)*X2-(AMES/PIM)*DHI3
      DDHI3 =-(AMES/PIM)*DFI3-DHI3*X1+HI3*X2
      D3FI3 =-(DDFI3-2*DDVKU3)*X1+(DFI3-2*DVKU3)*X2-(AMES/PIM)*DDHI3
     .       +(DFI3-2*DVKU3)*X2-2*(FI3-2*VKU3)*X3
      FC13  = (DDFI3+2*DFI3*X1)
      FT03  = (DDFI3-DFI3*X1)/3.D0
      DFC13 = (D3FI3+2*DDFI3*X1-2*DFI3*X2)
      DFT03 = (D3FI3-DDFI3*X1+DFI3*X2)/3.D0               

      FISLL = FISLL  -0.5D0*REDM(1)*GPLL*FC11*DIV1*PIM/3.D0         
      FISSS = FISSS  -0.5D0*REDM(2)*GPSS*FC12*DIV2*PIM/3.D0         
      FISLS = FISLS  -0.5D0*REDM(3)*GPLS*FC13*DIV3*PIM/3.D0         
      FISDR = FISDR  -0.5D0*REDM(2)*GPDR*FC12*DIV2*PIM/3.D0         
      DFISLL= DFISLL -0.5D0*REDM(1)*GPLL*DFC11*DIV1*PIM**2/3.D0
      DFISSS= DFISSS -0.5D0*REDM(2)*GPSS*DFC12*DIV2*PIM**2/3.D0
      DFISLS= DFISLS -0.5D0*REDM(3)*GPLS*DFC13*DIV3*PIM**2/3.D0
      DFISDR= DFISDR -0.5D0*REDM(2)*GPDR*DFC12*DIV2*PIM**2/3.D0

      if(x.lt.0.2d0) then
      write(*,*) 'psscal02: xa=',xa
      write(*,*) 'fi1,dfi1,ddfi1,d3fi1=',fi1,dfi1,ddfi1,d3fi1
      write(*,*) 'hi1,dhi1,ddhi1,fisll=',hi1,dhi1,ddhi1,fisll
      endif
c     FITLL = FITLL  -0.5D0*REDM(1)*GPLL*FT01*DIV1*PIM
c     FITSS = FITSS  -0.5D0*REDM(2)*GPSS*FT02*DIV2*PIM
c     FITLS = FITLS  -0.5D0*REDM(3)*GPLS*FT03*DIV3*PIM
c     FITDR = FITDR  -0.5D0*REDM(2)*GPDR*FT02*DIV2*PIM
c     DFITLL= DFITLL -0.5D0*REDM(1)*GPLL*DFT01*DIV1*PIM**2
c     DFITSS= DFITSS -0.5D0*REDM(2)*GPSS*DFT02*DIV2*PIM**2
c     DFITLS= DFITLS -0.5D0*REDM(3)*GPLS*DFT03*DIV3*PIM**2
c     DFITDR= DFITDR -0.5D0*REDM(2)*GPDR*DFT02*DIV2*PIM**2

C     END GRAZ 1978.
      ENDIF
C-----------------------------------------------------------------
C
* 104 CONTINUE
C
 1040 CONTINUE
C
      ICALL = 1
      RETURN
      END
C *********************************************************************
C
      SUBROUTINE PLFORM(XA,UMAS,ALAM)           
C
C**********************************************************************
C  september 2002: Pagnamenta-Licht Form-factor function:                  
C  from extra monopole factor U^2/(k^2+U^2) in g^2.
C----------------------------------------------------------------------
      IMPLICIT REAL *8(A-H,O-Z)
      COMMON/UFUNC/FCLL0,FCLS0,FCSS0,FCLL1,FCLS1,FCSS1,
     .UCLl2,UCLS2,UCSS2
      COMMON/MASSES/PIM,AM(3),AMY(3),REDM(3),PLAB,AK(3),AKS(3),TEM(3)
      COMMON/DYNMAS/REDMM,AMLN,AMSN,AMH,AMSS,AMLS,AMNN

      DATA PIM/138.041D0/,SR3/1.732051D0/,SRPI/1.772454D0/
C
C   THE POTENTIAL FUNCTIONS
C
      FF0(ERATH,EXH,XH,EM,EP)=ERATH*(EM/EXH-EXH*EP)/(2.0D00*XH)
      FF1(ERATH,EXH,XH,XLAMH,EM,EP,EXLAM)=ERATH*(EM/EXH
     . *(1.D00+XH)-EXH*EP*(1.D00-XH)-4.D00*XLAMH*EXLAM/ERATH/SRPI)
     .  /(2.D00*XH*XH*XH)
      FF3(ERATH,EXH,XH,XLAMH,EM,EP,EXLAM)=ERATH*(EM/EXH
     .  *(1.D00+XH+XH*XH/3.D00)-EXH*EP*(1.D00-XH+XH*XH/3.D00)
     .  -8.D00*XLAMH*(0.5D00+XLAMH*XLAMH/3.D00)*EXLAM/ERATH/
     .  1.7724538509D0)/(2.D00*XH*XH*XH)
C

      AMPS= UMAS
      ALM1=ALAM
      ALM2=ALAM
      ALM3=ALAM
      RATM1=AMPS/ALM1
      RATM2=AMPS/ALM2
      RATM3=AMPS/ALM3
c     FAC1=AMPS*AMPS/(AM(1)*AMY(1))
c     FAC2=AMPS*AMPS/(AM(1)*AMY(2))
c     FAC3=AMPS*AMPS/(AM(1)*AMH)
C
      X = XA    
      XLAM1=0.5D0*X*ALM1/PIM
      XLAM2=0.5D0*X*ALM2/PIM
      XLAM3=0.5D0*X*ALM3/PIM
      X =(AMPS/PIM)*X
      EX=FDEXP(X)
      VKULL=(ALM1/AMPS)**3*FDEXP(-XLAM1*XLAM1)/(2.D0*SRPI)
      VKUSS=(ALM2/AMPS)**3*FDEXP(-XLAM2*XLAM2)/(2.D0*SRPI)
      VKULS=(ALM3/AMPS)**3*FDEXP(-XLAM3*XLAM3)/(2.D0*SRPI)
C
      EXPM=DEXP(RATM1*RATM1)
      ELAM=FDEXP(-XLAM1*XLAM1)
      DERFCM=FDERFC(-XLAM1+RATM1)
      DERFCP=FDERFC( XLAM1+RATM1)
      FCLL0  = FF0(EXPM,EX,X,DERFCM,DERFCP)*AMPS
      FTENLL = FF3(EXPM,EX,X,XLAM1,DERFCM,DERFCP,ELAM)*AMPS
C

      EXPM=DEXP(RATM2*RATM2)
      ELAM=FDEXP(-XLAM2*XLAM2)
      DERFCM=FDERFC(-XLAM2+RATM2)
      DERFCP=FDERFC( XLAM2+RATM2)
      FCSS0  = FF0(EXPM,EX,X,DERFCM,DERFCP)*AMPS
      FTENSS = FF3(EXPM,EX,X,XLAM2,DERFCM,DERFCP,ELAM)*AMPS
C
      EXPM=DEXP(RATM3*RATM3)
      ELAM=FDEXP(-XLAM3*XLAM3)
      DERFCM=FDERFC(-XLAM3+RATM3)
      DERFCP=FDERFC( XLAM3+RATM3)
      FCLS0  = FF0(EXPM,EX,X,DERFCM,DERFCP)*AMPS
      FTENLS = FF3(EXPM,EX,X,XLAM3,DERFCM,DERFCP,ELAM)*AMPS
C
      FCLL1  = FCLL0  - VKULL*AMPS
      FCSS1  = FCSS0  - VKUSS*AMPS
      FCLS1  = FCLS0  - VKULS*AMPS
C
      FCLL2  = FCLL1+(1.5D0-XLAM1*XLAM1)*VKULL*AMPS/RATM1/RATM1
      FCSS2  = FCSS1+(1.5D0-XLAM2*XLAM2)*VKUSS*AMPS/RATM2/RATM2
      FCLS2  = FCLS1+(1.5D0-XLAM3*XLAM3)*VKULS*AMPS/RATM3/RATM3

      RETURN
      END


