C **********************************************************************
      SUBROUTINE YMKFUN(X,AMES,ALAM,SIGN,DAM,FC0,FC1,FC2,
     .                  FT0,FT1,FO0,FO1)
C **********************************************************************
C
C     YUKAWA-MACKE-KLEIN PROPAGATOR:
C                                        1          1
C     FOURIER TRANSFORM OF  F(OMEGA)=  ----- --------------
C                                      OMEGA (OMEGA +/- DAM)
C     IN THE FORM OF THE PHI^N_{C,T,SO}-FUNCTIONS DEFINED IN PRD17,PRC40
C     FOR FORM FACTOR TREATMENT SEE:
C     TH.A.RIJKEN, ANNALS OF PHYSICS 208, P.253 (1991).
C
C     VERSION: PHI-FUNCTIONS A LA PRD17 AND PRC40 !!
C
C **********************************************************************
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION XX(96),WW(96),YB(3)
***   COMMON/PIMAS/PIM
      DATA PIM/138.031D0/

      DATA PI/3.14159265D0/,SRPI/1.7724538509D0/,ICALL/0/
c     DATA YB/0.D0,10.D0,50.D0/,NINT/1/,NPNT/16/,IMETH/1/

      DATA PCUT/5.0D0/,PMAX/20/,IKIND/-1/,NPNT/32/,IQUADR/1/
***   DATA PCUT/5.0D0/,PMAX/40/,IKIND/+2/,NPNT/20/,IQUADR/1/
***   DATA PCUT/5.0D0/,PMAX/20/,IKIND/+3/,NPNT/32/,IQUADR/1/

      SAVE XX,WW
C ---------------------------------------------------------------
C
C     POTENTIAL FUNTIONS DEFINITION
C
C-------------------------------------------------------------------
      F0(ERATH,EXH,EM,EP,XH)=ERATH*(EM/EXH-EXH*EP)/(2.D0*XH)
      F1(ERATH,EXH,EM,EP,EXLAM,XH,XLAMH)=ERATH*(EM/EXH
     . *(1.D0+XH)-EXH*EP*(1.D0-XH)-4.D0*XLAMH*EXLAM/ERATH/SRPI)
     .  /(2.D0*XH*XH*XH)
      F3(ERATH,EXH,EM,EP,EXLAM,XH,XLAMH)=ERATH*(EM/EXH
     .  *(1.D0+XH+XH*XH/3.D0)-EXH*EP*(1.D0-XH+XH*XH/3.D0)
     .  -8.D0*XLAMH*(0.5D0+XLAMH*XLAMH/3.D0)*EXLAM/ERATH/SRPI)
     .  /(2.D0*XH*XH*XH)
C
C-------------------------------------------------------------------
c     IF(ICALL.EQ.0) THEN
c       CALL GAUSS(NPNT,XX,WW,1)
c       IF(IMETH.EQ.1) NINT=1
C       PRINT 52, IMETH,NPNT
C52     FORMAT(//,'  IN FFUN: IMETH=',I2,' NPNT=',I2,//)
C       PI = DACOS(-1.D0)
C       SRPI= DSQRT(PI)
***     ICALL=1
c     ENDIF
C ---------------------------------------------------------------
      IF(ICALL.EQ.0) THEN
C     GENERATION INTEGRATION POINTS:
      PRINT 1, NPNT,IKIND,PCUT,PMAX,IQUADR
    1 FORMAT(/,'  YMKFUN METHOD PARAMETERS ARE: NPNT=',I2,
     .' IKIND=',I2,' PCUT=',F10.3,' PMAX=',F10.3,' IQUADR=',I2,/) 
      CALL GRID(XX,WW,NPNT,0.D0,PCUT,PMAX,IKIND,IQUADR)
      PI = DACOS(-1.D0)
      SRPI= DSQRT(PI)
      ICALL=1
      ENDIF
C ---------------------------------------------------------------
CC
      AA   = DAM/PIM
CC
      XLAM =0.5D0*X*ALAM/PIM
      XLAM2=XLAM*XLAM
      EXLAM=FDEXP(-XLAM2)
      RATP = PIM/ALAM
C-------------------------------------------------------------------
      IF(SIGN.EQ.-1.D0.OR.DAM.EQ.0.D0) THEN
      FDISAA= DEXP(AA*AA/ALAM/ALAM)
      BMES = DSQRT(AMES**2-DAM**2)
      BMES1= BMES/PIM
      BMES3=(BMES/PIM)**3
      BMES5=(BMES/PIM)**5
      VKUA =(ALAM/BMES)**3*FDEXP(-XLAM2)/(2*SRPI)
      XA   =X*BMES/PIM
      RATA =BMES/ALAM
      ERATA=DEXP(RATA*RATA)
      EXA  =DEXP(XA)
      EMA  =FDERFC(-XLAM +RATA)
      EPA  =FDERFC( XLAM +RATA)
      FIA  =F0(ERATA,EXA ,EMA ,EPA ,XA)      
      FIAT =F3(ERATA,EXA ,EMA ,EPA ,EXLAM, XA, XLAM)      
      FIAO =F1(ERATA,EXA ,EMA ,EPA ,EXLAM, XA, XLAM)      
*     FIAO2=3*FIAT/(XA*XA)
C
      FIA1 = FIA - VKUA             
      FIA2 = FIA1 + (1.5D0-XLAM*XLAM)*VKUA/RATA/RATA   
      FIAT1= FIAT - XLAM*XLAM*VKUA/(3*RATA*RATA)  
      FIAO1= FIAO - VKUA/(2*RATA*RATA)    
C-------------------------------------------------------------------
C
       IF(DAM.EQ.0.D0) THEN
      FC0 = FIA  
      FC1 = FIA1
      FC2 = FIA2
      FT0 = FIAT
      FT1 = FIAT1
      FO0 = FIAO
      FO1 = FIAO1
      RETURN
       ENDIF
C                              
      FIB  = FIA*FDISAA*BMES1
      FIB1 = FIA1*FDISAA*BMES3
      FIB2 = FIA2*FDISAA*BMES5
      FIBT = FIAT*FDISAA*BMES3
      FIBT1= FIAT1*FDISAA*BMES5
      FIBO = FIAO*FDISAA*BMES3
      FIBO1= FIAO1*FDISAA*BMES5

      ENDIF
C ---------------------------------------------------------------
C
C     CONSTRUCTION BASE FUNCTIONS BY INTEGRATION
C
      if(icall.eq.0) test1=0.d0
      GG   =0.D0
      GG1  =0.D0
      GG2  =0.D0
      GGT  =0.D0
      GGO  =0.D0
      GGT1 =0.D0
      GGO1 =0.D0

C ---------------------------------------------------------------
C     USING GAUSS DIRECTLY:
c     DO 100 INT=1,NINT
c     ABM=0.5D0*(YB(INT+1)-YB(INT))
c     ABP=0.5D0*(YB(INT+1)+YB(INT))
c     DO 110 IY=1,NPNT
c     IF(IMETH.EQ.0) THEN
c     Y=ABM*XX(IY)+ABP
c     GEW=WW(IY)*ABM*2.D0/PI
c     ENDIF
c     IF(IMETH.EQ.1) THEN
c     Y=(1.D0+XX(IY))/(1.D0-XX(IY))
c     GEW=WW(IY)*(2.D0/(1.D0-XX(IY))**2)*2.D0/PI
c     ENDIF
c     IF(Y.GE.50.D0) GOTO 110
C ---------------------------------------------------------------
C     USING GRID:              
      DO 110 IY=1,NPNT
      Y = XX(IY)
      GEW = (2.D0/PI)*WW(IY)
C ---------------------------------------------------------------

      GEW = GEW*AA/(Y**2+AA**2)
C     FACTOR FROM FORM FACTOR EFFECTS THROUGH DISP. REL. :
      FDISP =FDEXP(-Y*Y*RATP*RATP)
C
      AM=PIM*DSQRT((AMES/PIM)**2+Y*Y)
      AM1 = AM/PIM
      AM3 = (AM/PIM)**3
      AM5 = (AM/PIM)**5
      VKUM =(ALAM/AM)**3*FDEXP(-XLAM2)/(2*SRPI)
      XM=AM*X/PIM
      RATM =AM/ALAM
      ERATM=FDEXP(RATM*RATM)
      EXM  =FDEXP(XM)
      EMM  =FDERFC(-XLAM+RATM)
      EPM  =FDERFC( XLAM+RATM)

      FIM  =F0(ERATM,EXM ,EMM ,EPM ,XM)      
      FIMT =F3(ERATM,EXM ,EMM ,EPM ,EXLAM, XM, XLAM)      
      FIMO =F1(ERATM,EXM ,EMM ,EPM ,EXLAM, XM, XLAM)      
*     FIMO2=3*FIAT/(XM*XM)
C
      FIM1 = FIM - VKUM            
      FIM2 = FIM1 + (1.5D0-XLAM*XLAM)*VKUM/RATM/RATM   
      FIMT1= FIMT - XLAM*XLAM*VKUM/(3*RATM*RATM)  
      FIMO1= FIMO - VKUM/(2*RATM*RATM)    
C
      IF(SIGN.EQ.1.D0) THEN
      GG    = GG   + GEW*FIM  *FDISP*AM1
      GG1   = GG1  + GEW*FIM1 *FDISP*AM3
      GG2   = GG2  + GEW*FIM2 *FDISP*AM5
      GGT   = GGT  + GEW*FIMT *FDISP*AM3            
      GGO   = GGO  + GEW*FIMO *FDISP*AM3         
      GGT1  = GGT1 + GEW*FIMT1*FDISP*AM5          
      GGO1  = GGO1 + GEW*FIMO1*FDISP*AM5           
      ENDIF
      IF(SIGN.EQ.-1.D0) THEN
      GG    = GG   + GEW*(2*FIB- FIM *FDISP*AM1)
      GG1   = GG1  + GEW*(2*FIB1-FIM1*FDISP*AM3)
      GG2   = GG2  + GEW*(2*FIB2-FIM2*FDISP*AM5)
      GGT   = GGT  + GEW*(2*FIBT-FIMT*FDISP*AM3)           
      GGO   = GGO  + GEW*(2*FIBO-FIMO*FDISP*AM3)             
      GGT1  = GGT1 + GEW*(2*FIBT1-FIMT1*FDISP*AM5)         
      GGO1  = GGO1 + GEW*(2*FIBO1-FIMO1*FDISP*AM5)             
      ENDIF
C
 110   CONTINUE
c100   CONTINUE
C ---------------------------------------------------------------
C
C     PHI-FUNCTIONS A LA PRD17 ANDPRC40:
      FC0 = (PIM/AMES)**1*GG
      FC1 = (PIM/AMES)**3*GG1
      FC2 = (PIM/AMES)**5*GG2
      FT0 = (PIM/AMES)**3*GGT
      FT1 = (PIM/AMES)**5*GGT1
      FO0 = (PIM/AMES)**3*GGO
      FO1 = (PIM/AMES)**5*GGO1
CC
C ---------------------------------------------------------------
      ICALL=1
      RETURN
      END
C **********************************************************************
      SUBROUTINE GRID(P,WH,NOGP,P0,PCUT,PMAX,IKIND,IQUADR)
C **********************************************************************
C
C  GENERATING THE INTEGRATION POINTS
C
C-----------------------------------------------------------------------
      IMPLICIT REAL*8(A-H,O-Z)
**    INCLUDE 'DIMPARS'
**    DIMENSION P(NGAUSS),WH(NGAUSS),X(NGAUSS),W(NGAUSS)
      DIMENSION P(96),WH(96),X(96),W(96)
      DATA NS/0/
      NT=1
      IF (IKIND.LT.0) NT=2
      IS=IABS(IKIND)
      NOGP=NOGP/NT
      IF(IQUADR.EQ.1) THEN
      IF(NS.EQ.1) PRINT 1007
      CALL GAUSSS(NOGP,X,W,NT)
      ENDIF
c     IF(IQUADR.EQ.2) THEN
c     IF(NS.EQ.1) PRINT 1008
c     CALL CHEBSV(NOGP,X,W)
c     ENDIF
      NOGP=NOGP*NT
C-----------------------------------------------------------------------
C
C  MAPPING BY HYPERBOLIC MAPPING:               
C
C-----------------------------------------------------------------------
C  INTERVAL: P0 - INFTY:
      IF(IABS(IKIND).EQ.1) THEN
      DO 20 I=1,NOGP
      P(I)=PCUT*(2.D0/(1.D0-X(I))-1.D0)
     . -2*P0*X(I)/(1.D0-X(I))
   20 WH(I)=2*(PCUT-P0)*W(I)/(1.D0-X(I))**2
      IF(NS.EQ.1) PRINT 1010
      ENDIF
C-----------------------------------------------------------------------
C
C  MAPPING BY LINEAR FRACTION:       
C
C-----------------------------------------------------------------------
C  INTERVAL: P0 - PMAX:   
      IF(IABS(IKIND).EQ.2) THEN
C  PARAMETERS ARE
      AA = ( (PMAX-PCUT)*P0+(P0-PCUT)*PMAX)/(PMAX+P0-2*PCUT)
      DD = (P0-PMAX)/(PMAX+P0-2*PCUT)
      BB = PCUT*DD                                               

      DO 30 I=1,NOGP
      P(I)=( AA*X(I)+BB )/( X(I)+DD )      
   30 WH(I)= W(I)*( AA*DD-BB )/( X(I)+DD)**2           
      IF(NS.EQ.1) PRINT 1030
      ENDIF
C-----------------------------------------------------------------------
C
C  MAPPING BY ARCTANGENT FUNCTION    
C
C-----------------------------------------------------------------------
C  INTERVAL: P0 - PMAX:   
      IF(IABS(IKIND).EQ.3) THEN
      PI4 = 0.25D0*DACOS(-1.D0)

      DO 40 I=1,NOGP
      AA = PI4*(X(I)+1.D0)
      P(I)=PCUT*DTAN(AA)                   
      CS  =DCOS(AA)
   40 WH(I)= PI4*PCUT*W(I)/(CS*CS)                              
      IF(NS.EQ.1) PRINT 1040
      ENDIF
C-----------------------------------------------------------------------
C
      IF(NS.EQ.1) THEN
      WRITE(6,1009) IKIND,NOGP,P0,PCUT,PMAX,(P(I),I=1,NOGP)
      WRITE(6,1019) (WH(I),I=1,NOGP)
      ENDIF
C-----------------------------------------------------------------------
      RETURN
 1007 FORMAT ('   GRID :  QUADRATURE = GAUSSIAN,',/)
 1008 FORMAT ('   GRID :  QUADRATURE = CHEBYSHEV,',/)
 1009 FORMAT ('           IKIND=',I2,' NOGP=',I3,' P0=',F10.3,' PCUT=',  
     .F10.3,' PMAX=',F10.3,/,10X,' GRID POINTS :',/,4(5D14.5,/))
 1019 FORMAT (10X,' GRID WEIGHTS:',/,4(5D14.5,/))
 1010 FORMAT ('           MAPPING WITH HYPERBOLA,',/)
 1030 FORMAT ('           MAPPING WITH LINEAR FRACTION,',/)
 1040 FORMAT ('           MAPPING WITH ARCTANGENT,',/)            
      END









