C **********************************************************************
C     VERSION DD. JUNE 2004: WRT MAY04: SU3SB -> SU3SB03 

C     SPLITTING YNPAIR: YNPRCOP + YNPAIR
C     version with explicit pi-omega , pi-phi for ntype=6
C **********************************************************************
C     FOR TREATMENT PAIR-EXCHANGES:
C **********************************************************************
      BLOCK DATA BLKDAT
*     subroutine setpar
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/PAIRON/IPIPI0,IPIPI1,IPIRO1,IPIRO0,IPIOM,IPISI
     .,ISISI,IPIET,IPIETP,IPIPOM,IPIROV,IPIOMV,IKKB0,IKKB1,IPIA1
      COMMON/TWOPR/N2PR0,N2PR1,N2PRV,N2PRA,N2PRB

      DATA IPIPI0/1/,IPIPI1/1/,IPIRO1/1/,IPIRO0/0/,IPIOM/2/,
     . IPISI/1/,ISISI/0/,IPIET/1/,IPIETP/0/,IPIPOM/1/,
     . IPIROV/0/,IPIOMV/0/,IKKB0/0/,IKKB1/0/,IPIA1/0/
**    DATA N2PR0/1/,N2PR1/1/,N2PRV/0/,N2PRA/1/,N2PRB/1/
      DATA N2PR0/0/,N2PR1/0/,N2PRV/0/,N2PRA/0/,N2PRB/0/
*     return
      END
C **********************************************************************
      SUBROUTINE YNPRCOP           
C **********************************************************************
C *
C
C *   COUPLINGS PION-MESON PAIR YN-POTENTIALS
C *
C     IN COUPLING COMBINATIONS CENLL1 ETC.:
C     (i) YNCCPR: L+R contributions included,
C     (ii) YNCCPR: 1 <-> 2 interchange factor included (extra diagrams)
C     (iii) FFUN2: identical particle factor included (2 contractions),
C                  facip=2.
C
C     ALTERNATIVE NOMENCLATURE PAIR COUPLINGS:
C     GAPAIR=GPIRO1, HAPAIR=GPIRO0, GPPAIR=GPISI, GEPAIR=GSISI

C     PISI and PIRO1 a la paper II !!
C
C **********************************************************************
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/PRMTRS/PAR(20,8)
      COMMON/COUCON/ALP,GX0,FX0,THPS,ALVD,GOM,THV,ALVV,FOM,THS,GDEL,
     .GEPS,GSST,ALF,GPOM,GPOMP,GA2,PSID,THD,AHYPC,ALS,SSCAL,ALD,ALPA
*     COMMON/COUPL/ F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,F11,
*    .              G1,G2,G3,G4,G5,G6,G7,G8,G9,G10,G11,
*    .              FD1,FD2,FD3,FD4,FD5,FD6,FD7,FD8,FD9,FD10,FD11,
*    .              FV1,FV2,FV3,FV4,FV5,FV6,FV7,FV8,FV9,FV10,FV11,
*    .              GS1,GS2,GS3,GS4,GS5,GS6,GS7,GS8,GS9,GS10,GS11,
*    .              GD1,GD2,GD3,GD4,GD5,GD6,GD7,GD8,GD9,GD10,GD11,P
*     DIMENSION F(11),G(11),FD(11),FV(11),GS(11),GD(11)
*     EQUIVALENCE (F1,F(1)),(G1,G(1)),(FD1,FD(1)),(FV1,FV(1))
*    . ,(GS1,GS(1)),(GD1,GD(1))
      COMMON/COUPL/ F(11),G(11),FD(11),FV(11),GS(11),GD(11),P
C
      DIMENSION PRF(11)
C
      COMMON/ALLPR/GSPAIR,GVPAIR,FVPAIR,GPIRO1,GPIRO0,GPISI,HOPAIR
     .            ,GSISI,GPIET,GPIETP,GPIPOM
     .            ,ALPVPR,ALVDPR,ALVVPR,ALSCPR,ALPAPR
      COMMON/PRCOP/PRPP0(11),PRPE1(11),PRPPG(11),PRPPF(11),
     .             PRPR1(11),PRPO1(11),PRPSI(11),PRPPO(11)

C     communication with routine YNPRCC:
C
C !!  NOTICE: THIS VERSION IN YNPRCC ALL COUPLINGS ARE ORDERED AS       !!!!!
C !!          FOR THE PS-SCALARS !!!!                                   !!!!!
C
      COMMON/PRCPLS/CENPR(10),SIGPR(10)
      COMMON/CPLRIJ/FA(11),FB(11),PR(11)
      COMMON/CCPR/ CCPR1(3,10),CCPR2(10,10),CCPRG(9,10),CCPRF(9,10),
     .CCPR4(9,10),CCPR4F(9,10),CCPR5(6 ,10),CCPR6(10)  ,CCPR7(3,10),
     .CCPR10(13,10)
C
      DATA FACID/1.0D0/,SR2/1.4142136D0/,SR3/1.732051D0/,FACIP/2.D0/
      COMMON/PAIRON/IPIPI0,IPIPI1,IPIRO1,IPIRO0,IPIOM,IPISI,
     .ISISI,IPIET,IPIETP,IPIPOM,IPIROV,IPIOMV,IKKB0,IKKB1,IPIA1
      COMMON/TWOPR/N2PR0,N2PR1,N2PRV,N2PRA,N2PRB
*     SAVE CCPR1,CCPR2,CCPRG,CCPRF,CCPR4,CCPR4F,CCPR5,CCPR6,CCPR7
      DATA ISU3/0/,ICALL/0/,NSCHR/0/                    
***   DATA ISU3/1/,ICALL/0/,NSCHR/1/                    
      DATA I3P0/1/
C
c      notice: check su3-symmetry, set isu3=1 also in YNPAIR!
**     isu3=1
       IF(ISU3.EQ.1) THEN
        GS(9)=PAR(3,5)
        GD(9)=PAR(3,6)
        CALL SU3(F,ALP)
        CALL SU3(FD,ALVD)
        CALL SU3(FV,ALVV)
        CALL SU3(GS,ALS)  
        CALL SU3(GD,ALD)  
        CALL SU3SYM(PIM)
       ENDIF
C     SU3-BREAKING IN PAIR COUPLINGS:
c       SONV  = PAR(10,7)
c       SONPV = PAR(11,7)
c       SONSC = PAR(12,7)
        SONV  = PAR(13,7)
        SONPV = PAR(14,7)
        SONSC = PAR(15,7)
*       SON1  = PAR(9,7)
        SON1  = PAR(14,1) 
        IF(I3P0.EQ.1) THEN
        SONPV = PAR(11,7)
        SONV  = PAR(10,7)
        SONSC = PAR(10,7)
        SONVA = PAR(10,7)
        SON1  = PAR(10,7)
        ENDIF
      IF(ICALL.EQ.0) THEN
        PRINT 99, 
     .  IPIPI0,IPIPI1,IPIRO1,IPIRO0,IPIROV,IPIOM,IPIOMV,
     .  IPISI,ISISI,IPIET,IPIETP,IKKB0,IKKB1,IPIPOM,
     .  GSPAIR,GVPAIR,FVPAIR,GPIRO1,GPIET,GPISI,GSISI,GPIRO0,
     .  HOPAIR,GPIETP,GPIPOM
     . ,ALPVPR,ALVDPR,ALVVPR,ALSCPR,ALPAPR
     . ,SONV,SONPV,SONSC,SON1
*    . ,N2PR0,N2PR1,N2PRV,N2PRA,N2PRB,PIM,DAM 
     . ,F,FD,FV,GS,GD
 99     FORMAT(//,'  IN YNPRCOP:',//,
     .  11X,'  IPIPI0,IPIPI1,IPIRO1,IPIRO0,IPIROV,IPIOM,IPIOMV=',7I2,//,
     .  11X,'  IPISI ,ISISI ,IPIET ,IPIETP,IKKB0 ,IKKB1,IPIPOM=',7I2,//,
     .  11X,'  GSPAIR=',F10.5,'  GVPAIR=',F10.5,'  FVPAIR=',F10.5,//,   
     .  11X,'  GPIRO1=',F10.5,'  GPIET =',F10.5,'  GPISI =',F10.5,//,   
     .  11X,'  GSISI =',F10.5,'  GPIRO0=',F10.5,'  HOPAIR=',F10.5,//,   
     .  11X,'  GPIETP=',F10.5,'  GPIPOM=',F10.5,//,   
     .  11X,'  ALPVPR=',F10.5,'  ALVDPR=',F10.5,'  ALVVPR=',F10.5,//,
     .  11X,'  ALSCPR=',F10.5,'  ALPAPR=',F10.5,//,
     .  11X,'  SONVPR=',F10.5,'  SONPPR=',F10.5,'  SONSPR=',F10.5,//,
     .  11X,'  SON{1}=',F10.5,//,
*    .  11X,'  N2PR0,N2PR1 ,N2PRV ,N2PRA ,N2PRB =',5(I3,2X),/, 
*    .  11X,'  PIM=',F10.3,' DAM=',F10.3,//,
     .  11X,'  F  =',6(F10.5),/,17X,5(F10.5),/,
     .  11X,'  FD =',6(F10.5),/,17X,5(F10.5),/,
     .  11X,'  FV =',6(F10.5),/,17X,5(F10.5),/,
     .  11X,'  GS =',6(F10.5),/,17X,5(F10.5),/,
     .  11X,'  GD =',6(F10.5),/,17X,5(F10.5))
*       ICALL=1
      ENDIF
C
C     CONSTRUCTION OF COUPLING COMBINATIONS
C
C !!  NOTICE: THIS VERSION ALL COUPLINGS ARE ORDERED AS       !!!!!
C !!          FOR THE PS-SCALARS!!                            !!!!!
C
C a)  scalar SU(3)-singlet pair terms, {1}->{8}x{8} :
C
      IF(IPIPI0.NE.0) THEN
      PR(1) = GSPAIR
c     PR(1) = GSPAIR*DCOS(THS)
c     PR(1) = GSPAIR*(1.D0-GPIET)
      DO 110 KK=1,11
      FA(KK) = F(KK)
 110  FB(KK) = F(KK)
      DO 111 II=1,3
      CALL YNPRCC(1,II,ALP,ALP,P)
      DO 111 KK=1,5 
      CCPR1(II,KK) = CENPR(KK)
 111  CCPR1(II,KK+5) = CENPR(KK+5)*N2PR0
      ENDIF
C
C b)  scalar SU(3)-octet pair terms, {8s}->{8}x{8} :
C
      IF(IPIET.NE.0) THEN
      PR(1) = GPIET
      PR(9) = 0.D0
c*    ALSCPR= ALS
c*    ALSCPR=(5.D0*ALP+5*ALP-10*ALP*ALP)/
c*   .       (8*ALP+8*ALP-4*ALP*ALP-3.D0)
      CALL SU3(PR,ALSCPR)
**    IF(SONSC.NE.1.D0) CALL SU3SB(PR,SONSC,3)
      IF(SONSC.NE.1.D0) CALL SU3SB03(PR,ALSCPR,SONSC)
      DO 120 KK=1,11
      if(icall.eq.0) prpe1(kk)=pr(kk)
      FA(KK) = F(KK)
 120  FB(KK) = F(KK)
      DO 121 II=1,7  
      CALL YNPRCC(2,II,ALP,ALP,P)
      DO 121 KK=1,5 
      CCPR2(II,KK) = CENPR(KK)
 121  CCPR2(II,KK+5) = CENPR(KK+5)*N2PR0
      ENDIF
C
C c)  vector SU(3)-octet pair terms, {8a}->{8}x{8} :
C
      IF(IPIPI1.NE.0) THEN
      PR(1) = GVPAIR
      PR(9) = 0.D0
c*    ALVDPR= ALVD
c*    ALVDPR=(5.D0-5*ALP-5*ALP+14*ALP*ALP)/
c*   .       (5.D0+4*ALP+4*ALP- 4*ALP*ALP)
      CALL SU3(PR,ALVDPR)
**    IF(SONV.NE.1.D0) CALL SU3SB(PR,SONV,2)
      IF(SONV.NE.1.D0) CALL SU3SB03(PR,ALVDPR,SONV)
      DO 130 KK=1,11
      if(icall.eq.0) prppg(kk)=pr(kk)
      FA(KK) = F(KK)
 130  FB(KK) = F(KK)
      DO 131 II=1,9
      CALL YNPRCC(3,II,ALP,ALP,P)
      DO 131 KK=1,5 
      CCPRG(II,KK) = SIGPR(KK)
 131  CCPRG(II,KK+5) = SIGPR(KK+5)*N2PR1
      PRF(1) = FVPAIR
      PRF(9) = 0.D0
*     ALVVPR= ALVV
*     ALVVPR=(5.D0-5*ALP-5*ALP+14*ALP*ALP)/
*    .       (5.D0+4*ALP+4*ALP- 4*ALP*ALP)
      CALL SU3(PRF,ALVVPR)
**    IF(SONV.NE.1.D0) CALL SU3SB(PRF,SONV,2)
      IF(SONV.NE.1.D0) CALL SU3SB03(PRF,ALVVPR,SONV)
      DO 135 II=1,11
      if(icall.eq.0) prppf(ii)=prf(ii)
 135  PR(II) = PR(II)+PRF(II)
      DO 136 II=1,9
      CALL YNPRCC(3,II,ALP,ALP,P)
      DO 136 KK=1,5 
      CCPRF(II,KK) = SIGPR(KK)
 136  CCPRF(II,KK+5) = SIGPR(KK+5)*N2PR1
      ENDIF
C
C d)  axial pair terms, {8a}->{8}x{8} :
C
      IF(IPIRO1.NE.0) THEN
      PR(1) = GPIRO1
      PR(9) = 0.D0
*     ALPAPR= ALP 
*     ALPAPR= ALPA
c*    ALPAPR=(5.D0-5*ALP-5*ALVD+14*ALP*ALVD)/
c*   .       (5.D0+4*ALP+4*ALVD- 4*ALP*ALVD)
      CALL SU3(PR,ALPAPR)
**    IF(SONPV.NE.1.D0) CALL SU3SB(PR,SONPV,1)
      IF(SONPV.NE.1.D0) CALL SU3SB03(PR,ALPAPR,SONPV)
      DO 140 KK=1,11
      if(icall.eq.0) prpr1(kk)=pr(kk)
      FA(KK) = F(KK)
 140  FB(KK) = FD(KK)
      if(isu3.eq.0) call reordr(fb)
      DO 141 II=1,9
      CALL YNPRCC(3,II,ALP,ALVD,P)
      DO 141 KK=1,5 
      CCPR4(II,KK) = SIGPR(KK)
 141  CCPR4(II,KK+5) = SIGPR(KK+5)*N2PRA
      DO 145 KK=1,11
      FA(KK) = F(KK)
 145  FB(KK) = FV(KK)
      if(isu3.eq.0) call reordr(fb)
      DO 146 II=1,9
      CALL YNPRCC(3,II,ALP,ALVV,P)
      DO 146 KK=1,5 
      CCPR4F(II,KK) = SIGPR(KK)
 146  CCPR4F(II,KK+5) = SIGPR(KK+5)*N2PRA
      ENDIF
C
C e)  axial pair terms, {8}->{8}x{1} :
C
      IF(IPISI.NE.0) THEN
C     PS-EPSILON CONTRIBUTIONS:
c*    ALPAPR= ALP  
c*    ALPAPR= 1.d0 
c*    ALPAPR= ALPA
      PR(1) = GPISI
**    PR(1) = GPISI*DCOS(THS)
      PR(9) = 0.D0
      CALL SU3(PR,ALPAPR)
      DO 150 KK=1,11
      if(icall.eq.0) prpsi(kk)=pr(kk)
      FA(KK) = F(KK)
 150  FB(KK) = GS(KK)
      if(isu3.eq.0) call reordr(fb)
      DO 151 II=1,3
      CALL YNPRCC(4,II,ALP,ALS,P)
      DO 151 KK=1,5 
      CCPR5(II,KK) = SIGPR(KK)
 151  CCPR5(II,KK+5) = SIGPR(KK+5)*N2PRA
C     PS-SSTAR CONTRIBUTIONS:
*     PR(1) = 0.D0
      PR(1) =-GPISI*DSIN(THS)
      PR(9) = 0.D0
      CALL SU3(PR,ALPAPR)
      DO 155 KK=1,11
      FA(KK) = F(KK)
 155  FB(KK) = GS(KK)
      if(isu3.eq.0) call reordr(fb)
      DO 156 II=4,6
      CALL YNPRCC(4,II,ALP,ALS,P)
      DO 156 KK=1,5 
      CCPR5(II,KK) = SIGPR(KK)
 156  CCPR5(II,KK+5) = SIGPR(KK+5)*N2PRA
      ENDIF

      IF(IPIPOM.NE.0) THEN
C     PS-POMERON CONTRIBUTIONS:
      PR(1) = GPIPOM
      PR(9) = 0.D0
      CALL SU3(PR,ALPAPR)
      DO 170 KK=1,11
      if(icall.eq.0) prppo(kk)=pr(kk)
      FA(KK) = F(KK)
 170  FB(KK) = GD(KK)
      if(isu3.eq.0) call reordr(fb)
      DO 171 II=1,3
      CALL YNPRCC(4,II,ALP,ALD,P)
      DO 171 KK=1,5 
      CCPR7(II,KK) = SIGPR(KK)
 171  CCPR7(II,KK+5) = SIGPR(KK+5)*N2PRA
      ENDIF
C
C f)  SU(3)-singlet pair terms, {1}->{1}x{1} :
C
      IF(ISISI.NE.0) THEN
*     PR(1) = GSISI*DCOS(THS)
      PR(1) = GSISI
      PR(2) = GSISI*DABS(SON1)
      PR(3) = GSISI*DABS(SON1)
      DO 160 KK=1,11
      FA(KK) = GS(KK)
 160  FB(KK) = GS(KK)
      if(isu3.eq.0) call reordr(fa)
      if(isu3.eq.0) call reordr(fb)
      DO 161 II=1,1
      CALL YNPRCC(5,II,ALS,ALS,P)
      DO 161 KK=1,5 
      CCPR6(KK) = CENPR(KK)
 161  CCPR6(KK+5) = CENPR(KK+5)*N2PR0
      ENDIF
C
C h)  second-class axial pair terms, {8s}->{8}x{8} :
C
      IF(IPIOM.NE.0) THEN
C     PI-OMEGA CONTRIBUTIONS:
      ALPBPR= PAR(16,7)
      alpbpr= alp
      IF(ALPBPR.EQ.0D0) ALPBPR= ALP 
**    PR(1) = GPIOM
      PR(1) = HOPAIR
      PR(9) = 0.D0
      CALL SU3(PR,ALPBPR)
      DO 190 KK=1,11
      if(icall.eq.0) prpo1(kk)=pr(kk)
      FA(KK) = F(KK)
 190  FB(KK) = FD(KK)
      if(isu3.eq.0) call reordr(fb)
      DO 191 II=1,13
      CALL YNPRCC(6,II,ALP,ALVD,P)
      DO 191 KK=1,5 
      CCPR10(II,KK) = CENPR(KK)
 191  CCPR10(II,KK+5) = CENPR(KK+5)*N2PRB
      ENDIF

*     PRINT 199, ALVDPR,ALVVPR,ALSCPR,ALPAPR,ALPBPR
 199  FORMAT(/,'  ALVDPR,ALVVPR,ALSCPR,ALPAPR,ALPBPR=',   
     .5F10.5,//)
C ******************************************************************
      if(icall.eq.0) then
      write(6,94) prpe1,prppg,prppf,prpr1,prpo1,prpsi,prppo
      endif
   94 format(/,72('*'),/,' Pair Coupling Constants:',/,72('-'),/,
     .'       ','   nnp  ','   ssp  ','   lsp  ','   lnk  ',
     .'   snk  ',/,'       ','   nne  ','   lle  ','   sse  ',
     .'   nnx  ','   llx  ','   ssx  ',/,72('-'),/,
     .' gpie =',5f8.5,/,7x,6f8.5,//,' gpp1 =',5f8.5,/,7x,6f8.5,//,
     .' fpp1 =',5f8.5,/,7x,6f8.5,//,' gpr1 =',5f8.5,/,7x,6f8.5,//,
     .' gpo1 =',5f8.5,/,7x,6f8.5,//,' gpsi =',5f8.5,/,7x,6f8.5,//,
     .' gppo"=',5f8.5,/,7x,6f8.5,//)
C ******************************************************************

      ICALL=1
      RETURN
      END
C **********************************************************************
      SUBROUTINE REORDR(FA)       
C **********************************************************************
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION FA(11)
      DO 5 JO=6,8
      JS=JO+3
      WOA=FA(JO)
      WSA=FA(JS)
      FA(JO)=WSA
    5 FA(JS)=WOA
      RETURN
      END
C **********************************************************************
C     FOR SU(3)-SYMMETRIC TREATMENT PAIR-EXCHANGES:
C **********************************************************************
      SUBROUTINE SU3SYM(PIM)
C **********************************************************************
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/FORMF/ALAM,ALMP8,ALMV8,ALMS8,ALMP1,ALMV1,ALMS1,
     .             ALMKA,ALMKS,ALMKP
      COMMON/ALLPS/AME,AMX,AMK,BMK
      COMMON/ALLVC/AVEC(2),AMVEC(2),AMOM,AMFI,AMKS,BMKS
      COMMON/ALLSC/ASIG(2),AMSIG(2),ASST,BSST,AMSST,AM2ST,AMD,AMSCK
      COMMON/ALLDF/AMPOM,AMF2,AMA2,AMKSS,G9D(11)
      COMMON/COUCON/ALP,GX0,FX0,THPS,ALVD,GOM,THV,ALVV,FOM,THS,GDEL,
     .GEPS,GSST,ALF,GPOM,GPOMP,GA2,PSID,THD,AHYPC,ALS,SSCAL,ALD,ALPA
      DATA AMPRO/938.2796D0/,AMRO/760.D0/,AMEPS/760.D0/

      THPS = 0.D0
      THV  = 0.D0
      THS  = 0.D0
      ALMP1=ALMP8
      ALMV1=ALMV8
      ALMS1=ALMS8
      ALMKA=ALMP8
      ALMKS=ALMV8
      ALMKP=ALMS8

      PIM=500.D0
      AMK = PIM
      BMK = PIM
      AME = PIM
      AMX = PIM
      AMOM = AMRO
      AMFI = AMRO
      AMKS = AMRO
      AMD  = AMEPS
      AMSCK= AMEPS
      AMSST= AMEPS

      AMSIG(1) = AMEPS
      AMSIG(2) = AMEPS
      ASIG(1)  = 1.D0
      ASIG(2)  = 0.D0
      AMVEC(1) = AMRO
      AMVEC(2) = AMRO
      AVEC(1)  = 1.D0
      AVEC(2)  = 0.D0
      RETURN
      END
C **********************************************************************
      SUBROUTINE YNPAIR(X,INA,IPV,APV)
C **********************************************************************
C *
C     VERSION WITH K-FORM FACTOR: ALMKA (SEPT. 2000)
C
C *   PHENOMENOLOGICAL PION-MESON PAIR YN-POTENTIALS
C *
C     PS-SCAL: ALMP1 = SU(3)-SINGLET, ALMP8 = SU(3)-OCTET
C     VECTOR : ALMV1 = SU(3)-SINGLET, ALMV8 = SU(3)-OCTET
C     SCALAR : ALMS1 = SU(3)-SINGLET, ALMS8 = SU(3)-OCTET
C *
C     IN CALLS AAFUN, ETC. SCHEMATICALLY:
C     FUN(1) = F*G,    FUN(2) = DF*G,   FUN(3) = F*DG,
C     FUN(4) = DF*DG,  FUN(5) = DDF*G,  FUN(6) = F*DDG,
C     FUN(7) = DDF*DG, FUN(8) = DF*DDG, FUN(9) = DDF*DDG
C
C     IN COUPLING COMBINATIONS CENLL1 ETC.:
C     (i) YNCCPR: L+R contributions included,
C     (ii) YNCCPR: 1 <-> 2 interchange factor included (extra diagrams)
C     (iii) FFUN2: identical particle factor included (2 contractions),
C                  facip=2.
C
C     FOR FORM FACTOR TREATMENT SEE:
C     TH.A.RIJKEN, ANNALS OF PHYSICS 208, P.253 (1990).
C
C **********************************************************************
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/PIMAS/PIM0
      COMMON/DYNMAS/REDMM,AMLN,AMSN,AMH,AMSS,AMLS,AMNN
      COMMON/FORMF/ALAM,ALMP8,ALMV8,ALMS8,ALMP1,ALMV1,ALMS1,
     .             ALMKA,ALMKS,ALMKP
      COMMON/POTESC/VCLL,VCSS,VCLS,VCDR,VSLL,VSSS,VSLS,VSDR,
     .              VTLL,VTSS,VTLS,VTDR,VOLL,VOSS,VOLS,VODR
      COMMON/ALLPS/AME,AMX,AMK,BMK
      COMMON/ALLVC/AVEC(2),AMVEC(2),AMOM,AMFI,AMKS,BMKS
      COMMON/ALLSC/ASIG(2),AMSIG(2),ASST,BSST,AMSST,AM2ST,AMD,AMSCK
      COMMON/ALLDF/AMPOM,AMF2,AMA2,AMKSS,G9D(11)
      COMMON/COUCON/ALP,GX0,FX0,THPS,ALVD,GOM,THV,ALVV,FOM,THS,GDEL,
     .GEPS,GSST,ALF,GPOM,GPOMP,GA2,PSID,THD,AHYPC,ALS,SSCAL,ALD,ALPA
      COMMON/COUPL/ F(11),G(11),FD(11),FV(11),GS(11),GD(11),P
C     COMMON/OOM/ INA,IPV,IOFF
C
      DIMENSION FUN(12),WGHTID(2)
C
      COMMON/ALLPR/GSPAIR,GVPAIR,FVPAIR,GPIRO1,GPIRO0,GPISI,HOPAIR
     .            ,GSISI,GPIET,GPIETP,GPIPOM
     .            ,ALPVPR,ALVDPR,ALVVPR,ALSCPR,ALPAPR

C     communication with routine YNPRCC:
C
      COMMON/CCPR/ CCPR1(3,10),CCPR2(10,10),CCPRG(9,10),CCPRF(9,10),
     .CCPR4(9,10),CCPR4F(9,10),CCPR5(6 ,10),CCPR6(10)  ,CCPR7(3,10),
     .CCPR10(13,10)

C     communication with routine WRITEPR:
      COMMON/PRWRITE/VPRA(5,3,4,4),VPRB(5,3,4,4),VPRC(5,3,4,4)
     .              ,VPRD(5,3,4,4),VPRE(5,3,4,4),VPRF(5,3,4,4)
     .              ,VPRG(5,3,4,4),VPRH(5,3,4,4)              
C
      COMMON/PAIRON/IPIPI0,IPIPI1,IPIRO1,IPIRO0,IPIOM,IPISI,
     .ISISI,IPIET,IPIETP,IPIPOM,IPIROV,IPIOMV,IKKB0,IKKB1,IPIA1
      COMMON/TWOPR/N2PR0,N2PR1,N2PRV,N2PRA,N2PRB
      COMMON/ZEROS/IZPS,IZVC,IZSC,IZAX,IZTEN

      DATA PI/3.14159265D0/,SRPI/1.7724538509D0/
      DATA FACID/1.0D0/,SR2/1.4142136D0/,SR3/1.732051D0/,FACIP/2.D0/
      DATA AMPRO/938.2796D0/,AMRO/760.D0/,AMEPS/760.D0/,AMSCR/750.D0/,
     .     AMN/938.2796D0/,FACT/138.041D0/,POLD/-12345.D0/,
     .     AKMAX/0000.D0/,XKMAX/2.D0/

      DATA ICALL/0/,NSCHR/0/,N3/27/,ISU3/0/

      SAVE PIM,XBEGIN,FACT,AMN,DAM,AA,ICALL
C
      if(p.eq.+1.d0) isfac=1
      if(p.eq.-1.d0) isfac=-3
**    isu3=1

C     WEIGHTS OMEGA AND PHI in PHI8, ACCORDING TO MIXING
      WGHTID(1) = DSIN(THV)       
      WGHTID(2) = DCOS(THV)       

      IF(ICALL.EQ.0) THEN
        PIM = PIM0
        IF(ISU3.EQ.1) CALL SU3SYM(PIM)
C       F1 = F(1)
C       GS6= GS(6)
        XBEGIN=X
        FACT  = PIM0
*       AMNC = DSQRT(AM(2)*AM(3))
*       AMHY = DSQRT(AMY(1)*AMY(2))
C       AMN  = DSQRT(AMNN*AMH )
        DAM  = AMH-AMN
        AA   = DAM/PIM0

        PRINT 99, IZSC,INA,IPV,
     .  IPIPI0,IPIPI1,IPIRO1,IPIRO0,IPIROV,IPIOM,IPIOMV,
     .  IPISI,ISISI,IPIET,IPIETP,IKKB0,IKKB1,IPIPOM,
     .  N2PR0,N2PR1,N2PRV,N2PRA,N2PRB,PIM,DAM,ALMKA,
     .  AKMAX,XKMAX
 99     FORMAT(//,'  IN YNPAIR.NOV02: IZSC, INA, IPV=',3I3,//,
     .  11X,'  IPIPI0,IPIPI1,IPIRO1,IPIRO0,IPIROV,IPIOM,IPIOMV=',7I2,//,
     .  11X,'  IPISI ,ISISI ,IPIET ,IPIETP,IKKB0 ,IKKB1,IPIPOM=',7I2,//,
     .  11X,'  N2PR0,N2PR1 ,N2PRV ,N2PRA ,N2PRB =',5(I3,2X),/, 
     .  11X,'  PIM=',F10.3,' DAM=',F10.3,' ALMKA=',F10.3,//, 
     .  '  IN YNPAIR,FOOMPR:  AKMAX=',F10.3,' XKMAX=',F10.3//)
*       ICALL=1
      ENDIF

      if(p.ne.pold) then
      icall=0
      pold=p
      nschr=1
      endif

*     DO 1 I=2,NMAX
*     X = XA(I)
      VCLL  =0.D0
      VCLS  =0.D0
      VCSS  =0.D0
      VCDR  =0.D0
      VSLL  =0.D0
      VSLS  =0.D0
      VSSS  =0.D0
      VSDR  =0.D0
      VTLL  =0.D0
      VTLS  =0.D0
      VTSS  =0.D0
      VTDR  =0.D0
      VCNN  =0.D0
      VSNN  =0.D0
      VTNN  =0.D0
      DO 250 NCHAN=1,5
      DO 250 ITYPV=1,3
      DO 250 IMES1=1,4
      DO 250 IMES2=1,4
      VPRA(NCHAN,ITYPV,IMES1,IMES2)=0.D0
      VPRB(NCHAN,ITYPV,IMES1,IMES2)=0.D0
      VPRC(NCHAN,ITYPV,IMES1,IMES2)=0.D0
      VPRD(NCHAN,ITYPV,IMES1,IMES2)=0.D0
      VPRE(NCHAN,ITYPV,IMES1,IMES2)=0.D0
      VPRF(NCHAN,ITYPV,IMES1,IMES2)=0.D0
  250 VPRH(NCHAN,ITYPV,IMES1,IMES2)=0.D0

C     1/M-CORRECTIONS:
c     IF(INA.EQ.1.OR.IPV.EQ.1) CALL OMPAIR(X,INA,IPV,APV)
c     if(icall.eq.0.and.nschr.eq.1) then
c     write(*,*) ' OMPAIR: x=',x
c     write(*,*) ' vcll,vsll=',vcll,vsll
c     write(*,*) ' vcls,vsls=',vcls,vsls
c     write(*,*) ' vcss,vsss=',vcss,vsss
c     write(*,*) ' vcdr,vsdr=',vcdr,vsdr
c     endif
CC
      X1   =1.D0/X
      X2   =X1*X1     
CC
      CALL FFUN(2,X,PIM,ALMP8,FI,DFI,DDFI,D3FI)
      CALL FFUN(1,X,PIM,ALMP8,FI1,DFI1,DDFI1,D3FI1)
      CALL FFUN(0,X,PIM,ALMP8,VKU,DVKU,DDVKU,D3VKU)
C     FINITE CUT-OFF CORRECTIONS:
      IF(AKMAX.NE.0.D0.AND.X.LT.XKMAX) THEN
      CALL DCOFUN(X,PIM,ALMP8,AKMAX,DFIC0,DFIC1,DFIC2,DFIC3)
      FI = FI + DFIC0
      DFI = DFI + DFIC1
      DDFI = DDFI + DFIC2
      D3FI  = D3FI + DFIC3
      ENDIF
C     ETA:
      CALL FFUN(2,X,AME,ALMP8,FIETA,DFIETA,DDFETA,D3FETA)
C     FINITE CUT-OFF CORRECTIONS:
      IF(AKMAX.NE.0.D0.AND.X.LT.XKMAX) THEN
      CALL DCOFUN(X,AME,ALMP8,AKMAX,DFIC0,DFIC1,DFIC2,DFIC3)
      FIETA = FIETA + DFIC0*AME/PIM
      DFIETA = DFIETA + DFIC1*AME/PIM
      DDFETA  = DDFETA + DFIC2*AME/PIM
      D3FETA   = D3FETA + DFIC3*AME/PIM
      ENDIF
C     ETAP:
      CALL FFUN(2,X,AMX,ALMP1,FIETP,DFIETP,DDFETP,D3FETP)
C     FINITE CUT-OFF CORRECTIONS:
      IF(AKMAX.NE.0.D0.AND.X.LT.XKMAX) THEN
      CALL DCOFUN(X,AMX,ALMP1,AKMAX,DFIC0,DFIC1,DFIC2,DFIC3) 
      FIETP = FIETP + DFIC0*AMX/PIM
      DFIETP = DFIETP + DFIC1*AMX/PIM
      DDFETP  = DDFETP + DFIC2*AMX/PIM
      D3FETP   = D3FETP + DFIC3*AMX/PIM
      ENDIF
  
C     KAON:
**    CALL FFUN(2,X,AMK,ALMP8,FIKA,DFIKA,DDFKA,D3FKA)
      CALL FFUN(2,X,AMK,ALMKA,FIKA,DFIKA,DDFKA,D3FKA)
C     FINITE CUT-OFF CORRECTIONS:
      IF(AKMAX.NE.0.D0.AND.X.LT.XKMAX) THEN
      CALL DCOFUN(X,AMK,ALMKA,AKMAX,DFIC0,DFIC1,DFIC2,DFIC3) 
      FIKA = FIKA + DFIC0*AMK/PIM
      DFIKA = DFIKA + DFIC1*AMK/PIM
      DDFKA  = DDFKA + DFIC2*AMK/PIM
      D3FKA   = D3FKA + DFIC3*AMK/PIM
      ENDIF
CC
*     CALL FFUN(2,X,AMRO,ALMV8,FIRO,DFIR,DDFIR,D3FIR)
      FIRO  = 0.D0
      DFIR  = 0.D0
      DO 410 JJ=1,2
      CALL FFUN(2,X,AMVEC(JJ),ALMV8,FJJ,DFJJ,DDFJJ,D3FJJ)
      FIRO = FIRO + AVEC(JJ)*FJJ
 410  DFIR = DFIR  + AVEC(JJ)*DFJJ
C     K*(892):
      CALL FFUN(2,X,AMKS,ALMV8,FIKS,DFIKS,DDFKS,D3FKS)
  
      CALL FFUN(2,X,AMOM,ALMV1,FIOM,DFIOM,DDFIO,D3FIO)
  
      CALL FFUN(2,X,AMFI,ALMV8,FIPH,DFIPH,DDFIPH,D3FIPH)
CC
*     CALL FFUN(2,X,AMA1,ALMA1,FIA1,DFIA1,DDFIA1,D3FIA1)

CC    CALL FFUN(2,X,AMEPS,ALMS1,FIEP,DFIEP,DDFIEP,D3FIEP)
      FIEP  = 0.D0
      DFIEP = 0.D0
      DDFIEP= 0.D0
      DO 510 JJ=1,2
      IF(IZSC.EQ.0) CALL
     .FFUN(2,X,AMSIG(JJ),ALMS1,FJJ,DFJJ,DDFJJ,D3FJJ)
      IF(IZSC.NE.0) CALL
     .FFUNZ(2,X,AMSIG(JJ),AMSCR,ALMS1,FJJ,DFJJ,DDFJJ,D3FJJ)
      FIEP = FIEP + ASIG(JJ)*FJJ
      DFIEP= DFIEP + ASIG(JJ)*DFJJ
 510  DDFIEP= DDFIEP + ASIG(JJ)*DDFJJ
C     S*:
      IF(IZSC.EQ.0) CALL
     .FFUN(2,X,AMSST,ALMS8,FIST,DFIST,DDFIST,D3FIST)
      IF(IZSC.NE.0) CALL
     .FFUNZ(2,X,AMSST,AMSCR,ALMS8,FIST,DFIST,DDFIST,D3FIST)

C     POMERON:
      XPOM = X*AMPOM/PIM0
      FIPO = (4.D0/SRPI)*(AMPOM/PIM0)*(AMPOM/AMPRO)**2*
     .       FDEXP(-XPOM*XPOM)
      DFIPO = -2*(AMPOM/PIM0)*XPOM*FIPO
      DDFIPO= -2*(AMPOM/PIM0)*(XPOM*DFIPO + FIPO*AMPOM/PIM0)

C------------------------------------------------------------
C
C     CONSTRUCTION OF THE POTENTIALS
C
C------------------------------------------------------------
C A)  SCALAR SU(3)-SINGLET PAIR TERMS, {1}->{8}x{8} :
C
      IF(IPIPI0.NE.0) THEN
      DO 10 II=1,3
      GOTO(11,12,13),II

C     PI-PI(I=0):
11    FFUN1 = 0.5D0*DFI*DFI
      CALL HFUN(0,X,PIM,PIM,ALMP8,ALMP8,0.D0,FUN)
      FFUN2 = -0.5D0*FUN(1)*FACIP
*     VCNN     =   VCNN    + FACT*(
*    .             6*GSPAIR*F1**2*FFUN1 + 3*GSPAIR**2*FFUN2 )*FACIP
      IMES = 1
      GOTO 14

C     ETA-ETA:
12    FFUN1 = 0.5D0*DFIETA*DFIETA
      CALL HFUN(0,X,AME,AME,ALMP8,ALMP8,0.D0,FUN)
      FFUN2 = -0.5D0*FUN(1)*FACIP
      IMES = 3
      GOTO 14

C     KA-KA(I=0):
13    FFUN1 = 0.5D0*DFIKA*DFIKA
**    CALL HFUN(0,X,AMK,AMK,ALMP8,ALMP8,0.D0,FUN)
      CALL HFUN(0,X,AMK,AMK,ALMKA,ALMKA,0.D0,FUN)
      FFUN2 = -0.5D0*FUN(1)
      IMES = 2
      GOTO 14

 14   CONTINUE
      VCLL     =   VCLL    + FACT*(
     .             CCPR1(II,2)*FFUN1 + CCPR1(II,7 )*FFUN2 )
      VCSS     =   VCSS    + FACT*(
     .             CCPR1(II,4)*FFUN1 + CCPR1(II,9 )*FFUN2 )
      VCDR     =   VCDR    + FACT*(
     .             CCPR1(II,5)*FFUN1 + CCPR1(II,10)*FFUN2 )

      VPRA(1,1,IMES,IMES) = VPRA(1,1,IMES,IMES) +  FACT*(
     .             CCPR1(II,1)*FFUN1 + CCPR1(II,6 )*FFUN2 )
      VPRA(2,1,IMES,IMES) = VPRA(2,1,IMES,IMES) +  FACT*(
     .             CCPR1(II,2)*FFUN1 + CCPR1(II,7 )*FFUN2 )
      VPRA(4,1,IMES,IMES) = VPRA(4,1,IMES,IMES) +  FACT*(
     .             CCPR1(II,4)*FFUN1 + CCPR1(II,9 )*FFUN2 )
      VPRA(5,1,IMES,IMES) = VPRA(5,1,IMES,IMES) +  FACT*(
     .             CCPR1(II,5)*FFUN1 + CCPR1(II,10)*FFUN2 )
10    CONTINUE
*     if(icall.eq.0.and.nschr.eq.1) call writepr(1,x,p)
**    if(icall.eq.20.and.nschr.eq.1) call writepr(1,x,p)
      ENDIF
C
C B)  SCALAR SU(3)-OCTET PAIR TERMS,  {8s}->{8}x{8} :
C
      IF(IPIET.NE.0) THEN
      DO 20 II=1,7 
      GOTO(21,22,23,24,25,26,27),II
C     PI-ETA:
21    FFUN1 = 0.5D0*DFI*DFIETA
      CALL HFUN(0,X,PIM,AME,ALMP8,ALMP8,0.D0,FUN)
      FFUN2 = -0.5D0*FUN(1)
      IMES1 = 1
      IMES2 = 3
      GOTO 28

C     KA-KA(8S)(I=1):
22    FFUN1 = 0.5D0*DFIKA*DFIKA
**    CALL HFUN(0,X,AMK,AMK,ALMP8,ALMP8,0.D0,FUN)
      CALL HFUN(0,X,AMK,AMK,ALMKA,ALMKA,0.D0,FUN)
      FFUN2 = -0.5D0*FUN(1)
      IMES1 = 2
      IMES2 = 2
      GOTO 28

C     PI-KA(8s):
23    FFUN1 = 0.5D0*DFI*DFIKA*P
**    CALL HFUN(0,X,PIM,AMK,ALMP8,ALMP8,0.D0,FUN)
      CALL HFUN(0,X,PIM,AMK,ALMP8,ALMKA,0.D0,FUN)
      FFUN2 = -0.5D0*FUN(1)*P
      IMES1 = 1
      IMES2 = 2
      GOTO 28

C     ETA-KA(8s):
24    FFUN1 = 0.5D0*DFIETA*DFIKA*P
**    CALL HFUN(0,X,AME,AMK,ALMP8,ALMP8,0.D0,FUN)
      CALL HFUN(0,X,AME,AMK,ALMP8,ALMKA,0.D0,FUN)
      FFUN2 = -0.5D0*FUN(1)*P
      IMES1 = 2
      IMES2 = 3
      GOTO 28

C     PI-PI(8S)(I=0):
25    FFUN1 = 0.5D0*DFI*DFI
      CALL HFUN(0,X,PIM,PIM,ALMP8,ALMP8,0.D0,FUN)
      FFUN2 = -0.5D0*FUN(1)*FACIP
**    FFUN2 = -0.5D0*FUN(1)
      IMES1 = 1
      IMES2 = 1
      GOTO 28

C     ETA-ETA(8s):
26    FFUN1 = 0.5D0*DFIETA*DFIETA
      CALL HFUN(0,X,AME,AME,ALMP8,ALMP8,0.D0,FUN)
      FFUN2 = -0.5D0*FUN(1)*FACIP
**    FFUN2 = -0.5D0*FUN(1)
      IMES1 = 3
      IMES2 = 3
      GOTO 28

C     KA-KA(8S)(I=0):
27    FFUN1 = 0.5D0*DFIKA*DFIKA
**    CALL HFUN(0,X,AMK,AMK,ALMP8,ALMP8,0.D0,FUN)
      CALL HFUN(0,X,AMK,AMK,ALMKA,ALMKA,0.D0,FUN)
      FFUN2 = -0.5D0*FUN(1)
      IMES1 = 2
      IMES2 = 2
      GOTO 28

 28   CONTINUE

      VCLL   =   VCLL    + FACT*(
     .           CCPR2(II,2)*FFUN1 + CCPR2(II,7)*FFUN2 )
      VCLS   =   VCLS    + FACT*(
     .           CCPR2(II,3)*FFUN1 + CCPR2(II,8)*FFUN2 )
      VCSS   =   VCSS    + FACT*(
     .           CCPR2(II,4)*FFUN1 + CCPR2(II,9)*FFUN2 )
      VCDR   =   VCDR    + FACT*(
     .           CCPR2(II,5)*FFUN1 + CCPR2(II,10)*FFUN2 )

      VPRB(1,1,IMES1,IMES2) = VPRB(1,1,IMES1,IMES2) +  FACT*(
     .           CCPR2(II,1)*FFUN1 + N2PR0*CCPR2(II,6)*FFUN2 )
      VPRB(2,1,IMES1,IMES2) = VPRB(2,1,IMES1,IMES2) +  FACT*(
     .           CCPR2(II,2)*FFUN1 + N2PR0*CCPR2(II,7)*FFUN2 )
      VPRB(3,1,IMES1,IMES2) = VPRB(3,1,IMES1,IMES2) +  FACT*(
     .           CCPR2(II,3)*FFUN1 + N2PR0*CCPR2(II,8)*FFUN2 )
      VPRB(4,1,IMES1,IMES2) = VPRB(4,1,IMES1,IMES2) +  FACT*(
     .           CCPR2(II,4)*FFUN1 + N2PR0*CCPR2(II,9)*FFUN2 )
      VPRB(5,1,IMES1,IMES2) = VPRB(5,1,IMES1,IMES2) +  FACT*(
     .           CCPR2(II,5)*FFUN1 + N2PR0*CCPR2(II,10)*FFUN2 )
20    CONTINUE
*     if(icall.eq.0.and.nschr.eq.1) call writepr(2,x,p)
**    if(icall.eq.20.and.nschr.eq.1) call writepr(2,x,p)
      ENDIF

C     PI-ETA':
*     IF(IPIETP.EQ.1) THEN
*     VC    =   VC + FACT*ISFAC*GPIETP*(
*    .               2*FP*FETAP*DFI*DFIETP-0.5D0*GPIETP*FIPEP2)
*     ENDIF
C
C C)  VECTOR SU(3)-OCTET PAIR TERMS, {8a}->{8}x{8} :
C
C     FOR IDENTICAL MESONS, WE HERE APPLY FACID=1.0D0!!
c     for non-identical mesons, we add a factor 2: P*2!
C
      IF(IPIPI1.NE.0) THEN
**    ALM1 = ALMP8
**    ALM2 = ALMP8
*     DO 30 II=1,9
      DO 30 II=1,6
      GOTO(31,32,33,34,341,35,33,34,341),II
C     PI-PI(I=1):
31    AM1 = PIM
      AM2 = PIM
      ALM1= ALMP8
      ALM2= ALMP8
      FFSIG1 = 0.5D0*X1*DFI*(X1*DFI+2*DDFI)*(PIM0/AMPRO)
      FFTEN1 = 0.5D0*X1*DFI*(X1*DFI-1*DDFI)*(PIM0/AMPRO)
      FFSO1  = X2*DFI*DFI*PIM/AMPRO/2.D0
*     PEX = 1.D0
      PEX = FACID
      IMES1 = 1
      IMES2 = 1
      GOTO 36

C     KA-KA(8A)(I=1):
32    AM1 = AMK
      AM2 = AMK
      ALM1= ALMKA
      ALM2= ALMKA
      FFSIG1 = 0.5D0*X1*DFIKA*(X1*DFIKA+2*DDFKA)*(PIM0/AMPRO)
      FFTEN1 = 0.5D0*X1*DFIKA*(X1*DFIKA-1*DDFKA)*(PIM0/AMPRO)
      FFSO1  = X2*DFIKA*DFIKA*PIM/AMPRO/2.D0
*     PEX = 1.D0
      PEX = FACID
      IMES1 = 2
      IMES2 = 2
      GOTO 36

C     PI-KA(8a):
33    AM1 = PIM
      AM2 = AMK
      ALM1= ALMP8
      ALM2= ALMKA
      FFSIG1 = 0.5D0*X1*(X1*DFI*DFIKA+DFI*DDFKA
     .          + DDFI*DFIKA )*(PIM0/AMPRO)
      FFTEN1 = 0.25D0*X1*(2*X1*DFI*DFIKA-DFI*DDFKA
     .          - DDFI*DFIKA )*(PIM0/AMPRO)
      FFSO1  = X2*DFI*DFIKA*PIM/AMPRO/2.D0
      PEX = P*2
      IF(II.EQ.3) THEN
      IMES1 = 1
      IMES2 = 2
      ENDIF
      IF(II.EQ.7) THEN
      IMES1 = 2
      IMES2 = 1
      ENDIF
      GOTO 36

C     ETA-KA(8a):
34    AM1 = AME
      AM2 = AMK
      ALM1= ALMP8
      ALM2= ALMKA
      FFSIG1 = 0.5D0*X1*(X1*DFIETA*DFIKA+DFIETA*DDFKA
     .          + DDFETA*DFIKA )*(PIM0/AMPRO)
      FFTEN1 = 0.25D0*X1*(2*X1*DFIETA*DFIKA-DFIETA*DDFKA
     .          - DDFETA*DFIKA)*(PIM0/AMPRO)
      FFSO1  = X2*DFIETA*DFIKA*PIM/AMPRO/2.D0
      PEX = P*2
      IF(II.EQ.4) THEN
      IMES1 = 3
      IMES2 = 2
      ENDIF
      IF(II.EQ.8) THEN
      IMES1 = 2
      IMES2 = 3
      ENDIF
      GOTO 36

C     ETAP-KA(8a):
341   AM1 = AMX
      AM2 = AMK
      ALM1= ALMP1
      ALM2= ALMKA
      FFSIG1 = 0.5D0*X1*(X1*DFIETP*DFIKA+DFIETP*DDFKA
     .          + DDFETP*DFIKA )*(PIM0/AMPRO)
      FFTEN1 = 0.25D0*X1*(2*X1*DFIETP*DFIKA-DFIETP*DDFKA
     .          - DDFETP*DFIKA)*(PIM0/AMPRO)
      FFSO1  = X2*DFIETP*DFIKA*PIM/AMPRO/2.D0
      PEX = P*2
      IF(II.EQ.5) THEN
      IMES1 = 4
      IMES2 = 2
      ENDIF
      IF(II.EQ.9) THEN
      IMES1 = 2
      IMES2 = 4
      ENDIF
      GOTO 36

C     KA-KA(8A)(I=0):
35    AM1 = AMK
      AM2 = AMK
      ALM1= ALMKA
      ALM2= ALMKA
      FFSIG1 = 0.5D0*X1*(X1*DFIKA*DFIKA+2*DFIKA*DDFKA)*(PIM0/AMPRO)
      FFTEN1 = 0.5D0*X1*(X1*DFIKA*DFIKA-1*DFIKA*DDFKA)*(PIM0/AMPRO)
      FFSO1  = X2*DFIKA*DFIKA*PIM/AMPRO/2.D0
*     PEX = 1.D0
      PEX = FACID
      IMES1 = 2
      IMES2 = 2
      GOTO 36

36    FFSIG1 = FFSIG1*PEX
      FFTEN1 = FFTEN1*PEX
      CALL HFUN(0,X,AM1,AM2,ALM1,ALM2,0.D0,FUN)
      FGCEN1 = 0.5D0*FUN(4)*PEX
      CALL FFUN(0,X,AM1,ALM1,FI10,DFI10,DDFI10,D3FI10)
      CALL FFUN(1,X,AM1,ALM1,FI11,DFI11,DDFI11,D3FI11)
      CALL FFUN(0,X,AM2,ALM2,FI20,DFI20,DDFI20,D3FI20)
      CALL FFUN(1,X,AM2,ALM2,FI21,DFI21,DDFI21,D3FI21)
      CALL HFUN(-1,X,AM1,AM2,ALM1,ALM2,0.D0,FUN)
      HFUN0 = FUN(1)
      FGCEN2 = -.25D0*(FI11*FI20+FI10*FI21-4*HFUN0)*PEX
      CALL HFUN(0,X,AM1,AM2,ALM1,ALM2,0.D0,FUN)
      DA11 = FUN(4)
      DA12 = FUN(8)
      FFSIG2 = -.5D0*X1*(X1*DA11+2*DA12)*(PIM0/AMPRO)**2*PEX
      FFTEN2 = -.5D0*X1*(2*X1*DA11-2*DA12)*(PIM0/AMPRO)**2*PEX

c     if(x.lt.0.5d0) then
c     write(*,*) ' in ynpairs: ii,x=',ii,x,' pim0,almka=',pim0,almka
c     write(*,*) ' fgcen1,fgcen2,ffsig1,ffsig2=',fgcen1,fgcen2,ffsig1,ffsig2
c     endif

      VCLL  =   VCLL    + FACT*( CCPRG(II,2)*FGCEN1
     .                          +CCPRG(II,7)*FGCEN2 )
      VCLS  =   VCLS    + FACT*( CCPRG(II,3)*FGCEN1
     .                          +CCPRG(II,8)*FGCEN2 )
      VCSS  =   VCSS    + FACT*( CCPRG(II,4)*FGCEN1
     .                          +CCPRG(II,9)*FGCEN2 )
      VCDR  =   VCDR    + FACT*( CCPRG(II,5)*FGCEN1
     .                          +CCPRG(II,10)*FGCEN2 )

      VSLL  =   VSLL    - FACT*( CCPRF(II,2)*FFSIG1/3.D0)
*    .                         + CCPRF(II,7)*FFSIG2/3.D0 )
      VSLS  =   VSLS    - FACT*( CCPRF(II,3)*FFSIG1/3.D0)
*    .                         + CCPRF(II,8)*FFSIG2/3.D0 )
      VSSS  =   VSSS    - FACT*( CCPRF(II,4)*FFSIG1/3.D0)
*    .                         + CCPRF(II,9)*FFSIG2/3.D0 )
      VSDR  =   VSDR    - FACT*( CCPRF(II,5)*FFSIG1/3.D0)
*    .                         + CCPRF(II,10)*FFSIG2/3.D0 )

      VTLL  =   VTLL    - FACT*( CCPRF(II,2)*FFTEN1/3.D0)
*    .                         + CCPRF(II,7)*FFTEN2/3.D0 )
      VTLS  =   VTLS    - FACT*( CCPRF(II,3)*FFTEN1/3.D0)
*    .                         + CCPRF(II,8)*FFTEN2/3.D0 )
      VTSS  =   VTSS    - FACT*( CCPRF(II,4)*FFTEN1/3.D0)
*    .                         + CCPRF(II,9)*FFTEN2/3.D0 )
      VTDR  =   VTDR    - FACT*( CCPRF(II,5)*FFTEN1/3.D0)
*    .                         + CCPRF(II,10)*FFTEN2/3.D0 )

      VOLL  =   VOLL    - FACT*( CCPRG(II,2)*FFSO1)        
      VOLS  =   VOLS    - FACT*( CCPRG(II,3)*FFSO1)       
      VOSS  =   VOSS    - FACT*( CCPRG(II,4)*FFSO1)       
      VODR  =   VODR    - FACT*( CCPRG(II,5)*FFSO1)       

      VPRC(1,1,IMES1,IMES2) = VPRC(1,1,IMES1,IMES2) +  FACT*(
     .                        CCPRG(II,1)*FGCEN1 +CCPRG(II,6)*FGCEN2 )
      VPRC(2,1,IMES1,IMES2) = VPRC(2,1,IMES1,IMES2) +  FACT*(
     .                        CCPRG(II,2)*FGCEN1 +CCPRG(II,7)*FGCEN2 )
      VPRC(3,1,IMES1,IMES2) = VPRC(3,1,IMES1,IMES2) +  FACT*(
     .                        CCPRG(II,3)*FGCEN1 +CCPRG(II,8)*FGCEN2 )
      VPRC(4,1,IMES1,IMES2) = VPRC(4,1,IMES1,IMES2) +  FACT*(
     .                        CCPRG(II,4)*FGCEN1 +CCPRG(II,9)*FGCEN2 )
      VPRC(5,1,IMES1,IMES2) = VPRC(5,1,IMES1,IMES2) +  FACT*(
     .                        CCPRG(II,5)*FGCEN1 +CCPRG(II,10)*FGCEN2 )

      VPRC(1,2,IMES1,IMES2) = VPRC(1,2,IMES1,IMES2) -  FACT*(
     .                                 CCPRF(II,1)*FFSIG1/3.D0 )
*    .                               + CCPRF(II,6)*FFSIG2/3.D0 )
      VPRC(2,2,IMES1,IMES2) = VPRC(2,2,IMES1,IMES2) -  FACT*(
     .                                 CCPRF(II,2)*FFSIG1/3.D0 )
*    .                               + CCPRF(II,7)*FFSIG2/3.D0 )
      VPRC(3,2,IMES1,IMES2) = VPRC(3,2,IMES1,IMES2) -  FACT*(
     .                                 CCPRF(II,3)*FFSIG1/3.D0 )
*    .                               + CCPRF(II,8)*FFSIG2/3.D0 )
      VPRC(4,2,IMES1,IMES2) = VPRC(4,2,IMES1,IMES2) -  FACT*(
     .                                 CCPRF(II,4)*FFSIG1/3.D0 )
*    .                               + CCPRF(II,9)*FFSIG2/3.D0 )
      VPRC(5,2,IMES1,IMES2) = VPRC(5,2,IMES1,IMES2) -  FACT*(
     .                                 CCPRF(II,5)*FFSIG1/3.D0 )
*    .                               + CCPRF(II,10)*FFSIG2/3.D0 )

30    CONTINUE
*     if(icall.eq.0.and.nschr.eq.1) call writepr(3,x,p)
**    if(icall.eq.20.and.nschr.eq.1) call writepr(3,x,p)
      ENDIF
C
C 3)  AXIAL PAIR TERMS OF THE FIRST CLASS:
C
      IF(IPIRO1.NE.0) THEN
**    ALM1 = ALMP8
      ALM2 = ALMV8
      DO 40 II=1,9
      GOTO(41,42,43,44,488,45,46,47,49),II

C     PI-RHO(I=1):
41    FMSIG1= 0.5D0* (2*X1*DFI+DDFI)*FIRO
      FESIG1= 0.5D0* DFI*DFIR
      FMTEN1= 0.5D0* (-X1*DFI+DDFI)*FIRO
      AM1 = PIM
      AM2 = AMRO
      ALM1= ALMP8
      PEX = 1.D0
      IMES1 = 1
      IMES2 = 1
      GOTO 48

C     KA-K*(AXIAL)(I=1):
42    FMSIG1= 0.5D0* (2*X1*DFIKA+DDFKA)*FIKS
      FESIG1= 0.5D0* DFIKA*DFIKS
      FMTEN1= 0.5D0* (-X1*DFIKA+DDFKA)*FIKS
      AM1 = AMK
      AM2 = AMKS
      ALM1= ALMKA
      PEX = 1.D0
      IMES1 = 2
      IMES2 = 2
      GOTO 48

C     PI-K*(AXIAL):
43    FMSIG1= 0.5D0* (2*X1*DFI+DDFI)*FIKS*P
      FESIG1= 0.5D0* DFI*DFIKS*P
      FMTEN1= 0.5D0* (-X1*DFI+DDFI)*FIKS*P
      AM1 = PIM
      AM2 = AMKS
      ALM1= ALMP8
      PEX = P
      IMES1 = 1
      IMES2 = 2
      GOTO 48

C     ETA-K*(AXIAL):
44    FMSIG1= 0.5D0* (2*X1*DFIETA+DDFETA)*FIKS*P
      FESIG1= 0.5D0* DFIETA*DFIKS*P
      FMTEN1= 0.5D0* (-X1*DFIETA+DDFETA)*FIKS*P
      AM1 = AME
      AM2 = AMKS
      ALM1= ALMP8
      PEX = P
      IMES1 = 3
      IMES2 = 2
      GOTO 48

C     ETA'-K*(AXIAL):
488   FMSIG1= 0.5D0* (2*X1*DFIETP+DDFETP)*FIKS*P
      FESIG1= 0.5D0* DFIETP*DFIKS*P
      FMTEN1= 0.5D0* (-X1*DFIETP+DDFETP)*FIKS*P
      AM1 = AMX
      AM2 = AMKS
      ALM1= ALMP1
      PEX = P
      IMES1 = 4
      IMES2 = 2
      GOTO 48

C     KA-K*(AXIAL)(I=0):
45    FMSIG1= 0.5D0* (2*X1*DFIKA+DDFKA)*FIKS
      FESIG1= 0.5D0* DFIKA*DFIKS
      FMTEN1= 0.5D0* (-X1*DFIKA+DDFKA)*FIKS
      AM1 = AMK
      AM2 = AMKS
      ALM1= ALMKA
      PEX = 1.D0
      IMES1 = 2
      IMES2 = 2
      GOTO 48

C     KA-RO(AXIAL):
46    FMSIG1= 0.5D0* (2*X1*DFIKA+DDFKA)*FIRO*P
      FESIG1= 0.5D0* DFIKA*DFIR*P
      FMTEN1= 0.5D0* (-X1*DFIKA+DDFKA)*FIRO*P
      AM1 = AMK
      AM2 = AMRO
      ALM1= ALMKA
      PEX = P
      IMES1 = 2
      IMES2 = 1
      GOTO 48

C     KA-PHI(AXIAL):
47    FMSIG1= 0.5D0* (2*X1*DFIKA+DDFKA)*FIPH*P
      FESIG1= 0.5D0* DFIKA*DFIPH*P
      FMTEN1= 0.5D0* (-X1*DFIKA+DDFKA)*FIPH*P
      AM1 = AMK
      AM2 = AMFI
      ALM1= ALMKA
      ALM2= ALMV8
      PEX = P
      IMES1 = 2
      IMES2 = 3
      GOTO 48

C     KA-OMEGA(AXIAL):
49    FMSIG1= 0.5D0* (2*X1*DFIKA+DDFKA)*FIOM*P
      FESIG1= 0.5D0* DFIKA*DFIOM*P
      FMTEN1= 0.5D0* (-X1*DFIKA+DDFKA)*FIOM*P
      AM1 = AMK
      AM2 = AMOM
      ALM1= ALMKA
      ALM2= ALMV1
      PEX = P
      IMES1 = 2
      IMES2 = 4
      GOTO 48

48    FFSIG1 = FMSIG1
      FFTEN1 = FMTEN1
      FETEN1 = FESIG1
      CALL HFUN(0,X,AM1,AM2,ALM1,ALM2,0.D0,FUN)
      FFSIG2 = -.5D0*FUN(1)*PEX

c     if(x.lt.0.5d0) then
c     write(*,*) ' in ynpairs: ii,x=',ii,x,' pim0,alka=',pim0,almka
c     write(*,*) ' ffsig1,fesig1,ffsig2=',ffsig1,fesig1,ffsig2
c     endif

      VSLL   =   VSLL    - FACT*(
     .              (PIM0/AMN/6.D0)*( CCPR4(II,2)*FFSIG1
     .             -2*(CCPR4(II,2)+CCPR4F(II,2))*FESIG1 )
     .             - CCPR4(II,7)*FFSIG2 )
      VSLS   =   VSLS    - FACT*(
     .              (PIM0/AMN/6.D0)*( CCPR4(II,3)*FFSIG1
     .             -2*(CCPR4(II,3)+CCPR4F(II,3))*FESIG1 )
     .             - CCPR4(II,8)*FFSIG2 )
      VSSS   =   VSSS    - FACT*(
     .              (PIM0/AMN/6.D0)*( CCPR4(II,4)*FFSIG1
     .             -2*(CCPR4(II,4)+CCPR4F(II,4))*FESIG1 )
     .             - CCPR4(II,9)*FFSIG2 )
      VSDR   =   VSDR    - FACT*(
     .              (PIM0/AMN/6.D0)*( CCPR4(II,5)*FFSIG1
     .             -2*(CCPR4(II,5)+CCPR4F(II,5))*FESIG1 )
     .             - CCPR4(II,10)*FFSIG2 )

      VTLL   =   VTLL    - FACT*(
     .              (PIM0/AMN/6.D0)*( CCPR4(II,2)*FFTEN1
     .              + (CCPR4(II,2)+CCPR4F(II,2))*FETEN1 ))
      VTLS   =   VTLS    - FACT*(
     .              (PIM0/AMN/6.D0)*( CCPR4(II,3)*FFTEN1
     .              + (CCPR4(II,3)+CCPR4F(II,3))*FETEN1 ))
      VTSS   =   VTSS    - FACT*(
     .              (PIM0/AMN/6.D0)*( CCPR4(II,4)*FFTEN1
     .              + (CCPR4(II,4)+CCPR4F(II,4))*FETEN1 ))
      VTDR   =   VTDR    - FACT*(
     .              (PIM0/AMN/6.D0)*( CCPR4(II,5)*FFTEN1
     .              + (CCPR4(II,5)+CCPR4F(II,5))*FETEN1 ))

      VPRD(1,2,IMES1,IMES2) = VPRD(1,2,IMES1,IMES2) - FACT*(
     .              (PIM0/AMN/6.D0)*( CCPR4(II,1)*FFSIG1
     .             -2*(CCPR4(II,1)+CCPR4F(II,1))*FESIG1 )
     .             - CCPR4(II,6)*FFSIG2 )
      VPRD(2,2,IMES1,IMES2) = VPRD(2,2,IMES1,IMES2) - FACT*(
     .              (PIM0/AMN/6.D0)*( CCPR4(II,2)*FFSIG1
     .             -2*(CCPR4(II,2)+CCPR4F(II,2))*FESIG1 )
     .             - CCPR4(II,7)*FFSIG2 )
      VPRD(3,2,IMES1,IMES2) = VPRD(3,2,IMES1,IMES2) - FACT*(
     .              (PIM0/AMN/6.D0)*( CCPR4(II,3)*FFSIG1
     .             -2*(CCPR4(II,3)+CCPR4F(II,3))*FESIG1 )
     .             - CCPR4(II,8)*FFSIG2 )
      VPRD(4,2,IMES1,IMES2) = VPRD(4,2,IMES1,IMES2) - FACT*(
     .              (PIM0/AMN/6.D0)*( CCPR4(II,4)*FFSIG1
     .             -2*(CCPR4(II,4)+CCPR4F(II,4))*FESIG1 )
     .             - CCPR4(II,9)*FFSIG2 )
      VPRD(5,2,IMES1,IMES2) = VPRD(5,2,IMES1,IMES2) - FACT*(
     .              (PIM0/AMN/6.D0)*( CCPR4(II,5)*FFSIG1
     .             -2*(CCPR4(II,5)+CCPR4F(II,5))*FESIG1 )
     .             - CCPR4(II,10)*FFSIG2 )
40    CONTINUE
*     if(icall.eq.0.and.nschr.eq.1) call writepr(4,x,p)
**    if(icall.eq.20.and.nschr.eq.1) call writepr(4,x,p)
      ENDIF

C
C 4)  AXIAL PAIR TERMS OF THE SECOND CLASS:
C
*     IF(IPIRO0.EQ.1) THEN
*     VSIG  =   VSIG + FACT*(-1.5D0*GPIRO0**2*FIHS2
*    .      -2*GPIRO0*GRNN*FP*( (2*X1*DFI+DDFI)*FIRO+DFI*DFIR) )
*
*     VTEN  =   VTEN + FACT*(-1.5D0*GPIRO0**2*FIHT2
*    .      -2*GPIRO0*GRNN*FP*( (-X1*DFI+DDFI)*FIRO+DFI*DFIR) )
*     ENDIF
C
C 5)  AXIAL SECOND CLASS PAIR TERMS (I=1, PION-OMEGA) :
*     IF(IPIOM.EQ.1) THEN
*     IF(HOPAIR.NE.0.D0) THEN
*     VSIG  =   VSIG  + FACT*ISFAC*(-0.5D0*HOPAIR**2*FIHOS2
*    .      -(2/3.D0)*HOPAIR*GONN*FP*( (2*X1*DFI+DDFI)*FIOM+DFI*DFIOM) )
*     VTEN  =   VTEN  + FACT*ISFAC*(-0.5D0*HOPAIR**2*FIHOT2
*    .      -(2/3.D0)*HOPAIR*GONN*FP*( (-X1*DFI+DDFI)*FIOM+DFI*DFIOM) )
*     ENDIF
*     ENDIF
C------------------------------------------------------------
C
C E)  AXIAL PAIR TERMS OF THE SECOND CLASS:
C
C------------------------------------------------------------
C     HERE: ETA8 = ETA(548) (THPS IS SMALL), 
C           PHI8 = WGHTID(1)*OMEGA(783)+WGHTID(2)*PHI(1019)
C------------------------------------------------------------
      IF(IPIOM.EQ.2) THEN
***   DO 90 II=IIMIN,10
      DO 90 II=1,13
      PEX = 1.D0
      GOTO(91,911,92,93,94,95,96,97,971,98,981,991,992),II

C     PI-OMEGA  
91    FFSIG1= -0.5D0*((2*X1*DFI+DDFI)*FIOM+DFI*DFIOM)*WGHTID(1)
      FFTEN1= -0.5D0*(( -X1*DFI+DDFI)*FIOM+DFI*DFIOM)*WGHTID(1)
      CALL HFUN(0,X,PIM,AMOM,ALMP8,ALMV1,0.D0,FUN)
      GOTO 990
C     PI-PHI:   
911   FFSIG1= -0.5D0*((2*X1*DFI+DDFI)*FIPH+DFI*DFIPH)*WGHTID(2)
      FFTEN1= -0.5D0*(( -X1*DFI+DDFI)*FIPH+DFI*DFIPH)*WGHTID(2)
      CALL HFUN(0,X,PIM,AMFI,ALMP8,ALMV8,0.D0,FUN)
      IMES1 = 1
      IMES2 = 3
      GOTO 990

C     ETA-RHO:   
92    FFSIG1= -0.5D0*((2*X1*DFIETA+DDFETA)*FIRO+DFIETA*DFIR )
      FFTEN1= -0.5D0*(( -X1*DFIETA+DDFETA)*FIRO+DFIETA*DFIR )
      CALL HFUN(0,X,AME,AMRO,ALMP8,ALMV8,0.D0,FUN)
      IMES1 = 3
      IMES2 = 1
      GOTO 990

C     KA-K*(8S)(I=1):
93    FFSIG1= -0.5D0*((2*X1*DFIKA+DDFKA)*FIKS+DFIKA*DFIKS )
      FFTEN1= -0.5D0*(( -X1*DFIKA+DDFKA)*FIKS+DFIKA*DFIKS )
      CALL HFUN(0,X,AMK,AMKS,ALMP8,ALMV8,0.D0,FUN)
      IMES1 = 2
      IMES2 = 2
      GOTO 990

C     PI-K*(8S):
94    FFSIG1= -0.5D0*((2*X1*DFI+DDFI)*FIKS+DFI*DFIKS )*P
      FFTEN1= -0.5D0*(( -X1*DFI+DDFI)*FIKS+DFI*DFIKS )*P
      CALL HFUN(0,X,PIM,AMKS,ALMP8,ALMV8,0.D0,FUN)
      IMES1 = 1
      IMES2 = 2
      PEX = P
      GOTO 990

C     KA-RHO(8S)(I=1):
95    FFSIG1= -0.5D0*((2*X1*DFIKA+DDFKA)*FIRO+DFIKA*DFIR )*P
      FFTEN1= -0.5D0*(( -X1*DFIKA+DDFKA)*FIRO+DFIKA*DFIR )*P
      CALL HFUN(0,X,AMK,AMRO,ALMP8,ALMV8,0.D0,FUN)
      IMES1 = 2
      IMES2 = 1
      PEX = P
      GOTO 990

C     ETA-K*:    
96    FFSIG1= -0.5D0*((2*X1*DFIETA+DDFETA)*FIKS+DFIETA*DFIKS )*P
      FFTEN1= -0.5D0*(( -X1*DFIETA+DDFETA)*FIKS+DFIETA*DFIKS )*P
      CALL HFUN(0,X,AME,AMKS,ALMP8,ALMV8,0.D0,FUN)
      IMES1 = 3
      IMES2 = 2
      PEX = P
      GOTO 990

C     KA-PHI8:  
C     KA-OMEGA:
97    FFSIG1= -0.5D0*((2*X1*DFIKA+DDFKA)*FIOM+DFIKA*DFIOM)
     .*WGHTID(1)*P
      FFTEN1= -0.5D0*(( -X1*DFIKA+DDFKA)*FIOM+DFIKA*DFIOM)
     .*WGHTID(1)*P
      CALL HFUN(0,X,AMK,AMOM,ALMP8,ALMV1,0.D0,FUN)
      PEX = P
      GOTO 990

C     KA-PHI:   
971   FFSIG1= -0.5D0*((2*X1*DFIKA+DDFKA)*FIPH+DFIKA*DFIPH)
     .*WGHTID(2)*P
      FFTEN1= -0.5D0*(( -X1*DFIKA+DDFKA)*FIPH+DFIKA*DFIPH)
     .*WGHTID(2)*P
      CALL HFUN(0,X,AMK,AMFI,ALMP8,ALMV8,0.D0,FUN)
      IMES1 = 2
      IMES2 = 3
      PEX = P
      GOTO 990

C     PI-RHO(8S)(I=0):
98    FFSIG1= -0.5D0*((2*X1*DFI+DDFI)*FIRO+DFI*DFIR )
      FFTEN1= -0.5D0*(( -X1*DFI+DDFI)*FIRO+DFI*DFIR )
      CALL HFUN(0,X,PIM,AMRO,ALMP8,ALMV8,0.D0,FUN)
      IMES1 = 1
      IMES2 = 1
      GOTO 990

C     KA-K*(8S)(I=0):
981   FFSIG1= -0.5D0*((2*X1*DFIKA+DDFKA)*FIKS+DFIKA*DFIKS )
      FFTEN1= -0.5D0*(( -X1*DFIKA+DDFKA)*FIKS+DFIKA*DFIKS )
      CALL HFUN(0,X,AMK,AMKS,ALMP8,ALMV8,0.D0,FUN)
      IMES1 = 2
      IMES2 = 2
      GOTO 990

C     ETA-OMEGA(8s):
991   FFSIG1= -0.5D0*((2*X1*DFIETA+DDFETA)*FIOM+DFIETA*DFIOM)
     .*WGHTID(1)
      FFTEN1= -0.5D0*(( -X1*DFIETA+DDFETA)*FIOM+DFIETA*DFIOM)
     .*WGHTID(1)
      CALL HFUN(0,X,AME,AMOM,ALMP8,ALMV1,0.D0,FUN)
      GOTO 990

C     ETA-PHI(8s):
992   FFSIG1= -0.5D0*((2*X1*DFIETA+DDFETA)*FIPH+DFIETA*DFIPH)
     .*WGHTID(2)
      FFTEN1= -0.5D0*(( -X1*DFIETA+DDFETA)*FIPH+DFIETA*DFIPH)
     .*WGHTID(2)
      CALL HFUN(0,X,AME,AMFI,ALMP8,ALMV8,0.D0,FUN)
      IMES1 = 3
      IMES2 = 3
      GOTO 990

990   FFSIG2 = -0.5D0*( (2*X1*FUN(2)+FUN(5))
     .                 +(2*X1*FUN(3)+FUN(6)) +2*FUN(4) )*PEX
      FFTEN2 = -0.5D0*( (-X1*FUN(2)+FUN(5))
     .                  +(-X1*FUN(3)+FUN(6)) +2*FUN(4) )*PEX
c     if(icall.eq.20.and.nschr.eq.1) then               
c     write(37,*) 'ynpairs: ii,x=',ii,x
c     write(37,*) 'ffsig1,ffsig2=',ffsig1,ffsig2
c     write(37,*) 'ccpr10(ii,kk=1-5)=',ccpr10(ii,1),ccpr10(ii,2),
c    .ccpr10(ii,3),ccpr10(ii,4),ccpr10(ii,5)
c     endif

      VSNN   =   VSNN    + FACT*(
     .           CCPR10(II,1)*FFSIG1 + CCPR10(II,6)*FFSIG2 )/3.D0
      VSLL   =   VSLL    + FACT*(
     .           CCPR10(II,2)*FFSIG1 + CCPR10(II,7)*FFSIG2 )/3.D0
      VSLS   =   VSLS    + FACT*(
     .           CCPR10(II,3)*FFSIG1 + CCPR10(II,8)*FFSIG2 )/3.D0
      VSSS   =   VSSS    + FACT*(
     .           CCPR10(II,4)*FFSIG1 + CCPR10(II,9)*FFSIG2 )/3.D0
      VSDR   =   VSDR    + FACT*(
     .           CCPR10(II,5)*FFSIG1 + CCPR10(II,10)*FFSIG2 )/3.D0

      VTNN   =   VTNN    + FACT*(
     .           CCPR10(II,1)*FFTEN1 + CCPR10(II,6)*FFTEN2 )/3.D0
      VTLL   =   VTLL    + FACT*(
     .           CCPR10(II,2)*FFTEN1 + CCPR10(II,7)*FFTEN2 )/3.D0
      VTLS   =   VTLS    + FACT*(
     .           CCPR10(II,3)*FFTEN1 + CCPR10(II,8)*FFTEN2 )/3.D0
      VTSS   =   VTSS    + FACT*(
     .           CCPR10(II,4)*FFTEN1 + CCPR10(II,9)*FFTEN2 )/3.D0
      VTDR   =   VTDR    + FACT*(
     .           CCPR10(II,5)*FFTEN1 + CCPR10(II,10)*FFTEN2 )/3.D0

      VPRH(1,2,IMES1,IMES2) = VPRH(1,2,IMES1,IMES2) + FACT*(
     .           1*CCPR10(II,1)*FFSIG1 + CCPR10(II,6)*FFSIG2 )/3.D0
      VPRH(2,2,IMES1,IMES2) = VPRH(2,2,IMES1,IMES2) + FACT*(
     .           1*CCPR10(II,2)*FFSIG1 + CCPR10(II,7)*FFSIG2 )/3.D0
      VPRH(3,2,IMES1,IMES2) = VPRH(3,2,IMES1,IMES2) + FACT*(
     .           1*CCPR10(II,3)*FFSIG1 + CCPR10(II,8)*FFSIG2 )/3.D0
      VPRH(4,2,IMES1,IMES2) = VPRH(4,2,IMES1,IMES2) + FACT*(
     .           1*CCPR10(II,4)*FFSIG1 + CCPR10(II,9)*FFSIG2 )/3.D0
      VPRH(5,2,IMES1,IMES2) = VPRH(5,2,IMES1,IMES2) + FACT*(
     .           1*CCPR10(II,5)*FFSIG1 + CCPR10(II,10)*FFSIG2 )/3.D0
90    CONTINUE
*     if(icall.eq.0.and.nschr.eq.1) call writepr(8,x,p)
**    if(icall.eq.20.and.nschr.eq.1) write(37,*) 'ccpr10=',ccpr10        
**    if(icall.eq.20.and.nschr.eq.1) call writepr(8,x,p)
      ENDIF
C------------------------------------------------------------
C
C 6)  PSEUDO SCALAR (PION-EPSILON) PAIR TERMS:
      IF(IPISI.NE.0) THEN
      DO 50 II=1,6
      GOTO(51,52,53,54,55,56),II

C     PI-EPSILON:
51    FFSIG1= 0.5D0*( (2*X1*DFI+DDFI)*FIEP -DFI*DFIEP)
      FFTEN1= 0.5D0*( (-X1*DFI+DDFI)*FIEP -DFI*DFIEP )
      AM1 = PIM
      ALM1= ALMP8
      PEX = 1.D0
      IMES1 = 1
      IMES2 = 4
      GOTO 57

C     KA-EPSILON:
52    FFSIG1= 0.5D0*( (2*X1*DFIKA+DDFKA)*FIEP -DFIKA*DFIEP)*P
      FFTEN1= 0.5D0*( (-X1*DFIKA+DDFKA)*FIEP -DFIKA*DFIEP )*P
      AM1 = AMK
      ALM1= ALMKA
      PEX = P
      IMES1 = 2
      IMES2 = 4
      GOTO 57

C     ETA-EPSILON:
53    FFSIG1= 0.5D0*( (2*X1*DFIETA+DDFETA)*FIEP -DFIETA*DFIEP)
      FFTEN1= 0.5D0*( (-X1*DFIETA+DDFETA)*FIEP -DFIETA*DFIEP )
      AM1 = AME
      ALM1= ALMP8
      PEX = 1.D0
      IMES1 = 3
      IMES2 = 4
      GOTO 57

C     PI-SSTAR:
54    FFSIG1= 0.5D0*( (2*X1*DFI+DDFI)*FIST -DFI*DFIST)
      FFTEN1= 0.5D0*( (-X1*DFI+DDFI)*FIST -DFI*DFIST )
      AM1 = PIM
      AM2 = AMSST
      ALM1= ALMP8
      PEX = 1.D0
      IMES1 = 1
      IMES2 = 3
      GOTO 57

C     KA-SSTAR:
55    FFSIG1= 0.5D0*( (2*X1*DFIKA+DDFKA)*FIST -DFIKA*DFIST)*P
      FFTEN1= 0.5D0*( (-X1*DFIKA+DDFKA)*FIST -DFIKA*DFIST )*P
      AM1 = AMK
      AM2 = AMSST
      ALM1= ALMKA
      PEX = P
      IMES1 = 2
      IMES2 = 3
      GOTO 57

C     ETA-SSTAR:
56    FFSIG1= 0.5D0*( (2*X1*DFIETA+DDFETA)*FIST -DFIETA*DFIST)
      FFTEN1= 0.5D0*( (-X1*DFIETA+DDFETA)*FIST -DFIETA*DFIST )
      AM1 = AME
      AM2 = AMSST
      ALM1= ALMP8
      PEX = 1.D0
      IMES1 = 3
      IMES2 = 3
      GOTO 57

57    IF(II.LE.3) THEN
      FFSIG2 = 0.D0
      FFTEN2 = 0.D0
      IF(N2PRA.EQ.1) THEN
      DO 112 JJ=1,2
      AM2=AMSIG(JJ)
      CALL HFUN(0,X,AM1,AM2,ALM1,ALMS1,0.D0,FUN)
      FFSIG2 = FFSIG2+ ASIG(JJ)*0.5D0*( (2*X1*FUN(2)+FUN(5))
     .                 +(2*X1*FUN(3)+FUN(6)) -2*FUN(4) )*PEX
  112 FFTEN2 = FFTEN2+ ASIG(JJ)*0.5D0*( (-X1*FUN(2)+FUN(5))
     .                 +(-X1*FUN(3)+FUN(6)) -2*FUN(4) )*PEX
      ENDIF
      ELSE
      CALL HFUN(0,X,AM1,AM2,ALM1,ALMS8,0.D0,FUN)
      FFSIG2 =        +N2PRA*0.5D0*( (2*X1*FUN(2)+FUN(5))
     .                 +(2*X1*FUN(3)+FUN(6)) -2*FUN(4) )*PEX
      FFTEN2 =        +N2PRA*0.5D0*( (-X1*FUN(2)+FUN(5))
     .                 +(-X1*FUN(3)+FUN(6)) -2*FUN(4) )*PEX
      ENDIF

      VSNN   =   VSNN    + FACT*(
     .           CCPR5(II,1)*FFSIG1 + CCPR5(II,6)*FFSIG2 )/3.D0
      VSLL   =   VSLL    + FACT*(
     .           CCPR5(II,2)*FFSIG1 + CCPR5(II,7)*FFSIG2 )/3.D0
      VSLS   =   VSLS    + FACT*(
     .           CCPR5(II,3)*FFSIG1 + CCPR5(II,8)*FFSIG2 )/3.D0
      VSSS   =   VSSS    + FACT*(
     .           CCPR5(II,4)*FFSIG1 + CCPR5(II,9)*FFSIG2 )/3.D0
      VSDR   =   VSDR    + FACT*(
     .           CCPR5(II,5)*FFSIG1 + CCPR5(II,10)*FFSIG2 )/3.D0

      VTNN   =   VTNN    + FACT*(
     .           CCPR5(II,1)*FFTEN1 + CCPR5(II,6)*FFTEN2 )/3.D0
      VTLL   =   VTLL    + FACT*(
     .           CCPR5(II,2)*FFTEN1 + CCPR5(II,7)*FFTEN2 )/3.D0
      VTLS   =   VTLS    + FACT*(
     .           CCPR5(II,3)*FFTEN1 + CCPR5(II,8)*FFTEN2 )/3.D0
      VTSS   =   VTSS    + FACT*(
     .           CCPR5(II,4)*FFTEN1 + CCPR5(II,9)*FFTEN2 )/3.D0
      VTDR   =   VTDR    + FACT*(
     .           CCPR5(II,5)*FFTEN1 + CCPR5(II,10)*FFTEN2 )/3.D0

      VPRE(1,2,IMES1,IMES2) = + FACT*(
     .           1*CCPR5(II,1)*FFSIG1 + CCPR5(II,6)*FFSIG2 )/3.D0
      VPRE(2,2,IMES1,IMES2) = + FACT*(
     .           1*CCPR5(II,2)*FFSIG1 + CCPR5(II,7)*FFSIG2 )/3.D0
      VPRE(3,2,IMES1,IMES2) = + FACT*(
     .           1*CCPR5(II,3)*FFSIG1 + CCPR5(II,8)*FFSIG2 )/3.D0
      VPRE(4,2,IMES1,IMES2) = + FACT*(
     .           1*CCPR5(II,4)*FFSIG1 + CCPR5(II,9)*FFSIG2 )/3.D0
      VPRE(5,2,IMES1,IMES2) = + FACT*(
     .           1*CCPR5(II,5)*FFSIG1 + CCPR5(II,10)*FFSIG2 )/3.D0
50    CONTINUE
*     if(icall.eq.0.and.nschr.eq.1) call writepr(5,x,p)
**    if(icall.eq.20.and.nschr.eq.1) call writepr(5,x,p)
      ENDIF
C
C     PSEUDO SCALAR (PS-POMERON) PAIR TERMS:
      IF(IPIPOM.NE.0) THEN
      DO 70 II=1,3
      GOTO(71,72,73),II

C     PI-POMERON:
71    FFSIG1= 0.5D0*( (2*X1*DFI+DDFI)*FIPO -DFI*DFIPO)
      FFTEN1= 0.5D0*( (-X1*DFI+DDFI)*FIPO -DFI*DFIPO )
      AM1 = PIM
      ALM1= ALMP8
      PEX = 1.D0
      IMES1 = 1
      IMES2 = 4
      GOTO 74

C     KA-POMERON:
72    FFSIG1= 0.5D0*( (2*X1*DFIKA+DDFKA)*FIPO -DFIKA*DFIPO)*P
      FFTEN1= 0.5D0*( (-X1*DFIKA+DDFKA)*FIPO -DFIKA*DFIPO )*P
      AM1 = AMK
      ALM1= ALMKA
      PEX = P
      IMES1 = 2
      IMES2 = 4
      GOTO 74

C     ETA-POMERON:
73    FFSIG1= 0.5D0*( (2*X1*DFIETA+DDFETA)*FIPO -DFIETA*DFIPO)
      FFTEN1= 0.5D0*( (-X1*DFIETA+DDFETA)*FIPO -DFIETA*DFIPO )
      AM1 = AME
      ALM1= ALMP8
      PEX = 1.D0
      IMES1 = 3
      IMES2 = 4
      GOTO 74

74    FFSIG2 = 0.D0
      FFTEN2 = 0.D0
      AM2=AMPOM
      CALL HDIF(0,X,AM1,AM2,ALM1,0.D0,FUN)
      FFSIG2 =         0.5D0*( (2*X1*FUN(2)+FUN(5))
     .                 +(2*X1*FUN(3)+FUN(6)) -2*FUN(4) )*PEX
      FFTEN2 =         0.5D0*( (-X1*FUN(2)+FUN(5))
     .                 +(-X1*FUN(3)+FUN(6)) -2*FUN(4) )*PEX

      VSNN   =   VSNN    - FACT*(
     .           CCPR7(II,1)*FFSIG1 + CCPR7(II,6)*FFSIG2 )/3.D0
      VSLL   =   VSLL    - FACT*(
     .           CCPR7(II,2)*FFSIG1 + CCPR7(II,7)*FFSIG2 )/3.D0
      VSLS   =   VSLS    - FACT*(
     .           CCPR7(II,3)*FFSIG1 + CCPR7(II,8)*FFSIG2 )/3.D0
      VSSS   =   VSSS    - FACT*(
     .           CCPR7(II,4)*FFSIG1 + CCPR7(II,9)*FFSIG2 )/3.D0
      VSDR   =   VSDR    - FACT*(
     .           CCPR7(II,5)*FFSIG1 + CCPR7(II,10)*FFSIG2 )/3.D0

      VTNN   =   VTNN    - FACT*(
     .           CCPR7(II,1)*FFTEN1 + CCPR7(II,6)*FFTEN2 )/3.D0
      VTLL   =   VTLL    - FACT*(
     .           CCPR7(II,2)*FFTEN1 + CCPR7(II,7)*FFTEN2 )/3.D0
      VTLS   =   VTLS    - FACT*(
     .           CCPR7(II,3)*FFTEN1 + CCPR7(II,8)*FFTEN2 )/3.D0
      VTSS   =   VTSS    - FACT*(
     .           CCPR7(II,4)*FFTEN1 + CCPR7(II,9)*FFTEN2 )/3.D0
      VTDR   =   VTDR    - FACT*(
     .           CCPR7(II,5)*FFTEN1 + CCPR7(II,10)*FFTEN2 )/3.D0

      VPRF(1,2,IMES1,IMES2) = - FACT*(
     .           1*CCPR7(II,1)*FFSIG1 + CCPR7(II,6)*FFSIG2 )/3.D0
      VPRF(2,2,IMES1,IMES2) = - FACT*(
     .           1*CCPR7(II,2)*FFSIG1 + CCPR7(II,7)*FFSIG2 )/3.D0
      VPRF(3,2,IMES1,IMES2) = - FACT*(
     .           1*CCPR7(II,3)*FFSIG1 + CCPR7(II,8)*FFSIG2 )/3.D0
      VPRF(4,2,IMES1,IMES2) = - FACT*(
     .           1*CCPR7(II,4)*FFSIG1 + CCPR7(II,9)*FFSIG2 )/3.D0
      VPRF(5,2,IMES1,IMES2) = - FACT*(
     .           1*CCPR7(II,5)*FFSIG1 + CCPR7(II,10)*FFSIG2 )/3.D0
70    CONTINUE
*     if(icall.eq.0.and.nschr.eq.1) call writepr(6,x,p)
**    if(icall.eq.20.and.nschr.eq.1) call writepr(6,x,p)
      ENDIF

C
C D)  SCALAR SU(3)-SINGLET PAIR TERMS, {1}->{1}x{1} :
C

C 7)  SCALAR (EPSILON-EPSILON) PAIR TERMS:
      IF(ISISI.NE.0) THEN
C     EPSILON-EPSILON:
      FFUN1 = 0.5D0*FIEP*FIEP
      CALL HFUN(0,X,AMEPS,AMEPS,ALMS1,ALMS1,0.D0,FUN)
      FFUN2 = -0.5D0*FUN(1)*FACIP

      VCNN    = VCNN    +FACT*(CCPR6(6)*FFUN2+CCPR6(1)*FFUN1)
      VCLL    = VCLL    +FACT*(CCPR6(7)*FFUN2+CCPR6(2)*FFUN1)
      VCSS    = VCSS    +FACT*(CCPR6(9)*FFUN2+CCPR6(4)*FFUN1)
      VCDR    = VCDR    +FACT*(CCPR6(10)*FFUN2+CCPR6(5)*FFUN1)
*     if(icall.eq.0.and.nschr.eq.1) then                    
      if(icall.eq.20.and.nschr.eq.1) then                    
      VPRGNN  =         +FACT*(CCPR6(6)*FFUN2+CCPR6(1)*FFUN1)
      VPRGLL  =         +FACT*(CCPR6(7)*FFUN2+CCPR6(2)*FFUN1)
      VPRGSS  =         +FACT*(CCPR6(9)*FFUN2+CCPR6(4)*FFUN1)
      VPRGDR  =         +FACT*(CCPR6(10)*FFUN2+CCPR6(5)*FFUN1)
      write(N3,*) ' EPSILON-EPSILON PAIR-TERMS: x=',x
      write(N3,*) ' VCNN=',vprgnn,' VCDR=',vprgdr
      write(N3,*) ' VCLL=',vprgll,' VCSS=',vprgss
      write(N3,*) '***************************************************'
      endif
      ENDIF
C
C 8)  VECTOR (PION-A1) PAIR TERMS:
C
*     IF(IPIA1.EQ.1) THEN
*     VC    =   VC + FACT*ISFAC*GPIA1*(GPIA1*FIPA1C
*    .                 - FP*(PIM/AMN)*(2*X1*DFI+DDFI)*FIA1 )
*     VSIG  =   VSIG - FACT*ISFAC*GPIA1*FA1*FP*(PIM/AMN)*
*    .          ((2*X1*DFI+DDFI)*FIA1 + DFI*DFIA)*(4.D0/3.D0)
*     VTEN  =   VTEN - FACT*ISFAC*GPIA1*FA1*FP*(PIM/AMN)*
*    .          ((X1*DFI-DDFI)*FIA1 - DFI*DFIA)*(2.D0/3.D0)
*     ENDIF
C
CC
*     if(icall.eq.0.and.nschr.eq.1) then                
c     if(icall.eq.20.and.nschr.eq.1) then                    
c     write(N3,*) ' YNPAIRS: contributions: x=',x
c     write(N3,*) ' vcll,vsll=',vcll,vsll
c     write(N3,*) ' vcls,vsls=',vcls,vsls
c     write(N3,*) ' vcss,vsss=',vcss,vsss
c     write(N3,*) ' vcdr,vsdr=',vcdr,vsdr
c     endif

C     1/M-CORRECTIONS:
      IF(INA.EQ.1.OR.IPV.EQ.1) THEN
      CALL OMPAIR(X,INA,IPV,APV)     
      ENDIF
c     if(icall.eq.20.and.nschr.eq.1) then                    
c     write(N3,*) ' YNPAIR+OMPAIR: x=',x
c     write(N3,*) ' vcll,vsll=',vcll,vsll
c     write(N3,*) ' vcls,vsls=',vcls,vsls
c     write(N3,*) ' vcss,vsss=',vcss,vsss
c     write(N3,*) ' vcdr,vsdr=',vcdr,vsdr
c     endif

      ICALL=ICALL+1
      RETURN
      END
C **********************************************************************
      SUBROUTINE YNPRCC(NTYPE,NCASE,ALFA,ALFB,P)
C **********************************************************************
C *   in this version: YNPRCC and YCCMPE give identical results!!
C **********************************************************************
C *
C *   COMPUTATION COUPLING-CONSTANT COMBINATIONS FOR THE
C *   1-PAIR AND 2-PAIR DIAGRAMS FOR THE YN-CHANNELS
C *
C     ntype = 1 : 1  -> {8}x{8}
C     ntype = 2 : 8s -> {8}x{8}
C     ntype = 3 : 8a -> {8}x{8}
C     ntype = 4 : 8  -> {8}x{1}
C     ntype = 5 : 1  -> {1}x{1}
C     ntype = 6 : 8s -> {8}x{8}
C
C     ncase: 1 -> pipi, 2 -> etc.
C
C !!  NOTICE: THIS VERSION ALL COUPLINGS ARE ORDERED AS       !!!!!
C !!          FOR THE PS-SCALARS!!                            !!!!!
C
c     exchanged mesons are treated as distinguishable particles ->
C     IN COUPLING COMBINATIONS CENLL1 ETC.:
C     (i) L+R contributions included,
C     (ii) 1 <-> 2 interchange factor included (extra diagrams).
C     note: for idendical particles factor 2 from vertex, so in effect
C           no difference with distinguishable particles in 1-pair graph
C     (iii) 1-pair graphs from (L_{meson}+L_{pair})**3/3! i.e. term
C           L_{pair}L_{meson}^{2}/2!, so this cancels 1<->2 factor: IP12
C     (iv)  2-pair graphs from L_{pair}^{2}/2!
C     note: identical particle factors for 2-pair graphs: added in YNPAI
C
C **********************************************************************
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/PRCPLS/CENNN1,CENLL1,CENLS1,CENSS1,CENDR1,   
     .              CENNN2,CENLL2,CENLS2,CENSS2,CENDR2,
     .              SIGNN1,SIGLL1,SIGLS1,SIGSS1,SIGDR1, 
     .              SIGNN2,SIGLL2,SIGLS2,SIGSS2,SIGDR2
*     COMMON/PRCPLS/CENLL1,CENLS1,CENSS1,CENDR1,                       
*    .              CENLL2,CENLS2,CENSS2,CENDR2,
*    .              SIGLL1,SIGLS1,SIGSS1,SIGDR1,                       
*    .              SIGLL2,SIGLS2,SIGSS2,SIGDR2

      COMMON/CPLRIJ/FA1,FA2,FA3,FA4,FA5,FA6,FA7,FA8,FA9,FA10,FA11,
     .              FB1,FB2,FB3,FB4,FB5,FB6,FB7,FB8,FB9,FB10,FB11,
     .              PR1,PR2,PR3,PR4,PR5,PR6,PR7,PR8,PR9,PR10,PR11
      COMMON/COUCON/XX1(3),THPS,XX2(2),THV,XX3(2),THS,XX4(8),THD,XX5(4)
     .,ALPA
      DIMENSION PR(11),FA(11),FB(11)
      EQUIVALENCE (PR1,PR(1)),(FA1,FA(1)),(FB1,FB(1))

C     CHANNEL-TYPE SEQUENCES:
C     (PI= PI, RHO, ETC.; ETA = ETA, PHI, ETC.; K = KA, K*, ETC. )
C     8S: (PI1 ETA2), (K1 K2)_{1}, (PI1 K2), (ETA1 K2),
C         (PI1 PI2)_{0}, (EAT1 ETA2), (K1 K2)_{0}, (7-CASES).
C         (K1 PI2), (K1 ETA2).
C     8A: (PI1 PI2), (K1 K2)_{1}, (PI1 K2), (ETA1 K2), (K1 K2)_{0},
C         (K1 PI2), (K1 ETA2), (7-CASES).

C
      DATA SR2/1.4142136D0/,SR3/1.732051D0/
C
C     CONSTRUCTION OF THE COUPLINGS 
C
      IF(P.EQ.+1.D0) ISFAC=+1
      IF(P.EQ.-1.D0) ISFAC=-3
**    ISFAC = +1
C     XI-COUPLINGS:
      XA12 = -FA1*(4*ALFA-1.D0)/SR3
      XA13 = +FA1
      XB12 = -FB1*(4*ALFB-1.D0)/SR3
      XB13 = +FB1
C 1)  SCALAR SU(3)-SINGLET PAIR TERMS, {1}->{8}x{8} :
C
      IF(NTYPE.EQ.1) THEN
      GOTO(11,12,13),NCASE
C     PI1-PI2(I=0):
11    GPRNN = PR(1)
      GPRLL = GPRNN
      GPRSS = GPRNN
      CENNN1 =  3*GPRNN*FA1*FB1*4
      CENLL1 =  (3*GPRLL*FA1*FB1+3*GPRNN*FA3*FB3)*2
      CENLS1 =  0.D0
      CENSS1 =  (3*GPRSS*FA1*FB1+GPRNN*(FA3*FB3+2*FA2*FB2) )*2
      CENDR1 =  CENSS1
      CENNN2 =  3*GPRNN*GPRNN
      CENLL2 =  3*GPRLL*GPRNN
      CENLS2 =  0.D0
      CENSS2 =  3*GPRSS*GPRNN
      CENDR2 =  CENSS2
      GOTO 14
C     ETA1-ETA2:
12    GPRNN = PR(1)
      GPRLL = GPRNN
      GPRSS = GPRNN
      CENNN1 =  GPRNN*(FA6*FB6)*4
      CENLL1 =  (GPRLL*FA6*FB6+GPRNN*FA7*FB7)*2
      CENLS1 =  0.D0
      CENSS1 =  (GPRSS*FA6*FB6+GPRNN*FA8*FB8)*2
      CENDR1 =  CENSS1
      CENNN2 =  1*GPRNN*GPRNN
      CENLL2 =  1*GPRLL*GPRNN
      CENLS2 =  0.D0
      CENSS2 =  1*GPRSS*GPRNN
      CENDR2 =  CENSS2
      GOTO 14
C     KA1-KA2(I=0):
13    GPRNN = 1*PR(1)
      GPRLL = GPRNN
      GPRSS = GPRNN
      CENNN1 =  GPRNN*(FA4*FB4+3*FA5*FB5)*4
      CENLL1 =  GPRLL*(FA4*FB4+3*FA5*FB5)*2 +
     .          GPRNN*(2*FA4*FB4+2*XA12*XB12)*2  
      CENLS1 =  0.D0
      CENSS1 =  GPRSS*(FA4*FB4+3*FA5*FB5)*2 +
     .          GPRNN*(2*FA5*FB5+2*XA13*XB13)*2
      CENDR1 =  CENSS1
      CENNN2 =  4*GPRNN*GPRNN
      CENLL2 =  4*GPRLL*GPRNN
      CENLS2 =  0.D0
      CENSS2 =  4*GPRSS*GPRNN
      CENDR2 =  CENSS2
      GOTO 14
14    RETURN
      ENDIF
C
C 2)  SCALAR SU(3)-OCTET PAIR TERMS,  {8s}->{8}x{8} :
C
      IF(NTYPE.EQ.2) THEN
      GOTO(21,22,23,24,25,26,27),NCASE
C     PI1-ETA2:
21    GPRNN = PR(1)
      GPRSS = PR(2)
      GPRLS = PR(3)
      CENNN1 = ISFAC*GPRNN*FA1*FB6*4
      CENLL1 =  0.D0
      CENLS1 = -SR3*(GPRNN*FA3*FB8+GPRLS*FA1*FB6
     .              +GPRNN*FA3*FB7+GPRLS*FA1*FB6 )
      CENSS1 = -2*(GPRSS*FA1*FB6+GPRNN*FA2*FB8)*2
      CENDR1 = -0.5D0*CENSS1
      CENNN2 =  ISFAC*GPRNN*GPRNN
      CENLL2 =  0.D0
      CENLS2 = -SR3*GPRLS*GPRNN
      CENSS2 = -2*GPRSS*GPRNN
      CENDR2 = -0.5D0*CENSS2
      GOTO 28
C     KA1-KA2(I=1)(8S):
22    GPRNN = 0.5D0*SR3*PR(1)
      GPRSS = 0.5D0*SR3*PR(2)
      GPRLS = 0.5D0*SR3*PR(3)
      CENNN1 = ISFAC*GPRNN*(FA4*FB4-FA5*FB5)*2
      CENLL1 =  0.D0
      CENLS1 = -0.5D0*SR3*(GPRLS*(FA4*FB4-FA5*FB5)*2 +
     .               GPRNN*(2*FA4*FB5-2*XA12*XB13) +
     .               GPRNN*(2*FA5*FB4-2*XA13*XB12) )
      CENSS1 = -1*(GPRSS*(FA4*FB4-FA5*FB5) 
     .            -GPRNN*(2*FA5*FB5-2*XA13*XB13) )*2
      CENDR1 = -0.5D0*CENSS1
      CENNN2 = ISFAC*2*GPRNN*GPRNN
      CENLL2 =  0.D0
      CENLS2 = -2*SR3*GPRLS*GPRNN
      CENSS2 = -4*GPRSS*GPRNN
      CENDR2 = -0.5D0*CENSS2
      GOTO 28
C     PI1-KA2(8s):
23    GPRLN = 0.5D0*SR3*PR(4)
      GPRSN = 0.5D0*SR3*PR(5)
      CENNN1 = 0.D0
      CENLL1 =  GPRLN*(3*FA1*FB4+3*FA3*FB5)*2
      CENLS1 = -SR3*(-GPRLN*FA1*FB5 + GPRSN*3*FA3*FB5)
     .         -SR3*(+GPRLN*(FA3*FB4-2*FA2*FB5)+3*GPRSN*FA1*FB4)
      CENSS1 =  +GPRSN*(+FA1*FB5-FA3*FB4+2*FA2*FB5)*2
      CENDR1 = -2*CENSS1
      CENNN2 = 0.D0
      CENLL2 =  3*GPRLN**2
      CENLS2 = -3*SR3*GPRLN*GPRSN
      CENSS2 = -3*GPRSN**2
      CENDR2 = -2*CENSS2
      GOTO 28
C     ETA1-KA2(8S):
24    GPRLN = -0.5D0*PR(4)
      GPRSN = -0.5D0*PR(5)
      CENNN1  = 0.D0
      CENLL1  = GPRLN*(FA6+FA7)*FB4*2
      CENLS1  = -SR3*(GPRLN*FA6*FB5+GPRSN*FA7*FB4) 
     .          -SR3*(GPRLN*FA8*FB5+GPRSN*FA6*FB4) 
      CENSS1  = -GPRSN*(FA6*FB5+FA8*FB5)*2
      CENNN2  = 0.D0
      CENDR1  = -2*CENSS1
      CENLL2  =  GPRLN**2
      CENLS2  = -SR3*GPRLN*GPRSN
      CENSS2  = -GPRSN**2
      CENDR2  = -2*CENSS2
      GOTO 28
C     PI1-PI2(I=0)(8S):
25    GPRNN = 0.5D0*PR(6)
      GPRLL = 0.5D0*PR(7)
      GPRSS = 0.5D0*PR(8)
      CENNN1  =  3*GPRNN*FA1*FB1*4
      CENLL1  =  (3*GPRLL*FA1*FB1+3*GPRNN*FA3*FB3)*2
      CENLS1  =  0.D0
      CENSS1  =  (3*GPRSS*FA1*FB1+GPRNN*(FA3*FB3+2*FA2*FB2))*2
      CENDR1  =  CENSS1
      CENNN2  =  3*GPRNN*GPRNN
      CENLL2  =  3*GPRLL*GPRNN
      CENLS2  =  0.D0
      CENSS2  =  3*GPRSS*GPRNN
      CENDR2  =  CENSS2
      GOTO 28
C     ETA-ETA(8s):
26    GPRNN = -0.5D0*PR(6)
      GPRLL = -0.5D0*PR(7)
      GPRSS = -0.5D0*PR(8)
      CENNN1  =  GPRNN*FA6*FB6*4
      CENLL1  =  (GPRLL*FA6*FB6+GPRNN*FA7*FB7)*2
      CENLS1  =  0.D0
      CENSS1  =  (GPRSS*FA6*FB6+GPRNN*FA8*FB8)*2
      CENDR1  =  CENSS1
      CENNN2  =  GPRNN*GPRNN
      CENLL2  =  1*GPRLL*GPRNN
      CENLS2  =  0.D0
      CENSS2  =  1*GPRSS*GPRNN
      CENDR2  =  CENSS2
      GOTO 28
C     KA1-KA2(I=0)(8S):
27    GPRNN = -0.5D0*PR(6)
      GPRLL = -0.5D0*PR(7)
      GPRSS = -0.5D0*PR(8)
      CENNN1  =  GPRNN*(FA4*FB4+3*FA5*FB5)*2
      CENLL1  =  (GPRLL*(FA4*FB4+3*FA5*FB5) +
     .           GPRNN*(2*FA4*FB4+2*XA12*XB12))*1
      CENLS1  =  0.D0
      CENSS1  =  (GPRSS*(FA4*FB4+3*FA5*FB5) +
     .           GPRNN*(2*FA5*FB5+2*XA13*XB13))*1
      CENDR1  =  CENSS1
      CENNN2  =  2*GPRNN*GPRNN
      CENLL2  =  2*GPRLL*GPRNN
      CENLS2  =  0.D0
      CENSS2  =  2*GPRSS*GPRNN
      CENDR2  =  CENSS2
      GOTO 28
28    RETURN
      ENDIF
C
C 3)  VECTOR SU(3)-OCTET PAIR TERMS, {8a}->{8}x{8} :
C
      IF(NTYPE.EQ.3) THEN
      GOTO(41,42,43,44,48,45,46,47,49),NCASE
C     PI1-RHO2(I=1)(AXIAL):
41    GPRNN = PR(1)
      GPRSS = PR(2)
      GPRLS = PR(3)

      SIGNN1  =  ISFAC*GPRNN*(2*FA1*FB1)*4
      SIGLL1  =  0.D0
      SIGLS1  = -SR3*(2*GPRLS*FA1*FB1+2*GPRNN*(FA3*FB2))
     .          -SR3*(2*GPRLS*FA1*FB1+2*GPRNN*(FA2*FB3))
      SIGSS1  = -2*(2*GPRSS*FA1*FB1+GPRNN*(FA3*FB3+FA2*FB2))*2
      SIGDR1  = -0.5D0*SIGSS1
      SIGNN2  =  ISFAC*2*GPRNN*GPRNN
      SIGLL2  =  0.D0
      SIGLS2  = -2*SR3*GPRLS*GPRNN
      SIGSS2  = -4*GPRSS*GPRNN
      SIGDR2  = -0.5D0*SIGSS2
      GOTO 488
C     KA-K*(I=1)(AXIAL):
42    GPRNN = 0.5D0*PR(1)
      GPRSS = 0.5D0*PR(2)
      GPRLS = 0.5D0*PR(3)

      SIGNN1  =  ISFAC*GPRNN*(FA4*FB4-FA5*FB5)*4
      SIGLL1  =  0.D0
      SIGLS1  = -SR3*(GPRLS*(FA4*FB4-FA5*FB5)*2
     .                -2*GPRNN*(FA4*FB5+XA12*XB13)  
     .                -2*GPRNN*(FA5*FB4+XA13*XB12) )
      SIGSS1  = -2*GPRSS*(FA4*FB4-FA5*FB5)*2
     .          -4*GPRNN*(FA5*FB5+XA13*XB13)*2
      SIGDR1  = -0.5D0*SIGSS1
      SIGNN2  =  ISFAC*4*GPRNN*GPRNN
      SIGLL2  =  0.D0
      SIGLS2  = -4*SR3*GPRLS*GPRNN
      SIGSS2  = -8*GPRSS*GPRNN
      SIGDR2  = -0.5D0*SIGSS2
      GOTO 488
C     PI-K*(AXIAL):
43    GPRLN = -0.5D0*PR(4)
      GPRSN = -0.5D0*PR(5)

      SIGNN1  =  0.D0
      SIGLL1  =  3*GPRLN*(-FA1*FB4+FA3*FB5)*2
      SIGLS1  = -SR3*(+GPRLN*FA1*FB5+3*GPRSN*FA3*FB5)
     .          -SR3*(+GPRLN*(+FA3*FB4-2*FA2*FB5)-3*GPRSN*FA1*FB4)
      SIGSS1  =  1*GPRSN*(-FA1*FB5-FA3*FB4+2*FA2*FB5)*2
      SIGDR1  = -2*SIGSS1
      SIGNN2  =  0.D0
      SIGLL2  =  3*GPRLN**2
      SIGLS2  = -3*SR3*GPRLN*GPRSN
      SIGSS2  = -3*GPRSN**2
      SIGDR2  = -2*SIGSS2
      GOTO 488
C     ETA-K*(AXIAL):
44    GPRLN = -0.5D0*SR3*PR(4)*DCOS(THPS)
      GPRSN = -0.5D0*SR3*PR(5)*DCOS(THPS)

      SIGNN1  =  0.D0
      SIGLL1  =  GPRLN*(-FA6*FB4+FA7*FB4)*2
      SIGLS1  = -SR3*(-GPRLN*FA6*FB5+GPRSN*FA7*FB4)
     .          -SR3*(+GPRLN*FA8*FB5-GPRSN*FA6*FB4)
      SIGSS1  = -1*GPRSN*(-FA6*FB5+FA8*FB5)*2
      SIGDR1  = -2*SIGSS1
      SIGNN2  =  0.D0
      SIGLL2  =  GPRLN**2
      SIGLS2  = -SR3*GPRLN*GPRSN
      SIGSS2  = -GPRSN**2
      SIGDR2  = -2*SIGSS2
      GOTO 488
C     ETA'-K*(AXIAL):
48    GPRLN = -0.5D0*SR3*PR(4)*DSIN(THPS)
      GPRSN = -0.5D0*SR3*PR(5)*DSIN(THPS)

      SIGNN1  =  0.D0
      SIGLL1  =  GPRLN*(-FA9*FB4+FA10*FB4)*2
      SIGLS1  = -SR3*(-GPRLN*FA9*FB5+GPRSN*FA10*FB4)
     .          -SR3*(+GPRLN*FA11*FB5-GPRSN*FA9*FB4)
      SIGSS1  = -1*GPRSN*(-FA9*FB5+FA11*FB5)*2
      SIGDR1  = -2*SIGSS1
      SIGNN2  =  0.D0
      SIGLL2  =  GPRLN**2
      SIGLS2  = -SR3*GPRLN*GPRSN
      SIGSS2  = -GPRSN**2
      SIGDR2  = -2*SIGSS2
      GOTO 488
C     KA-K*(I=0)(AXIAL):
45    GPRNN = 0.5D0*SR3*PR(6)
      GPRLL = 0.5D0*SR3*PR(7)
      GPRSS = 0.5D0*SR3*PR(8)

      SIGNN1  =  GPRNN*(FA4*FB4+3*FA5*FB5)*4
      SIGLL1  =  1*(GPRLL*(FA4*FB4+3*FA5*FB5)  
     .             +GPRNN*(-2*FA4*FB4+2*XA12*XB12) )*2
      SIGLS1  =  0.D0
      SIGSS1  = +1*(GPRSS*(FA4*FB4+3*FA5*FB5)
     .             +GPRNN*(-2*FA5*FB5+2*XA13*XB13) )*2
      SIGDR1  =  SIGSS1
      SIGNN2  =  4*GPRNN*GPRNN
      SIGLL2  =  4*GPRLL*GPRNN
      SIGLS2  =  0.D0
      SIGSS2  =  4*GPRSS*GPRNN
      SIGDR2  =  SIGSS2
      GOTO 488
C     KA-RO(AXIAL):
46    GPRLN = -0.5D0*PR(4)
      GPRSN = -0.5D0*PR(5)
c     gprln = +0.5D0*PR(4)
c     gprsn = +0.5D0*PR(5)

      SIGNN1  =  0.D0
      SIGLL1  =  3*GPRLN*(FA5*FB3-FA4*FB1)*2
      SIGLS1  = -SR3*(+GPRLN*FA5*FB1+3*GPRSN*FA5*FB3)
     .          -SR3*(+GPRLN*(FA4*FB3-2*FA5*FB2)-3*GPRSN*FA4*FB1)
      SIGSS1  = -1*GPRSN*(FA4*FB3-2*FA5*FB2+FA5*FB1)*2        
      SIGDR1  = -2*SIGSS1
      SIGNN2  =  0.D0
      SIGLL2  =  3*GPRLN**2
      SIGLS2  = -3*SR3*GPRLN*GPRSN
      SIGSS2  = -3*GPRSN**2
      SIGDR2  = -2*SIGSS2
      GOTO 488
C     KA-PHI(AXIAL):
47    GPRLN = -0.5D0*SR3*PR(4)*DCOS(THV)
      GPRSN = -0.5D0*SR3*PR(5)*DCOS(THV)
c     gprln = +0.5D0*SR3*PR(4)*DCOS(THV)
c     gprsn = +0.5D0*SR3*PR(5)*DCOS(THV)

      SIGNN1  =  0.D0
      SIGLL1  =  1*GPRLN*(-FA4*FB6+FA4*FB7)*2
      SIGLS1  = -SR3*(GPRLN*FA5*FB8-GPRSN*FA4*FB6)
     .          -SR3*(-GPRLN*FA5*FB6+GPRSN*FA4*FB7)
      SIGSS1  = -1*GPRSN*(FA5*FB8-FA5*FB6)*2
      SIGDR1  = -2*SIGSS1
      SIGNN2  =  0.D0
      SIGLL2  =  GPRLN**2
      SIGLS2  = -SR3*GPRLN*GPRSN
      SIGSS2  = -GPRSN**2
      SIGDR2  = -2*SIGSS2
      GOTO 488
C     KA-OMEGA(AXIAL):
49    GPRLN = -0.5D0*SR3*PR(4)*DSIN(THV)
      GPRSN = -0.5D0*SR3*PR(5)*DSIN(THV)
c     gprln = +0.5D0*SR3*PR(4)*DSIN(THV)
c     gprsn = +0.5D0*SR3*PR(5)*DSIN(THV)

      SIGNN1  =  0.D0
      SIGLL1  =  1*GPRLN*(-FA4*FB9+FA4*FB10)*2
      SIGLS1  = -SR3*(GPRLN*FA5*FB11-GPRSN*FA4*FB9)
     .          -SR3*(-GPRLN*FA5*FB9+GPRSN*FA4*FB10)
      SIGSS1  = -1*GPRSN*(FA5*FB11-FA5*FB9)*2
      SIGDR1  = -2*SIGSS1
      SIGNN2  =  0.D0
      SIGLL2  =  GPRLN**2
      SIGLS2  = -SR3*GPRLN*GPRSN
      SIGSS2  = -GPRSN**2
      SIGDR2  = -2*SIGSS2
      GOTO 488
488   RETURN
      ENDIF
C
C 4)  PSEUDO SCALAR PAIR TERMS {8}->{8}x{1} (PION-EPSILON):
C
      IF(NTYPE.EQ.4) THEN
      if(ncase.eq.1) then
      gnn1  = 0.d0
      gnn2  = 0.d0
      gdr1  = 0.d0
      gdr2  = 0.d0
      endif
      GOTO(51,52,53,54,55,56),NCASE

C     PI-EPSILON:
51    GPRNN = PR(1)
      GPRSS = PR(2)
      GPRLS = PR(3)

      signn1  =  isfac*2*pr(1)*fa1*fb9*2
      signn2  =  isfac*pr(1)*pr(1)
      SIGLL1  =  0.D0
      SIGLS1  = -0.5D0*SR3*(2*GPRLS*FA1*FB9+GPRNN*FA3*(FB10+FB11))*2
      SIGSS1  = -2*(GPRSS*FA1*FB9+GPRNN*FA2*FB10)*2
      SIGDR1  = -0.5D0*SIGSS1
      SIGLL2  =  0.D0
      SIGLS2  = -SR3*GPRLS*GPRNN
      SIGSS2  = -2*GPRSS*GPRNN
      SIGDR2  = -0.5D0*SIGSS2
      GOTO 57
C     KA-EPSILON:
52    GPRLN = PR(4)
      GPRSN = PR(5)
C     GPRLN = PR(4)*2
C     GPRSN = PR(5)*2

      signn1  =  0.d0
      signn2  =  0.d0
      SIGLL1  =  1*GPRLN*FA4*(FB9+FB10)*2
      SIGLS1  = -0.5D0*SR3*(GPRLN*FA5*(FB9+FB11)+GPRSN*FA4*(FB9+FB10))*2
      SIGSS1  = -1*GPRSN*FA5*(FB9+FB11)*2
      SIGDR1  = -2*SIGSS1
      SIGLL2  =  GPRLN**2
      SIGLS2  = -SR3*GPRLN*GPRSN
      SIGSS2  = -GPRSN**2
      SIGDR2  = -2*SIGSS2
      GOTO 57
C     ETA-EPSILON:
53    GPRNN = PR(6)
      GPRLL = PR(7)
      GPRSS = PR(8)

      signn1  =   2*pr(6)*fa6*fb9*2
      signn2  =   pr(6)*pr(6)
      SIGLL1  =   1*(GPRNN*FA7*FB10+GPRLL*FA6*FB9)*2
      SIGLS1  =   0.D0
      SIGSS1  =   1*(GPRNN*FA8*FB11+GPRSS*FA6*FB9)*2
      SIGDR1  =   SIGSS1
      SIGLL2  =   GPRLL*GPRNN
      SIGLS2  =   0.D0
      SIGSS2  =   GPRSS*GPRNN
      SIGDR2  =   SIGSS2
      GOTO 57

C     PI-SSTAR:
54    GPRNN = PR(1)
      GPRSS = PR(2)
      GPRLS = PR(3)

      signn1  =  isfac*2*pr(1)*fa1*fb6*2
      signn2  =  isfac*pr(1)*pr(1)
      SIGLL1  =  0.D0
      SIGLS1  = -0.5D0*SR3*(2*GPRLS*FA1*FB6+GPRNN*FA3*(FB7+FB8))*2
      SIGSS1  = -2*(GPRSS*FA1*FB6+GPRNN*FA2*FB8)*2
      SIGDR1  = -0.5D0*SIGSS1
      SIGLL2  =  0.D0
      SIGLS2  = -SR3*GPRLS*GPRNN
      SIGSS2  = -2*GPRSS*GPRNN
      SIGDR2  = -0.5D0*SIGSS2
      GOTO 57
C     KA-SSTAR:
55    GPRLN = PR(4)
      GPRSN = PR(5)
C     GPRLN = PR(4)*2
C     GPRSN = PR(5)*2

      signn1  =  0.d0
      signn2  =  0.d0
      SIGLL1  =  1*GPRLN*FA4*(FB6+FB7)*2
      SIGLS1  = -0.5D0*SR3*(GPRLN*FA5*(FB6+FB8)+GPRSN*FA4*(FB6+FB7))*2
      SIGSS1  = -1*GPRSN*FA5*(FB6+FB8)*2
      SIGDR1  = -2*SIGSS1
      SIGLL2  =  GPRLN**2
      SIGLS2  = -SR3*GPRLN*GPRSN
      SIGSS2  = -GPRSN**2
      SIGDR2  = -2*SIGSS2
      GOTO 57
C     ETA-SSTAR:
56    GPRNN = PR(6)
      GPRLL = PR(7)
      GPRSS = PR(8)

      signn1  =  2*pr(6)*fa6*fb6*2
      signn2  =  pr(6)*pr(6)
      SIGLL1  =  1*(GPRNN*FA7*FB7+GPRLL*FA6*FB6)*2
      SIGLS1  =  0.D0
      SIGSS1  =  1*(GPRNN*FA8*FB8+GPRSS*FA6*FB6)*2
      SIGDR1  =  SIGSS1
      SIGLL2  =  GPRLL*GPRNN
      SIGLS2  =  0.D0
      SIGSS2  =  GPRSS*GPRNN
      SIGDR2  =  SIGSS2
      GOTO 57
57    RETURN
      ENDIF
C
C D)  SCALAR SU(3)-SINGLET PAIR TERMS, {1}->{1}x{1} (EPSILON-EPSILON):
C
C 5)  SCALAR (EPSILON-EPSILON) PAIR TERMS:
      IF(NTYPE.EQ.5) THEN
C     EPSILON-EPSILON:
      GPRNN = PR(1)
      GPRLL = PR(2)
      GPRSS = PR(3)
*     GPRLL = GPRNN
*     GPRSS = GPRNN
      CENNN1  = (GPRNN*FA9*FB9)*4
      CENLL1  = (GPRLL*FA9*FB9+GPRNN*FA10*FB10)*2
      CENLS1  = 0.D0
      CENSS1  = (GPRSS*FA9*FB9+GPRNN*FA11*FB11)*2
      CENDR1  = CENSS1
      CENNN2 =  GPRNN*GPRNN
      CENLL2 =  GPRLL*GPRNN
      CENLS2 =  0.D0
      CENSS2 =  GPRSS*GPRNN
      CENDR2 =  CENSS2
      ENDIF
C
C 6)  SCALAR SU(3)-OCTET PAIR TERMS,  {8s}->{8}x{8} :
C
      IF(NTYPE.EQ.6) THEN
      GOTO(61,611,62,63,64,65,66,67,671,68,69,691,693), NCASE
C     PI1-OMEGA:
61    GPRNN = 0.5D0*PR(1)
      GPRSS = 0.5D0*PR(2)
      GPRLS = 0.5D0*PR(3)
      CENNN1 = ISFAC*GPRNN*FA1*FB9*4
      CENLL1 =  0.D0
      CENLS1 = -SR3*(GPRNN*FA3*FB11+GPRLS*FA1*FB9
     .              +GPRNN*FA3*FB10+GPRLS*FA1*FB9 )
      CENSS1 = -2*(GPRSS*FA1*FB9+GPRNN*FA2*FB11)*2
      CENDR1 = -0.5D0*CENSS1
      CENNN2 =  ISFAC*GPRNN*GPRNN
      CENLL2 =  0.D0
      CENLS2 = -SR3*GPRLS*GPRNN
      CENSS2 = -2*GPRSS*GPRNN
      CENDR2 = -0.5D0*CENSS2
      GOTO 692
C     PI1-PHI2: 
611   GPRNN = 0.5D0*PR(1)
      GPRSS = 0.5D0*PR(2)
      GPRLS = 0.5D0*PR(3)
      CENNN1 = ISFAC*GPRNN*FA1*FB6*4
      CENLL1 =  0.D0
      CENLS1 = -SR3*(GPRNN*FA3*FB8+GPRLS*FA1*FB6
     .              +GPRNN*FA3*FB7+GPRLS*FA1*FB6 )
      CENSS1 = -2*(GPRSS*FA1*FB6+GPRNN*FA2*FB8)*2
      CENDR1 = -0.5D0*CENSS1
      CENNN2 =  ISFAC*GPRNN*GPRNN
      CENLL2 =  0.D0
      CENLS2 = -SR3*GPRLS*GPRNN
      CENSS2 = -2*GPRSS*GPRNN
      CENDR2 = -0.5D0*CENSS2
      GOTO 692
C     ETA1-RHO2:
62    GPRNN = 0.5D0*PR(1)
      GPRSS = 0.5D0*PR(2)
      GPRLS = 0.5D0*PR(3)
      CENNN1 = ISFAC*GPRNN*FA6*FB1*4
      CENLL1 =  0.D0
      CENLS1 = -SR3*(GPRNN*FA8*FB3+GPRLS*FA6*FB1
     .              +GPRNN*FA7*FB3+GPRLS*FA6*FB1 )
      CENSS1 = -2*(GPRSS*FA6*FB1+GPRNN*FA8*FB2)*2
      CENDR1 = -0.5D0*CENSS1
      CENNN2 =  ISFAC*GPRNN*GPRNN
      CENLL2 =  0.D0
      CENLS2 = -SR3*GPRLS*GPRNN
      CENSS2 = -2*GPRSS*GPRNN
      CENDR2 = -0.5D0*CENSS2
      GOTO 692
C     KA1-K*2(I=1)(8S):
63    GPRNN = 0.25D0*SR3*PR(1)
      GPRSS = 0.25D0*SR3*PR(2)
      GPRLS = 0.25D0*SR3*PR(3)
      CENNN1 = ISFAC*GPRNN*(FA4*FB4-FA5*FB5)*4
      CENLL1 =  0.D0
      CENLS1 = -SR3*(GPRLS*(FA4*FB4-FA5*FB5)*2 +
     .               GPRNN*(2*FA4*FB5-2*XA12*XB13) +
     .               GPRNN*(2*FA5*FB4-2*XA13*XB12) )
      CENSS1 = -2*(GPRSS*(FA4*FB4-FA5*FB5) 
     .            -GPRNN*(2*FA5*FB5-2*XA13*XB13) )*2
      CENDR1 = -0.5D0*CENSS1
      CENNN2 = ISFAC*4*GPRNN*GPRNN
      CENLL2 =  0.D0
      CENLS2 = -4*SR3*GPRLS*GPRNN
      CENSS2 = -8*GPRSS*GPRNN
      CENDR2 = -0.5D0*CENSS2
      GOTO 692
C     PI1-K*2(8s):
64    GPRLN = 0.25D0*SR3*PR(4)
      GPRSN = 0.25D0*SR3*PR(5)
      CENNN1 = 0.D0
      CENLL1 =  GPRLN*(3*FA1*FB4+3*FA3*FB5)*2
      CENLS1 = -SR3*(-GPRLN*FA1*FB5 + GPRSN*3*FA3*FB5)
     .         -SR3*(+GPRLN*(FA3*FB4-2*FA2*FB5)+3*GPRSN*FA1*FB4)
      CENSS1 =  +GPRSN*(+FA1*FB5-FA3*FB4+2*FA2*FB5)*2
      CENDR1 = -2*CENSS1
      CENNN2 = 0.D0
      CENLL2 =  3*GPRLN**2
      CENLS2 = -3*SR3*GPRLN*GPRSN
      CENSS2 = -3*GPRSN**2
      CENDR2 = -2*CENSS2
      GOTO 692
C     KA1-RHO2(8s):
65    GPRLN = 0.25D0*SR3*PR(4)
      GPRSN = 0.25D0*SR3*PR(5)
      CENNN1 = 0.D0
      CENLL1 =  GPRLN*(3*FA4*FB1+3*FA5*FB3)*2
      CENLS1 = -SR3*(-GPRLN*FA5*FB1 + GPRSN*3*FA5*FB3)
     .         -SR3*(+GPRLN*(FA4*FB3-2*FA5*FB2)+3*GPRSN*FA4*FB1)
      CENSS1 =  +GPRSN*(+FA5*FB1-FA4*FB3+2*FA5*FB2)*2
      CENDR1 = -2*CENSS1
      CENNN2 = 0.D0
      CENLL2 =  3*GPRLN**2
      CENLS2 = -3*SR3*GPRLN*GPRSN
      CENSS2 = -3*GPRSN**2
      CENDR2 = -2*CENSS2
      GOTO 692
C     ETA1-K*2(8S):
66    GPRLN = -0.25D0*PR(4)
      GPRSN = -0.25D0*PR(5)
      CENNN1  = 0.D0
      CENLL1  = GPRLN*(FA6+FA7)*FB4*2
      CENLS1  = -SR3*(GPRLN*FA6*FB5+GPRSN*FA7*FB4) 
     .          -SR3*(GPRLN*FA8*FB5+GPRSN*FA6*FB4) 
      CENSS1  = -GPRSN*(FA6*FB5+FA8*FB5)*2
      CENNN2  = 0.D0
      CENDR1  = -2*CENSS1
      CENLL2  =  GPRLN**2
      CENLS2  = -SR3*GPRLN*GPRSN
      CENSS2  = -GPRSN**2
      CENDR2  = -2*CENSS2
      GOTO 692
C     KA1-OMEGA(8S):
67    GPRLN = -0.25D0*PR(4)
      GPRSN = -0.25D0*PR(5)
      CENNN1  = 0.D0
      CENLL1  = GPRLN*(FB9+FB10)*FA4*2
      CENLS1  = -SR3*(GPRLN*FA5*FB9+GPRSN*FA4*FB10) 
     .          -SR3*(GPRLN*FA5*FB11+GPRSN*FA4*FB9) 
      CENSS1  = -GPRSN*(FA5*FB9+FA5*FB11)*2
      CENNN2  = 0.D0
      CENDR1  = -2*CENSS1
      CENLL2  =  GPRLN**2
      CENLS2  = -SR3*GPRLN*GPRSN
      CENSS2  = -GPRSN**2
      CENDR2  = -2*CENSS2
      GOTO 692
C     KA1-PHI2(8S):
671   GPRLN = -0.25D0*PR(4)
      GPRSN = -0.25D0*PR(5)
      CENNN1  = 0.D0
      CENLL1  = GPRLN*(FB6+FB7)*FA4*2
      CENLS1  = -SR3*(GPRLN*FA5*FB6+GPRSN*FA4*FB7) 
     .          -SR3*(GPRLN*FA5*FB8+GPRSN*FA4*FB6) 
      CENSS1  = -GPRSN*(FA5*FB6+FA5*FB8)*2
      CENNN2  = 0.D0
      CENDR1  = -2*CENSS1
      CENLL2  =  GPRLN**2
      CENLS2  = -SR3*GPRLN*GPRSN
      CENSS2  = -GPRSN**2
      CENDR2  = -2*CENSS2
      GOTO 692
C     PI1-RHO2(I=0)(8S):
68    GPRNN = 0.5D0*PR(6)
      GPRLL = 0.5D0*PR(7)
      GPRSS = 0.5D0*PR(8)
      CENNN1  =  3*GPRNN*FA1*FB1*4
      CENLL1  =  (3*GPRLL*FA1*FB1+3*GPRNN*FA3*FB3)*2
      CENLS1  =  0.D0
      CENSS1  =  (3*GPRSS*FA1*FB1+GPRNN*(FA3*FB3+2*FA2*FB2))*2
      CENDR1  =  CENSS1
      CENNN2  =  3*GPRNN*GPRNN
      CENLL2  =  3*GPRLL*GPRNN
      CENLS2  =  0.D0
      CENSS2  =  3*GPRSS*GPRNN
      CENDR2  =  CENSS2
      GOTO 692
C     KA1-K*2(I=0)(8S):
69    GPRNN = -0.25D0*PR(6)
      GPRLL = -0.25D0*PR(7)
      GPRSS = -0.25D0*PR(8)
      CENNN1  =  GPRNN*(FA4*FB4+3*FA5*FB5)*4
      CENLL1  =  (GPRLL*(FA4*FB4+3*FA5*FB5) +
     .           GPRNN*(2*FA4*FB4+2*XA12*XB12))*2
      CENLS1  =  0.D0
      CENSS1  =  (GPRSS*(FA4*FB4+3*FA5*FB5) +
     .           GPRNN*(2*FA5*FB5+2*XA13*XB13))*2
      CENDR1  =  CENSS1
      CENNN2  =  4*GPRNN*GPRNN
      CENLL2  =  4*GPRLL*GPRNN
      CENLS2  =  0.D0
      CENSS2  =  4*GPRSS*GPRNN
      CENDR2  =  CENSS2
      GOTO 692
C     ETA-OMEGA(8s):
691   GPRNN = -0.5D0*PR(6)
      GPRLL = -0.5D0*PR(7)
      GPRSS = -0.5D0*PR(8)
      CENNN1  =  GPRNN*FA6*FB9*4
      CENLL1  =  (GPRLL*FA6*FB9+GPRNN*FA7*FB10)*2
      CENLS1  =  0.D0
      CENSS1  =  (GPRSS*FA6*FB9+GPRNN*FA8*FB11)*2
      CENDR1  =  CENSS1
      CENNN2  =  GPRNN*GPRNN
      CENLL2  =  1*GPRLL*GPRNN
      CENLS2  =  0.D0
      CENSS2  =  1*GPRSS*GPRNN
      CENDR2  =  CENSS2
      GOTO 692
C     ETA-PHI(8s):
693   GPRNN = -0.5D0*PR(6)
      GPRLL = -0.5D0*PR(7)
      GPRSS = -0.5D0*PR(8)
      CENNN1  =  GPRNN*FA6*FB6*4
      CENLL1  =  (GPRLL*FA6*FB6+GPRNN*FA7*FB7)*2
      CENLS1  =  0.D0
      CENSS1  =  (GPRSS*FA6*FB6+GPRNN*FA8*FB8)*2
      CENDR1  =  CENSS1
      CENNN2  =  GPRNN*GPRNN
      CENLL2  =  1*GPRLL*GPRNN
      CENLS2  =  0.D0
      CENSS2  =  1*GPRSS*GPRNN
      CENDR2  =  CENSS2
      GOTO 692

692   RETURN
      ENDIF
      END
C **********************************************************************
      SUBROUTINE WRITEPR(NCASE,X,P)
C **********************************************************************
C
C     NCASE = 1,2,7 : VC ; NCASE = 3 : VC,VS,VT ; NCASE = 4,5,6 : VS,VT
C     NCASE = 8 : VS,VT
C
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/PRWRITE/VPR(5,3,4,4,8)
      CHARACTER *4 NTYPM(4,4)
      DATA N3/37/,NTYPM/
     .'PI  ','KA  ','ETA ','ETAP','RHO ','K*  ','PHI ','OM  ',
     .'DE  ','KAP ','S*  ','EPS ','A2  ','K** ','POMP','POM '/
C
c     selected printing:
      if(ncase.ne.8) return

      write(N3,*)'CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC'
      if(ncase.eq.1) write(N3,101)
      if(ncase.eq.2) write(N3,102)
      if(ncase.eq.3) write(N3,103)
      if(ncase.eq.4) write(N3,104)
      if(ncase.eq.5) write(N3,105)
      if(ncase.eq.6) write(N3,106)
      if(ncase.eq.8) write(N3,108)
      if(ncase.le.3) JJ=1
      if(ncase.eq.4) JJ=2
      if(ncase.eq.5) JJ=3
      if(ncase.eq.6) JJ=4
      if(ncase.eq.8) JJ=2

*     if(ncase.le.3 .OR. ncase.eq.7) then
      if(ncase.ne.8) then
      write(N3,100) x,p
      write(N3,110) (NTYPM(KK,JJ),KK=1,4)
  110 format(10x,4(3x,a4,5x))
      write(N3,*)'-----------------------------------------------------'
      DO 111 II=1,4
  111 write(N3,1) NTYPM(II,1),(VPR(1,1,II,KK,NCASE),KK=1,4)
      write(N3,*)'====================================================='
      DO 112 II=1,4
  112 write(N3,2) NTYPM(II,1),(VPR(2,1,II,KK,NCASE),KK=1,4)
      write(N3,*)'====================================================='
      DO 113 II=1,4
  113 write(N3,3) NTYPM(II,1),(VPR(3,1,II,KK,NCASE),KK=1,4)
      write(N3,*)'====================================================='
      DO 114 II=1,4
  114 write(N3,4) NTYPM(II,1),(VPR(4,1,II,KK,NCASE),KK=1,4)
      write(N3,*)'====================================================='
      DO 115 II=1,4
  115 write(N3,5) NTYPM(II,1),(VPR(5,1,II,KK,NCASE),KK=1,4)
      call su3prnt(1,ncase,x,p)
      endif

      if(ncase.ge.3 .AND. ncase.ne.7) then
      write(N3,200) x,p
      write(N3,110) (NTYPM(KK,JJ),KK=1,4)
      write(N3,*)'-----------------------------------------------------'
      DO 211 II=1,4
  211 write(N3,1) NTYPM(II,1),(VPR(1,2,II,KK,NCASE),KK=1,4)
      write(N3,*)'====================================================='
      DO 212 II=1,4
  212 write(N3,2) NTYPM(II,1),(VPR(2,2,II,KK,NCASE),KK=1,4)
      write(N3,*)'====================================================='
      DO 213 II=1,4
  213 write(N3,3) NTYPM(II,1),(VPR(3,2,II,KK,NCASE),KK=1,4)
      write(N3,*)'====================================================='
      DO 214 II=1,4
  214 write(N3,4) NTYPM(II,1),(VPR(4,2,II,KK,NCASE),KK=1,4)
      write(N3,*)'====================================================='
      DO 215 II=1,4
  215 write(N3,5) NTYPM(II,1),(VPR(5,2,II,KK,NCASE),KK=1,4)
      write(N3,*)'*****************************************************'
      call su3prnt(2,ncase,x,p)
      endif
      return              

  101 format(/,' SCALAR SU(3)-SINGLET PAIR TERMS, {1}->{8}x{8} :',/)
  102 format(/,' SCALAR SU(3)-OCTET PAIR TERMS,  {8s}->{8}x{8} :',/)
  103 format(/,' VECTOR SU(3)-OCTET PAIR TERMS,  {8a}->{8}x{8} :',/)
  104 format(/,' AXIAL (PION-RHO) PAIR TERMS OF THE FIRST CLASS:',/)
  105 format(/,' PSEUDO SCALAR (PION-EPSILON) PAIR TERMS:',/)
  106 format(/,' PSEUDO SCALAR (PS-POMERON) PAIR TERMS:',/)
  107 format(/,' SCALAR SU(3)-SINGLET PAIR TERMS, {1}->{1}x{1} :',/)
  108 format(/,' AXIAL (PION-PHI) PAIR TERMS OF THE SECND CLASS:',/)

  100 format(55('*'),/,' YNPAIR: CENTRAL POTENTIALS: x=',f7.3,    
     .' p=',f4.1,/,55('*'))
  200 format(55('*'),/,' YNPAIR: SPIN-SPIN POTENTIALS: x=',f7.3,    
     .' p=',f4.1,/,55('*'))
    1 FORMAT(1x,'NN: ',A4,4(F10.3,2X))
    2 FORMAT(1x,'LL: ',A4,4(F10.3,2X))
    3 FORMAT(1x,'LS: ',A4,4(F10.3,2X))
    4 FORMAT(1x,'SS: ',A4,4(F10.3,2X))
    5 FORMAT(1x,'DR: ',A4,4(F10.3,2X))
      end
C **********************************************************************
      SUBROUTINE SU3PRNT(IV,NCASE,X,P)
C **********************************************************************
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/PRWRITE/VPR(5,3,4,4,8)
      DIMENSION VTOT(5)
      DATA N3/37/
C SUMMED CONTRIBUTIONS:                   
      DO 120 ICHAN=1,5
      VTOT(ICHAN)=0.D0
      DO 120 M=1,4
      DO 120 N=1,4
  120 VTOT(ICHAN)=VTOT(ICHAN)+VPR(ICHAN,IV,M,N,NCASE)
      if(iv.eq.1) write(N3,121) VTOT(1),VTOT(5),VTOT(2),VTOT(3),VTOT(4)
  121 format(' VCNN=',F10.2,3x,' VCDR=',F10.2,3x,' VCLL=',F10.2,/,
     .       ' VCLS=',F10.2,3x,' VCSS=',F10.2,/)
      if(iv.eq.2) write(N3,122) VTOT(1),VTOT(5),VTOT(2),VTOT(3),VTOT(4)
  122 format(' VSNN=',F10.2,3x,' VSDR=',F10.2,3x,' VSLL=',F10.2,/,
     .       ' VSLS=',F10.2,3x,' VSSS=',F10.2,/)
C CONTRIBUTIONS TO SU(3)-POTENTIALS:                        
      if(p.eq.1.d0) then
      V27a = VTOT(1)                                                    
      V27b = VTOT(5)                                                    
**    V27c = (9*VTOT(2)-VTOT(4))/8.D0
      V27c = (3*VTOT(2)-VTOT(3))/3.D0
*     V8Sa = 10*VTOT(2)-9*VTOT(5)
      V8Sa =    VTOT(2)+3*VTOT(3)
      V8Sb = (10*VTOT(4)-VTOT(5))/9.D0
      V8Sc = (9*VTOT(4)-VTOT(2))/8.D0
      VLSa = (-3*V27b+3*V8Sa)/10.D0
      VLSb = (-3*V27b+3*V8Sb)/10.D0
      VLSc = (-3*V27c+3*V8Sc)/10.D0
      write(N3,123) V27a,V27b,V27c,V8Sa,V8Sb,V8Sc,VLSa,VLSb,VLSc
      write(*,123) V27a,V27b,V27c,V8Sa,V8Sb,V8Sc,VLSa,VLSb,VLSc
  123 format(' V27a =',F10.3,3x,' V27b =',F10.3,3x,' V27c =',F10.3,/,
     .       ' V8Sa =',F10.2,3x,' V8Sb =',F10.2,3x,' V8Sc =',F10.2,/,
     .       ' VLSa =',F10.2,3x,' VLSb =',F10.2,3x,' VLSc =',F10.2)
      endif
      if(p.eq.-1.d0) then
      V10nn= VTOT(1)
      V10  = VTOT(5)
      V10sa= VTOT(2)+VTOT(3)                                            
      V10sb= VTOT(4)+VTOT(3)                                            
      V8Aa = VTOT(2)-VTOT(3)                                            
      V8Ab = VTOT(4)-VTOT(3)                                            
      write(N3,124) V10sa,V10sb,V10nn,V8Aa,V8Ab,V10
  124 format(' V10*a=',F10.2,3x,' V10*b=',F10.2,3x,' V10nn=',F10.2,/,
     .       ' V8Aa =',F10.2,3x,' V8Ab =',F10.2,3x,' V10  =',F10.2)
      endif
      write(N3,*)'*****************************************************'
      return
      END

