C **********************************************************************
C     ESCROMP1.F: VERSION SEPT. 1997, su3 checked okay!
C **********************************************************************
      SUBROUTINE YNPSPS(X,INA,IPV,IOFF,APV)
C **********************************************************************
C *
C *   DATE: JANUARY, 1995, UPDATED DECEMBER 1996 (REORGANIZED VECTORS)
C
C     version: january 1997, used in latest TOKYO version!
C
C *   YN-POTENTIALS FROM DOUBLE PSEUDO-SCALAR EXCHANGE
C *
C * THIS ROUTINE: BW ADIABATIC-APPROXIMATION, TMO LOWEST APPROXIMATION
C *               NO MASS-DIFFERENCES BETWEEN BARYONS TAKEN INTO ACCOUNT
C *
C     PS-SCAL: ALMP1 = SU(3)-SINGLET, ALMP8 = SU(3)-OCTET
C *
C **********************************************************************
C     CALL YNFUN(KIND,X,AM1,AM2,ALM1,ALM2,FUN):
C
C     IKIND=3, PSSCALAR-PSSCALAR EXCHANGE:
C     FUN(1) = OPSC    FUN(2) = OPSS    FUN(3) = OPST
C **********************************************************************
C
C     INCLUDED IN ENERGY DENOMINATORS:
C     (i) L+R contributions included, 1/4 -> 1/2, the latter is
C         put into FACT.
C     INCLUDED IN COUPLING-COMBINATIONS CPANLL ETC.:
C     (ii) 1 <-> 2 interchange effects for non-identical mesons.
C
C     FOR FORM FACTOR TREATMENT SEE:
C     TH.A.RIJKEN, ANNALS OF PHYSICS 208, P.253 (1990).
C
C **********************************************************************
C
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/PIMAS/PIM0
      COMMON/POTESC/VCLL,VCSS,VCLS,VCDR,VSLL,VSSS,VSLS,VSDR,
     .              VTLL,VTSS,VTLS,VTDR,VOLL,VOSS,VOLS,VODR,
     .              VALL,VASS,VALS,VADR
      COMMON/DYNMAS/REDMM,AMLN,AMSN,AMH,AMSS,AMLS,AMNN
      COMMON/FORMF/ALAM,ALMP8,ALMV8,ALMS8,ALMP1,ALMV1,ALMS1,
     .             ALMKA,ALMKS,ALMKP
      COMMON/COUCON/ALP,XZ1(3),ALVD,XZ2(2),ALVV,XZ3(12),ALS,XZ4,ALD,
     .ALPA
      COMMON/ALLPS/AME,AMX,AMK,BMK
C     COMMON/OOM/ INA,IPV,IOFF
      COMMON/COUPL/ F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,F11,
     .              G1,G2,G3,G4,G5,G6,G7,G8,G9,G10,G11,
     .              FD1,FD2,FD3,FD4,FD5,FD6,FD7,FD8,FD9,FD10,FD11,
     .              FV1,FV2,FV3,FV4,FV5,FV6,FV7,FV8,FV9,FV10,FV11,
     .              GS1,GS2,GS3,GS4,GS5,GS6,GS7,GS8,GS9,GS10,GS11,
     .              GD1,GD2,GD3,GD4,GD5,GD6,GD7,GD8,GD9,GD10,GD11,P
      COMMON/PSBE/ 
     .VPSPS(5,4,4,4),VPSVC(5,4,4,4),VPSSC(5,4,4,4),VPSDF(5,4,4,4)
      DIMENSION F(11),G(11),FD(11),FV(11),GS(11),GD(11)
      EQUIVALENCE (F1,F(1)),(G1,G(1)),(FD1,FD(1)),(FV1,FV(1))
     . ,(GS1,GS(1)),(GD1,GD(1))

      CHARACTER *4 NTYPM(4)
      DATA NTYPM/'PI  ','KA  ','ETA ','ETAP'/
C
      DIMENSION FUN(12),FUNX(12)
C
      DATA PI/3.14159265D0/,SRPI/1.7724538509D0/,
     . SR2/1.41421356D0/,SR6/2.44948974D0/,SR3/1.732051D0/
      DATA IPIPI/1/,IPIET/1/,IPIETP/1/,IPIKA/1/,IKAKA/1/,
     .     IETA2/1/,IETKA/1/,IETETP/1/,IETPKA/1/,IETAP2/1/
      DATA N3/27/,FACT/70.D0/,DAM/230.D0/,ICALL/0/,ISFAC/1/,NSCHR/0/
     .,POLD/-12345.D0/,ISU3/0/
      SAVE FACT,DAM

      pim=pim0
**    isu3 = 1
**    nschr=1
**    if(isu3.eq.1) call su3sym(pim)
C
      CALL ERRSET(208,256,-1,1)
C
  12  IF(ICALL.EQ.0) THEN
        FACT = PIM0/2.D0
        IF(P.EQ.+1.D0) ISFAC=+1
        IF(P.EQ.-1.D0) ISFAC=-3
        PRINT 52, INA,IPV,IOFF
 52     FORMAT(//,'  IN YNPSPS: INA, IPV, IOFF=',3I3,//)
        PRINT 53, ALMP1,ALMP8,PIM,AMK,AME,AMX,DAM
 53     FORMAT(/,' IN YNPSPS: ALMP1=',D10.3,' ALMP8=',D10.3,/,
     .  11X,' PIM, AMK, AME, AMX =',4(F10.3,2X),/,
     .  11X,'  DAM =',F10.3,/)
*       ICALL=1
      ENDIF

      if(pold.ne.p) then
      icall=0
      pold=p    
      nschr=1
      endif
C
C     XI-COUPLINGS:
      F12 = F1*(4*ALP-1.D0)/SR3
      F13 = -F1
C
C     CONSTRUCTION OF THE POTENTIALS
C
C     DO 1 I=2,NMAX
C     X = XA(I)
      VCNN =0.D0
      VSNN =0.D0
      VTNN =0.D0
      VCLL =0.D0
      VCLS =0.D0
      VCSS =0.D0
      VCDR =0.D0
      VSLL =0.D0
      VSLS =0.D0
      VSSS =0.D0
      VSDR =0.D0
      VTLL =0.D0
      VTLS =0.D0
      VTSS =0.D0
      VTDR =0.D0

      VOLL =0.D0
      VOLS =0.D0
      VOSS =0.D0
      VODR =0.D0

      DO 25 NCHAN=1,5
      DO 25 IPTYP=1,4
      DO 25 IPSI=1,4
      DO 25 IPSJ=1,4
   25 VPSPS(NCHAN,IPTYP,IPSI,IPSJ)=0.D0

      IF(INA.EQ.1.OR.IPV.EQ.1.OR.IOFF.EQ.1)
     .CALL OMPSPS(X,INA,IPV,IOFF,ALP,APV)
*     if(icall.eq.20.and.nschr.eq.1) then
c**   for check su3-symmetry:
**    write(N3,*) 'from YNPSPS: CALL OMPSPS TURNED OFF!!'
*     write(N3,*) 'from OMPSPS: x=',x
*     write(N3,*) 'vcll,vsll=',vcll,vsll
*     write(N3,*) 'vcls,vsls=',vcls,vsls
*     write(N3,*) 'vcss,vsss=',vcss,vsss
*     write(N3,*) 'vcdr,vsdr=',vcdr,vsdr
*     endif

C PION-PION EXCHANGE POTENTIALS:
      IF(IPIPI.EQ.1) THEN
C     PARALLEL:
      CPANN  =  1*(3-2*ISFAC)*F1**2*F1**2
      CPALL  =  1*3*F1*F1*F3*F3
      CPALS  =  1*2*SR3*F1*F1*F3*F2
      CPASS  =  1*F1*F1*(3*F3*F3+4*F2*F2)
      CPADR  =  +1*F1*F1*F2*F2
C     CROSSED:
      CCRNN  =  1*(3+2*ISFAC)*F1**2*F1**2
      CCRLL  =  1*3*F1*F1*F3*F3
      CCRLS  = -1*2*SR3*F1*F1*F3*F2
      CCRSS  =  -1*F1*F1*F3*F3
      CCRDR  =  1*F1*F1*(2*F3*F3+3*F2*F2)

      CALL YNFUN(3,X,PIM,PIM,ALMP8,ALMP8,FUN)

      VPSPS(1,1,1,1) = VPSPS(1,1,1,1) + FACT*( CPANN-CCRNN )*FUN(1)
      VPSPS(2,1,1,1) = VPSPS(2,1,1,1) + FACT*( CPALL-CCRLL )*FUN(1)
      VPSPS(3,1,1,1) = VPSPS(3,1,1,1) + FACT*( CPALS-CCRLS )*FUN(1)
      VPSPS(4,1,1,1) = VPSPS(4,1,1,1) + FACT*( CPASS-CCRSS )*FUN(1)
      VPSPS(5,1,1,1) = VPSPS(5,1,1,1) + FACT*( CPADR-CCRDR )*FUN(1)

      VPSPS(1,2,1,1) = VPSPS(1,2,1,1) - FACT*( CPANN+CCRNN )*FUN(2)
      VPSPS(2,2,1,1) = VPSPS(2,2,1,1) - FACT*( CPALL+CCRLL )*FUN(2)
      VPSPS(3,2,1,1) = VPSPS(3,2,1,1) - FACT*( CPALS+CCRLS )*FUN(2)
      VPSPS(4,2,1,1) = VPSPS(4,2,1,1) - FACT*( CPASS+CCRSS )*FUN(2)
      VPSPS(5,2,1,1) = VPSPS(5,2,1,1) - FACT*( CPADR+CCRDR )*FUN(2)

      VPSPS(1,3,1,1) = VPSPS(1,3,1,1) - FACT*( CPANN+CCRNN )*FUN(3)
      VPSPS(2,3,1,1) = VPSPS(2,3,1,1) - FACT*( CPALL+CCRLL )*FUN(3)
      VPSPS(3,3,1,1) = VPSPS(3,3,1,1) - FACT*( CPALS+CCRLS )*FUN(3)
      VPSPS(4,3,1,1) = VPSPS(4,3,1,1) - FACT*( CPASS+CCRSS )*FUN(3)
      VPSPS(5,3,1,1) = VPSPS(5,3,1,1) - FACT*( CPADR+CCRDR )*FUN(3)
      ENDIF
C END PION-PION

C PION-ETA EXCHANGE POTENTIALS:
      IF(IPIET.EQ.1) THEN
C     PARALLEL:
      CPANN  =  +2*F1**2*F6**2*ISFAC
      CPALS  =  -SR3*F1*F6*F3*(F8+F7)
      CPASS  =  -4*F1*F6*F2*F8
      CPADR  =  +2*F1*F6*F2*F8
C     CROSSED:
      CCRNN  =  +2*F1**2*F6**2*ISFAC
      CCRLS  =  -SR3*F1*F6*F3*(F8+F7)
      CCRSS  =  -4*F1*F6*F2*F8
      CCRDR  =  +2*F1*F6*F2*F8

      CALL YNFUN(3,X,PIM,AME,ALMP8,ALMP8,FUN)

      VPSPS(1,2,1,3) = VPSPS(1,2,1,3) - FACT*( CPANN+CCRNN )*FUN(2)
      VPSPS(3,2,1,3) = VPSPS(3,2,1,3) - FACT*( CPALS+CCRLS )*FUN(2)
      VPSPS(4,2,1,3) = VPSPS(4,2,1,3) - FACT*( CPASS+CCRSS )*FUN(2)
      VPSPS(5,2,1,3) = VPSPS(5,2,1,3) - FACT*( CPADR+CCRDR )*FUN(2)

      VPSPS(1,3,1,3) = VPSPS(1,3,1,3) - FACT*( CPANN+CCRNN )*FUN(3)
      VPSPS(3,3,1,3) = VPSPS(3,3,1,3) - FACT*( CPALS+CCRLS )*FUN(3)
      VPSPS(4,3,1,3) = VPSPS(4,3,1,3) - FACT*( CPASS+CCRSS )*FUN(3)
      VPSPS(5,3,1,3) = VPSPS(5,3,1,3) - FACT*( CPADR+CCRDR )*FUN(3)
      ENDIF
C END PION-ETA

C PION-ETA' EXCHANGE POTENTIALS:
      IF(IPIETP.EQ.1) THEN
C     PARALLEL:
      CPANN  =  +2*F1**2*F9**2*ISFAC
      CPALS  =  -SR3*F1*F9*F3*(F11+F10)
      CPASS  =  -4*F1*F9*F2*F11
      CPADR  =  +2*F1*F9*F2*F11
C     CROSSED:
      CCRNN  =  +2*F1**2*F9**2*ISFAC
      CCRLS  =  -SR3*F1*F9*F3*(F11+F10)
      CCRSS  =  -4*F1*F9*F2*F11
      CCRDR  =  +2*F1*F9*F2*F11

      CALL YNFUN(3,X,PIM,AMX,ALMP8,ALMP1,FUN)

      VPSPS(1,2,1,4) = VPSPS(1,2,1,4) - FACT*( CPANN+CCRNN )*FUN(2)
      VPSPS(3,2,1,4) = VPSPS(3,2,1,4) - FACT*( CPALS+CCRLS )*FUN(2)
      VPSPS(4,2,1,4) = VPSPS(4,2,1,4) - FACT*( CPASS+CCRSS )*FUN(2)
      VPSPS(5,2,1,4) = VPSPS(5,2,1,4) - FACT*( CPADR+CCRDR )*FUN(2)

      VPSPS(1,3,1,4) = VPSPS(1,3,1,4) - FACT*( CPANN+CCRNN )*FUN(3)
      VPSPS(3,3,1,4) = VPSPS(3,3,1,4) - FACT*( CPALS+CCRLS )*FUN(3)
      VPSPS(4,3,1,4) = VPSPS(4,3,1,4) - FACT*( CPASS+CCRSS )*FUN(3)
      VPSPS(5,3,1,4) = VPSPS(5,3,1,4) - FACT*( CPADR+CCRDR )*FUN(3)
      ENDIF
C END PION-ETA'

C PION-KAON EXCHANGE POTENTIALS:
      IF(IPIKA.EQ.1) THEN
C     PARALLEL:
      CPALL  =  6*F1*F4*F3*F5
      CPALS  =  -SR3*F1*F3*(F4**2-F5**2)
     .          +2*SR3*F1*F2*F4*F5
      CPASS  =  F1*F5*(6*F3*F4+4*F2*F5)
      CPADR  =  +4*F1*F2*F5**2
C     CROSSED:
      CCRLL  =  3*(F1*F1*F4**2+F3*F3*F5**2)
      CCRLS  =  SR3*F4*F5*(F1**2-F3**2)
     .         +2*SR3*F2*F3*F5**2
      CCRSS  =  5*F1**2*F5**2+F3**2*F4**2
     .         +4*F2*F3*F4*F5
      CCRDR  =  2*F1**2*F5**2+F3**2*F4**2
     .         +3*F2**2*F5**2-2*F2*F3*F4*F5

      CALL YNFUN(3,X,PIM,AMK,ALMP8,ALMKA,FUN)
c     CALL YNFUN2(3,X,PIM,AMK,ALMP8,ALMKA,DAM,2,FUN)

      VPSPS(2,1,1,2) = VPSPS(2,1,1,2) + FACT*(CPALL-CCRLL)*FUN(1)*P
      VPSPS(3,1,1,2) = VPSPS(3,1,1,2) + FACT*(CPALS-CCRLS)*FUN(1)*P
      VPSPS(4,1,1,2) = VPSPS(4,1,1,2) + FACT*(CPASS-CCRSS)*FUN(1)*P
      VPSPS(5,1,1,2) = VPSPS(5,1,1,2) + FACT*(CPADR-CCRDR)*FUN(1)*P

      VPSPS(2,2,1,2) = VPSPS(2,2,1,2) - FACT*(CPALL+CCRLL)*FUN(2)*P
      VPSPS(3,2,1,2) = VPSPS(3,2,1,2) - FACT*(CPALS+CCRLS)*FUN(2)*P
      VPSPS(4,2,1,2) = VPSPS(4,2,1,2) - FACT*(CPASS+CCRSS)*FUN(2)*P
      VPSPS(5,2,1,2) = VPSPS(5,2,1,2) - FACT*(CPADR+CCRDR)*FUN(2)*P

      VPSPS(2,3,1,2) = VPSPS(2,3,1,2) - FACT*(CPALL+CCRLL)*FUN(3)*P
      VPSPS(3,3,1,2) = VPSPS(3,3,1,2) - FACT*(CPALS+CCRLS)*FUN(3)*P
      VPSPS(4,3,1,2) = VPSPS(4,3,1,2) - FACT*(CPASS+CCRSS)*FUN(3)*P
      VPSPS(5,3,1,2) = VPSPS(5,3,1,2) - FACT*(CPADR+CCRDR)*FUN(3)*P
      ENDIF
C END PION-KAON

C KAON-KAON EXCHANGE POTENTIALS:
      IF(IKAKA.EQ.1) THEN
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  1*(F4**2+3*F5**2)*F4**2
      CPALS  =  1*SR3*(F5**2-F4**2)*F4*F5
      CPASS  =  1*(3*F4**2+F5**2)*F5**2
      CPADR  =  1*4*F5**4
C     CROSSED:
      CCRNN  =  1*((F4**2+3*F5**2)**2+ISFAC*(F4**2-F5**2)**2)/2.D0
      CCRLL  =  +1*(F4**2*F12**2+3*F5**2*F12**2)
      CCRLS  =  1*SR3*(F4*F4-F5*F5)*F13*F12
      CCRSS  =  +1*(-F4**2+5*F5**2)*F13**2
      CCRDR  =  +1*2*(F4**2+1*F5**2)*F13**2

      CALL YNFUN(3,X,AMK,AMK,ALMKA,ALMKA,FUN)
      CALL YNFUN(3,X,AMK,AMK,ALMKA,ALMKA,FUNX)
cc    CALL DKBFUN(3,X,AMK,AMK,ALMKA,ALMKA,DAM,FUN)
cc    CALL DKBFUN(3,X,AMK,AMK,ALMKA,ALMKA,DAM,FUNX)
*     CALL YNFUN3(1,3,X,AMK,AMK,ALMKA,ALMKA,DAM,FUN)
*     CALL YNFUN3(2,3,X,AMK,AMK,ALMKA,ALMKA,DAM,FUNX)

      VPSPS(1,1,2,2)=VPSPS(1,1,2,2)+FACT*(CPANN*FUN(1)-CCRNN*FUNX(1))
      VPSPS(2,1,2,2)=VPSPS(2,1,2,2)+FACT*(CPALL*FUN(1)-CCRLL*FUNX(1))
      VPSPS(3,1,2,2)=VPSPS(3,1,2,2)+FACT*(CPALS*FUN(1)-CCRLS*FUNX(1))
      VPSPS(4,1,2,2)=VPSPS(4,1,2,2)+FACT*(CPASS*FUN(1)-CCRSS*FUNX(1))
      VPSPS(5,1,2,2)=VPSPS(5,1,2,2)+FACT*(CPADR*FUN(1)-CCRDR*FUNX(1))

      VPSPS(1,2,2,2)=VPSPS(1,2,2,2)-FACT*(CPANN*FUN(2)+CCRNN*FUNX(2))
      VPSPS(2,2,2,2)=VPSPS(2,2,2,2)-FACT*(CPALL*FUN(2)+CCRLL*FUNX(2))
      VPSPS(3,2,2,2)=VPSPS(3,2,2,2)-FACT*(CPALS*FUN(2)+CCRLS*FUNX(2))
      VPSPS(4,2,2,2)=VPSPS(4,2,2,2)-FACT*(CPASS*FUN(2)+CCRSS*FUNX(2))
      VPSPS(5,2,2,2)=VPSPS(5,2,2,2)-FACT*(CPADR*FUN(2)+CCRDR*FUNX(2))

      VPSPS(1,3,2,2)=VPSPS(1,3,2,2)-FACT*(CPANN*FUN(3)+CCRNN*FUNX(3))
      VPSPS(2,3,2,2)=VPSPS(2,3,2,2)-FACT*(CPALL*FUN(3)+CCRLL*FUNX(3))
      VPSPS(3,3,2,2)=VPSPS(3,3,2,2)-FACT*(CPALS*FUN(3)+CCRLS*FUNX(3))
      VPSPS(4,3,2,2)=VPSPS(4,3,2,2)-FACT*(CPASS*FUN(3)+CCRSS*FUNX(3))
      VPSPS(5,3,2,2)=VPSPS(5,3,2,2)-FACT*(CPADR*FUN(3)+CCRDR*FUNX(3))
      ENDIF
C END KAON-KAON

C ETA-ETA EXCHANGE POTENTIALS:
      IF(IETA2.EQ.1) THEN
C     PARALLEL:
      CPANN  =  1*F6**2*F6**2
      CPALL  =  1*F6**2*F7**2
      CPASS  =  1*F6**2*F8**2
      CPADR  =  CPASS
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  1*F6**2*F7**2
      CCRSS  =  1*F6**2*F8**2
      CCRDR  =  CCRSS

      CALL YNFUN(3,X,AME,AME,ALMP8,ALMP8,FUN)

      VPSPS(1,2,3,3) = VPSPS(1,2,3,3) - FACT*( CPANN+CCRNN )*FUN(2)
      VPSPS(2,2,3,3) = VPSPS(2,2,3,3) - FACT*( CPALL+CCRLL )*FUN(2)
      VPSPS(4,2,3,3) = VPSPS(4,2,3,3) - FACT*( CPASS+CCRSS )*FUN(2)
      VPSPS(5,2,3,3) = VPSPS(5,2,3,3) - FACT*( CPADR+CCRDR )*FUN(2)

      VPSPS(1,3,3,3) = VPSPS(1,3,3,3) - FACT*( CPANN+CCRNN )*FUN(3)
      VPSPS(2,3,3,3) = VPSPS(2,3,3,3) - FACT*( CPALL+CCRLL )*FUN(3)
      VPSPS(4,3,3,3) = VPSPS(4,3,3,3) - FACT*( CPASS+CCRSS )*FUN(3)
      VPSPS(5,3,3,3) = VPSPS(5,3,3,3) - FACT*( CPADR+CCRDR )*FUN(3)
      ENDIF
C END ETA-ETA

C ETA-KAON EXCHANGE POTENTIALS:
      IF(IETKA.EQ.1) THEN
C     PARALLEL:
      CPALL  =  2*F6*F7*F4**2
      CPALS  =  -SR3*F6*(F7+F8)*F4*F5
      CPASS  =  -2*F6*F8*F5**2
      CPADR  =  -2*CPASS
C     CROSSED:
      CCRLL  =  (F6**2+F7**2)*F4**2
      CCRLS  =  -SR3*(F6**2+F7*F8)*F4*F5
      CCRSS  =  -1*(F6**2+F8**2)*F5**2
      CCRDR  =  -2*CCRSS

      CALL YNFUN(3,X,AME,AMK,ALMP8,ALMKA,FUN)
**    CALL YNFUN2(3,X,AME,AMK,ALMP8,ALMKA,DAM,2,FUN)

      VPSPS(2,1,2,3) = VPSPS(2,1,2,3) + FACT*(CPALL-CCRLL)*FUN(1)*P
      VPSPS(3,1,2,3) = VPSPS(3,1,2,3) + FACT*(CPALS-CCRLS)*FUN(1)*P
      VPSPS(4,1,2,3) = VPSPS(4,1,2,3) + FACT*(CPASS-CCRSS)*FUN(1)*P
      VPSPS(5,1,2,3) = VPSPS(5,1,2,3) + FACT*(CPADR-CCRDR)*FUN(1)*P

      VPSPS(2,2,2,3) = VPSPS(2,2,2,3) - FACT*(CPALL+CCRLL)*FUN(2)*P
      VPSPS(3,2,2,3) = VPSPS(3,2,2,3) - FACT*(CPALS+CCRLS)*FUN(2)*P
      VPSPS(4,2,2,3) = VPSPS(4,2,2,3) - FACT*(CPASS+CCRSS)*FUN(2)*P
      VPSPS(5,2,2,3) = VPSPS(5,2,2,3) - FACT*(CPADR+CCRDR)*FUN(2)*P

      VPSPS(2,3,2,3) = VPSPS(2,3,2,3) - FACT*(CPALL+CCRLL)*FUN(3)*P
      VPSPS(3,3,2,3) = VPSPS(3,3,2,3) - FACT*(CPALS+CCRLS)*FUN(3)*P
      VPSPS(4,3,2,3) = VPSPS(4,3,2,3) - FACT*(CPASS+CCRSS)*FUN(3)*P
      VPSPS(5,3,2,3) = VPSPS(5,3,2,3) - FACT*(CPADR+CCRDR)*FUN(3)*P
      ENDIF
C END ETA-KAON

C ETA-ETA' EXCHANGE POTENTIALS:
      IF(IETETP.EQ.1) THEN
C     PARALLEL:
      CPANN  =  2*F6**2*F9**2
      CPALL  =  2*F6*F9*F7*F10
      CPASS  =  2*F6*F9*F8*F11
      CPADR  =  CPASS
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  2*F6*F9*F7*F10
      CCRSS  =  2*F6*F9*F8*F11
      CCRDR  =  CCRSS

      CALL YNFUN(3,X,AME,AMX,ALMP8,ALMP1,FUN)

      VPSPS(1,2,3,4) = VPSPS(1,2,3,4) - FACT*( CPANN+CCRNN )*FUN(2)
      VPSPS(2,2,3,4) = VPSPS(2,2,3,4) - FACT*( CPALL+CCRLL )*FUN(2)
      VPSPS(4,2,3,4) = VPSPS(4,2,3,4) - FACT*( CPASS+CCRSS )*FUN(2)
      VPSPS(5,2,3,4) = VPSPS(5,2,3,4) - FACT*( CPADR+CCRDR )*FUN(2)

      VPSPS(1,3,3,4) = VPSPS(1,3,3,4) - FACT*( CPANN+CCRNN )*FUN(3)
      VPSPS(2,3,3,4) = VPSPS(2,3,3,4) - FACT*( CPALL+CCRLL )*FUN(3)
      VPSPS(4,3,3,4) = VPSPS(4,3,3,4) - FACT*( CPASS+CCRSS )*FUN(3)
      VPSPS(5,3,3,4) = VPSPS(5,3,3,4) - FACT*( CPADR+CCRDR )*FUN(3)
      ENDIF
C END ETA-ETA'

C ETA'-KAON EXCHANGE POTENTIALS:
      IF(IETPKA.EQ.1) THEN
C     PARALLEL:
      CPALL  =  2*F9*F10*F4**2
      CPALS  =  -SR3*F9*(F10+F11)*F4*F5
      CPASS  =  -2*F9*F11*F5**2
      CPADR  =  -2*CPASS
C     CROSSED:
      CCRLL  =  (F9**2+F10**2)*F4**2
      CCRLS  =  -SR3*(F9**2+F10*F11)*F4*F5
      CCRSS  =  -1*(F9**2+F11**2)*F5**2
      CCRDR  =  -2*CCRSS

      CALL YNFUN(3,X,AMX,AMK,ALMP1,ALMKA,FUN)
**    CALL YNFUN2(3,X,AMX,AMK,ALMP1,ALMKA,DAM,2,FUN)

      VPSPS(2,1,2,4) = VPSPS(2,1,2,4) + FACT*(CPALL-CCRLL)*FUN(1)*P
      VPSPS(3,1,2,4) = VPSPS(3,1,2,4) + FACT*(CPALS-CCRLS)*FUN(1)*P
      VPSPS(4,1,2,4) = VPSPS(4,1,2,4) + FACT*(CPASS-CCRSS)*FUN(1)*P
      VPSPS(5,1,2,4) = VPSPS(5,1,2,4) + FACT*(CPADR-CCRDR)*FUN(1)*P

      VPSPS(2,2,2,4) = VPSPS(2,2,2,4) - FACT*(CPALL+CCRLL)*FUN(2)*P
      VPSPS(3,2,2,4) = VPSPS(3,2,2,4) - FACT*(CPALS+CCRLS)*FUN(2)*P
      VPSPS(4,2,2,4) = VPSPS(4,2,2,4) - FACT*(CPASS+CCRSS)*FUN(2)*P
      VPSPS(5,2,2,4) = VPSPS(5,2,2,4) - FACT*(CPADR+CCRDR)*FUN(2)*P

      VPSPS(2,3,2,4) = VPSPS(2,3,2,4) - FACT*(CPALL+CCRLL)*FUN(3)*P
      VPSPS(3,3,2,4) = VPSPS(3,3,2,4) - FACT*(CPALS+CCRLS)*FUN(3)*P
      VPSPS(4,3,2,4) = VPSPS(4,3,2,4) - FACT*(CPASS+CCRSS)*FUN(3)*P
      VPSPS(5,3,2,4) = VPSPS(5,3,2,4) - FACT*(CPADR+CCRDR)*FUN(3)*P
      ENDIF
C END ETAP-KAON

C ETA'-ETA' EXCHANGE POTENTIALS:
      IF(IETAP2.EQ.1) THEN
C     PARALLEL:
      CPANN  =  1*F9**2*F9**2
      CPALL  =  1*F9**2*F10**2
      CPASS  =  1*F9**2*F11**2
      CPADR  =  CPASS
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  1*F9**2*F10**2
      CCRSS  =  1*F9**2*F11**2
      CCRDR  =  CCRSS

      CALL YNFUN(3,X,AMX,AMX,ALMP1,ALMP1,FUN)

      VPSPS(1,2,4,4) = VPSPS(1,2,4,4) - FACT*( CPANN+CCRNN )*FUN(2)
      VPSPS(2,2,4,4) = VPSPS(2,2,4,4) - FACT*( CPALL+CCRLL )*FUN(2)
      VPSPS(4,2,4,4) = VPSPS(4,2,4,4) - FACT*( CPASS+CCRSS )*FUN(2)
      VPSPS(5,2,4,4) = VPSPS(5,2,4,4) - FACT*( CPADR+CCRDR )*FUN(2)

      VPSPS(1,3,4,4) = VPSPS(1,3,4,4) - FACT*( CPANN+CCRNN )*FUN(3)
      VPSPS(2,3,4,4) = VPSPS(2,3,4,4) - FACT*( CPALL+CCRLL )*FUN(3)
      VPSPS(4,3,4,4) = VPSPS(4,3,4,4) - FACT*( CPASS+CCRSS )*FUN(3)
      VPSPS(5,3,4,4) = VPSPS(5,3,4,4) - FACT*( CPADR+CCRDR )*FUN(3)
      ENDIF
C END ETA'-ETA'

C     TOTAL CONTRIBUTION:
      DO 30 IMES=1,4
      DO 30 IPS=1,IMES

      VCNN = VCNN + VPSPS(1,1,IPS,IMES)
      VCLL = VCLL + VPSPS(2,1,IPS,IMES)
      VCLS = VCLS + VPSPS(3,1,IPS,IMES)
      VCSS = VCSS + VPSPS(4,1,IPS,IMES)
      VCDR = VCDR + VPSPS(5,1,IPS,IMES)

      VSNN = VSNN + VPSPS(1,2,IPS,IMES)
      VSLL = VSLL + VPSPS(2,2,IPS,IMES)
      VSLS = VSLS + VPSPS(3,2,IPS,IMES)
      VSSS = VSSS + VPSPS(4,2,IPS,IMES)
      VSDR = VSDR + VPSPS(5,2,IPS,IMES)

      VTNN = VTNN + VPSPS(1,3,IPS,IMES)
      VTLL = VTLL + VPSPS(2,3,IPS,IMES)
      VTLS = VTLS + VPSPS(3,3,IPS,IMES)
      VTSS = VTSS + VPSPS(4,3,IPS,IMES)
      VTDR = VTDR + VPSPS(5,3,IPS,IMES)
  30  CONTINUE

*     if(icall.eq.0.and.nschr.eq.1) then                   
**    if(icall.eq.20.and.nschr.eq.1) then                   
**    call writetm(1,x,p)
**    write(N3,*)'*****************************************************'
**    write(N3,*) 'YNPSPS total contributions: x=',x
**    write(N3,*) 'vcll,vsll=',vcll,vsll
**    write(N3,*) 'vcls,vsls=',vcls,vsls
**    write(N3,*) 'vcss,vsss=',vcss,vsss
**    write(N3,*) 'vcdr,vsdr=',vcdr,vsdr
**    write(N3,*)'*****************************************************'
**    endif
C END PSEUDO-SCALAR MESONS
C  1  CONTINUE
      ICALL=ICALL+1

1000  CALL ERRSET(208,256,1,1)
      RETURN
C END YNPSPS ROUTINE ***************************************************
      END
C
C FOR ROUTINE PIHBE:  ***********************************************
      BLOCK DATA
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/TREATV/IPIRO,IPIOM,IPIPH,IPIKS
      COMMON/TREATS/IPIDE,IPIEP,IPIST,IPIKSC
      COMMON/TREATD/IPIA2,IPIPOM,IPIKSS
      DATA IPIRO/1/,IPIOM/1/,IPIPH/1/,IPIKS/1/
      DATA IPIDE/1/,IPIEP/1/,IPIST/1/,IPIKSC/1/
      DATA IPIA2/1/,IPIPOM/1/,IPIKSS/1/
      END

C **********************************************************************
      SUBROUTINE YNPIBE(X,INA,IPV,IOFF,APV)
C **********************************************************************
C *
C *   DATE: JANUARY, 1995
C
C *   PION-MESON EXCHANGE YN-POTENTIALS (MESON= VECTOR, SCALAR, DIFFR.)
C *
C * THIS ROUTINE: BW ADIABATIC-APPROXIMATION, TMO LOWEST APPROXIMATION
C *               NO MASS-DIFFERENCES BETWEEN BARYONS TAKEN INTO ACCOUNT
C *
C * NOTE THAT IN THE ADIABATIC APPROXIMATION THERE ARE NO CONTRIBUTIONS
C * FROM: PI-EPSILON, PI-POMERON
C
C     PS-SCAL: ALMP1 = SU(3)-SINGLET, ALMP8 = SU(3)-OCTET
C     VECTOR : ALMV1 = SU(3)-SINGLET, ALMV8 = SU(3)-OCTET
C     SCALAR : ALMS1 = SU(3)-SINGLET, ALMS8 = SU(3)-OCTET
C
C   STORAGE INDIDUAL CONTRIBUTIONS TO THE POTENTIALS:
C   VPSVC(NCHAN,TYPE,IPS,IVC): PS-VECTOR POTENTIALS,
C   NCHAN=1,2,3,4,5: NN,LL,LS,SS,DR;  TYPE=1,2,3,4: VC,VSIG,VTEN,VSO
C   IPS  =1,2,3,4: PI,K,ETA,ETAP;  IVC=1,2,3,4: RHO,K*,OMEGA,PHI
C   ISC  =1,2,3,4: DE,KAP,EPS,S*;  IDF=1,2,3,4: A2,K**,POM,POMP
C   VPSSC and VPSDF ANALOGOUSLY
C   VPSSC and VPSDF ANALOGOUSLY
C *
C **********************************************************************
C     CALL YNFUN(KIND,X,AM1,AM2,ALM1,ALM2,FUN):
C
C     IKIND=1, PION-VECTOR EXCHANGE:
C     FUN(1) = OPAEES  FUN(2) = OPAEET  FUN(3) = OPAEMT  FUN(4) = OPAEMO
C     FUN(5) = OPAMMC  FUN(6) = OPAMMS  FUN(7) = OPAMMT
C     IKIND=2, PION-SCALAR EXCHANGE:
C     FUN(1) = OSCS    FUN(2) = OSCT
C     IKIND=4, PION-DIFFRACTIVE EXCHANGE:
C     FUN(1) = OSCS    FUN(2) = OSCT
C **********************************************************************
C
C     INCLUDED IN ENERGY-DENOMINATORS:
C     (i) L+R contributions included, 1/4 -> 1/2, the latter is
C         put into FACT,FACT2
C     INCLUDED IN COUPLINGCOMBINATIONS CPANLL ETC.:
C     (ii) 1 <-> 2 interchange effects for non-identical mesons.
C
C     FOR FORM FACTOR TREATMENT SEE:
C     TH.A.RIJKEN, ANNALS OF PHYSICS 208, P.253 (1990).
C
C **********************************************************************
C
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/PIMAS/PIM0
      COMMON/POTNN /VCNN,VSNN,VTNN,VONN
      COMMON/POTESC/VCLL,VCSS,VCLS,VCDR,VSLL,VSSS,VSLS,VSDR,
     .              VTLL,VTSS,VTLS,VTDR,VOLL,VOSS,VOLS,VODR,
     .              VALL,VASS,VALS,VADR
      COMMON/DYNMAS/REDMM,AMLN,AMSN,AMH,AMSS,AMLS,AMNN
      COMMON/FORMF/ALAM,ALMP8,ALMV8,ALMS8,ALMP1,ALMV1,ALMS1,
     .             ALMKA,ALMKS,ALMKP
      COMMON/ALLPS/AME,AMX,AMK,BMK
*     COMMON/ALLVC/ARO,BRO,AM1RO,AM2RO,AMOM,AMFI,AMKS,BMKS
      COMMON/ALLVC/AVEC(2),AMVEC(2),AMOM,AMFI,AMKS,BMKS
      COMMON/ALLSC/ASI,BSI,AM1SI,AM2SI,ASST,BSST,AMSST,AM2ST,AMD,AMSCK
      COMMON/ALLDF/AMPOM,AMF2,AMA2,AMKSS,GDA(11)
*     COMMON/ALLAX/FA1,FA9,ALPA
c     COMMON/OOM/ INA,IPV,IOFF
      COMMON/COUPL/ F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,F11,
     .              G1,G2,G3,G4,G5,G6,G7,G8,G9,G10,G11,
     .              FD1,FD2,FD3,FD4,FD5,FD6,FD7,FD8,FD9,FD10,FD11,
     .              FV1,FV2,FV3,FV4,FV5,FV6,FV7,FV8,FV9,FV10,FV11,
     .              GS1,GS2,GS3,GS4,GS5,GS6,GS7,GS8,GS9,GS10,GS11,
     .              GD1,GD2,GD3,GD4,GD5,GD6,GD7,GD8,GD9,GD10,GD11,P
      DIMENSION F(11),G(11),FD(11),FV(11),GS(11),GD(11)
      EQUIVALENCE (F1,F(1)),(G1,G(1)),(FD1,FD(1)),(FV1,FV(1))
     . ,(GS1,GS(1)),(GD1,GD(1))
C
      DIMENSION FUN(12),FUNH(12),AMSIG(2),ASIG(2)
      COMMON/TREATV/IPIRO,IPIOM,IPIPH,IPIKS
      COMMON/TREATS/IPIDE,IPIEP,IPIST,IPIKSC
      COMMON/TREATD/IPIA2,IPIPOM,IPIKSS
      COMMON/PSBE/ 
     .VPSPS(5,4,4,4),VPSVC(5,4,4,4),VPSSC(5,4,4,4),VPSDF(5,4,4,4)
      common/cpsbe/papssc(5,4,4,4),crpssc(5,4,4,4)
      CHARACTER *4 NTYPM(4,4)
      DATA NTYPM/
     .'PI  ','KA  ','ETA ','ETAP','RHO ','K*  ','OM  ','PHI ',
     .'DE  ','KAP ','EPS ','S*  ','A2  ','K** ','POM ','POMP'/
C
      DATA PI/3.14159265D0/,SRPI/1.7724538509D0/,
     . SR2/1.41421356D0/,SR6/2.44948974D0/,SR3/1.732051D0/
      DATA AMPRO/938.2796D0/,AMRO/760.D0/,AMEPS/760.D0/,DAM/230.D0/
*     DATA AMPRO/1138.2796D0/,AMRO/760.D0/,AMEPS/760.D0/
      DATA N3/27/,ICALL/0/,FACT/70.D0/,FACT2/0.D0/,ISFAC/1/,NSCHR/0/
      SAVE FACT,FACT2,FACT3
      pim=pim0
*     pim=500.d0
C
      CALL ERRSET(208,256,-1,1)
C
  12  IF(ICALL.EQ.0) THEN
        FACT = PIM0/2.D0
*       FACT2= 0.25D0*FACT*(PIM0/AMPRO)**2
*       FACT3= 0.5D0*FACT2
        FACT2= 0.5D0*FACT*(PIM0/AMPRO)**2
        FACT3= 0.5D0*FACT2 
        IF(P.EQ.+1.D0) ISFAC=+1
        IF(P.EQ.-1.D0) ISFAC=-3

        PRINT 52, INA,IPV,IOFF,IPIRO,IPIOM,IPIPH,IPIKS,
     .  IPIDE,IPIEP,IPIST,IPIKSC,IPIA2,IPIPOM,IPIKSS
 52     FORMAT(//,'  IN YNPIBE: INA,IPV,IOFF=',3I3,//,
     .  11X,'  IPIRO,IPIOM,IPIPH,IPIKS=',4I2,//,
     .  11X,'  IPIDE,IPIEP,IPIST,IPIKSC=',4I2,//,
     .  11X,'  IPIA2,IPIPOM,IPIKSS=',3I2,//)
        PRINT 53, ALMP1,ALMV1,ALMS1,ALMP8,ALMV8,ALMS8,PIM,DAM
 53     FORMAT(/,' IN YNPIBE: ALMP1=',D10.3,' ALMV1=',D10.3,' ALMS1=',
     .  D10.3,/,11X,' ALMP8=',D10.3,' ALMV8=',D10.3,' ALMS8=',D10.3,/,
     .  11X,'  PIM =',F10.3,'  DAM =',F10.3,/)
*       ICALL=1
      ENDIF
C
C     CONSTRUCTION OF THE POTENTIALS
C
C     DO 1 I=2,NMAX
C     X = XA(I)
      VCNN =0.D0
      VSNN =0.D0
      VCLL =0.D0
      VCLS =0.D0
      VCSS =0.D0
      VCDR =0.D0
      VSLL =0.D0
      VSLS =0.D0
      VSSS =0.D0
      VSDR =0.D0
      VTLL =0.D0
      VTLS =0.D0
      VTSS =0.D0
      VTDR =0.D0
      DO 25 NCHAN=1,5
      DO 25 IVTYP=1,4
      DO 25 IPSI=1,4
      DO 25 IMES=1,4
      papssc(nchan,ivtyp,ipsi,imes)=0.d0
      crpssc(nchan,ivtyp,ipsi,imes)=0.d0
      VPSVC(NCHAN,IVTYP,IPSI,IMES)=0.D0
      VPSSC(NCHAN,IVTYP,IPSI,IMES)=0.D0
   25 VPSDF(NCHAN,IVTYP,IPSI,IMES)=0.D0

C     1/M-CORRECTIONS:
      IF(INA.EQ.1.OR.IPV.EQ.1.OR.IOFF.EQ.1)
     .CALL OMPIBE(X,INA,IPV,IOFF,APV)
c     if(icall.eq.0.and.nschr.eq.1) then
c     write(N3,*) 'in OMPIBE: x=',x
c     write(N3,*) 'vcll,vsll=',vcll,vsll
c     write(N3,*) 'vcls,vsls=',vcls,vsls
c     write(N3,*) 'vcss,vsss=',vcss,vsss
c     write(N3,*) 'vcdr,vsdr=',vcdr,vsdr
c     endif

C A)  PION-VECTOR-MESON POTENTIALS: ******************************
C
C     PI-RHO:
      IF(IPIRO.EQ.1) THEN
C     EE-CONTRIBUTIONS:
C     PARALLEL:
      CPANN  =  2*(3.D0-2.D0*ISFAC)*F1**2*FD1**2
      CPALL  =  6*F1*FD1*F3*FD3
      CPALS  =  +2*SR3*F1*FD1*(F3*FD2+F2*FD3)
      CPASS  =  2*F1*FD1*(3*F3*FD3+4*F2*FD2)
      CPADR  =  2*F1*FD1*F2*FD2
C     CROSSED:
      CCRNN  =  2*(3.D0+2.D0*ISFAC)*F1**2*FD1**2
      CCRLL  =  6*F1*FD1*F3*FD3
      CCRLS  =  -2*SR3*F1*FD1*(F3*FD2+F2*FD3)
      CCRSS  =  -2*F1*FD1*F3*FD3
      CCRDR  =  2*F1*FD1*(2*F3*FD3+3*F2*FD2)

      DO 710 LL=1,12
  710 FUN(LL)=0.D0
      DO 711 KK=1,2
      CALL YNFUN(1,X,PIM,AMVEC(KK),ALMP8,ALMV8,FUNH)
      DO 711 LL=1,12
  711 FUN(LL)=FUN(LL)+AVEC(KK)*FUNH(LL)
*     CALL YNFUN(1,X,PIM,AMRO,ALMP8,ALMV8,FUN)

      VPSVC(1,2,1,1)=
     .VPSVC(1,2,1,1) + FACT*( CPANN*FUN(1) - CCRNN*FUN(11) )
      VPSVC(2,2,1,1)=
     .VPSVC(2,2,1,1) + FACT*( CPALL*FUN(1) - CCRLL*FUN(11) )
      VPSVC(3,2,1,1)=
     .VPSVC(3,2,1,1) + FACT*( CPALS*FUN(1) - CCRLS*FUN(11) )
      VPSVC(4,2,1,1)=
     .VPSVC(4,2,1,1) + FACT*( CPASS*FUN(1) - CCRSS*FUN(11) )
      VPSVC(5,2,1,1)=
     .VPSVC(5,2,1,1) + FACT*( CPADR*FUN(1) - CCRDR*FUN(11) )

      VPSVC(1,3,1,1)=
     .VPSVC(1,3,1,1) + FACT*( CPANN*FUN(2) - CCRNN*FUN(12) )
      VPSVC(2,3,1,1)=
     .VPSVC(2,3,1,1) + FACT*( CPALL*FUN(2) - CCRLL*FUN(12) )
      VPSVC(3,3,1,1)=
     .VPSVC(3,3,1,1) + FACT*( CPALS*FUN(2) - CCRLS*FUN(12) )
      VPSVC(4,3,1,1)=
     .VPSVC(4,3,1,1) + FACT*( CPASS*FUN(2) - CCRSS*FUN(12) )
      VPSVC(5,3,1,1)=
     .VPSVC(5,3,1,1) + FACT*( CPADR*FUN(2) - CCRDR*FUN(12) )

C     1/M^2-TERMS:
      FVE1 = FD1+FV1
      FVE2 = FD2+FV2
      FVE3 = FD3+FV3
C     MM-CONTRIBUTION:
C     PARALLEL:
      CPANN  =  2*(3.D0-2.D0*ISFAC)*F1**2*FVE1**2
      CPALL  =  6*F1*FVE1*F3*FVE3
      CPALS  =  +2*SR3*F1*FVE1*(F3*FVE2+F2*FVE3)
      CPASS  =  2*F1*FVE1*(3*F3*FVE3+4*F2*FVE2)
      CPADR  =  2*F1*FVE1*F2*FVE2
C     CROSSED:
      CCRNN  =  2*(3.D0+2.D0*ISFAC)*F1**2*FVE1**2
      CCRLL  =  6*F1*FVE1*F3*FVE3
      CCRLS  =  -2*SR3*F1*FVE1*(F3*FVE2+F2*FVE3)
      CCRSS  =  -2*F1*FVE1*F3*FVE3
      CCRDR  =  2*F1*FVE1*(2*F3*FVE3+3*F2*FVE2)

*     CALL YNFUN(1,X,PIM,AMRO,ALMP8,ALMV8,FUN)

      VPSVC(1,1,1,1)=VPSVC(1,1,1,1)+FACT2*( CPANN-CCRNN)*FUN(5)
      VPSVC(2,1,1,1)=VPSVC(2,1,1,1)+FACT2*( CPALL-CCRLL)*FUN(5)
      VPSVC(3,1,1,1)=VPSVC(3,1,1,1)+FACT2*( CPALS-CCRLS)*FUN(5)
      VPSVC(4,1,1,1)=VPSVC(4,1,1,1)+FACT2*( CPASS-CCRSS)*FUN(5)
      VPSVC(5,1,1,1)=VPSVC(5,1,1,1)+FACT2*( CPADR-CCRDR)*FUN(5)

      VPSVC(1,2,1,1)=VPSVC(1,2,1,1)+FACT2*( CPANN+CCRNN)*FUN(6)
      VPSVC(2,2,1,1)=VPSVC(2,2,1,1)+FACT2*( CPALL+CCRLL)*FUN(6)
      VPSVC(3,2,1,1)=VPSVC(3,2,1,1)+FACT2*( CPALS+CCRLS)*FUN(6)
      VPSVC(4,2,1,1)=VPSVC(4,2,1,1)+FACT2*( CPASS+CCRSS)*FUN(6)
      VPSVC(5,2,1,1)=VPSVC(5,2,1,1)+FACT2*( CPADR+CCRDR)*FUN(6)

      VPSVC(1,3,1,1)=VPSVC(1,3,1,1)+FACT2*( CPANN+CCRNN)*FUN(7)
      VPSVC(2,3,1,1)=VPSVC(2,3,1,1)+FACT2*( CPALL+CCRLL)*FUN(7)
      VPSVC(3,3,1,1)=VPSVC(3,3,1,1)+FACT2*( CPALS+CCRLS)*FUN(7)
      VPSVC(4,3,1,1)=VPSVC(4,3,1,1)+FACT2*( CPASS+CCRSS)*FUN(7)
      VPSVC(5,3,1,1)=VPSVC(5,3,1,1)+FACT2*( CPADR+CCRDR)*FUN(7)

C     EM-CONTRIBUTIONS:
      DO 31 ME=1,2
C     EM,2-CONTRIBUTION:
      IF(ME.EQ.2) THEN
      FVE1 = FD1+2*FV1
      FVE2 = FD2+2*FV2
      FVE3 = FD3+2*FV3
      ENDIF
C     PARALLEL:
      CPANN  =  2*(3.D0-2.D0*ISFAC)*F1**2*(2*FD1*FVE1)
      CPALL  =  6*F1*F3*(FD1*FVE3+FVE1*FD3)
      CPALS  =  +2*SR3*F1*FD1*(F3*FVE2+F2*FVE3)
     .          +2*SR3*F1*FVE1*(F3*FD2+F2*FD3)
      CPASS  =  2*F1*FD1*(3*F3*FVE3+4*F2*FVE2)
     .         +2*F1*FVE1*(3*F3*FD3+4*F2*FD2)
      CPADR  =  2*F1*F2*(FD1*FVE2+FVE1*FD2)
C     CROSSED:
      CCRNN  =  2*(3.D0+2.D0*ISFAC)*F1**2*(2*FD1*FVE1)
      CCRLL  =  6*F1*F3*(FD1*FVE3+FVE1*FD3)
      CCRLS  =  -2*SR3*F1*FD1*(F3*FVE2+F2*FVE3)
     .          -2*SR3*F1*FVE1*(F3*FD2+F2*FD3)
      CCRSS  =  -2*F1*F3*(FD1*FVE3+FVE1*FD3)
      CCRDR  =  2*F1*FD1*(2*F3*FVE3+3*F2*FVE2)
     .         +2*F1*FVE1*(2*F3*FD3+3*F2*FD2)
      IF(ME.EQ.1) THEN
      VPSVC(1,3,1,1)=VPSVC(1,3,1,1)+FACT3*(CPANN+CCRNN)*FUN(3)
      VPSVC(2,3,1,1)=VPSVC(2,3,1,1)+FACT3*(CPALL+CCRLL)*FUN(3)
      VPSVC(3,3,1,1)=VPSVC(3,3,1,1)+FACT3*(CPALS+CCRLS)*FUN(3)
      VPSVC(4,3,1,1)=VPSVC(4,3,1,1)+FACT3*(CPASS+CCRSS)*FUN(3)
      VPSVC(5,3,1,1)=VPSVC(5,3,1,1)+FACT3*(CPADR+CCRDR)*FUN(3)

      VPSVC(1,4,1,1)=VPSVC(1,4,1,1)+FACT3*(CPANN-CCRNN)*FUN(4)
      VPSVC(2,4,1,1)=VPSVC(2,4,1,1)+FACT3*(CPALL-CCRLL)*FUN(4)
      VPSVC(3,4,1,1)=VPSVC(3,4,1,1)+FACT3*(CPALS-CCRLS)*FUN(4)
      VPSVC(4,4,1,1)=VPSVC(4,4,1,1)+FACT3*(CPASS-CCRSS)*FUN(4)
      VPSVC(5,4,1,1)=VPSVC(5,4,1,1)+FACT3*(CPADR-CCRDR)*FUN(4)
      ENDIF
      IF(ME.EQ.2) THEN
      VPSVC(1,2,1,1)=VPSVC(1,2,1,1)+FACT3*(CPANN-CCRNN)*FUN(8)
      VPSVC(2,2,1,1)=VPSVC(2,2,1,1)+FACT3*(CPALL-CCRLL)*FUN(8)
      VPSVC(3,2,1,1)=VPSVC(3,2,1,1)+FACT3*(CPALS-CCRLS)*FUN(8)
      VPSVC(4,2,1,1)=VPSVC(4,2,1,1)+FACT3*(CPASS-CCRSS)*FUN(8)
      VPSVC(5,2,1,1)=VPSVC(5,2,1,1)+FACT3*(CPADR-CCRDR)*FUN(8)

      VPSVC(1,3,1,1)=VPSVC(1,3,1,1)+FACT3*(CPANN-CCRNN)*FUN(9)
      VPSVC(2,3,1,1)=VPSVC(2,3,1,1)+FACT3*(CPALL-CCRLL)*FUN(9)
      VPSVC(3,3,1,1)=VPSVC(3,3,1,1)+FACT3*(CPALS-CCRLS)*FUN(9)
      VPSVC(4,3,1,1)=VPSVC(4,3,1,1)+FACT3*(CPASS-CCRSS)*FUN(9)
      VPSVC(5,3,1,1)=VPSVC(5,3,1,1)+FACT3*(CPADR-CCRDR)*FUN(9)

      VPSVC(1,4,1,1)=VPSVC(1,4,1,1)+FACT3*(CPANN-CCRNN)*FUN(10)
      VPSVC(2,4,1,1)=VPSVC(2,4,1,1)+FACT3*(CPALL-CCRLL)*FUN(10)
      VPSVC(3,4,1,1)=VPSVC(3,4,1,1)+FACT3*(CPALS-CCRLS)*FUN(10)
      VPSVC(4,4,1,1)=VPSVC(4,4,1,1)+FACT3*(CPASS-CCRSS)*FUN(10)
      VPSVC(5,4,1,1)=VPSVC(5,4,1,1)+FACT3*(CPADR-CCRDR)*FUN(10)
      ENDIF
   31 CONTINUE
      ENDIF
C END PION-RHO

C
C PION-OMEGA EXCHANGE POTENTIALS:
C     PI-OMEGA
      IF(IPIOM.EQ.1) THEN
C     1/M^2-TERMS:
      FVE6 = FD6+FV6
      FVE7 = FD7+FV7
      FVE8 = FD8+FV8
C     MM-CONTRIBUTION:
C     PARALLEL:
      CPANN  =  2*ISFAC*F1**2*FVE6**2
      CPALS  =  -SR3*F1*FVE6*F3*(FVE7+FVE8)
      CPASS  =  -4*F1*FVE6*F2*FVE8
      CPADR  =  +2*F1*FVE6*F2*FVE8
C     CROSSED:
      CCRNN  =  CPANN
      CCRLS  =  CPALS
      CCRSS  =  CPASS
      CCRDR  =  CPADR

      CALL YNFUN(1,X,PIM,AMOM,ALMP8,ALMV1,FUN)

      VPSVC(1,2,1,3)=VPSVC(1,2,1,3)+FACT2*( CPANN+CCRNN)*FUN(6)
      VPSVC(3,2,1,3)=VPSVC(3,2,1,3)+FACT2*( CPALS+CCRLS)*FUN(6)
      VPSVC(4,2,1,3)=VPSVC(4,2,1,3)+FACT2*( CPASS+CCRSS)*FUN(6)
      VPSVC(5,2,1,3)=VPSVC(5,2,1,3)+FACT2*( CPADR+CCRDR)*FUN(6)

      VPSVC(1,3,1,3)=VPSVC(1,3,1,3)+FACT2*( CPANN+CCRNN)*FUN(7)
      VPSVC(3,3,1,3)=VPSVC(3,3,1,3)+FACT2*( CPALS+CCRLS)*FUN(7)
      VPSVC(4,3,1,3)=VPSVC(4,3,1,3)+FACT2*( CPASS+CCRSS)*FUN(7)
      VPSVC(5,3,1,3)=VPSVC(5,3,1,3)+FACT2*( CPADR+CCRDR)*FUN(7)

C     EM-CONTRIBUTION:
C     PARALLEL:
      CPANN  =   4*ISFAC*F1**2*FD6*FVE6
      CPALS  =  -SR3*F1*FVE6*F3*(FD8+FD7)
     .          -SR3*F1*(FD6)*F3*(FVE7+FVE8)
      CPASS  =  -4*F1*FVE6*F2*(FD8)
     .          -4*F1*(FD6)*F2*FVE8
      CPADR  =  +2*F1*FVE6*F2*(FD8)
     .          +2*F1*(FD6)*F2*FVE8
C     CROSSED:
      CCRNN  =  CPANN
      CCRLS  =  CPALS
      CCRSS  =  CPASS
      CCRDR  =  CPADR

      VPSVC(1,3,1,3)=VPSVC(1,3,1,3)+FACT3*(CPANN+CCRNN)*FUN(3)
      VPSVC(3,3,1,3)=VPSVC(3,3,1,3)+FACT3*(CPALS+CCRLS)*FUN(3)
      VPSVC(4,3,1,3)=VPSVC(4,3,1,3)+FACT3*(CPASS+CCRSS)*FUN(3)
      VPSVC(5,3,1,3)=VPSVC(5,3,1,3)+FACT3*(CPADR+CCRDR)*FUN(3)

      ENDIF
C END PION-OMEGA

C PION-PHI EXCHANGE POTENTIALS:
      IF(IPIPH.EQ.1) THEN
C     1/M^2-TERMS:
      FVE9  = FD9+FV9
      FVE10 = FD10+FV10
      FVE11 = FD11+FV11
C     MM-CONTRIBUTION:
C     PARALLEL:
      CPANN  =   2*ISFAC*F1**2*FVE9**2
      CPALS  =  -SR3*F1*FVE9*F3*(FVE10+FVE11)
      CPASS  =  -4*F1*FVE9*F2*FVE11
      CPADR  =  +2*F1*FVE9*F2*FVE11
C     CROSSED:
      CCRNN  =   CPANN
      CCRLS  =   CPALS
      CCRSS  =   CPASS
      CCRDR  =   CPADR

      CALL YNFUN(1,X,PIM,AMFI,ALMP8,ALMV8,FUN)

      VPSVC(1,2,1,4)=VPSVC(1,2,1,4)+FACT2*( CPANN+CCRNN)*FUN(6)
      VPSVC(3,2,1,4)=VPSVC(3,2,1,4)+FACT2*( CPALS+CCRLS)*FUN(6)
      VPSVC(4,2,1,4)=VPSVC(4,2,1,4)+FACT2*( CPASS+CCRSS)*FUN(6)
      VPSVC(5,2,1,4)=VPSVC(5,2,1,4)+FACT2*( CPADR+CCRDR)*FUN(6)

      VPSVC(1,3,1,4)=VPSVC(1,3,1,4)+FACT2*( CPANN+CCRNN)*FUN(7)
      VPSVC(3,3,1,4)=VPSVC(3,3,1,4)+FACT2*( CPALS+CCRLS)*FUN(7)
      VPSVC(4,3,1,4)=VPSVC(4,3,1,4)+FACT2*( CPASS+CCRSS)*FUN(7)
      VPSVC(5,3,1,4)=VPSVC(5,3,1,4)+FACT2*( CPADR+CCRDR)*FUN(7)

C     EM-CONTRIBUTION:
C     PARALLEL:
      CPANN  =   4*ISFAC*F1**2*FD9*FVE9
      CPALS  =  -SR3*F1*FVE9*F3*(FD11+FD10)
     .          -SR3*F1*(FD9)*F3*(FVE10+FVE11)
      CPASS  =  -4*F1*FVE9*F2*(FD11)
     .          -4*F1*(FD9)*F2*FVE11
      CPADR  =  +2*F1*FVE9*F2*(FD11)
     .          +2*F1*(FD9)*F2*FVE11
C     CROSSED:
      CCRNN  =  CPANN
      CCRLS  =  CPALS
      CCRSS  =  CPASS
      CCRDR  =  CPADR

      VPSVC(1,3,1,4)=VPSVC(1,3,1,4)+FACT3*( CPANN+CCRNN)*FUN(3)
      VPSVC(3,3,1,4)=VPSVC(3,3,1,4)+FACT3*( CPALS+CCRLS)*FUN(3)
      VPSVC(4,3,1,4)=VPSVC(4,3,1,4)+FACT3*( CPASS+CCRSS)*FUN(3)
      VPSVC(5,3,1,4)=VPSVC(5,3,1,4)+FACT3*( CPADR+CCRDR)*FUN(3)
      ENDIF
C END PION-PHI

C PION-KSTAR EXCHANGE POTENTIALS:
      IF(IPIKS.EQ.1) THEN
C     EE-CONTRIBUTION:
C     PARALLEL:
      CPALL  =  6*F1*FD4*F3*FD5
      CPALS  =  -SR3*F1*F3*(FD4**2-FD5**2)
     .          +2*SR3*F1*F2*FD4*FD5
      CPASS  =  F1*FD5*(6*F3*FD4+4*F2*FD5)
      CPADR  =  +4*F1*F2*FD5**2
C     CROSSED:
      CCRLL  =  3*(F1*F1*FD4**2+F3*F3*FD5**2)
      CCRLS  =  SR3*(F1**2-F3**2)*FD4*FD5
     .         +2*SR3*F2*F3*FD5**2
      CCRSS  =  5*F1**2*FD5**2+F3*F3*FD4**2
     .         +4*F2*F3*FD4*FD5
      CCRDR  =  2*F1**2*FD5**2+F3**2*FD4**2
     .         +3*F2**2*FD5**2-2*F2*F3*FD4*FD5

      CALL YNFUN(1,X,PIM,AMKS,ALMP8,ALMKS,FUN)
**    CALL YNFUN2(1,X,PIM,AMKS,ALMP8,ALMKS,DAM,2,FUN)

      VPSVC(2,2,1,2)=
     .VPSVC(2,2,1,2) + FACT*( CPALL*FUN(1) - CCRLL*FUN(11) )*P
      VPSVC(3,2,1,2)=
     .VPSVC(3,2,1,2) + FACT*( CPALS*FUN(1) - CCRLS*FUN(11) )*P
      VPSVC(4,2,1,2)=
     .VPSVC(4,2,1,2) + FACT*( CPASS*FUN(1) - CCRSS*FUN(11) )*P
      VPSVC(5,2,1,2)=
     .VPSVC(5,2,1,2) + FACT*( CPADR*FUN(1) - CCRDR*FUN(11) )*P

      VPSVC(2,3,1,2)=
     .VPSVC(2,3,1,2) + FACT*( CPALL*FUN(2) - CCRLL*FUN(12) )*P
      VPSVC(3,3,1,2)=
     .VPSVC(3,3,1,2) + FACT*( CPALS*FUN(2) - CCRLS*FUN(12) )*P
      VPSVC(4,3,1,2)=
     .VPSVC(4,3,1,2) + FACT*( CPASS*FUN(2) - CCRSS*FUN(12) )*P
      VPSVC(5,3,1,2)=
     .VPSVC(5,3,1,2) + FACT*( CPADR*FUN(2) - CCRDR*FUN(12) )*P

C     1/M^2-TERMS:
      FVE4 = FD4+FV4
      FVE5 = FD5+FV5
C     MM-CONTRIBUTION:
C     PARALLEL:
      CPALL  =  6*F1*FVE4*F3*FVE5
      CPALS  =  -SR3*F1*F3*(FVE4**2-FVE5**2)
     .          +2*SR3*F1*F2*FVE4*FVE5
      CPASS  =  F1*FVE5*(6*F3*FVE4+4*F2*FVE5)
      CPADR  =  +4*F1*F2*FVE5**2
C     CROSSED:
      CCRLL  =  3*(F1*F1*FVE4**2+F3*F3*FVE5**2)
      CCRLS  =  SR3*(F1**2-F3**2)*FVE4*FVE5
     .         +2*SR3*F2*F3*FVE5**2
      CCRSS  =  5*F1**2*FVE5**2+F3**2*FVE4**2
     .         +4*F2*F3*FVE4*FVE5
      CCRDR  =  2*F1**2*FVE5**2+F3**2*FVE4**2
     .         +3*F2**2*FVE5**2-2*F2*F3*FVE4*FVE5

      CALL YNFUN(1,X,PIM,AMKS,ALMP8,ALMKS,FUN)
**    CALL YNFUN2(1,X,PIM,AMKS,ALMP8,ALMKS,DAM,2,FUN)

      VPSVC(2,1,1,2)=VPSVC(2,1,1,2)+FACT2*(CPALL-CCRLL)*FUN(5)*P
      VPSVC(3,1,1,2)=VPSVC(3,1,1,2)+FACT2*(CPALS-CCRLS)*FUN(5)*P
      VPSVC(4,1,1,2)=VPSVC(4,1,1,2)+FACT2*(CPASS-CCRSS)*FUN(5)*P
      VPSVC(5,1,1,2)=VPSVC(5,1,1,2)+FACT2*(CPADR-CCRDR)*FUN(5)*P

      VPSVC(2,2,1,2)=VPSVC(2,2,1,2)+FACT2*(CPALL+CCRLL)*FUN(6)*P
      VPSVC(3,2,1,2)=VPSVC(3,2,1,2)+FACT2*(CPALS+CCRLS)*FUN(6)*P
      VPSVC(4,2,1,2)=VPSVC(4,2,1,2)+FACT2*(CPASS+CCRSS)*FUN(6)*P
      VPSVC(5,2,1,2)=VPSVC(5,2,1,2)+FACT2*(CPADR+CCRDR)*FUN(6)*P

      VPSVC(2,3,1,2)=VPSVC(2,3,1,2)+FACT2*(CPALL+CCRLL)*FUN(7)*P
      VPSVC(3,3,1,2)=VPSVC(3,3,1,2)+FACT2*(CPALS+CCRLS)*FUN(7)*P
      VPSVC(4,3,1,2)=VPSVC(4,3,1,2)+FACT2*(CPASS+CCRSS)*FUN(7)*P
      VPSVC(5,3,1,2)=VPSVC(5,3,1,2)+FACT2*(CPADR+CCRDR)*FUN(7)*P

C     EM-CONTRIBUTIONS:
      DO 32 ME=1,2
C     EM,2-CONTRIBUTION:
      IF(ME.EQ.2) THEN
      FVE4 = FD4+2*FV4
      FVE5 = FD5+2*FV5
      ENDIF
C     PARALLEL:
      CPALL  =  6*F1*FVE4*F3*FD5 +6*F1*FD4*F3*FVE5
      CPALS  =  -SR3*F1*F3*(FD4*FVE4-FD5*FVE5)*2
     .          +2*SR3*F1*F2*(FD4*FVE5+FVE4*FD5)
      CPASS  =  F1*FD5*(6*F3*FVE4+4*F2*FVE5)
     .         +F1*FVE5*(6*F3*FD4+4*F2*FD5)
      CPADR  =  +4*F1*F2*FD5*FVE5*2
C     CROSSED:
      CCRLL  =  3*(F1*F1*FD4*FVE4+F3*F3*FD5*FVE5)*2
      CCRLS  =  SR3*(F1**2-F3**2)*(FD4*FVE5+FVE4*FD5)
     .         +2*SR3*F2*F3*FD5*FVE5*2
      CCRSS  =  5*F1**2*FD5*FVE5*2+F3**2*FD4*FVE4*2
     .         +4*F2*F3*(FD4*FVE5+FD5*FVE4)
      CCRDR  =  2*F1**2*FD5*FVE5*2+F3**2*FD4*FVE4*2
     .         +3*F2**2*FD5*FVE5*2-2*F2*F3*(FD4*FVE5+FD5*FVE4)
      IF(ME.EQ.1) THEN
      VPSVC(2,3,1,2)=VPSVC(2,3,1,2)+FACT3*(CPALL+CCRLL)*FUN(3)*P
      VPSVC(3,3,1,2)=VPSVC(3,3,1,2)+FACT3*(CPALS+CCRLS)*FUN(3)*P
      VPSVC(4,3,1,2)=VPSVC(4,3,1,2)+FACT3*(CPASS+CCRSS)*FUN(3)*P
      VPSVC(5,3,1,2)=VPSVC(5,3,1,2)+FACT3*(CPADR+CCRDR)*FUN(3)*P

      VPSVC(2,4,1,2)=VPSVC(2,4,1,2)+FACT3*(CPALL-CCRLL)*FUN(4)*P
      VPSVC(3,4,1,2)=VPSVC(3,4,1,2)+FACT3*(CPALS-CCRLS)*FUN(4)*P
      VPSVC(4,4,1,2)=VPSVC(4,4,1,2)+FACT3*(CPASS-CCRSS)*FUN(4)*P
      VPSVC(5,4,1,2)=VPSVC(5,4,1,2)+FACT3*(CPADR-CCRDR)*FUN(4)*P
      ENDIF
      IF(ME.EQ.2) THEN
      VPSVC(2,2,1,2)=VPSVC(2,2,1,2)+FACT3*(CPALL-CCRLL)*FUN(8)*P
      VPSVC(3,2,1,2)=VPSVC(3,2,1,2)+FACT3*(CPALS-CCRLS)*FUN(8)*P
      VPSVC(4,2,1,2)=VPSVC(4,2,1,2)+FACT3*(CPASS-CCRSS)*FUN(8)*P
      VPSVC(5,2,1,2)=VPSVC(5,2,1,2)+FACT3*(CPADR-CCRDR)*FUN(8)*P

      VPSVC(2,3,1,2)=VPSVC(2,3,1,2)+FACT3*(CPALL-CCRLL)*FUN(9)*P
      VPSVC(3,3,1,2)=VPSVC(3,3,1,2)+FACT3*(CPALS-CCRLS)*FUN(9)*P
      VPSVC(4,3,1,2)=VPSVC(4,3,1,2)+FACT3*(CPASS-CCRSS)*FUN(9)*P
      VPSVC(5,3,1,2)=VPSVC(5,3,1,2)+FACT3*(CPADR-CCRDR)*FUN(9)*P

      VPSVC(2,4,1,2)=VPSVC(2,4,1,2)+FACT3*(CPALL-CCRLL)*FUN(10)*P
      VPSVC(3,4,1,2)=VPSVC(3,4,1,2)+FACT3*(CPALS-CCRLS)*FUN(10)*P
      VPSVC(4,4,1,2)=VPSVC(4,4,1,2)+FACT3*(CPASS-CCRSS)*FUN(10)*P
      VPSVC(5,4,1,2)=VPSVC(5,4,1,2)+FACT3*(CPADR-CCRDR)*FUN(10)*P
      ENDIF
   32 CONTINUE
      ENDIF
C END PION-KSTAR
c     if(icall.eq.0.and.nschr.eq.1) call writetm(2,x,p)
      if(icall.eq.20.and.nschr.eq.1) call writetm(2,x,p)
C END VECTOR MESONS

C
C B) PION-SCALAR MESONS: *****************************************
C
C PION-DELTA EXCHANGE POTENTIALS:
      IF(IPIDE.EQ.1) THEN
C     PARALLEL:
      CPANN  =  2*(3.D0-2.D0*ISFAC)*F1**2*GS1**2
      CPALL  =  6*F1*GS1*F3*GS3
      CPALS  =  +2*SR3*F1*GS1*(F3*GS2+F2*GS3)
      CPASS  =  2*F1*GS1*(3*F3*GS3+4*F2*GS2)
      CPADR  =  2*F1*GS1*F2*GS2
C     CROSSED:
      CCRNN  =  2*(3.D0+2.D0*ISFAC)*F1**2*GS1**2
      CCRLL  =  6*F1*GS1*F3*GS3
      CCRLS  =  -2*SR3*F1*GS1*(F3*GS2+F2*GS3)
      CCRSS  =  -2*F1*GS1*F3*GS3
      CCRDR  =  2*F1*GS1*(2*F3*GS3+3*F2*GS2)
      papssc(1,1,1,1)=cpann
      crpssc(1,1,1,1)=ccrnn
      papssc(5,1,1,1)=cpadr
      crpssc(5,1,1,1)=ccrdr
      papssc(2,1,1,1)=cpall
      crpssc(2,1,1,1)=ccrll
      papssc(3,1,1,1)=cpals
      crpssc(3,1,1,1)=ccrls
      papssc(4,1,1,1)=cpass
      crpssc(4,1,1,1)=ccrss

      CALL YNFUN(2,X,PIM,AMD,ALMP8,ALMS8,FUN)

      VPSSC(1,2,1,1)=VPSSC(1,2,1,1)+FACT*( CPANN-CCRNN)*FUN(1)
      VPSSC(2,2,1,1)=VPSSC(2,2,1,1)+FACT*( CPALL-CCRLL)*FUN(1)
      VPSSC(3,2,1,1)=VPSSC(3,2,1,1)+FACT*( CPALS-CCRLS)*FUN(1)
      VPSSC(4,2,1,1)=VPSSC(4,2,1,1)+FACT*( CPASS-CCRSS)*FUN(1)
      VPSSC(5,2,1,1)=VPSSC(5,2,1,1)+FACT*( CPADR-CCRDR)*FUN(1)

      VPSSC(1,3,1,1)=VPSSC(1,3,1,1)+FACT*( CPANN-CCRNN)*FUN(2)
      VPSSC(2,3,1,1)=VPSSC(2,3,1,1)+FACT*( CPALL-CCRLL)*FUN(2)
      VPSSC(3,3,1,1)=VPSSC(3,3,1,1)+FACT*( CPALS-CCRLS)*FUN(2)
      VPSSC(4,3,1,1)=VPSSC(4,3,1,1)+FACT*( CPASS-CCRSS)*FUN(2)
      VPSSC(5,3,1,1)=VPSSC(5,3,1,1)+FACT*( CPADR-CCRDR)*FUN(2)

      VPSSC(1,4,1,1)=VPSSC(1,4,1,1)+FACT*( CPANN-CCRNN)*FUN(3)
      VPSSC(2,4,1,1)=VPSSC(2,4,1,1)+FACT*( CPALL-CCRLL)*FUN(3)
      VPSSC(3,4,1,1)=VPSSC(3,4,1,1)+FACT*( CPALS-CCRLS)*FUN(3)
      VPSSC(4,4,1,1)=VPSSC(4,4,1,1)+FACT*( CPASS-CCRSS)*FUN(3)
      VPSSC(5,4,1,1)=VPSSC(5,4,1,1)+FACT*( CPADR-CCRDR)*FUN(3)
      ENDIF
C END PION-DELTA

C PION-EPSILON1 EXCHANGE POTENTIALS: NO ADIABATIC CONTRIBUTIONS

C PION-SSTAR EXCHANGE POTENTIALS: NO ADIABATIC CONTRIBUTIONS

C PION-KAPPA EXCHANGE POTENTIALS:
      IF(IPIKSC.EQ.1) THEN
C     PARALLEL:
      CPALL  =  6*F1*GS4*F3*GS5
      CPALS  =  -SR3*F1*F3*(GS4**2-GS5**2)
     .          +2*SR3*F1*F2*GS4*GS5
      CPASS  =  F1*GS5*(6*F3*GS4+4*F2*GS5)
      CPADR  =  +4*F1*F2*GS5**2
C     CROSSED:
      CCRLL  =  3*(F1*F1*GS4**2+F3*F3*GS5**2)
      CCRLS  =  SR3*(F1**2-F3**2)*GS4*GS5
     .         +2*SR3*F2*F3*GS5**2
      CCRSS  =  5*F1**2*GS5**2+F3*F3*GS4**2
     .         +4*F2*F3*GS4*GS5
      CCRDR  =  2*F1**2*GS5**2+F3**2*GS4**2
     .         +3*F2**2*GS5**2-2*F2*F3*GS4*GS5
      papssc(5,1,1,2)=cpadr
      crpssc(5,1,1,2)=ccrdr
      papssc(2,1,1,2)=cpall
      crpssc(2,1,1,2)=ccrll
      papssc(3,1,1,2)=cpals
      crpssc(3,1,1,2)=ccrls
      papssc(4,1,1,2)=cpass
      crpssc(4,1,1,2)=ccrss

      CALL YNFUN(2,X,PIM,AMSCK,ALMP8,ALMS8,FUN)
**    CALL YNFUN2(2,X,PIM,AMSCK,ALMP8,ALMS8,DAM,2,FUN)

      VPSSC(2,2,1,2)=VPSSC(2,2,1,2)+FACT*(CPALL-CCRLL)*FUN(1)*P
      VPSSC(3,2,1,2)=VPSSC(3,2,1,2)+FACT*(CPALS-CCRLS)*FUN(1)*P
      VPSSC(4,2,1,2)=VPSSC(4,2,1,2)+FACT*(CPASS-CCRSS)*FUN(1)*P
      VPSSC(5,2,1,2)=VPSSC(5,2,1,2)+FACT*(CPADR-CCRDR)*FUN(1)*P

      VPSSC(2,3,1,2)=VPSSC(2,3,1,2)+FACT*(CPALL-CCRLL)*FUN(2)*P
      VPSSC(3,3,1,2)=VPSSC(3,3,1,2)+FACT*(CPALS-CCRLS)*FUN(2)*P
      VPSSC(4,3,1,2)=VPSSC(4,3,1,2)+FACT*(CPASS-CCRSS)*FUN(2)*P
      VPSSC(5,3,1,2)=VPSSC(5,3,1,2)+FACT*(CPADR-CCRDR)*FUN(2)*P
      ENDIF
C END PION-KAPPA
c     if(icall.eq.0.and.nschr.eq.1) call writetm(3,x,p)
      if(icall.eq.20.and.nschr.eq.1) call writetm(3,x,p)
C END SCALAR MESONS

C
C D) BEGIN DIFFRACTIVE CONTRIBUTIONS *******************
C
C PION-A2 EXCHANGE POTENTIALS:
      IF(IPIA2.EQ.1) THEN
C     PARALLEL:
      CPANN  =  2*(3.D0-2.D0*ISFAC)*F1**2*GD1**2
      CPALL  =  6*F1*GD1*F3*GD3
      CPALS  =  +2*SR3*F1*GD1*(F3*GD2+F2*GD3)
      CPASS  =  2*F1*GD1*(3*F3*GD3+4*F2*GD2)
      CPADR  =  2*F1*GD1*F2*GD2
C     CROSSED:
      CCRNN  =  2*(3.D0+2.D0*ISFAC)*F1**2*GD1**2
      CCRLL  =  6*F1*GD1*F3*GD3
      CCRLS  =  -2*SR3*F1*GD1*(F3*GD2+F2*GD3)
      CCRSS  =  -2*F1*GD1*F3*GD3
      CCRDR  =  2*F1*GD1*(2*F3*GD3+3*F2*GD2)

      CALL YNFUN(4,X,PIM,AMPOM,ALMP8,AMPRO,FUN)

      VPSDF(1,2,1,1)=VPSDF(1,2,1,1)-FACT*(CPANN-CCRNN)*FUN(1)
      VPSDF(2,2,1,1)=VPSDF(2,2,1,1)-FACT*(CPALL-CCRLL)*FUN(1)
      VPSDF(3,2,1,1)=VPSDF(3,2,1,1)-FACT*(CPALS-CCRLS)*FUN(1)
      VPSDF(4,2,1,1)=VPSDF(4,2,1,1)-FACT*(CPASS-CCRSS)*FUN(1)
      VPSDF(5,2,1,1)=VPSDF(5,2,1,1)-FACT*(CPADR-CCRDR)*FUN(1)

      VPSDF(1,3,1,1)=VPSDF(1,3,1,1)-FACT*(CPANN-CCRNN)*FUN(2)
      VPSDF(2,3,1,1)=VPSDF(2,3,1,1)-FACT*(CPALL-CCRLL)*FUN(2)
      VPSDF(3,3,1,1)=VPSDF(3,3,1,1)-FACT*(CPALS-CCRLS)*FUN(2)
      VPSDF(4,3,1,1)=VPSDF(4,3,1,1)-FACT*(CPASS-CCRSS)*FUN(2)
      VPSDF(5,3,1,1)=VPSDF(5,3,1,1)-FACT*(CPADR-CCRDR)*FUN(2)
      ENDIF
C END PION-A2

C PION-POMERON: NO ADIABATIC CONTRIBUTIONS

C PION-K** EXCHANGE POTENTIALS:
      IF(IPIKSS.EQ.1) THEN
C     PARALLEL:
      CPALL  =  6*F1*GD4*F3*GD5
      CPALS  =  -SR3*F1*F3*(GD4**2-GD5**2)
     .          +2*SR3*F1*F2*GD4*GD5
      CPASS  =  F1*GD5*(6*F3*GD4+4*F2*GD5)
      CPADR  =  +4*F1*F2*GD5**2
C     CROSSED:
      CCRLL  =  3*(F1*F1*GD4**2+F3*F3*GD5**2)
      CCRLS  =  SR3*(F1**2-F3**2)*GD4*GD5
     .         +2*SR3*F2*F3*GD5**2
      CCRSS  =  5*F1**2*GD5**2+F3*F3*GD4**2
     .         +4*F2*F3*GD4*GD5
      CCRDR  =  2*F1**2*GD5**2+F3**2*GD4**2
     .         +3*F2**2*GD5**2-2*F2*F3*GD4*GD5

      CALL YNFUN(4,X,PIM,AMPOM,ALMP8,AMPRO,FUN)
**    CALL YNFUN2(4,X,PIM,AMPOM,ALMP8,AMPRO,DAM,2,FUN)

      VPSDF(2,2,1,2)=VPSDF(2,2,1,2)-FACT*(CPALL-CCRLL)*FUN(1)*P
      VPSDF(3,2,1,2)=VPSDF(3,2,1,2)-FACT*(CPALS-CCRLS)*FUN(1)*P
      VPSDF(4,2,1,2)=VPSDF(4,2,1,2)-FACT*(CPASS-CCRSS)*FUN(1)*P
      VPSDF(5,2,1,2)=VPSDF(5,2,1,2)-FACT*(CPADR-CCRDR)*FUN(1)*P

      VPSDF(2,3,1,2)=VPSDF(2,3,1,2)-FACT*(CPALL-CCRLL)*FUN(2)*P
      VPSDF(3,3,1,2)=VPSDF(3,3,1,2)-FACT*(CPALS-CCRLS)*FUN(2)*P
      VPSDF(4,3,1,2)=VPSDF(4,3,1,2)-FACT*(CPASS-CCRSS)*FUN(2)*P
      VPSDF(5,3,1,2)=VPSDF(5,3,1,2)-FACT*(CPADR-CCRDR)*FUN(2)*P
      ENDIF
C END PION-K**
  30  CONTINUE
c     if(icall.eq.0.and.nschr.eq.1) call writetm(4,x,p)
      if(icall.eq.20.and.nschr.eq.1) call writetm(4,x,p)
C END DIFFRACTIVE CONTRIBUTIONS

C  1  CONTINUE

1000  CALL ERRSET(208,256,1,1)
      ICALL = ICALL + 1
      RETURN
C END YNPIBE ROUTINE ***************************************************
      END
C **********************************************************************
      SUBROUTINE YNPSBE(X,INA,IPV,IOFF,APV)
C **********************************************************************
C *
C *   DATE: FEBRUARY 1995 , YNPSBE = COMPLEMENT YNPIBE
C
C *   KAON-MESON AND ETA(P)-MESON EXCHANGE YN-POTENTIALS
C *   (MESON= VECTOR, SCALAR, DIFFR.)
C *
C * THIS ROUTINE: BW ADIABATIC-APPROXIMATION, TMO LOWEST APPROXIMATION
C *               NO MASS-DIFFERENCES BETWEEN BARYONS TAKEN INTO ACCOUNT
C *
C * NOTE THAT IN THE ADIABATIC APPROXIMATION THERE ARE NO CONTRIBUTIONS
C * FROM: PI-EPSILON, PI-POMERON
C
C     PS-SCAL: ALMP1 = SU(3)-SINGLET, ALMP8 = SU(3)-OCTET
C     VECTOR : ALMV1 = SU(3)-SINGLET, ALMV8 = SU(3)-OCTET
C     SCALAR : ALMS1 = SU(3)-SINGLET, ALMS8 = SU(3)-OCTET
C *
C **********************************************************************
C     CALL YNFUN(KIND,X,AM1,AM2,ALM1,ALM2,FUN):
C
C     KIND=1, PSEUDOSCALAR-VECTOR EXCHANGE:
C     FUN(1) = OPAEES  FUN(2) = OPAEET  FUN(3) = OPAEMT  FUN(4) = OPAEMO
C     FUN(5) = OPAMMC  FUN(6) = OPAMMS  FUN(7) = OPAMMT
C     KIND=2, PSEUDOSCALAR-SCALAR EXCHANGE:
C     FUN(1) = OSCS    FUN(2) = OSCT
C     KIND=4, PSEUDOSCALAR-DIFFRACTIVE EXCHANGE:
C     FUN(1) = OSCS    FUN(2) = OSCT
C **********************************************************************
C
C     INCLUDED IN ENERGY-DENOMINATORS:
C     (i) L+R contributions included, 1/4 -> 1/2, the latter is
C         put into FACT,FACT2
C     INCLUDED IN COUPLINGCOMBINATIONS CPANLL ETC.:
C     (ii) 1 <-> 2 interchange effects for non-identical mesons.
C
C     FOR FORM FACTOR TREATMENT SEE:
C     TH.A.RIJKEN, ANNALS OF PHYSICS 208, P.253 (1990).
C
C **********************************************************************
C
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/PIMAS/PIM0
      COMMON/DYNMAS/REDMM,AMLN,AMSN,AMH,AMSS,AMLS,AMNN
      COMMON/POTESC/VCLL,VCSS,VCLS,VCDR,VSLL,VSSS,VSLS,VSDR,
     .              VTLL,VTSS,VTLS,VTDR,VOLL,VOSS,VOLS,VODR,
     .              VALL,VASS,VALS,VADR
      COMMON/FORMF/ALAM,ALMP8,ALMV8,ALMS8,ALMP1,ALMV1,ALMS1,
     .             ALMKA,ALMKS,ALMKAP
      COMMON/COUCON/ALP,XZ1(3),ALVD,XZ2(2),ALVV,XZ3(12),ALS,XZ4,ALD,
     .ALPA
      COMMON/ALLPS/AME,AMX,AMK,BMK
      COMMON/ALLVC/ARO,BRO,AM1RO,AM2RO,AMOM,AMFI,AMKS,BMKS
*     COMMON/ALLVC/AVEC(2),AMVEC(2),AMOM,AMFI,AMKS,BMKS
      COMMON/ALLSC/ASI,BSI,AM1SI,AM2SI,ASST,BSST,AMSST,AM2ST,AMD,AMSCK
      COMMON/ALLDF/AMPOM,AMF2,AMA2,AMKSS,GDA(11)
*     COMMON/ALLAX/FA1,FA9,ALPAX
*     COMMON/OOM/ INA,IPV,IOFF
C
      DIMENSION FUN(12),FUNX(12),AMSIG(2),ASIG(2),AMVEC(2),AVEC(2)

      COMMON/COUPL/ F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,F11,
     .              G1,G2,G3,G4,G5,G6,G7,G8,G9,G10,G11,
     .              FD1,FD2,FD3,FD4,FD5,FD6,FD7,FD8,FD9,FD10,FD11,
     .              FV1,FV2,FV3,FV4,FV5,FV6,FV7,FV8,FV9,FV10,FV11,
     .              GS1,GS2,GS3,GS4,GS5,GS6,GS7,GS8,GS9,GS10,GS11,
     .              GD1,GD2,GD3,GD4,GD5,GD6,GD7,GD8,GD9,GD10,GD11,P
      DIMENSION F(11),G(11),FD(11),FV(11),GS(11),GD(11)
      EQUIVALENCE (F1,F(1)),(G1,G(1)),(FD1,FD(1)),(FV1,FV(1))
     . ,(GS1,GS(1)),(GD1,GD(1))
      COMMON/PSBE/ 
     .VPSPS(5,4,4,4),VPSVC(5,4,4,4),VPSSC(5,4,4,4),VPSDF(5,4,4,4)
      CHARACTER *4 NTYPM(4,4)
      DATA NTYPM/
     .'PI  ','KA  ','ETA ','ETAP','RHO ','K*  ','OM  ','PHI ',
     .'DE  ','KAP ','EPS ','S*  ','A2  ','K** ','POM ','POMP'/
C

      DATA IKARO/1/,IKAOM/1/,IKAPH/1/,IKAKS/1/,IKADE/1/,IKAEP/1/,
     .     IKAST/1/,IKAKSC/1/,IKAA2/1/,IKAPOM/1/,IKAKSS/1/,
     .     IETKSC/1/,IETPKP/1/,IETAKS/1/,IETPKS/1/,IEPEP/0/
C
      DATA PI/3.14159265D0/,SRPI/1.7724538509D0/,
     . SR2/1.41421356D0/,SR6/2.44948974D0/,SR3/1.732051D0/
      DATA AMPRO/938.2796D0/,AMRO/760.D0/,AMEPS/760.D0/,DAM/230.D0/
*     DATA AMPRO/1138.2796D0/,AMRO/760.D0/,AMEPS/760.D0/
      DATA N3/27/,ICALL/0/,ISFAC/1/,NSCHR/1/
      SAVE AMN,FACT,FACT2,FACT3,ISFLL,ISFLS,ISFSS
C
      CALL ERRSET(208,256,-1,1)
C
      pim=pim0
*     pim=500.d0

      IF(ICALL.EQ.0) THEN
        AMN = AMPRO
        FACT = PIM0/2.D0
*       FACT2= 0.25D0*FACT*(PIM0/AMN)**2
*       FACT3=0.5D0*FACT2
        FACT2= 0.5D0*FACT*(PIM0/AMN)**2
        FACT3= 0.5D0*FACT2
        IF(P.EQ.+1.D0) ISFAC=+1
        IF(P.EQ.-1.D0) ISFAC=-3
        ISFLL=(1+ISFAC)/2
        ISFLS=(3-ISFAC)
        ISFSS=(9+ISFAC)/2

        PRINT 52, INA,IPV,IOFF,IKARO,IKAOM,IKAPH,IKAKS,
     .  IKADE,IKAEP,IKAST,IKAKSC,IKAA2,IKAPOM,IKAKSS,
     .  IETKSC,IETPKP,IETAKS,IETPKS
 52     FORMAT(//,'  IN YNPSBE: INA,IPV,IOFF=',3I3,//,
     .  11X,'  IKARO,IKAOM,IKAPH,IKAKS=',4I2,//,
     .  11X,'  IKADE,IKAEP,IKAST,IKAKSC=',4I2,//,
     .  11X,'  IPIA2,IPIPOM,IPIKSS=',3I2,//,
     .  11X,'  IETKSC,IETPKP,IETAKS,IETPKS=',4I2,//)
        PRINT 53, ALMP1,ALMV1,ALMS1,ALMP8,ALMV8,ALMS8,PIM,DAM
 53     FORMAT(/,' IN YNPSBE: ALMP1=',D10.3,' ALMV1=',D10.3,' ALMS1=',
     .  D10.3,/,11X,' ALMP8=',D10.3,' ALMV8=',D10.3,' ALMS8=',D10.3,/,
     .  11X,'  PIM =',F10.3,'  DAM =',F10.3,/)
**      ICALL=1
      ENDIF
C     XI-COUPLINGS:
      XF12 = F1*(4*ALP-1.D0)/SR3
      XF13 = -F1
      XFD12= FD1*(4*ALVD-1.D0)/SR3
      XFD13= -FD1
      XFV12= FV1*(4*ALVV-1.D0)/SR3
      XFV13= -FV1
      XGS12= GS1*(4*ALS-1.D0)/SR3
      XGS13= -GS1
      XGD12= GD1*(4*ALD-1.D0)/SR3
      XGD13= -GD1
C
C     CONSTRUCTION OF THE POTENTIALS
C
*     DO 1 I=2,NMAX
*     X = XA(I)
c     VCNN =0.D0
c     VSNN =0.D0
c     VCLL =0.D0
c     VCLS =0.D0
c     VCSS =0.D0
c     VCDR =0.D0
c     VSLL =0.D0
c     VSLS =0.D0
c     VSSS =0.D0
c     VSDR =0.D0
c     VTLL =0.D0
c     VTLS =0.D0
c     VTSS =0.D0
c     VTDR =0.D0

C     1/M-CORRECTIONS:
      IF(INA.EQ.1.OR.IPV.EQ.1.OR.IOFF.EQ.1)
     .CALL OMPSBE(X,INA,IPV,IOFF,APV)
      IF(INA.EQ.1.AND.IEPEP.NE.0) CALL OMSCDF(X,INA)

C A)  PSEUDO-SCALAR-VECTOR-MESON POTENTIALS: **********************
C
      DO 100 II=1,12
      IF(II.LE.4) M=2
      IF(II.GE.5.and.II.LE.8) M=3
      IF(II.GE.9.and.II.LE.12) M=4
      DO 101 IVV=1,4
      GOTO(1,2,3,4,5,6,7,8,9,10,11,12), II
C     KA-RHO:
    1 N = 1
      PEX= P
      CALL YNFUN(1,X,AMK,AMRO,ALMKA,ALMV8,FUN)
**    CALL YNFUN2(1,X,AMK,AMRO,ALMKA,ALMV8,DAM,1,FUN)
C     EE-TERMS:
      IF(IVV.EQ.1) THEN
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  6*FD1*FD3*F4*F5
      CPALS  =  +2*SR3*FD1*FD2*F4*F5-SR3*FD1*FD3*(F4**2-F5**2)
      CPASS  =  6*FD1*FD3*F4*F5+4*FD1*FD2*F5**2
      CPADR  =  4*FD1*FD2*F5**2
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  3*(FD1**2*F4**2+FD3**2*F5**2)
      CCRLS  =  SR3*(FD1**2*F4*F5-FD3**2*F4*F5+2*FD2*FD3*F5**2)
      CCRSS  =  5*FD1**2*F5**2+FD3**2*F4**2+4*FD2*FD3*F4*F5
      CCRDR  =  2*FD1**2*F5**2+FD3**2*F4**2
     .         +3*FD2**2*F5**2-2*FD2*FD3*F4*F5
      ENDIF

      IF(IVV.EQ.2) THEN
C     1/M^2-TERMS:
      FVE1 = FD1+FV1
      FVE2 = FD2+FV2
      FVE3 = FD3+FV3
C     MM-CONTRIBUTION:
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  6*FVE1*FVE3*F4*F5
      CPALS  =  +2*SR3*FVE1*FVE2*F4*F5-SR3*FVE1*FVE3*(F4**2-F5**2)
      CPASS  =  6*FVE1*FVE3*F4*F5+4*FVE1*FVE2*F5**2
      CPADR  =  4*FVE1*FVE2*F5**2
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  3*(FVE1**2*F4**2+FVE3**2*F5**2)
      CCRLS  =  SR3*(FVE1**2*F4*F5-FVE3**2*F4*F5+2*FVE2*FVE3*F5**2)
      CCRSS  =  5*FVE1**2*F5**2+FVE3**2*F4**2+4*FVE2*FVE3*F4*F5
      CCRDR  =  2*FVE1**2*F5**2+FVE3**2*F4**2+
     .          3*FVE2**2*F5**2-2*FVE2*FVE3*F4*F5
      ENDIF

C     EM-CONTRIBUTIONS:
      IF(IVV.GE.3) THEN
      IF(IVV.EQ.3) THEN
      FVE1 = FD1+FV1
      FVE2 = FD2+FV2
      FVE3 = FD3+FV3
      ENDIF
      IF(IVV.EQ.4) THEN
      FVE1 = FD1+2*FV1
      FVE2 = FD2+2*FV2
      FVE3 = FD3+2*FV3
      ENDIF
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  6*(FVE1*FD3+FD1*FVE3)*F4*F5
      CPALS  =  +2*SR3*FVE1*FD2*F4*F5-SR3*FVE1*FD3*(F4**2-F5**2)
     .          +2*SR3*FVE2*FD1*F4*F5-SR3*FVE3*FD1*(F4**2-F5**2)
      CPASS  =  6*FVE1*FD3*F4*F5+4*FVE1*FD2*F5**2
     .         +6*FVE3*FD1*F4*F5+4*FVE2*FD1*F5**2
      CPADR  =  4*(FVE1*FD2+FVE2*FD1)*F5**2
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  6*(FVE1*FD1*F4**2+FVE3*FD3*F5**2)
      CCRLS  =  SR3*(FVE1*FD1*F4*F5-FVE3*FD3*F4*F5+2*FVE2*FD3*F5**2)
     .         +SR3*(FVE1*FD1*F4*F5-FVE3*FD3*F4*F5+2*FVE3*FD2*F5**2)
      CCRSS  =  5*FVE1*FD1*F5**2+FVE3*FD3*F4**2+4*FVE2*FD3*F4*F5
     .         +5*FVE1*FD1*F5**2+FVE3*FD3*F4**2+4*FVE3*FD2*F4*F5
      CCRDR  =  (2*FVE1*FD1*F5**2+FVE3*FD3*F4**2)*2
     .         +6*FVE2*FD2*F5**2-2*(FVE2*FD3+FVE3*FD2)*F4*F5
      ENDIF
      GOTO 102
C END KAON-RHO
C
C KAON-OMEGA EXCHANGE POTENTIALS:
    3 N = 3
      PEX= P
      CALL YNFUN(1,X,AMK,AMOM,ALMKA,ALMV1,FUN)
**    CALL YNFUN2(1,X,AMK,AMOM,ALMKA,ALMV1,DAM,1,FUN)
      IF(IVV.EQ.1) THEN
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  2*FD6*FD7*F4**2
      CPALS  =  -SR3*FD6*(FD7+FD8)*F4*F5
      CPASS  =  -2*FD6*FD8*F5**2
      CPADR  =  -2*CPASS
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  (FD6**2+FD7**2)*F4**2
      CCRLS  =  -SR3*(FD6**2+FD7*FD8)*F4*F5
      CCRSS  =  -(FD6**2+FD8**2)*F5**2
      CCRDR  =  -2*CCRSS
      ENDIF

C     1/M^2-TERMS:
      IF(IVV.EQ.2) THEN
      FVE6 = FD6+FV6
      FVE7 = FD7+FV7
      FVE8 = FD8+FV8
C     MM-CONTRIBUTION:
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  2*FVE6*FVE7*F4**2
      CPALS  =  -SR3*FVE6*(FVE7+FVE8)*F4*F5
      CPASS  =  -2*FVE6*FVE8*F5**2
      CPADR  =  -2*CPASS
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  (FVE6**2+FVE7**2)*F4**2
      CCRLS  =  -SR3*(FVE6**2+FVE7*FVE8)*F4*F5
      CCRSS  =  -(FVE6**2+FVE8**2)*F5**2
      CCRDR  =  -2*CCRSS
      ENDIF

C     EM-CONTRIBUTION:
      IF(IVV.GE.3) THEN
      IF(IVV.EQ.3) THEN
      FVE6 = FD6+FV6
      FVE7 = FD7+FV7
      FVE8 = FD8+FV8
      ENDIF
      IF(IVV.EQ.4) THEN
      FVE6 = FD6+2*FV6
      FVE7 = FD7+2*FV7
      FVE8 = FD8+2*FV8
      ENDIF
c     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  2*(FVE6*FD7+FVE7*FD6)*F4**2
      CPALS  =  -SR3*FVE6*(FD7+FD8)*F4*F5
     .          -SR3*FD6*(FVE7+FVE8)*F4*F5
      CPASS  =  -2*(FVE6*FD8+FVE8*FD6)*F5**2
      CPADR  =  -2*CPASS
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  2*(FVE6*FD6+FVE7*FD7)*F4**2
      CCRLS  =  -SR3*(2*FVE6*FD6+FVE7*FD8+FVE8*FD7)*F4*F5
      CCRSS  =  -2*(FVE6*FD6+FVE8*FD8)*F5**2
      CCRDR  =  -2*CCRSS
      ENDIF
      GOTO 102
C END KAON-OMEGA

C KAON-PHI EXCHANGE POTENTIALS:
    4 N = 4
      PEX= P
      CALL YNFUN(1,X,AMK,AMFI,ALMKA,ALMV8,FUN)
**    CALL YNFUN2(1,X,AMK,AMFI,ALMKA,ALMV8,DAM,1,FUN)
      IF(IVV.EQ.1) THEN
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  2*FD9*FD10*F4**2
      CPALS  =  -SR3*FD9*(FD10+FD11)*F4*F5
      CPASS  =  -2*FD9*FD11*F5**2
      CPADR  =  -2*CPASS
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  (FD9**2+FD10**2)*F4**2
      CCRLS  =  -SR3*(FD9**2+FD10*FD11)*F4*F5
      CCRSS  =  -(FD9**2+FD11**2)*F5**2
      CCRDR  =  -2*CCRSS
      ENDIF

C     1/M^2-TERMS:
      IF(IVV.EQ.2) THEN
      FVE9 = FD9+FV9
      FVE10= FD10+FV10
      FVE11= FD11+FV11
C     MM-CONTRIBUTION:
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  2*FVE9*FVE10*F4**2
      CPALS  =  -SR3*FVE9*(FVE10+FVE11)*F4*F5
      CPASS  =  -2*FVE9*FVE11*F5**2
      CPADR  =  -2*CPASS
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  (FVE9**2+FVE10**2)*F4**2
      CCRLS  =  -SR3*(FVE9**2+FVE10*FVE11)*F4*F5
      CCRSS  =  -(FVE9**2+FVE11**2)*F5**2
      CCRDR  =  -2*CCRSS
      ENDIF

C     EM-CONTRIBUTION:
      IF(IVV.GE.3) THEN
      IF(IVV.EQ.3) THEN
      FVE9 = FD9+FV9
      FVE10= FD10+FV10
      FVE11= FD11+FV11
      ENDIF
      IF(IVV.EQ.4) THEN
      FVE9 = FD9+2*FV9
      FVE10= FD10+2*FV10
      FVE11= FD11+2*FV11
      ENDIF
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  2*(FVE9*FD10+FVE10*FD9)*F4**2
      CPALS  =  -SR3*FVE9*(FD10+FD11)*F4*F5
     .          -SR3*FD9*(FVE10+FVE11)*F4*F5
      CPASS  =  -2*(FVE9*FD11+FVE11*FD9)*F5**2
      CPADR  =  -2*CPASS
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  2*(FVE9*FD9+FVE10*FD10)*F4**2
      CCRLS  =  -SR3*(2*FVE9*FD9+FVE10*FD11+FVE11*FD10)*F4*F5
      CCRSS  =  -2*(FVE9*FD9+FVE11*FD11)*F5**2
      CCRDR  =  -2*CCRSS
      ENDIF
      GOTO 102
C END KAON-PHI

C KAON-KSTAR EXCHANGE POTENTIALS:
    2 N = 2
      PEX= 1.D0
      CALL YNFUN(1,X,AMK,AMKS,ALMKA,ALMKS,FUN)
*     CALL YNFUN3(1,1,X,AMK,AMKS,ALMKA,ALMKS,DAM,FUN)
*     CALL YNFUN3(2,1,X,AMK,AMKS,ALMKA,ALMKS,DAM,FUNX)
*     FUN(11) = FUNX(1)
*     FUN(12) = FUNX(2)
**    CALL DKBFUN(1,X,AMK,AMKS,ALMKA,ALMKS,DAM,FUN)
      IF(IVV.EQ.1) THEN
C     PARALLEL:
      CPANN  = 0.D0
      CPALL  =  2*(FD4**2*F4**2+3*FD4*FD5*F4*F5)
      CPALS  =  SR3*(FD5**2*F4*F5+FD4*FD5*F5**2
     .          -FD4**2*F4*F5-FD4*FD5*F4**2)
      CPASS  =  2*(3*FD4*FD5*F4*F5+FD5**2*F5**2)
      CPADR  =  8*FD5**2*F5**2
C     CROSSED:
*     CCRNN  =  2*(ISFLL*FD4**2*F4**2+ISFLS*FD4*FD5*F4*F5+
*    .          ISFSS*FD5**2*F5**2)
      CCRNN  =  (FD4*F4+3*FD5*F5)**2+ISFAC*(FD4*F4-FD5*F5)**2
      CCRLL  =  +2*(FD4*XFD12*F4*XF12+3*FD5*XFD12*F5*XF12)
      CCRLS  =  SR3*(FD4*F4-FD5*F5)*(XFD13*XF12+XFD12*XF13)
      CCRSS  =  -2*FD4*XFD13*F4*XF13+10*FD5*XFD13*F5*XF13
      CCRDR  =  +4*FD5*F5*XFD13*XF13 + 4*FD4*F4*XFD13*XF13
      ENDIF

C     1/M^2-TERMS:
      IF(IVV.EQ.2) THEN
      FVE4 = FD4+FV4
      FVE5 = FD5+FV5
      FVE12= XFD12+XFV12
      FVE13= XFD13+XFV13
C     MM-CONTRIBUTION:
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  2*(FVE4**2*F4**2+3*FVE4*FVE5*F4*F5)
      CPALS  =  SR3*(FVE5**2*F4*F5+FVE4*FVE5*F5**2
     .          -FVE4**2*F4*F5-FVE4*FVE5*F4**2)
      CPASS  =  2*(3*FVE4*FVE5*F4*F5+FVE5**2*F5**2)
      CPADR  =  8*FVE5**2*F5**2
C     CROSSED:
*     CCRNN  =  2*(isfll*fve4**2*f4**2+isfls*fve4*fve5*f4*f5+
*    .             isfss*fve5**2*f5**2)
      CCRNN  =  (FVE4*F4+3*FVE5*F5)**2+ISFAC*(FVE4*F4-FVE5*F5)**2
      CCRLL  =  +2*(FVE4*FVE12*F4*XF12+3*FVE5*FVE12*F5*XF12)
      CCRLS  =  +SR3*(FVE4*F4-FVE5*F5)*(FVE13*XF12+FVE12*XF13)
      CCRSS  =  -2*FVE4*FVE13*F4*XF13+10*FVE5*FVE13*F5*XF13
      CCRDR  =  +4*FVE5*FVE13*F5*XF13 +4*FVE4*F4*FVE13*XF13
      ENDIF

C     EM-CONTRIBUTION:
      IF(IVV.GE.3) THEN
      IF(IVV.EQ.4) THEN
      FVE4 = FD4+FV4
      FVE5 = FD5+FV5
      FVE12= XFD12+XFV12
      FVE13= XFD13+XFV13
      ENDIF
      IF(IVV.EQ.4) THEN
      FVE4 = FD4+2*FV4
      FVE5 = FD5+2*FV5
      FVE12= XFD12+2*XFV12
      FVE13= XFD13+2*XFV13
      ENDIF
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  2*(2*FVE4*FD4*F4**2+3*(FVE4*FD5+FVE5*FD4)*F4*F5)
      CPALS  =  SR3*(2*FVE5*FD5*F4*F5+(FVE4*FD5+FD4*FVE5)*F5**2
     .          -2*FVE4*FD4*F4*F5-(FVE4*FD5+FVE5*FD4)*F4**2)
      CPASS  =  2*(3*(FVE4*FD5+FD4*FVE5)*F4*F5+2*FVE5*FD5*F5**2)
      CPADR  =  16*FVE5*FD5*F5**2
C     CROSSED:
*     CCRNN  =  2*(2*isfll*fve4*fd4*f4**2+isfls*(fve4*fd5+fd4*fve5)*
*    .            f4*f5+2*isfss*fve5*fd5*f5**2)
      CCRNN  =  (FVE4*F4+3*FVE5*F5)*(FD4*F4+3*FD5*F5)*2
     .          +ISFAC*(FVE4*F4-FVE5*F5)*(FD4*F4-FD5*F5)*2
      CCRLL  =  +2*(FD4*FVE12*F4*XF12+3*FD5*FVE12*F5*XF12)
     .          +2*(FVE4*XFD12*F4*XF12+3*FVE5*XFD12*F5*XF12)
      CCRLS  =  +SR3*(FVE4*F4-FVE5*F5)*(XFD13*XF12+XFD12*XF13)
     .          +SR3*(FD4*F4-FD5*F5)*(FVE13*XF12+FVE12*XF13)
      CCRSS  =  -2*FVE4*XFD13*F4*XF13+10*FVE5*XFD13*F5*XF13
     .          -2*FD4*FVE13*F4*XF13+10*FD5*FVE13*F5*XF13
      CCRDR  =  +4*(FVE4*XFD13+FD4*FVE13)*F4*XF13
     .          +4*(FVE5*XFD13+FD5*FVE13)*F5*XF13
      ENDIF
      GOTO 102
C END KAON-KSTAR

C ETA-RHO EXCHANGE POTENTIALS:
    5 N = 1
      PEX= 1.D0
      CALL YNFUN(1,X,AME,AMRO,ALMP8,ALMV8,FUN)
      IF(IVV.EQ.1) THEN    
C     PARALLEL:
      CPANN  =  2*ISFAC*FD1**2*F6**2
      CPALL  =  0.D0           
      CPALS  =  -SR3*FD1*FD3*F6*(F7+F8)
      CPASS  =  -4*FD1*FD2*F6*F8
      CPADR  =  +2*FD1*F6*FD2*F8
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL                
      CCRLS  =  CPALS                        
      CCRSS  =  CPASS                  
      CCRDR  =  CPADR    
      ENDIF

C     1/M^2-TERMS:
      IF(IVV.EQ.2) THEN    
      FVE1 = FD1+FV1
      FVE2 = FD2+FV2
      FVE3 = FD3+FV3
C     MM-CONTRIBUTION:
C     PARALLEL:
      CPANN  =  2*ISFAC*FVE1**2*F6**2
      CPALL  =  0.D0           
      CPALS  =  -SR3*FVE1*FVE3*F6*(F7+F8)
      CPASS  =  -4*FVE1*FVE2*F6*F8
      CPADR  =  +2*FVE1*F6*FVE2*F8
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL                
      CCRLS  =  CPALS                        
      CCRSS  =  CPASS                  
      CCRDR  =  CPADR    
      ENDIF
C
C     EM-CONTRIBUTION:
      IF(IVV.GE.3) THEN
      IF(IVV.EQ.3) THEN
      FVE1 = FD1+FV1
      FVE2 = FD2+FV2
      FVE3 = FD3+FV3
      ENDIF
      IF(IVV.EQ.4) THEN
      FVE1 = FD1+2*FV1
      FVE2 = FD2+2*FV2
      FVE3 = FD3+2*FV3
      ENDIF
C     PARALLEL:
      CPANN  =  4*ISFAC*FVE1*FD1*F6**2
      CPALL  =  0.D0           
      CPALS  =  -SR3*(FVE1*FD3+FVE3*FD1)*F6*(F7+F8)
      CPASS  =  -4*(FVE1*FD2+FVE2*FD1)*F6*F8
      CPADR  =  +2*(FVE1*FD2+FVE2*FD1)*F6*F8
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL                
      CCRLS  =  CPALS                        
      CCRSS  =  CPASS                  
      CCRDR  =  CPADR    
      ENDIF
      GOTO 102

C ETA-KSTAR EXCHANGE POTENTIALS:
    6 N = 2
      PEX= P    
      CALL YNFUN(1,X,AME,AMKS,ALMP8,ALMKS,FUN)
**    CALL YNFUN2(1,X,AME,AMKS,ALMP8,ALMKS,DAM,2,FUN)
      IF(IVV.EQ.1) THEN    
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  2*FD4**2*F6*F7
      CPALS  =  -SR3*FD4*FD5*F6*(F7+F8)
      CPASS  =  -2*FD5**2*F6*F8
      CPADR  =  -2*CPASS
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  FD4**2*(F6**2+F7**2)
      CCRLS  =  -SR3*FD4*FD5*(F6**2+F7*F8)
      CCRSS  =  -FD5**2*(F6**2+F8**2)
      CCRDR  =  -2*CCRSS
      ENDIF

C     1/M^2-TERMS:
      IF(IVV.EQ.2) THEN    
      FVE4 = FD4+FV4
      FVE5 = FD5+FV5
C     MM-CONTRIBUTION:
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  2*FVE4**2*F6*F7
      CPALS  =  -SR3*FVE4*FVE5*F6*(F7+F8)
      CPASS  =  -2*FVE5**2*F6*F8
      CPADR  =  -2*CPASS
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  FVE4**2*(F6**2+F7**2)
      CCRLS  =  -SR3*FVE4*FVE5*(F6**2+F7*F8)
      CCRSS  =  -FVE5**2*(F6**2+F8**2)
      CCRDR  =  -2*CCRSS
      ENDIF
C
C     EM-CONTRIBUTION:
      IF(IVV.GE.3) THEN
      IF(IVV.EQ.3) THEN
      FVE4 = FD4+FV4
      FVE5 = FD5+FV5
      ENDIF
      IF(IVV.EQ.4) THEN
      FVE4 = FD4+2*FV4
      FVE5 = FD5+2*FV5
      ENDIF
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  4*FVE4*FD4*F6*F7
      CPALS  =  -SR3*(FVE4*FD5+FD4*FVE5)*F6*(F7+F8)
      CPASS  =  -4*FVE5*FD5*F6*F8
      CPADR  =  -2*CPASS
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  2*FVE4*FD4*(F6**2+F7**2)
      CCRLS  =  -SR3*(FVE4*FD5+FD4*FVE5)*(F6**2+F7*F8)
      CCRSS  =  -2*FVE5*FD5*(F6**2+F8**2)
      CCRDR  =  -2*CCRSS
      ENDIF
      GOTO 102
C END ETA-KSTAR

C ETA-OM EXCHANGE POTENTIALS:
    7 N = 3
      PEX= 1.D0 
      CALL YNFUN(1,X,AME,AMOM,ALMP8,ALMV1,FUN)
      IF(IVV.EQ.1) THEN    
C     PARALLEL:
      CPANN  =  2*FD6**2*F6**2
      CPALL  =  2*FD6*FD7*F6*F7
      CPALS  =  0.D0   
      CPASS  =  2*FD6*FD8*F6*F8 
      CPADR  =  CPASS             
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL                
      CCRLS  =  CPALS                        
      CCRSS  =  CPASS                  
      CCRDR  =  CPADR    
      ENDIF

C     1/M^2-TERMS:
      IF(IVV.EQ.2) THEN    
      FVE6 = FD6+FV6
      FVE7 = FD7+FV7
      FVE8 = FD8+FV8
C     MM-CONTRIBUTION:
C     PARALLEL:
      CPANN  =  2*FVE6**2*F6**2
      CPALL  =  2*FVE6*FVE7*F6*F7
      CPALS  =  0.D0   
      CPASS  =  2*FVE6*FVE8*F6*F8 
      CPADR  =  CPASS             
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL                
      CCRLS  =  CPALS                        
      CCRSS  =  CPASS                  
      CCRDR  =  CPADR    
      ENDIF
C
C     EM-CONTRIBUTION:
      IF(IVV.GE.3) THEN
      IF(IVV.EQ.3) THEN
      FVE6 = FD6+FV6
      FVE7 = FD7+FV7
      FVE8 = FD8+FV8
      ENDIF
      IF(IVV.EQ.4) THEN
      FVE6 = FD6+2*FV6
      FVE7 = FD7+2*FV7
      FVE8 = FD8+2*FV8
      ENDIF
C     PARALLEL:
      CPANN  =  4*FVE6*FD6*F6**2
      CPALL  =  2*(FVE6*FD7+FVE7*FD6)*F6*F7
      CPALS  =  0.D0   
      CPASS  =  2*(FVE6*FD8+FVE8*FD7)*F6*F8 
      CPADR  =  CPASS             
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL                
      CCRLS  =  CPALS                        
      CCRSS  =  CPASS                  
      CCRDR  =  CPADR    
      ENDIF
      GOTO 102

C ETA-PHI EXCHANGE POTENTIALS:
    8 N = 4
      PEX= 1.D0 
      CALL YNFUN(1,X,AME,AMFI,ALMP8,ALMV8,FUN)
      IF(IVV.EQ.1) THEN    
C     PARALLEL:
      CPANN  =  2*FD9**2*F6**2
      CPALL  =  2*FD9*FD10*F6*F7
      CPALS  =  0.D0   
      CPASS  =  2*FD9*FD11*F6*F8 
      CPADR  =  CPASS             
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL                
      CCRLS  =  CPALS                        
      CCRSS  =  CPASS                  
      CCRDR  =  CPADR    
      ENDIF

C     1/M^2-TERMS:
      IF(IVV.EQ.2) THEN    
      FVE9 = FD9+FV9
      FVE10= FD10+FV10
      FVE11= FD11+FV11
C     MM-CONTRIBUTION:
C     PARALLEL:
      CPANN  =  2*FVE9**2*F6**2
      CPALL  =  2*FVE9*FVE10*F6*F7
      CPALS  =  0.D0   
      CPASS  =  2*FVE9*FVE11*F6*F8 
      CPADR  =  CPASS             
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL                
      CCRLS  =  CPALS                        
      CCRSS  =  CPASS                  
      CCRDR  =  CPADR    
      ENDIF
C
C     EM-CONTRIBUTION:
      IF(IVV.GE.3) THEN
      IF(IVV.EQ.3) THEN
      FVE9 = FD9+FV9
      FVE10= FD10+FV10
      FVE11= FD11+FV11
      ENDIF
      IF(IVV.EQ.4) THEN
      FVE9 = FD9+2*FV9
      FVE10= FD10+2*FV10
      FVE11= FD11+2*FV11
      ENDIF
C     PARALLEL:
      CPANN  =  4*FVE9*FD9*F6**2
      CPALL  =  2*(FVE9*FD10+FVE10*FD9)*F6*F7
      CPALS  =  0.D0   
      CPASS  =  2*(FVE9*FD11+FVE11*FD9)*F6*F8 
      CPADR  =  CPASS             
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL                
      CCRLS  =  CPALS                        
      CCRSS  =  CPASS                  
      CCRDR  =  CPADR    
      ENDIF
      GOTO 102

C ETAP-RHO EXCHANGE POTENTIALS:
    9 N = 1
      PEX= 1.D0 
      CALL YNFUN(1,X,AMX,AMRO,ALMP1,ALMV8,FUN)
      IF(IVV.EQ.1) THEN    
C     PARALLEL:
      CPANN  =  2*ISFAC*FD1**2*F9**2
      CPALL  =  0.D0           
      CPALS  =  -SR3*FD1*FD3*F9*(F10+F11)
      CPASS  =  -4*FD1*FD2*F9*F11
      CPADR  =  +2*FD1*F9*FD2*F11
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL                
      CCRLS  =  CPALS                        
      CCRSS  =  CPASS                  
      CCRDR  =  CPADR    
      ENDIF

C     1/M^2-TERMS:
      IF(IVV.EQ.2) THEN    
      FVE1 = FD1+FV1
      FVE2 = FD2+FV2
      FVE3 = FD3+FV3
C     MM-CONTRIBUTION:
C     PARALLEL:
      CPANN  =  2*ISFAC*FVE1**2*F9**2
      CPALL  =  0.D0           
      CPALS  =  -SR3*FVE1*FVE3*F9*(F11+F11)
      CPASS  =  -4*FVE1*FVE2*F9*F11
      CPADR  =  +2*FVE1*F9*FVE2*F11
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL                
      CCRLS  =  CPALS                        
      CCRSS  =  CPASS                  
      CCRDR  =  CPADR    
      ENDIF
C
C     EM-CONTRIBUTION:
      IF(IVV.GE.3) THEN
      IF(IVV.EQ.3) THEN
      FVE1 = FD1+FV1
      FVE2 = FD2+FV2
      FVE3 = FD3+FV3
      ENDIF
      IF(IVV.EQ.4) THEN
      FVE1 = FD1+2*FV1
      FVE2 = FD2+2*FV2
      FVE3 = FD3+2*FV3
      ENDIF
C     PARALLEL:
      CPANN  =  4*ISFAC*FVE1*FD1*F9**2
      CPALL  =  0.D0           
      CPALS  =  -SR3*(FVE1*FD3+FVE3*FD1)*F9*(F10+F11)
      CPASS  =  -4*(FVE1*FD2+FVE2*FD1)*F9*F11
      CPADR  =  +2*(FVE1*FD2+FVE2*FD1)*F9*F11
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL                
      CCRLS  =  CPALS                        
      CCRSS  =  CPASS                  
      CCRDR  =  CPADR    
      ENDIF
      GOTO 102

C ETAP-KSTAR EXCHANGE POTENTIALS:
   10 N = 2
      PEX= P    
      CALL YNFUN(1,X,AMX,AMKS,ALMP1,ALMKS,FUN)
**    CALL YNFUN2(1,X,AMX,AMKS,ALMP1,ALMKS,DAM,2,FUN)
      IF(IVV.EQ.1) THEN    
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  2*FD4**2*F9*F10
      CPALS  =  -SR3*FD4*FD5*F9*(F10+F11)
      CPASS  =  -2*FD5**2*F9*F11
      CPADR  =  -2*CPASS
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  FD4**2*(F9**2+F10**2)
      CCRLS  =  -SR3*FD4*FD5*(F9**2+F10*F11)
      CCRSS  =  -FD5**2*(F9**2+F11**2)
      CCRDR  =  -2*CCRSS
      ENDIF

C     1/M^2-TERMS:
      IF(IVV.EQ.2) THEN
      FVE4 = FD4+FV4
      FVE5 = FD5+FV5
C     MM-CONTRIBUTION:
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  2*FVE4**2*F9*F10
      CPALS  =  -SR3*FVE4*FVE5*F9*(F10+F11)
      CPASS  =  -2*FVE5**2*F9*F11
      CPADR  =  -2*CPASS
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  FVE4**2*(F9**2+F10**2)
      CCRLS  =  -SR3*FVE4*FVE5*(F9**2+F10*F11)
      CCRSS  =  -FVE5**2*(F9**2+F11**2)
      CCRDR  =  -2*CCRSS
      ENDIF

C     EM-CONTRIBUTION:
      IF(IVV.GE.3) THEN
      IF(IVV.EQ.4) THEN
      FVE4 = FD4+FV4
      FVE5 = FD5+FV5
      ENDIF
      IF(IVV.EQ.4) THEN
      FVE4 = FD4+2*FV4
      FVE5 = FD5+2*FV5
      ENDIF
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  4*FVE4*FD4*F9*F10
      CPALS  =  -SR3*(FVE4*FD5+FD4*FVE5)*F9*(F10+F11)
      CPASS  =  -4*FVE5*FD5*F9*F11
      CPADR  =  -2*CPASS
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  2*FVE4*FD4*(F9**2+F10**2)
      CCRLS  =  -SR3*(FVE4*FD5+FD4*FVE5)*(F9**2+F10*F11)
      CCRSS  =  -2*FVE5*FD5*(F9**2+F11**2)
      CCRDR  =  -2*CCRSS
      ENDIF
      GOTO 102
C END ETAP-KSTAR

C ETAP-OM EXCHANGE POTENTIALS:
   11 N = 3
      PEX = 1.D0
      CALL YNFUN(1,X,AMX,AMOM,ALMP1,ALMV1,FUN)
      IF(IVV.EQ.1) THEN    
C     PARALLEL:
      CPANN  =  2*FD6**2*F9**2
      CPALL  =  2*FD6*FD7*F9*F10
      CPALS  =  0.D0   
      CPASS  =  2*FD6*FD8*F9*F11 
      CPADR  =  CPASS             
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL                
      CCRLS  =  CPALS                        
      CCRSS  =  CPASS                  
      CCRDR  =  CPADR    
      ENDIF

C     1/M^2-TERMS:
      IF(IVV.EQ.2) THEN    
      FVE6 = FD6+FV6
      FVE7 = FD7+FV7
      FVE8 = FD8+FV8
C     MM-CONTRIBUTION:
C     PARALLEL:
      CPANN  =  2*FVE6**2*F9**2
      CPALL  =  2*FVE6*FVE7*F9*F10
      CPALS  =  0.D0   
      CPASS  =  2*FVE6*FVE8*F9*F11 
      CPADR  =  CPASS             
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL                
      CCRLS  =  CPALS                        
      CCRSS  =  CPASS                  
      CCRDR  =  CPADR    
      ENDIF
C
C     EM-CONTRIBUTION:
      IF(IVV.GE.3) THEN
      IF(IVV.EQ.3) THEN
      FVE6 = FD6+FV6
      FVE7 = FD7+FV7
      FVE8 = FD8+FV8
      ENDIF
      IF(IVV.EQ.4) THEN
      FVE6 = FD6+2*FV6
      FVE7 = FD7+2*FV7
      FVE8 = FD8+2*FV8
      ENDIF
C     PARALLEL:
      CPANN  =  4*FVE6*FD6*F9**2
      CPALL  =  2*(FVE6*FD7+FVE7*FD6)*F9*F10
      CPALS  =  0.D0   
      CPASS  =  2*(FVE6*FD8+FVE8*FD7)*F9*F11 
      CPADR  =  CPASS             
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL                
      CCRLS  =  CPALS                        
      CCRSS  =  CPASS                  
      CCRDR  =  CPADR    
      ENDIF
      GOTO 102

C ETAP-PHI EXCHANGE POTENTIALS:
   12 N = 4
      PEX = 1.D0
      CALL YNFUN(1,X,AMX,AMFI,ALMP1,ALMV8,FUN)
      IF(IVV.EQ.1) THEN    
C     PARALLEL:
      CPANN  =  2*FD9**2*F9**2
      CPALL  =  2*FD9*FD10*F9*F10
      CPALS  =  0.D0   
      CPASS  =  2*FD9*FD11*F9*F11 
      CPADR  =  CPASS             
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL                
      CCRLS  =  CPALS                        
      CCRSS  =  CPASS                  
      CCRDR  =  CPADR    
      ENDIF

C     1/M^2-TERMS:
      IF(IVV.EQ.2) THEN    
      FVE9 = FD9+FV9
      FVE10= FD10+FV10
      FVE11= FD11+FV11
C     MM-CONTRIBUTION:
C     PARALLEL:
      CPANN  =  2*FVE9**2*F9**2
      CPALL  =  2*FVE9*FVE10*F9*F10
      CPALS  =  0.D0   
      CPASS  =  2*FVE9*FVE11*F9*F11 
      CPADR  =  CPASS             
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL                
      CCRLS  =  CPALS                        
      CCRSS  =  CPASS                  
      CCRDR  =  CPADR    
      ENDIF
C
C     EM-CONTRIBUTION:
      IF(IVV.GE.3) THEN
      IF(IVV.EQ.3) THEN
      FVE9 = FD9+FV9
      FVE10= FD10+FV10
      FVE11= FD11+FV11
      ENDIF
      IF(IVV.EQ.4) THEN
      FVE9 = FD9+2*FV9
      FVE10= FD10+2*FV10
      FVE11= FD11+2*FV11
      ENDIF
C     PARALLEL:
      CPANN  =  4*FVE9*FD9*F9**2
      CPALL  =  2*(FVE9*FD10+FVE10*FD9)*F9*F10
      CPALS  =  0.D0   
      CPASS  =  2*(FVE9*FD11+FVE11*FD9)*F9*F11 
      CPADR  =  CPASS             
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL                
      CCRLS  =  CPALS                        
      CCRSS  =  CPASS                  
      CCRDR  =  CPADR    
      ENDIF
      GOTO 102

  102 IF(IVV.EQ.1) THEN
      VPSVC(1,2,M,N)=
     .VPSVC(1,2,M,N) + FACT*( CPANN*FUN(1) - CCRNN*FUN(11))*PEX
      VPSVC(2,2,M,N)=
     .VPSVC(2,2,M,N) + FACT*( CPALL*FUN(1) - CCRLL*FUN(11))*PEX
      VPSVC(3,2,M,N)=
     .VPSVC(3,2,M,N) + FACT*( CPALS*FUN(1) - CCRLS*FUN(11))*PEX
      VPSVC(4,2,M,N)=
     .VPSVC(4,2,M,N) + FACT*( CPASS*FUN(1) - CCRSS*FUN(11))*PEX
      VPSVC(5,2,M,N)=
     .VPSVC(5,2,M,N) + FACT*( CPADR*FUN(1) - CCRDR*FUN(11))*PEX

      VPSVC(1,3,M,N)=
     .VPSVC(1,3,M,N) + FACT*( CPANN*FUN(2) - CCRNN*FUN(12))*PEX
      VPSVC(2,3,M,N)=
     .VPSVC(2,3,M,N) + FACT*( CPALL*FUN(2) - CCRLL*FUN(12))*PEX
      VPSVC(3,3,M,N)=
     .VPSVC(3,3,M,N) + FACT*( CPALS*FUN(2) - CCRLS*FUN(12))*PEX
      VPSVC(4,3,M,N)=
     .VPSVC(4,3,M,N) + FACT*( CPASS*FUN(2) - CCRSS*FUN(12))*PEX
      VPSVC(5,3,M,N)=
     .VPSVC(4,3,M,N) + FACT*( CPADR*FUN(2) - CCRDR*FUN(12))*PEX
      ENDIF
      IF(IVV.EQ.2) THEN
      VPSVC(1,1,M,N)=VPSVC(1,1,M,N)+FACT2*(CPANN-CCRNN)*FUN(5)*PEX
      VPSVC(2,1,M,N)=VPSVC(2,1,M,N)+FACT2*(CPALL-CCRLL)*FUN(5)*PEX
      VPSVC(3,1,M,N)=VPSVC(3,1,M,N)+FACT2*(CPALS-CCRLS)*FUN(5)*PEX
      VPSVC(4,1,M,N)=VPSVC(4,1,M,N)+FACT2*(CPASS-CCRSS)*FUN(5)*PEX
      VPSVC(5,1,M,N)=VPSVC(5,1,M,N)+FACT2*(CPADR-CCRDR)*FUN(5)*PEX

      VPSVC(1,2,M,N)=VPSVC(1,2,M,N)+FACT2*(CPANN+CCRNN)*FUN(6)*PEX
      VPSVC(2,2,M,N)=VPSVC(2,2,M,N)+FACT2*(CPALL+CCRLL)*FUN(6)*PEX
      VPSVC(3,2,M,N)=VPSVC(3,2,M,N)+FACT2*(CPALS+CCRLS)*FUN(6)*PEX
      VPSVC(4,2,M,N)=VPSVC(4,2,M,N)+FACT2*(CPASS+CCRSS)*FUN(6)*PEX
      VPSVC(5,2,M,N)=VPSVC(5,2,M,N)+FACT2*(CPADR+CCRDR)*FUN(6)*PEX

      VPSVC(1,3,M,N)=VPSVC(1,3,M,N)+FACT2*(CPANN+CCRNN)*FUN(7)*PEX
      VPSVC(2,3,M,N)=VPSVC(2,3,M,N)+FACT2*(CPALL+CCRLL)*FUN(7)*PEX
      VPSVC(3,3,M,N)=VPSVC(3,3,M,N)+FACT2*(CPALS+CCRLS)*FUN(7)*PEX
      VPSVC(4,3,M,N)=VPSVC(4,3,M,N)+FACT2*(CPASS+CCRSS)*FUN(7)*PEX
      VPSVC(5,3,M,N)=VPSVC(5,3,M,N)+FACT2*(CPADR+CCRDR)*FUN(7)*PEX
      ENDIF
      IF(IVV.EQ.3) THEN
      VPSVC(1,3,M,N)=VPSVC(1,3,M,N)+FACT3*(CPANN+CCRNN)*FUN(3)*PEX
      VPSVC(2,3,M,N)=VPSVC(2,3,M,N)+FACT3*(CPALL+CCRLL)*FUN(3)*PEX
      VPSVC(3,3,M,N)=VPSVC(3,3,M,N)+FACT3*(CPALS+CCRLS)*FUN(3)*PEX
      VPSVC(4,3,M,N)=VPSVC(4,3,M,N)+FACT3*(CPASS+CCRSS)*FUN(3)*PEX
      VPSVC(5,3,M,N)=VPSVC(5,3,M,N)+FACT3*(CPADR+CCRDR)*FUN(3)*PEX

      VPSVC(1,4,M,N)=VPSVC(1,4,M,N)+FACT3*(CPANN-CCRNN)*FUN(4)*PEX
      VPSVC(2,4,M,N)=VPSVC(2,4,M,N)+FACT3*(CPALL-CCRLL)*FUN(4)*PEX
      VPSVC(3,4,M,N)=VPSVC(3,4,M,N)+FACT3*(CPALS-CCRLS)*FUN(4)*PEX
      VPSVC(4,4,M,N)=VPSVC(4,4,M,N)+FACT3*(CPASS-CCRSS)*FUN(4)*PEX
      VPSVC(5,4,M,N)=VPSVC(5,4,M,N)+FACT3*(CPADR-CCRDR)*FUN(4)*PEX
      ENDIF
      IF(IVV.EQ.4) THEN
      VPSVC(1,2,M,N)=VPSVC(1,2,M,N)+FACT3*(CPANN-CCRNN)*FUN(8)*PEX
      VPSVC(2,2,M,N)=VPSVC(2,2,M,N)+FACT3*(CPALL-CCRLL)*FUN(8)*PEX
      VPSVC(3,2,M,N)=VPSVC(3,2,M,N)+FACT3*(CPALS-CCRLS)*FUN(8)*PEX
      VPSVC(4,2,M,N)=VPSVC(4,2,M,N)+FACT3*(CPASS-CCRSS)*FUN(8)*PEX
      VPSVC(5,2,M,N)=VPSVC(5,2,M,N)+FACT3*(CPADR-CCRDR)*FUN(8)*PEX

      VPSVC(1,3,M,N)=VPSVC(1,3,M,N)+FACT3*(CPANN-CCRNN)*FUN(9)*PEX
      VPSVC(2,3,M,N)=VPSVC(2,3,M,N)+FACT3*(CPALL-CCRLL)*FUN(9)*PEX
      VPSVC(3,3,M,N)=VPSVC(3,3,M,N)+FACT3*(CPALS-CCRLS)*FUN(9)*PEX
      VPSVC(4,3,M,N)=VPSVC(4,3,M,N)+FACT3*(CPASS-CCRSS)*FUN(9)*PEX
      VPSVC(5,3,M,N)=VPSVC(5,3,M,N)+FACT3*(CPADR-CCRDR)*FUN(9)*PEX

      VPSVC(1,4,M,N)=VPSVC(1,4,M,N)+FACT3*(CPANN-CCRNN)*FUN(10)*PEX
      VPSVC(2,4,M,N)=VPSVC(2,4,M,N)+FACT3*(CPALL-CCRLL)*FUN(10)*PEX
      VPSVC(3,4,M,N)=VPSVC(3,4,M,N)+FACT3*(CPALS-CCRLS)*FUN(10)*PEX
      VPSVC(4,4,M,N)=VPSVC(4,4,M,N)+FACT3*(CPASS-CCRSS)*FUN(10)*PEX
      VPSVC(5,4,M,N)=VPSVC(5,4,M,N)+FACT3*(CPADR-CCRDR)*FUN(10)*PEX
      ENDIF
  101 CONTINUE
  100 CONTINUE

C     TOTAL CONTRIBUTIONS:
      DO 20 IPS=1,4
      DO 20 IMES=1,4
      VCNN = VCNN + VPSVC(1,1,IPS,IMES)
      VCLL = VCLL + VPSVC(2,1,IPS,IMES)
      VCLS = VCLS + VPSVC(3,1,IPS,IMES)
      VCSS = VCSS + VPSVC(4,1,IPS,IMES)
      VCDR = VCDR + VPSVC(5,1,IPS,IMES)

      VSNN = VSNN + VPSVC(1,2,IPS,IMES)
      VSLL = VSLL + VPSVC(2,2,IPS,IMES)
      VSLS = VSLS + VPSVC(3,2,IPS,IMES)
      VSSS = VSSS + VPSVC(4,2,IPS,IMES)
      VSDR = VSDR + VPSVC(5,2,IPS,IMES)

      VTNN = VTNN + VPSVC(1,3,IPS,IMES)
      VTLL = VTLL + VPSVC(2,3,IPS,IMES)
      VTLS = VTLS + VPSVC(3,3,IPS,IMES)
      VTSS = VTSS + VPSVC(4,3,IPS,IMES)
      VTDR = VTDR + VPSVC(5,3,IPS,IMES)
  20  CONTINUE
C END VECTOR MESONS
c     if(icall.eq.0.and.nschr.eq.1) call writetm(5,x,p)
      if(icall.eq.20.and.nschr.eq.1) call writetm(5,x,p)

C
C B) KAON-SCALAR MESONS: *****************************************
C
C KAON-DELTA EXCHANGE POTENTIALS:
      IF(IKADE.EQ.1) THEN
C     PARALLEL:
      CPALL  =  6*GS1*GS3*F4*F5
      CPALS  =  +2*SR3*GS1*GS2*F4*F5-SR3*GS1*GS3*(F4**2-F5**2)
      CPASS  =  6*GS1*GS3*F4*F5+4*GS1*GS2*F5**2
      CPADR  =  4*GS1*GS2*F5**2
C     CROSSED:
      CCRLL  =  3*(GS1**2*F4**2+GS3**2*F5**2)
      CCRLS  =  SR3*(GS1**2*F4*F5-GS3**2*F4*F5+2*GS2*GS3*F5**2)
      CCRSS  =  5*GS1**2*F5**2+GS3**2*F4**2+4*GS2*GS3*F4*F5
      CCRDR  =  2*GS1**2*F5**2+GS3**2*F4**2
     .         +3*GS2**2*F5**2-2*GS2*GS3*F4*F5

      CALL YNFUN(2,X,AMK,AMD,ALMKA,ALMS8,FUN)
**    CALL YNFUN2(2,X,AMK,AMD,ALMKA,ALMS8,DAM,1,FUN)

      VPSSC(2,2,2,1)=VPSSC(2,2,2,1)+FACT*(CPALL-CCRLL)*FUN(1)*P
      VPSSC(3,2,2,1)=VPSSC(3,2,2,1)+FACT*(CPALS-CCRLS)*FUN(1)*P
      VPSSC(4,2,2,1)=VPSSC(4,2,2,1)+FACT*(CPASS-CCRSS)*FUN(1)*P
      VPSSC(5,2,2,1)=VPSSC(5,2,2,1)+FACT*(CPADR-CCRDR)*FUN(1)*P

      VPSSC(2,3,2,1)=VPSSC(2,3,2,1)+FACT*(CPALL-CCRLL)*FUN(2)*P
      VPSSC(3,3,2,1)=VPSSC(3,3,2,1)+FACT*(CPALS-CCRLS)*FUN(2)*P
      VPSSC(4,3,2,1)=VPSSC(4,3,2,1)+FACT*(CPASS-CCRSS)*FUN(2)*P
      VPSSC(5,3,2,1)=VPSSC(5,3,2,1)+FACT*(CPADR-CCRDR)*FUN(2)*P

      VPSSC(2,4,2,1)=VPSSC(2,4,2,1)+FACT*(CPALL-CCRLL)*FUN(3)*P
      VPSSC(3,4,2,1)=VPSSC(3,4,2,1)+FACT*(CPALS-CCRLS)*FUN(3)*P
      VPSSC(4,4,2,1)=VPSSC(4,4,2,1)+FACT*(CPASS-CCRSS)*FUN(3)*P
      VPSSC(5,4,2,1)=VPSSC(5,4,2,1)+FACT*(CPADR-CCRDR)*FUN(3)*P
      ENDIF
C END KAON-DELTA

C KAON-EPSILON1 EXCHANGE POTENTIALS:
      IF(IKAEP.EQ.1) THEN
C     PARALLEL:
      CPALL  =  2*GS6*GS7*F4**2
      CPALS  =  -SR3*GS6*(GS7+GS8)*F4*F5
      CPASS  =  -2*GS6*GS8*F5**2
      CPADR  =  -2*CPASS
C     CROSSED:
      CCRLL  =  (GS6**2+GS7**2)*F4**2
      CCRLS  =  -SR3*(GS6**2+GS7*GS8)*F4*F5
      CCRSS  =  -(GS6**2+GS8**2)*F5**2
      CCRDR  =  -2*CCRSS

C KAON-EPSILON1 EXCHANGE POTENTIALS:

      CALL YNFUN(2,X,AMK,AM1SI,ALMKA,ALMS1,FUN)
**    CALL YNFUN2(2,X,AMK,AM1SI,ALMKA,ALMS1,DAM,1,FUN)

      VPSSC(2,2,2,3)=VPSSC(2,2,2,3)+FACT*(CPALL-CCRLL)*FUN(1)*ASI*P
      VPSSC(3,2,2,3)=VPSSC(3,2,2,3)+FACT*(CPALS-CCRLS)*FUN(1)*ASI*P
      VPSSC(4,2,2,3)=VPSSC(4,2,2,3)+FACT*(CPASS-CCRSS)*FUN(1)*ASI*P
      VPSSC(5,2,2,3)=VPSSC(5,2,2,3)+FACT*(CPADR-CCRDR)*FUN(1)*ASI*P

      VPSSC(2,3,2,3)=VPSSC(2,3,2,3)+FACT*(CPALL-CCRLL)*FUN(2)*ASI*P
      VPSSC(3,3,2,3)=VPSSC(3,3,2,3)+FACT*(CPALS-CCRLS)*FUN(2)*ASI*P
      VPSSC(4,3,2,3)=VPSSC(4,3,2,3)+FACT*(CPASS-CCRSS)*FUN(2)*ASI*P
      VPSSC(5,3,2,3)=VPSSC(5,3,2,3)+FACT*(CPADR-CCRDR)*FUN(2)*ASI*P

      VPSSC(2,4,2,3)=VPSSC(2,4,2,3)+FACT*(CPALL-CCRLL)*FUN(3)*ASI*P
      VPSSC(3,4,2,3)=VPSSC(3,4,2,3)+FACT*(CPALS-CCRLS)*FUN(3)*ASI*P
      VPSSC(4,4,2,3)=VPSSC(4,4,2,3)+FACT*(CPASS-CCRSS)*FUN(3)*ASI*P
      VPSSC(5,4,2,3)=VPSSC(5,4,2,3)+FACT*(CPADR-CCRDR)*FUN(3)*ASI*P
C END KAON-EPSILON1

C KAON-EPSILON2 EXCHANGE POTENTIALS:

      CALL YNFUN(2,X,AMK,AM2SI,ALMKA,ALMS1,FUN)
**    CALL YNFUN2(2,X,AMK,AM2SI,ALMKA,ALMS1,DAM,1,FUN)

      VPSSC(2,2,2,3)=VPSSC(2,2,2,3)+FACT*(CPALL-CCRLL)*FUN(1)*BSI*P
      VPSSC(3,2,2,3)=VPSSC(3,2,2,3)+FACT*(CPALS-CCRLS)*FUN(1)*BSI*P
      VPSSC(4,2,2,3)=VPSSC(4,2,2,3)+FACT*(CPASS-CCRSS)*FUN(1)*BSI*P
      VPSSC(5,2,2,3)=VPSSC(5,2,2,3)+FACT*(CPADR-CCRDR)*FUN(1)*BSI*P

      VPSSC(2,3,2,3)=VPSSC(2,3,2,3)+FACT*(CPALL-CCRLL)*FUN(2)*BSI*P
      VPSSC(3,3,2,3)=VPSSC(3,3,2,3)+FACT*(CPALS-CCRLS)*FUN(2)*BSI*P
      VPSSC(4,3,2,3)=VPSSC(4,3,2,3)+FACT*(CPASS-CCRSS)*FUN(2)*BSI*P
      VPSSC(5,3,2,3)=VPSSC(5,3,2,3)+FACT*(CPADR-CCRDR)*FUN(2)*BSI*P

      VPSSC(2,4,2,3)=VPSSC(2,4,2,3)+FACT*(CPALL-CCRLL)*FUN(3)*BSI*P
      VPSSC(3,4,2,3)=VPSSC(3,4,2,3)+FACT*(CPALS-CCRLS)*FUN(3)*BSI*P
      VPSSC(4,4,2,3)=VPSSC(4,4,2,3)+FACT*(CPASS-CCRSS)*FUN(3)*BSI*P
      VPSSC(5,4,2,3)=VPSSC(5,4,2,3)+FACT*(CPADR-CCRDR)*FUN(3)*BSI*P
      ENDIF
C END KAON-EPSILON2
C END KAON-EPSILON

C KAON-SSTAR EXCHANGE POTENTIALS:
      IF(IKAST.EQ.1) THEN
C     PARALLEL:
      CPALL  =  2*GS9*GS10*F4**2
      CPALS  =  -SR3*GS9*(GS10+GS11)*F4*F5
      CPASS  =  -2*GS9*GS11*F5**2
      CPADR  =  -2*CPASS
C     CROSSED:
      CCRLL  =  (GS9**2+GS10**2)*F4**2
      CCRLS  =  -SR3*(GS9**2+GS10*GS11)*F4*F5
      CCRSS  =  -(GS9**2+GS11**2)*F5**2
      CCRDR  =  -2*CCRSS

      CALL YNFUN(2,X,AMK,AMSST,ALMKA,ALMS8,FUN)
**    CALL YNFUN2(2,X,AMK,AMSST,ALMKA,ALMS8,DAM,1,FUN)

      VPSSC(2,2,2,4)=VPSSC(2,2,2,4)+FACT*(CPALL-CCRLL)*FUN(1)*P
      VPSSC(3,2,2,4)=VPSSC(3,2,2,4)+FACT*(CPALS-CCRLS)*FUN(1)*P
      VPSSC(4,2,2,4)=VPSSC(4,2,2,4)+FACT*(CPASS-CCRSS)*FUN(1)*P
      VPSSC(5,2,2,4)=VPSSC(5,2,2,4)+FACT*(CPADR-CCRDR)*FUN(1)*P

      VPSSC(2,3,2,4)=VPSSC(2,3,2,4)+FACT*(CPALL-CCRLL)*FUN(2)*P
      VPSSC(3,3,2,4)=VPSSC(3,3,2,4)+FACT*(CPALS-CCRLS)*FUN(2)*P
      VPSSC(4,3,2,4)=VPSSC(4,3,2,4)+FACT*(CPASS-CCRSS)*FUN(2)*P
      VPSSC(5,3,2,4)=VPSSC(5,3,2,4)+FACT*(CPADR-CCRDR)*FUN(2)*P

      VPSSC(2,4,2,4)=VPSSC(2,4,2,4)+FACT*(CPALL-CCRLL)*FUN(3)*P
      VPSSC(3,4,2,4)=VPSSC(3,4,2,4)+FACT*(CPALS-CCRLS)*FUN(3)*P
      VPSSC(4,4,2,4)=VPSSC(4,4,2,4)+FACT*(CPASS-CCRSS)*FUN(3)*P
      VPSSC(5,4,2,4)=VPSSC(5,4,2,4)+FACT*(CPADR-CCRDR)*FUN(3)*P
      ENDIF
C END KAON-SSTAR

C KAON-KAPPA EXCHANGE POTENTIALS:
      IF(IKAKSC.EQ.1) THEN
C     PARALLEL:
      CPANN  = 0.D0
      CPALL  =  2*(GS4**2*F4**2+3*GS4*GS5*F4*F5)
      CPALS  =  SR3*(GS5**2*F4*F5+GS4*GS5*F5**2
     .          -GS4**2*F4*F5-GS4*GS5*F4**2)
      CPASS  =  2*(3*GS4*GS5*F4*F5+GS5**2*F5**2)
      CPADR  =  8*GS5**2*F5**2
C     CROSSED:
c     CCRNN  =  2*(ISFLL*GS4**2*F4**2+ISFLS*GS4*GS5*F4*F5+
c    .             ISFSS*GS5**2*F5**2)
      CCRNN  =  (GS4*F4+3*GS5*F5)**2+ISFAC*(GS4*F4-GS5*F5)**2
      CCRLL  =  +2*(GS4*XGS12*F4*XF12+3*GS5*XGS12*F5*XF12)
      CCRLS  =  +SR3*(GS4*F4-GS5*F5)*(XGS13*XF12+XGS12*XF13)
      CCRSS  =  -2*GS4*XGS13*F4*XF13+10*GS5*XGS13*F5*XF13
      CCRDR  = +4*GS5*XGS13*F5*XF13 +4*GS4*XGS13*F4*XF13

      CALL YNFUN(2,X,AMK,AMSCK,ALMKA,ALMS8,FUN)
*     CALL YNFUN3(1,2,X,AMK,AMSCK,ALMKA,ALMS8,DAM,FUN)
*     CALL YNFUN3(2,2,X,AMK,AMSCK,ALMKA,ALMS8,DAM,FUNX)
*     FUN(11) = FUNX(1)
*     FUN(12) = FUNX(2)
**    CALL DKBFUN(2,X,AMK,AMSCK,ALMKA,ALMS8,DAM,FUN)

      VPSSC(1,2,2,2)=VPSSC(1,2,2,2)+FACT*(CPANN-CCRNN)*FUN(1)
      VPSSC(2,2,2,2)=VPSSC(2,2,2,2)+FACT*(CPALL-CCRLL)*FUN(1)
      VPSSC(3,2,2,2)=VPSSC(3,2,2,2)+FACT*(CPALS-CCRLS)*FUN(1)
      VPSSC(4,2,2,2)=VPSSC(4,2,2,2)+FACT*(CPASS-CCRSS)*FUN(1)
      VPSSC(5,2,2,2)=VPSSC(5,2,2,2)+FACT*(CPADR-CCRDR)*FUN(1)

      VPSSC(1,3,2,2)=VPSSC(1,3,2,2)+FACT*(CPANN-CCRNN)*FUN(2)
      VPSSC(2,3,2,2)=VPSSC(2,3,2,2)+FACT*(CPALL-CCRLL)*FUN(2)
      VPSSC(3,3,2,2)=VPSSC(3,3,2,2)+FACT*(CPALS-CCRLS)*FUN(2)
      VPSSC(4,3,2,2)=VPSSC(4,3,2,2)+FACT*(CPASS-CCRSS)*FUN(2)
      VPSSC(5,3,2,2)=VPSSC(5,3,2,2)+FACT*(CPADR-CCRDR)*FUN(2)

      VPSSC(1,4,2,2)=VPSSC(1,4,2,2)+FACT*(CPANN-CCRNN)*FUN(3)
      VPSSC(2,4,2,2)=VPSSC(2,4,2,2)+FACT*(CPALL-CCRLL)*FUN(3)
      VPSSC(3,4,2,2)=VPSSC(3,4,2,2)+FACT*(CPALS-CCRLS)*FUN(3)
      VPSSC(4,4,2,2)=VPSSC(4,4,2,2)+FACT*(CPASS-CCRSS)*FUN(3)
      VPSSC(5,4,2,2)=VPSSC(5,4,2,2)+FACT*(CPADR-CCRDR)*FUN(3)
      ENDIF
C END KAON-KAPPA

C ETA-KAPPA EXCHANGE POTENTIALS:
      IF(IETKSC.EQ.1) THEN
C     PARALLEL:
      CPALL  =  2*GS4**2*F6*F7
      CPALS  =  -SR3*GS4*GS5*F6*(F7+F8)
      CPASS  =  -2*GS5**2*F6*F8
      CPADR  =  -2*CPASS
C     CROSSED:
      CCRLL  =  GS4**2*(F6**2+F7**2)
      CCRLS  =  -SR3*GS4*GS5*(F6**2+F7*F8)
      CCRSS  =  -GS5**2*(F6**2+F8**2)
      CCRDR  =  -2*CCRSS

      CALL YNFUN(2,X,AME,AMSCK,ALMP8,ALMS8,FUN)
**    CALL YNFUN2(2,X,AME,AMSCK,ALMP8,ALMS8,DAM,2,FUN)

      VPSSC(2,2,3,2)=VPSSC(2,2,3,2)+FACT*(CPALL-CCRLL)*FUN(1)*P
      VPSSC(3,2,3,2)=VPSSC(3,2,3,2)+FACT*(CPALS-CCRLS)*FUN(1)*P
      VPSSC(4,2,3,2)=VPSSC(4,2,3,2)+FACT*(CPASS-CCRSS)*FUN(1)*P
      VPSSC(5,2,3,2)=VPSSC(5,2,3,2)+FACT*(CPADR-CCRDR)*FUN(1)*P

      VPSSC(2,3,3,2)=VPSSC(2,3,3,2)+FACT*(CPALL-CCRLL)*FUN(2)*P
      VPSSC(3,3,3,2)=VPSSC(3,3,3,2)+FACT*(CPALS-CCRLS)*FUN(2)*P
      VPSSC(4,3,3,2)=VPSSC(4,3,3,2)+FACT*(CPASS-CCRSS)*FUN(2)*P
      VPSSC(5,3,3,2)=VPSSC(5,3,3,2)+FACT*(CPADR-CCRDR)*FUN(2)*P

      VPSSC(2,4,3,2)=VPSSC(2,4,3,2)+FACT*(CPALL-CCRLL)*FUN(3)*P
      VPSSC(3,4,3,2)=VPSSC(3,4,3,2)+FACT*(CPALS-CCRLS)*FUN(3)*P
      VPSSC(4,4,3,2)=VPSSC(4,4,3,2)+FACT*(CPASS-CCRSS)*FUN(3)*P
      VPSSC(5,4,3,2)=VPSSC(5,4,3,2)+FACT*(CPADR-CCRDR)*FUN(3)*P
      ENDIF
C END ETA-KAPPA

C ETAP-KAPPA EXCHANGE POTENTIALS:
      IF(IETPKP.EQ.1) THEN
C     PARALLEL:
      CPALL  =  2*GS4**2*F9*F10
      CPALS  =  -SR3*GS4*GS5*F9*(F10+F11)
      CPASS  =  -2*GS5**2*F9*F11
      CPADR  =  -2*CPASS
C     CROSSED:
      CCRLL  =  GS4**2*(F9**2+F10**2)
      CCRLS  =  -SR3*GS4*GS5*(F9**2+F10*F11)
      CCRSS  =  -GS5**2*(F9**2+F11**2)
      CCRDR  =  -2*CCRSS

      CALL YNFUN(2,X,AMX,AMSCK,ALMP1,ALMS8,FUN)
**    CALL YNFUN2(2,X,AME,AMSCK,ALMP1,ALMS8,DAM,2,FUN)

      VPSSC(2,2,4,2)=VPSSC(2,2,4,2)+FACT*(CPALL-CCRLL)*FUN(1)*P
      VPSSC(3,2,4,2)=VPSSC(3,2,4,2)+FACT*(CPALS-CCRLS)*FUN(1)*P
      VPSSC(4,2,4,2)=VPSSC(4,2,4,2)+FACT*(CPASS-CCRSS)*FUN(1)*P
      VPSSC(5,2,4,2)=VPSSC(5,2,4,2)+FACT*(CPADR-CCRDR)*FUN(1)*P

      VPSSC(2,3,4,2)=VPSSC(2,3,4,2)+FACT*(CPALL-CCRLL)*FUN(2)*P
      VPSSC(3,3,4,2)=VPSSC(3,3,4,2)+FACT*(CPALS-CCRLS)*FUN(2)*P
      VPSSC(4,3,4,2)=VPSSC(4,3,4,2)+FACT*(CPASS-CCRSS)*FUN(2)*P
      VPSSC(5,3,4,2)=VPSSC(5,3,4,2)+FACT*(CPADR-CCRDR)*FUN(2)*P

      VPSSC(2,4,4,2)=VPSSC(2,4,4,2)+FACT*(CPALL-CCRLL)*FUN(3)*P
      VPSSC(3,4,4,2)=VPSSC(3,4,4,2)+FACT*(CPALS-CCRLS)*FUN(3)*P
      VPSSC(4,4,4,2)=VPSSC(4,4,4,2)+FACT*(CPASS-CCRSS)*FUN(3)*P
      VPSSC(5,4,4,2)=VPSSC(5,4,4,2)+FACT*(CPADR-CCRDR)*FUN(3)*P
      ENDIF
C END ETAP-KAPPA

C     TOTAL CONTRIBUTIONS:
      DO 30 IPS=1,4
      DO 30 IMES=1,4
      VCNN = VCNN + VPSSC(1,1,IPS,IMES)
      VCLL = VCLL + VPSSC(2,1,IPS,IMES)
      VCLS = VCLS + VPSSC(3,1,IPS,IMES)
      VCSS = VCSS + VPSSC(4,1,IPS,IMES)
      VCDR = VCDR + VPSSC(5,1,IPS,IMES)

      VSNN = VSNN + VPSSC(1,2,IPS,IMES)
      VSLL = VSLL + VPSSC(2,2,IPS,IMES)
      VSLS = VSLS + VPSSC(3,2,IPS,IMES)
      VSSS = VSSS + VPSSC(4,2,IPS,IMES)
      VSDR = VSDR + VPSSC(5,2,IPS,IMES)

      VTNN = VTNN + VPSSC(1,3,IPS,IMES)
      VTLL = VTLL + VPSSC(2,3,IPS,IMES)
      VTLS = VTLS + VPSSC(3,3,IPS,IMES)
      VTSS = VTSS + VPSSC(4,3,IPS,IMES)
      VTDR = VTDR + VPSSC(5,3,IPS,IMES)
  30  CONTINUE
C END SCALAR MESONS
c     if(icall.eq.0.and.nschr.eq.1) call writetm(6,x,p)
      if(icall.eq.20.and.nschr.eq.1) call writetm(6,x,p)
C
C D) BEGIN DIFFRACTIVE CONTRIBUTIONS *******************
C
C KAON-A2 EXCHANGE POTENTIALS:
      IF(IKAA2.EQ.1) THEN
C     PARALLEL:
      CPALL  =  6*GD1*GD3*F4*F5
      CPALS  =  +2*SR3*GD1*GD2*F4*F5-SR3*GD1*GD3*(F4**2-F5**2)
      CPASS  =  6*GD1*GD3*F4*F5+4*GD1*GD2*F5**2
      CPADR  =  4*GD1*GD2*F5**2
C     CROSSED:
      CCRLL  =  3*(GD1**2*F4**2+GD3**2*F5**2)
      CCRLS  =  SR3*(GD1**2*F4*F5-GD3**2*F4*F5+2*GD2*GD3*F5**2)
      CCRSS  =  5*GD1**2*F5**2+GD3**2*F4**2+4*GD2*GD3*F4*F5
      CCRDR  =  2*GD1**2*F5**2+GD3**2*F4**2+
     .          3*GD2**2*F5**2-2*GD2*GD3*F4*F5

      CALL YNFUN(4,X,AMK,AMPOM,ALMKA,AMPRO,FUN)
**    CALL YNFUN2(4,X,AMK,AMPOM,ALMKA,AMPRO,DAM,1,FUN)

      VPSDF(2,2,2,1)=VPSDF(2,2,2,1)-FACT*(CPALL-CCRLL)*FUN(1)*P
      VPSDF(3,2,2,1)=VPSDF(3,2,2,1)-FACT*(CPALS-CCRLS)*FUN(1)*P
      VPSDF(4,2,2,1)=VPSDF(4,2,2,1)-FACT*(CPASS-CCRSS)*FUN(1)*P
      VPSDF(5,2,2,1)=VPSDF(5,2,2,1)-FACT*(CPADR-CCRDR)*FUN(1)*P

      VPSDF(2,3,2,1)=VPSDF(2,3,2,1)-FACT*(CPALL-CCRLL)*FUN(2)*P
      VPSDF(3,3,2,1)=VPSDF(3,3,2,1)-FACT*(CPALS-CCRLS)*FUN(2)*P
      VPSDF(4,3,2,1)=VPSDF(4,3,2,1)-FACT*(CPASS-CCRSS)*FUN(2)*P
      VPSDF(5,3,2,1)=VPSDF(5,3,2,1)-FACT*(CPADR-CCRDR)*FUN(2)*P

      VPSDF(2,4,2,1)=VPSDF(2,4,2,1)-FACT*(CPALL-CCRLL)*FUN(3)*P
      VPSDF(3,4,2,1)=VPSDF(3,4,2,1)-FACT*(CPALS-CCRLS)*FUN(3)*P
      VPSDF(4,4,2,1)=VPSDF(4,4,2,1)-FACT*(CPASS-CCRSS)*FUN(3)*P
      VPSDF(5,4,2,1)=VPSDF(5,4,2,1)-FACT*(CPADR-CCRDR)*FUN(3)*P
      ENDIF
C END KAON-A2

C KAON-POMERON:
      IF(IKAPOM.EQ.1) THEN
C     PARALLEL:
      CPALL  =  2*GD6*GD7*F4**2
      CPALS  =  -SR3*GD6*(GD7+GD8)*F4*F5
      CPASS  =  -2*GD6*GD8*F5**2
      CPADR  =  -2*CPASS
C     CROSSED:
      CCRLL  =  (GD6**2+GD7**2)*F4**2
      CCRLS  =  -SR3*(GD6**2+GD7*GD8)*F4*F5
      CCRSS  =  -(GD6**2+GD8**2)*F5**2
      CCRDR  =  -2*CCRSS

      CALL YNFUN(4,X,AMK,AMPOM,ALMKA,AMPRO,FUN)
**    CALL YNFUN2(4,X,AMK,AMPOM,ALMKA,AMPRO,DAM,1,FUN)

      VPSDF(2,2,2,3)=VPSDF(2,2,2,3)-FACT*(CPALL-CCRLL)*FUN(1)*P
      VPSDF(3,2,2,3)=VPSDF(3,2,2,3)-FACT*(CPALS-CCRLS)*FUN(1)*P
      VPSDF(4,2,2,3)=VPSDF(4,2,2,3)-FACT*(CPASS-CCRSS)*FUN(1)*P
      VPSDF(5,2,2,3)=VPSDF(5,2,2,3)-FACT*(CPADR-CCRDR)*FUN(1)*P

      VPSDF(2,3,2,3)=VPSDF(2,3,2,3)-FACT*(CPALL-CCRLL)*FUN(2)*P
      VPSDF(3,3,2,3)=VPSDF(3,3,2,3)-FACT*(CPALS-CCRLS)*FUN(2)*P
      VPSDF(4,3,2,3)=VPSDF(4,3,2,3)-FACT*(CPASS-CCRSS)*FUN(2)*P
      VPSDF(5,3,2,3)=VPSDF(5,3,2,3)-FACT*(CPADR-CCRDR)*FUN(2)*P

      VPSDF(2,4,2,3)=VPSDF(2,4,2,3)-FACT*(CPALL-CCRLL)*FUN(3)*P
      VPSDF(3,4,2,3)=VPSDF(3,4,2,3)-FACT*(CPALS-CCRLS)*FUN(3)*P
      VPSDF(4,4,2,3)=VPSDF(4,4,2,3)-FACT*(CPASS-CCRSS)*FUN(3)*P
      VPSDF(5,4,2,3)=VPSDF(5,4,2,3)-FACT*(CPADR-CCRDR)*FUN(3)*P
      ENDIF
C END KAON-POMERON

C KAON-POMP EXCHANGE POTENTIALS:
      IF(IKAPOM.EQ.1) THEN
C     PARALLEL:
      CPALL  =  2*GD9*GD10*F4**2
      CPALS  =  -SR3*GD9*(GD10+GD11)*F4*F5
      CPASS  =  -2*GD9*GD11*F5**2
      CPADR  =  -2*CPASS
C     CROSSED:
      CCRLL  =  (GD9**2+GD10**2)*F4**2
      CCRLS  =  -SR3*(GD9**2+GD10*GD11)*F4*F5
      CCRSS  =  -(GD9**2+GD11**2)*F5**2
      CCRDR  =  -2*CCRSS

      CALL YNFUN(4,X,AMK,AMPOM,ALMKA,AMPRO,FUN)
**    CALL YNFUN2(4,X,AMK,AMPOM,ALMKA,AMPRO,DAM,1,FUN)

      VPSDF(2,2,2,4)=VPSDF(2,2,2,4)-FACT*(CPALL-CCRLL)*FUN(1)*P
      VPSDF(3,2,2,4)=VPSDF(3,2,2,4)-FACT*(CPALS-CCRLS)*FUN(1)*P
      VPSDF(4,2,2,4)=VPSDF(4,2,2,4)-FACT*(CPASS-CCRSS)*FUN(1)*P
      VPSDF(5,2,2,4)=VPSDF(5,2,2,4)-FACT*(CPADR-CCRDR)*FUN(1)*P

      VPSDF(2,3,2,4)=VPSDF(2,3,2,4)-FACT*(CPALL-CCRLL)*FUN(2)*P
      VPSDF(3,3,2,4)=VPSDF(3,3,2,4)-FACT*(CPALS-CCRLS)*FUN(2)*P
      VPSDF(4,3,2,4)=VPSDF(4,3,2,4)-FACT*(CPASS-CCRSS)*FUN(2)*P
      VPSDF(5,3,2,4)=VPSDF(5,3,2,4)-FACT*(CPADR-CCRDR)*FUN(2)*P

      VPSDF(2,4,2,4)=VPSDF(2,4,2,4)-FACT*(CPALL-CCRLL)*FUN(3)*P
      VPSDF(3,4,2,4)=VPSDF(3,4,2,4)-FACT*(CPALS-CCRLS)*FUN(3)*P
      VPSDF(4,4,2,4)=VPSDF(4,4,2,4)-FACT*(CPASS-CCRSS)*FUN(3)*P
      VPSDF(5,4,2,4)=VPSDF(5,4,2,4)-FACT*(CPADR-CCRDR)*FUN(3)*P
      ENDIF
C END KAON-POMP

C KAON-K** EXCHANGE POTENTIALS:
      IF(IKAKSS.EQ.1) THEN
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  2*(GD4**2*F4**2+3*GD4*GD5*F4*F5)
      CPALS  =  SR3*(GD5**2*F4*F5+GD4*GD5*F5**2
     .          -GD4**2*F4*F5-GD4*GD5*F4**2)
      CPASS  =  2*(3*GD4*GD5*F4*F5+GD5**2*F5**2)
      CPADR  =  8*GD5**2*F5**2
C     CROSSED:
      CCRNN  =  2*(ISFLL*GD4**2*F4**2+ISFLS*GD5*GD4*F4*F5+
     .             ISFSS*GD5**2*F5**2)
      CCRLL  =  +2*(GD4*XGD12*F4*XF12+3*GD5*XGD12*F5*XF12)
      CCRLS  =  +SR3*(GD4*F4-GD5*F5)*(XGD13*XF12+XGD12*XF13)
      CCRSS  =  -2*GD4*XGD13*F4*XF13+10*GD5*XGD13*F5*XF13
      CCRDR  =  +4*GD5*XGD13*F5*XF13 + 4*GD4*XGD13*F4*XF13

      CALL YNFUN(4,X,AMK,AMPOM,ALMKA,AMPRO,FUN)
*     CALL YNFUN3(1,4,X,AMK,AMPOM,ALMKA,AMPRO,DAM,FUN)
*     CALL YNFUN3(2,4,X,AMK,AMPOM,ALMKA,AMPRO,DAM,FUNX)
*     FUN(11) = FUNX(1)
*     FUN(12) = FUNX(2)
**    CALL DKBFUN(4,X,AMK,AMPOM,ALMKA,AMPRO,DAM,FUN)

      VPSDF(1,2,2,2)=VPSDF(1,2,2,2)-FACT*(CPANN-CCRNN)*FUN(1)
      VPSDF(2,2,2,2)=VPSDF(2,2,2,2)-FACT*(CPALL-CCRLL)*FUN(1)
      VPSDF(3,2,2,2)=VPSDF(3,2,2,2)-FACT*(CPALS-CCRLS)*FUN(1)
      VPSDF(4,2,2,2)=VPSDF(4,2,2,2)-FACT*(CPASS-CCRSS)*FUN(1)
      VPSDF(5,2,2,2)=VPSDF(5,2,2,2)-FACT*(CPADR-CCRDR)*FUN(1)

      VPSDF(1,3,2,2)=VPSDF(1,3,2,2)-FACT*(CPANN-CCRNN)*FUN(2)
      VPSDF(2,3,2,2)=VPSDF(2,3,2,2)-FACT*(CPALL-CCRLL)*FUN(2)
      VPSDF(3,3,2,2)=VPSDF(3,3,2,2)-FACT*(CPALS-CCRLS)*FUN(2)
      VPSDF(4,3,2,2)=VPSDF(4,3,2,2)-FACT*(CPASS-CCRSS)*FUN(2)
      VPSDF(5,3,2,2)=VPSDF(5,3,2,2)-FACT*(CPADR-CCRDR)*FUN(2)

      VPSDF(1,4,2,2)=VPSDF(1,4,2,2)-FACT*(CPANN-CCRNN)*FUN(3)
      VPSDF(2,4,2,2)=VPSDF(2,4,2,2)-FACT*(CPALL-CCRLL)*FUN(3)
      VPSDF(3,4,2,2)=VPSDF(3,4,2,2)-FACT*(CPALS-CCRLS)*FUN(3)
      VPSDF(4,4,2,2)=VPSDF(4,4,2,2)-FACT*(CPASS-CCRSS)*FUN(3)
      VPSDF(5,4,2,2)=VPSDF(5,4,2,2)-FACT*(CPADR-CCRDR)*FUN(3)
      ENDIF
C END KAON-K**

C ETA-K** EXCHANGE POTENTIALS:
      IF(IETKSC.EQ.1) THEN
C     PARALLEL:
      CPALL  =  2*GD4**2*F6*F7
      CPALS  =  -SR3*GD4*GD5*F6*(F7+F8)
      CPASS  =  -2*GD5**2*F6*F8
      CPADR  =  -2*CPASS
C     CROSSED:
      CCRLL  =  GD4**2*(F6**2+F7**2)
      CCRLS  =  -SR3*GD4*GD5*(F6**2+F7*F8)
      CCRSS  =  -GD5**2*(F6**2+F8**2)
      CCRDR  =  -2*CCRSS

      CALL YNFUN(4,X,AME,AMPOM,ALMP8,AMPRO,FUN)
**    CALL YNFUN2(4,X,AME,AMPOM,ALMP8,AMPRO,DAM,2,FUN)

      VPSDF(2,2,3,2)=VPSDF(2,2,3,2)-FACT*(CPALL-CCRLL)*FUN(1)*P
      VPSDF(3,2,3,2)=VPSDF(3,2,3,2)-FACT*(CPALS-CCRLS)*FUN(1)*P
      VPSDF(4,2,3,2)=VPSDF(4,2,3,2)-FACT*(CPASS-CCRSS)*FUN(1)*P
      VPSDF(5,2,3,2)=VPSDF(5,2,3,2)-FACT*(CPADR-CCRDR)*FUN(1)*P

      VPSDF(2,3,3,2)=VPSDF(2,3,3,2)-FACT*(CPALL-CCRLL)*FUN(2)*P
      VPSDF(3,3,3,2)=VPSDF(3,3,3,2)-FACT*(CPALS-CCRLS)*FUN(2)*P
      VPSDF(4,3,3,2)=VPSDF(4,3,3,2)-FACT*(CPASS-CCRSS)*FUN(2)*P
      VPSDF(5,3,3,2)=VPSDF(5,3,3,2)-FACT*(CPADR-CCRDR)*FUN(2)*P

      VPSDF(2,4,3,2)=VPSDF(2,4,3,2)-FACT*(CPALL-CCRLL)*FUN(3)*P
      VPSDF(3,4,3,2)=VPSDF(3,4,3,2)-FACT*(CPALS-CCRLS)*FUN(3)*P
      VPSDF(4,4,3,2)=VPSDF(4,4,3,2)-FACT*(CPASS-CCRSS)*FUN(3)*P
      VPSDF(5,4,3,2)=VPSDF(5,4,3,2)-FACT*(CPADR-CCRDR)*FUN(3)*P
      ENDIF
C END ETA-K**

C ETAP-K** EXCHANGE POTENTIALS:
      IF(IETPKP.EQ.1) THEN
C     PARALLEL:
      CPALL  =  2*GD4**2*F9*F10
      CPALS  =  -SR3*GD4*GD5*F9*(F10+F11)
      CPASS  =  -2*GD5**2*F9*F11
      CPADR  =  -2*CPASS
C     CROSSED:
      CCRLL  =  GD4**2*(F9**2+F10**2)
      CCRLS  =  -SR3*GD4*GD5*(F9**2+F10*F11)
      CCRSS  =  -GD5**2*(F9**2+F11**2)
      CCRDR  =  -2*CCRSS

      CALL YNFUN(4,X,AMX,AMPOM,ALMP1,AMPRO,FUN)
**    CALL YNFUN2(4,X,AMX,AMPOM,ALMP1,AMPRO,DAM,2,FUN)

      VPSDF(2,2,4,2)=VPSDF(2,2,4,2)-FACT*(CPALL-CCRLL)*FUN(1)*P
      VPSDF(3,2,4,2)=VPSDF(3,2,4,2)-FACT*(CPALS-CCRLS)*FUN(1)*P
      VPSDF(4,2,4,2)=VPSDF(4,2,4,2)-FACT*(CPASS-CCRSS)*FUN(1)*P
      VPSDF(5,2,4,2)=VPSDF(5,2,4,2)-FACT*(CPADR-CCRDR)*FUN(1)*P

      VPSDF(2,3,4,2)=VPSDF(2,3,4,2)-FACT*(CPALL-CCRLL)*FUN(2)*P
      VPSDF(3,3,4,2)=VPSDF(3,3,4,2)-FACT*(CPALS-CCRLS)*FUN(2)*P
      VPSDF(4,3,4,2)=VPSDF(4,3,4,2)-FACT*(CPASS-CCRSS)*FUN(2)*P
      VPSDF(5,3,4,2)=VPSDF(5,3,4,2)-FACT*(CPADR-CCRDR)*FUN(2)*P

      VPSDF(2,4,4,2)=VPSDF(2,4,4,2)-FACT*(CPALL-CCRLL)*FUN(3)*P
      VPSDF(3,4,4,2)=VPSDF(3,4,4,2)-FACT*(CPALS-CCRLS)*FUN(3)*P
      VPSDF(4,4,4,2)=VPSDF(4,4,4,2)-FACT*(CPASS-CCRSS)*FUN(3)*P
      VPSDF(5,4,4,2)=VPSDF(5,4,4,2)-FACT*(CPADR-CCRDR)*FUN(3)*P
      ENDIF
C END ETAP-K**

C     TOTAL CONTRIBUTIONS:
      DO 40 IPS=1,4
      DO 40 IMES=1,4
      VCNN = VCNN + VPSDF(1,1,IPS,IMES)
      VCLL = VCLL + VPSDF(2,1,IPS,IMES)
      VCLS = VCLS + VPSDF(3,1,IPS,IMES)
      VCSS = VCSS + VPSDF(4,1,IPS,IMES)
      VCDR = VCDR + VPSDF(5,1,IPS,IMES)

      VSNN = VSNN + VPSDF(1,2,IPS,IMES)
      VSLL = VSLL + VPSDF(2,2,IPS,IMES)
      VSLS = VSLS + VPSDF(3,2,IPS,IMES)
      VSSS = VSSS + VPSDF(4,2,IPS,IMES)
      VSDR = VSDR + VPSDF(5,2,IPS,IMES)

      VTNN = VTNN + VPSDF(1,3,IPS,IMES)
      VTLL = VTLL + VPSDF(2,3,IPS,IMES)
      VTLS = VTLS + VPSDF(3,3,IPS,IMES)
      VTSS = VTSS + VPSDF(4,3,IPS,IMES)
      VTDR = VTDR + VPSDF(5,3,IPS,IMES)
  40  CONTINUE
c     if(icall.eq.0.and.nschr.eq.1) call writetm(7,x,p)
      if(icall.eq.20.and.nschr.eq.1) call writetm(7,x,p)
C END DIFFRACTIVE CONTRIBUTIONS
*  1  CONTINUE

c     if(icall.eq.0.and.nschr.eq.1) then
      if(icall.eq.20.and.nschr.eq.1) then
      write(N3,*)'*****************************************************'
      write(N3,*) 'YNPIBE+YNPSBE total contributions: x=',x
      write(N3,*) 'vcll,vsll=',vcll,vsll
      write(N3,*) 'vcls,vsls=',vcls,vsls
      write(N3,*) 'vcss,vsss=',vcss,vsss
      write(N3,*) 'vcdr,vsdr=',vcdr,vsdr
      write(N3,*)'*****************************************************'
      endif
      ICALL=ICALL+1

1000  CALL ERRSET(208,256,1,1)
      RETURN
C END YNPSBE ROUTINE ***************************************************
      END
C **********************************************************************
      SUBROUTINE WRITETM(NNCASE,X,P)
C **********************************************************************
C
C     NCASE = 1: PSEUDO-PSEUDO-SCALAR POTENTIALS,
C     NCASE = 2: PSEUDO-SCALAR-VECTOR POTENTIALS,
C     NCASE = 3: PSEUDO-SCALAR-SCALAR POTENTIALS,
C     NCASE = 4: PSEUDO-SCALAR-DIFFR. POTENTIALS.
C
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/PSBE/ VPSBE(5,4,4,4,4)                              
      CHARACTER *4 NTYPM(4,4)
      DATA N3/27/,NTYPM/
     .'PI  ','KA  ','ETA ','ETAP','RHO ','K*  ','OM  ','PHI ',
     .'DE  ','KAP ','EPS ','S*  ','A2  ','K** ','POM ','POMP'/
C
      if(nncase.le.4) ncase=nncase
      if(nncase.ge.5) ncase=nncase-3
      write(N3,*)'CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC'
      write(N3,*)'*****************************************************'
      if(nncase.eq.1) write(N3,*) ' YNPSPS: CENTRAL POTENTIALS: x=',x
      if(nncase.ge.2.and.nncase.le.4)
     .               write(N3,*) ' YNPIBE: CENTRAL POTENTIALS: x=',x
      if(nncase.ge.5) write(N3,*) ' YNPSBE: CENTRAL POTENTIALS: x=',x
      write(N3,*)'*****************************************************'
      write(N3,110) (NTYPM(KK,NCASE),KK=1,4)
  110 format(10x,4(3x,a4,5x))
      write(N3,*)'-----------------------------------------------------'
      DO 111 II=1,4
  111 write(N3,112) NTYPM(II,1),(VPSBE(1,1,II,KK,NCASE),KK=1,4)
      write(N3,*)'====================================================='
      DO 113 II=1,4
  113 write(N3,114) NTYPM(II,1),(VPSBE(5,1,II,KK,NCASE),KK=1,4)
      write(N3,*)'====================================================='
      DO 123 II=1,4
  123 write(N3,124) NTYPM(II,1),(VPSBE(2,1,II,KK,NCASE),KK=1,4)
      write(N3,*)'====================================================='
      DO 125 II=1,4
  125 write(N3,126) NTYPM(II,1),(VPSBE(3,1,II,KK,NCASE),KK=1,4)
      write(N3,*)'====================================================='
      DO 127 II=1,4
  127 write(N3,128) NTYPM(II,1),(VPSBE(4,1,II,KK,NCASE),KK=1,4)
      call prsu3tm(1,ncase,x,p,n3)        
      write(N3,*)'*****************************************************'
      if(nncase.eq.1) write(N3,*) ' YNPSPS: SPIN-SPIN POTENTIALS: x=',x
      if(nncase.ge.2.and.nncase.le.4)
     .               write(N3,*) ' YNPIBE: SPIN-SPIN POTENTIALS: x=',x
      if(nncase.ge.5) write(N3,*) ' YNPSBE: SPIN-SPIN POTENTIALS: x=',x
      write(N3,*)'*****************************************************'
      write(N3,115) (NTYPM(KK,NCASE),KK=1,4)
  115 format(10x,4(3x,a4,5x))
      write(N3,*)'-----------------------------------------------------'
      DO 116 II=1,4
  116 write(N3,112) NTYPM(II,1),(VPSBE(1,2,II,KK,NCASE),KK=1,4)
      write(N3,*)'====================================================='
      DO 118 II=1,4
  118 write(N3,114) NTYPM(II,1),(VPSBE(5,2,II,KK,NCASE),KK=1,4)
      write(N3,*)'====================================================='
      DO 120 II=1,4
  120 write(N3,124) NTYPM(II,1),(VPSBE(2,2,II,KK,NCASE),KK=1,4)
      write(N3,*)'====================================================='
      DO 129 II=1,4
  129 write(N3,126) NTYPM(II,1),(VPSBE(3,2,II,KK,NCASE),KK=1,4)
      write(N3,*)'====================================================='
      DO 131 II=1,4
  131 write(N3,128) NTYPM(II,1),(VPSBE(4,2,II,KK,NCASE),KK=1,4)
      write(N3,*)'*****************************************************'
      call prsu3tm(2,ncase,x,p,n3)        
      RETURN
  112 FORMAT(1x,'NN: ',A4,4(F10.2,2X))
  114 FORMAT(1x,'DR: ',A4,4(F10.2,2X))
  124 FORMAT(1x,'LL: ',A4,4(F10.2,2X))
  126 FORMAT(1x,'LS: ',A4,4(F10.2,2X))
  128 FORMAT(1x,'SS: ',A4,4(F10.2,2X))
C END WRITETM ROUTINE **************************************************
      END
C **********************************************************************
      SUBROUTINE YNFUN(KIND,X,AM1,AM2,ALM1,ALM2,FUN)
C **********************************************************************
C
C     VERSION: AUGUST 1996  ( 1/M^2-TERMS FROM IOFF=1 INCLUDED)
C              THIS VERSION IS, EXCEPT FOR A FACTOR 2, IDENTICAL
C              TO PHBFUN USED IN NN!
C     THIS ROUTINE IS CALLED FROM: YNPIBE.FORTRAN.C
C     IT IS UNDERSTOOD THAT AM1=PIM, SO INDEX 1 REFERS TO THE PION.
C
C     COMPUTES THE FOURIER TRANSFORMS OF
C
C                      1       [  1     1         1      ]
C   1*D^(0)(//)= ------------- [ --- + --- - ----------- ]  --->
C                  OM1^2 OM2^2 [ OM1   OM2   (OM1 + OM2) ]
C
C      YNFUN  = (1/PI) INT_{0}^{\INFTY} (D LAM/ LAM**2)
C
C              [      1                  1                 1        ]
C            X [ ------------  - ----------------  ---------------- ]
C              [ (OM1.OM2)^{2}   (OM1^{2}+LAM^{2}) (OM2^{2}+LAM^{2})]
C
C     FOR VARIOUS THE COMBINATIONS OF DERIVATIVES CORRESPONDING TO
C     THE OPERATORS O_{i} GIVEN IN TABLE II, PAPER I.
C
C     KIND = 1: PION-VECTOR-,   KIND = 2: PION-SCALAR-,
C     KIND = 3: PION-PSSCALAR-, KIND = 4: PION-POMERON-EXCHANGE,
C     KIND = 5: SCAL-DIFRAC-  , KIND = 6: PION-AXIAL  -EXCHANGE,
C     KIND = 7: VECTOR-VECTOR
C
C     SCHEMATICALLY:
C     PION-VECTOR EXCHANGE:
C     FUN(1) = OPAEES  FUN(2) = OPAEET  FUN(3) = OPAEMT1
C     FUN(4) = OPAEMO1 FUN(5) = OPAMMC  FUN(6) = OPAMMS
C     FUN(7) = OPAMMT  FUN(8) = OPAEMS2 FUN(9) = OPAEMT2
C     FUN(10)= OPAEMO2 FUN(11)= OCREES  FUN(12)= OCREET
C     PION-SCALAR EXCHANGE:
C     FUN(1) = OSCS    FUN(2) = OSCT    FUN(3) = OSCO
C     PION-PSSCALAR EXCHANGE:
C     FUN(1) = OPSC    FUN(2) = OPSS    FUN(3) = OPST
C     DIFRAC-DIFRAC EXCHANGE:
C     FUN(1) = ODFC    FUN(2) = ODFO
C     PION-AXIAL EXCHANGE:
C     FUN(1) = OAXC    FUN(2) = OAXS    FUN(3) = OAXT
C
C     FOR FORM FACTOR TREATMENT SEE:
C     TH.A.RIJKEN, ANNALS OF PHYSICS 208, P.253 (1990).
C
C **********************************************************************
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/PIMAS/PIM                  

      DIMENSION XX(20),WW(20),YB(3),FUN(12)
      DATA PI/3.14159265D0/,SRPI/1.7724538509D0/,ICALL/0/
      DATA IPV/1/,YB/0.D0,10.D0,50.D0/,NINT/1/,NPNT/16/,IMETH/1/
      DATA AMPRO/938.2796D0/
      SAVE XX,WW,XBEGIN
C
C     ACCORDING TO THE PAPER I, TABLE II AND APPENDIX A,B,
C     APPROXIMATION: Q^2+K^2/4 = 0
C     DEFINITION STATEMENT OPERATORS:
C     (NOTICE: G-FUNTIONS REFER TO PION, F-FUNCTIONS TO MESONS.)
C
C 1)  PION-VECTOR EXCHANGE:
      OPAEES(FF,D1F,D2F,D1G,D2G,D3G,XH)=
     .  2*FF*(2*D1G/XH+D2G)/3.D0

*    .+(4*D1F*(D3G+2*D2G/XH-2*D1G/XH/XH)
*    .+(2*D1F/XH+D2F)*(2*D1G/XH+D2G) )*(PIM/AMPRO)**2/6.D0
*    .  +(1-2*IPV)*(2*D1F*D1G/XH/XH+D2F*D2G)*(PIM/AMPRO)**2/6.D0

      OPAEET(FF,D1F,D2F,D1G,D2G,D3G,XH)=
     . -2*FF*(D1G/XH-D2G)/3.D0

*    .+(4*D1F*(D3G-  D2G/XH+  D1G/XH/XH)
*    .+(2*D1F/XH+D2F)*(D2G-D1G/XH) )*(PIM/AMPRO)**2/6.D0
*    .  +(1-2*IPV)*(D2F*D2G-D1F*D1G/XH/XH)*(PIM/AMPRO)**2/6.D0

      OCREES(FF,D1F,D2F,D1G,D2G,D3G,D4G,XH)=
     .OPAEES(FF,D1F,D2F,D1G,D2G,D3G,XH)

*    .+FF*(D4G+4*D3G/XH)*(PIM/AMPRO)**2/3.D0

      OCREET(FF,D1F,D2F,D1G,D2G,D3G,D4G,XH)=
     .OPAEET(FF,D1F,D2F,D1G,D2G,D3G,XH)

*    .+FF*(D4G+D3G/XH-6*D2G/XH**2+6*D1G/XH**3)*(PIM/AMPRO)**2/3.D0

      OPAEMT(D1F,D1G,D2G,XH)=  2*D1F*(D1G/XH-D2G)/XH
      OPAEMO(D1F,D1G,XH)=  4*D1F*D1G/XH/XH
      OPEMS2(D1F,D2F,D1G,D2G,XH)= (2*D1F/XH+D2F)*(2*D1G/XH+D2G)/3.D0
      OPEMT2(D1F,D2F,D1G,D2G,XH)=  (D1F/XH-D2F)*(D1G/XH-D2G)/3.D0
      OPEMO2(D1F,D1G,XH)=  2*D1F*D1G/XH/XH

      OPAMMC(D1F,D2F,D1G,D2G,XH)=
     .2*( D1F*D1G/XH + D1F*D2G + D2F*D1G)/XH
      OPAMMS(D1F,D2F,D1G,D2G,XH)=
     .-2*( 3*D1F*D1G/XH/XH + D1F*D2G/XH + D2F*D1G/XH +D2F*D2G)/3.D0
      OPAMMT(D1F,D2F,D1G,D2G,XH)=
     .+(D2F+D1F/XH)*(D2G-D1G/XH)/3.D0-1*(D2F-D1F/XH)*D1G/XH/3.D0
     .-1*(D2G-D1G/XH)*D1F/XH/3.D0

C 2)  PION-SCALAR EXCHANGE:
      OSCS(FF,D1F,D2F,D1G,D2G,XH)= -2*FF*(2*D1G/XH+D2G)/3.D0

*    .  +(2*D1F/XH+D2F)*(2*D1G/XH+D2G)*(PIM/AMPRO)**2/6.D0
*    .  -(1-2*IPV)*(2*D1F*D1G/XH/XH+D2F*D2G)*(PIM/AMPRO)**2/6.D0

      OSCT(FF,D1F,D2F,D1G,D2G,XH)= +2*FF*(D1G/XH-D2G)/3.D0

*    .      +(D1F/XH-D2F)*(D1G/XH-D2G)*(PIM/AMPRO)**2/6.D0
*    .  +(1-2*IPV)*(D1F*D1G/XH/XH-D2F*D2G)*(PIM/AMPRO)**2/6.D0

      OSCO(D1F,D1G,XH)= 0.D0

*    .                 +(D1F*D1G/XH/XH)*(PIM/AMPRO)**2

C 3)  PION-PSEUDO-SCALAR EXCHANGE:
      OPSC(D1F,D2F,D1G,D2G,XH)= 2*(2*D1F*D1G/XH/XH+D2F*D2G)
      OPSS(D1F,D2F,D1G,D2G,XH)=+4*(D1F*D1G/XH+D1F*D2G+D2F*D1G)/XH/3.D0
      OPST(D1F,D2F,D1G,D2G,XH)=+2*( (D1F/XH-D2F)*D1G/XH +
     . (D1G/XH-D2G)*D1F/XH )/3.D0

C 4)  DIFRAC-DIFRAC EXCHANGE:
      ODFC(FF,D1F,D2F,GG,D1G,D2G,XH)= 2*FF*GG -0.5D0*(PIM/AMPRO)**2
     . *((D2F+2*D1F/XH)*GG+FF*(D2G+2*D1G/XH)-2*D1F*D1G)
      ODFO(FF,D1F,GG,D1G,XH)= 0.D0

*    .                        -(D1F*GG+FF*D1G)/XH*(PIM/AMPRO)**2

C 5)  PION-AXIAL EXCHANGE:
      OAXC(FF,D1G,D2G,XH)= -2*FF*(2*D1G/XH+D2G)
      OAXS(FF,D1G,D2G,XH)= +2*FF*(2*D1G/XH+D2G)*2/3.D0
      OAXT(FF,D1G,D2G,XH)= -2*FF*( -D1G/XH+D2G)/3.D0
C
C     POTENTIAL FUNTION DEFINITION
C
      F0(ERATH,EXH,EMH,EPH,XH)=ERATH*( EMH/EXH-EPH*EXH )/(2*XH)
      H0(ERATH,EXH,EMH,EPH,XH)=ERATH*( EMH/EXH+EPH*EXH )/(2*XH)
C
      CALL ERRSET(208,256,-1,1)
      IF(ICALL.EQ.0) THEN
        XBEGIN=X
        CALL GAUSS(NPNT,XX,WW,1)
        IF(IMETH.EQ.1) NINT=1
C       PRINT 52, IMETH,NPNT
C52     FORMAT(//,'  IN HFUN: IMETH=',I2,' NPNT=',I2,//)
        ICALL=1
      ENDIF
CC
      X1   = 1.D0/X
      X2   = X1*X1
      X3   = X1*X2
      X4   = X1*X3
CC
      RATP1=PIM/ALM1
      XLM1 =0.5D0*X*ALM1/PIM
      XLM12=XLM1*XLM1
      VKU1 =(ALM1/PIM)*FDEXP(-XLM12)/(2*SRPI)
      DVKU1 =-0.5D0*(ALM1/PIM)**2*X*VKU1
      DDVKU1 =-0.5D0*(ALM1/PIM)**2*(VKU1+X*DVKU1)
      D3VKU1 =-0.5D0*(ALM1/PIM)**2*(2*DVKU1+X*DDVKU1)

      RATP2=PIM/ALM2
      XLM2 =0.5D0*X*ALM2/PIM
      XLM22=XLM2*XLM2
      VKU2 =(ALM2/PIM)*FDEXP(-XLM22)/(2*SRPI)
      DVKU2=-0.5D0*(ALM2/PIM)**2*X*VKU2

      IF(KIND.NE.5) THEN
      XA   =X*AM1/PIM
      RATA =AM1/ALM1
      ERATA=DEXP(RATA*RATA)
      EXA  =DEXP(XA)
      EMA  =FDERFC(-XLM1 +RATA)
      EPA  =FDERFC( XLM1 +RATA)
      FIA  =F0(ERATA,EXA ,EMA ,EPA ,X)
      HIA  =H0(ERATA,EXA ,EMA ,EPA ,X)
      DFIA =-(FIA -2*VKU1)*X1-(AM1/PIM)*HIA
      DHIA  =-(AM1/PIM)*FIA -HIA*X1
      DDFIA  =-(DFIA-2*DVKU1)*X1+(FIA-2*VKU1)*X2-(AM1/PIM)*DHIA
      DDHIA  =-(AM1/PIM)*DFIA -DHIA*X1 +HIA*X2
      D3FIA  =-(DDFIA-2*DDVKU1)*X1+2*(DFIA-2*DVKU1)*X2
     .        -2*(FIA-2*VKU1)*X3-(AM1/PIM)*DDHIA
      D3HIA  =-(AM1/PIM)*DDFIA -DDHIA*X1 +2*DHIA*X2-2*HIA*X3
      D4FIA  =-(D3FIA-2*D3VKU1)*X1+3*(DDFIA-2*DDVKU1)*X2
     .        -6*(DFIA-2*DVKU1)*X3+6*(FIA-2*VKU1)*X4-(AM1/PIM)*D3HIA
      FI1= FIA
      DFI1= DFIA
      DDFI1= DDFIA
      D3FI1= D3FIA
      D4FI1= D4FIA
      ENDIF
      IF(KIND.EQ.5) THEN
      XA   =X*AM1/PIM
      FI1  =(4.D0/SRPI)*(AM1/PIM)*(AM1/AMPRO)**2*FDEXP(-XA*XA)
      DFI1  = -2*(AM1/PIM)*XA*FI1
      DDFI1  = -2*(AM1/PIM)*(XA*DFI1 + FI1*AM1/PIM)
      ENDIF

      IF(KIND.LT.4.OR.KIND.GE.6) THEN
      XA   =X*AM2/PIM
      RATA =AM2/ALM2
      ERATA=DEXP(RATA*RATA)
      EXA  =DEXP(XA)
      EMA  =FDERFC(-XLM2 +RATA)
      EPA  =FDERFC( XLM2 +RATA)
      FIA  =F0(ERATA,EXA ,EMA ,EPA ,X)
      HIA  =H0(ERATA,EXA ,EMA ,EPA ,X)
      DFIA =-(FIA -2*VKU2)*X1-(AM2/PIM)*HIA
      DHIA  =-(AM2/PIM)*FIA -HIA *X1
      DDFIA  =-(DFIA-2*DVKU2)*X1+(FIA-2*VKU2)*X2-(AM2/PIM)*DHIA
      ENDIF
      IF(KIND.EQ.4.OR.KIND.EQ.5) THEN
      XA   =X*AM2/PIM
      FIA  =(4.D0/SRPI)*(AM2/PIM)*(AM2/AMPRO)**2*FDEXP(-XA*XA)
      DFIA  = -2*(AM2/PIM)*XA*FIA
      DDFIA  = -2*(AM2/PIM)*(XA*DFIA + FIA*AM2/PIM)
      ENDIF
      FI2= FIA
      DFI2= DFIA
      DDFI2= DDFIA
C
C     CONSTRUCTION BASE FUNCTIONS BY INTEGRATION
C
      DO 105 IFUN=1,12
  105 FUN(IFUN) = 0.D0
      DO 100 INT=1,NINT
      ABM=0.5D0*(YB(INT+1)-YB(INT))
      ABP=0.5D0*(YB(INT+1)+YB(INT))
      DO 110 IY=1,NPNT
      IF(IMETH.EQ.0) THEN
      Y=ABM*XX(IY)+ABP
      GEW=WW(IY)*ABM*1.D0/PI
      ENDIF
      IF(IMETH.EQ.1) THEN
      Y=(1.D0+XX(IY))/(1.D0-XX(IY))
      GEW=WW(IY)*(2.D0/(1.D0-XX(IY))**2)*1.D0/PI
      ENDIF
*     IF(Y.GT.50.D0) GOTO 110
      IF(Y.GT.90.D0) GOTO 110
      GEW = GEW/(Y*Y)
C     FACTOR FROM FORM FACTOR EFFECTS THROUGH DISP. REL. :
      FDISP1=FDEXP(-Y*Y*RATP1*RATP1)
      FDISP2=FDEXP(-Y*Y*RATP2*RATP2)
      FDISP = FDISP1*FDISP2
C
      IF(KIND.NE.5) THEN
      AM=PIM*DSQRT((AM1/PIM)**2+Y*Y)
      XM=AM*X/PIM
      RATM =AM/ALM1
      ERATM=FDEXP(RATM*RATM)
      EXM  =FDEXP(XM)
      EMM  =FDERFC(-XLM1+RATM)
      EPM  =FDERFC( XLM1+RATM)
C
      FIM   = F0(ERATM,EXM,EMM,EPM,X )
      HIM   = H0(ERATM,EXM,EMM,EPM,X )
      DFIM  =-(FIM-2*VKU1)*X1-(AM/PIM)*HIM
      DHIM  =-(AM/PIM)*FIM-HIM*X1
      DDFIM =-(DFIM-2*DVKU1)*X1+(FIM-2*VKU1)*X2-(AM/PIM)*DHIM
      DDHIM  =-(AM/PIM)*DFIM -DHIM*X1 +HIM*X2
      D3FIM  =-(DDFIM-2*DDVKU1)*X1+2*(DFIM-2*DVKU1)*X2
     .        -2*(FIM-2*VKU1)*X3-(AM/PIM)*DDHIM
      D3HIM  =-(AM/PIM)*DDFIM -DDHIM*X1 +2*DHIM*X2-2*HIM*X3
      D4FIM  =-(D3FIM-2*D3VKU1)*X1+3*(DDFIM-2*DDVKU1)*X2
     .        -6*(DFIM-2*DVKU1)*X3+6*(FIM-2*VKU1)*X4-(AM/PIM)*D3HIM

      FIM1  = FIM
      DFIM1  = DFIM
      DDFIM1  = DDFIM
      D3FIM1  = D3FIM
      D4FIM1  = D4FIM
      ENDIF
      IF(KIND.EQ.5) THEN
      FIM1= FI1
      DFIM1= DFI1
      DDFIM1= DDFI1
      ENDIF
C
      IF(KIND.LT.4.OR.KIND.GE.6) THEN
      AM=PIM*DSQRT((AM2/PIM)**2+Y*Y)
      XM=AM*X/PIM
      RATM =AM/ALM2
      ERATM=FDEXP(RATM*RATM)
      EXM  =FDEXP(XM)
      EMM  =FDERFC(-XLM2+RATM)
      EPM  =FDERFC( XLM2+RATM)

      FIM   = F0(ERATM,EXM,EMM,EPM,X )
      HIM   = H0(ERATM,EXM,EMM,EPM,X )
      DFIM  =-(FIM-2*VKU2)*X1-(AM/PIM)*HIM
      DHIM  =-(AM/PIM)*FIM-HIM*X1
      DDFIM =-(DFIM-2*DVKU2)*X1+(FIM-2*VKU2)*X2-(AM/PIM)*DHIM
      FIM2  = FIM
      DFIM2  = DFIM
      DDFIM2  = DDFIM
      ENDIF
      IF(KIND.EQ.4.OR.KIND.EQ.5) THEN
      FIM2= FI2
      DFIM2= DFI2
      DDFIM2= DDFI2
      ENDIF
C
      IF(KIND.EQ.1) THEN
      FUN(1)  = FUN(1)  + GEW*(
     .   OPAEES(FI2,DFI2,DDFI2,DFI1,DDFI1,D3FI1,X)
     .  -FDISP*OPAEES(FIM2,DFIM2,DDFIM2,DFIM1,DDFIM1,D3FIM1,X))
      FUN(2)  = FUN(2)  + GEW*(
     .   OPAEET(FI2,DFI2,DDFI2,DFI1,DDFI1,D3FI1,X)
     .  -FDISP*OPAEET(FIM2,DFIM2,DDFIM2,DFIM1,DDFIM1,D3FIM1,X))
      FUN(11) = FUN(11) + GEW*(
     .   OCREES(FI2,DFI2,DDFI2,DFI1,DDFI1,D3FI1,D4FI1,X)-FDISP*
     .   OCREES(FIM2,DFIM2,DDFIM2,DFIM1,DDFIM1,D3FIM1,D4FIM1,X))
      FUN(12) = FUN(12) + GEW*(
     .   OCREET(FI2,DFI2,DDFI2,DFI1,DDFI1,D3FI1,D4FI1,X)-FDISP*
     .   OCREET(FIM2,DFIM2,DDFIM2,DFIM1,DDFIM1,D3FIM1,D4FIM1,X))
      FUN(3)  = FUN(3)  + GEW*(OPAEMT(DFI2,DFI1,DDFI1,X)
     .                  -FDISP*OPAEMT(DFIM2,DFIM1,DDFIM1,X))
      FUN(4)  = FUN(4)  + GEW*(OPAEMO(DFI2,DFI1,X)
     .                  -FDISP*OPAEMO(DFIM2,DFIM1,X))
      FUN(5)  = FUN(5)  + GEW*(OPAMMC(DFI2,DDFI2,DFI1,DDFI1,X)
     .                  -FDISP*OPAMMC(DFIM2,DDFIM2,DFIM1,DDFIM1,X))
      FUN(6)  = FUN(6)  + GEW*(OPAMMS(DFI2,DDFI2,DFI1,DDFI1,X)
     .                  -FDISP*OPAMMS(DFIM2,DDFIM2,DFIM1,DDFIM1,X))
      FUN(7)  = FUN(7)  + GEW*(OPAMMT(DFI2,DDFI2,DFI1,DDFI1,X)
     .                  -FDISP*OPAMMT(DFIM2,DDFIM2,DFIM1,DDFIM1,X))
      FUN(8)  = FUN(8)  + GEW*(OPEMS2(DFI2,DDFI2,DFI1,DDFI1,X)
     .                  -FDISP*OPEMS2(DFIM2,DDFIM2,DFIM1,DDFIM1,X))
      FUN(9)  = FUN(9)  + GEW*(OPEMT2(DFI2,DDFI2,DFI1,DDFI1,X)
     .                  -FDISP*OPEMT2(DFIM2,DDFIM2,DFIM1,DDFIM1,X))
      FUN(10) = FUN(10) + GEW*(OPEMO2(DFI2,DFI1,X)
     .                  -FDISP*OPEMO2(DFIM2,DFIM1,X))
      ENDIF
C
      IF(KIND.EQ.2.OR.KIND.EQ.4) THEN
      FUN(1)  = FUN(1)  + GEW*(OSCS(FI2,DFI2,DDFI2,DFI1,DDFI1,X)
     .         -FDISP*OSCS(FIM2,DFIM2,DDFIM2,DFIM1,DDFIM1,X))
      FUN(2)  = FUN(2)  + GEW*(OSCT(FI2,DFI2,DDFI2,DFI1,DDFI1,X)
     .         -FDISP*OSCT(FIM2,DFIM2,DDFIM2,DFIM1,DDFIM1,X))
      FUN(3)  = FUN(3)  + GEW*(OSCO(DFI2,DFI1,X)
     .         -FDISP*OSCO(DFIM2,DFIM1,X))
      ENDIF
C
      IF(KIND.EQ.3) THEN
      FUN(1)  = FUN(1)  + GEW*(OPSC(DFI2,DDFI2,DFI1,DDFI1,X)
     .                  -FDISP*OPSC(DFIM2,DDFIM2,DFIM1,DDFIM1,X))
      FUN(2)  = FUN(2)  + GEW*(OPSS(DFI2,DDFI2,DFI1,DDFI1,X)
     .                  -FDISP*OPSS(DFIM2,DDFIM2,DFIM1,DDFIM1,X))
      FUN(3)  = FUN(3)  + GEW*(OPST(DFI2,DDFI2,DFI1,DDFI1,X)
     .                  -FDISP*OPST(DFIM2,DDFIM2,DFIM1,DDFIM1,X))
      ENDIF
C
      IF(KIND.EQ.5) THEN
      FUN(1)  = FUN(1)  + GEW*(ODFC(FI2,DFI2,DDFI2,FI1,DFI1,DDFI1,X)
     .         -FDISP*ODFC(FIM2,DFIM2,DDFIM2,FIM1,DFIM1,DDFIM1,X))
      FUN(2)  = FUN(2)  + GEW*(ODFO(FI2,DFI2,FI1,DFI1,X)
     .         -FDISP*ODFO(FIM2,DFIM2,FIM1,DFIM1,X))
      ENDIF
C
      IF(KIND.EQ.6) THEN
      FUN(1)  = FUN(1)  + GEW*(OAXC(FI2,DFI1,DDFI1,X)
     .         -FDISP*OAXC(FIM2,DFIM1,DDFIM1,X))
      FUN(2)  = FUN(2)  + GEW*(OAXS(FI2,DFI1,DDFI1,X)
     .         -FDISP*OAXS(FIM2,DFIM1,DDFIM1,X))
      FUN(3)  = FUN(3)  + GEW*(OAXT(FI2,DFI1,DDFI1,X)
     .         -FDISP*OAXT(FIM2,DFIM1,DDFIM1,X))
      ENDIF
C
      IF(KIND.EQ.7) THEN
      FUN(1)  = FUN(1)  + GEW*(FI2*FI1-FDISP*FIM2*FIM1)
      ENDIF
C
110   CONTINUE
100   CONTINUE
C
C     CONTRIBUTIONS FROM Y>YMAX=YB(NINT+1)
C
      IF(IMETH.EQ.0) THEN
      YMAX = YB(NINT+1)
      IF(KIND.EQ.1) THEN
      FUN(1) = FUN(1)+
     .(1.D0/PI)*OPAEES(FI2,DFI2,DDFI2,DFI1,DDFI1,D3FI1,X)/YMAX
      FUN(2) = FUN(2)+
     .(1.D0/PI)*OPAEET(FI2,DFI2,DDFI2,DFI1,DDFI1,D3FI1,X)/YMAX
      FUN(11)= FUN(11)+(1.D0/PI)*
     .OCREES(FI2,DFI2,DDFI2,DFI1,DDFI1,D3FI1,D4FIM1,X)/YMAX
      FUN(12)= FUN(12)+(1.D0/PI)*
     .OCREET(FI2,DFI2,DDFI2,DFI1,DDFI1,D3FI1,D4FIM1,X)/YMAX
      FUN(3) = FUN(3)+(1.D0/PI)*OPAEMT(DFI2,DFI1,DDFI1,X)/YMAX
      FUN(4) = FUN(4)+(1.D0/PI)*OPAEMO(DFI2,DFI1,X)/YMAX
      FUN(5) = FUN(5)+(1.D0/PI)*OPAMMC(DFI2,DDFI2,DFI1,DDFI1,X)/YMAX
      FUN(6) = FUN(6)+(1.D0/PI)*OPAMMS(DFI2,DDFI2,DFI1,DDFI1,X)/YMAX
      FUN(7) = FUN(7)+(1.D0/PI)*OPAMMT(DFI2,DDFI2,DFI1,DDFI1,X)/YMAX
      FUN(8) = FUN(8)+(1.D0/PI)*OPEMS2(DFI2,DDFI2,DFI1,DDFI1,X)/YMAX
      FUN(9) = FUN(9)+(1.D0/PI)*OPEMT2(DFI2,DDFI2,DFI1,DDFI1,X)/YMAX
      FUN(10)= FUN(10)+(1.D0/PI)*OPEMO2(DFI2,DFI1,X)/YMAX
      ENDIF
C
      IF(KIND.EQ.2.OR.KIND.EQ.4) THEN
      FUN(1) = FUN(1)+
     .(1.D0/PI)*OSCS(FI2,DFI2,DDFI2,DFI1,DDFI1,X)/YMAX
      FUN(2) = FUN(2)+
     .(1.D0/PI)*OSCT(FI2,DFI2,DDFI2,DFI1,DDFI1,X)/YMAX
      FUN(3) = FUN(3)+ (1.D0/PI)*OSCO(DFI2,DFI1,X)/YMAX
      ENDIF
C
      IF(KIND.EQ.3) THEN
      FUN(1) = FUN(1)+(1.D0/PI)*OPSC(DFI2,DDFI2,DFI1,DDFI1,X)/YMAX
      FUN(2) = FUN(2)+(1.D0/PI)*OPSS(DFI2,DDFI2,DFI1,DDFI1,X)/YMAX
      FUN(3) = FUN(3)+(1.D0/PI)*OPST(DFI2,DDFI2,DFI1,DDFI1,X)/YMAX
      ENDIF
C
      IF(KIND.EQ.5) THEN
      FUN(1) = FUN(1)+
     .(1.D0/PI)*ODFC(FI2,DFI2,DDFI2,FI1,DFI1,DDFI1,X)/YMAX
      FUN(2) = FUN(2)+(1.D0/PI)*ODFO(FI2,DFI2,FI1,DFI1,X)/YMAX
      ENDIF
C
      IF(KIND.EQ.6) THEN
      FUN(1) = FUN(1)+(1.D0/PI)*OAXC(FI2,DFI1,DDFI1,X)/YMAX
      FUN(2) = FUN(2)+(1.D0/PI)*OAXS(FI2,DFI1,DDFI1,X)/YMAX
      FUN(3) = FUN(3)+(1.D0/PI)*OAXT(FI2,DFI1,DDFI1,X)/YMAX
      ENDIF
C
      IF(KIND.EQ.7) THEN
      FUN(1) = FUN(1)+(1.D0/PI)*FI2*FI1/YMAX
      ENDIF
      ENDIF
CC
c     PRINT 99, KIND,X,AM1,AM2,ALM1,ALM2,(FUN(II),II=1,12)
c99   FORMAT(/,' IN YNFUN: KIND=',I2,' X=',F10.3,/,
c    .'  AM1,AM2=',2(F10.3,3X),'  ALM1,ALM2=',2(F10.3,3X),/,
c    .       /,' IN YNFUN: FUN(II)=',/,5(D10.3,3X),/)
CC
1000  CALL ERRSET(208,256,1,1)
      RETURN
      END
C **********************************************************************
      SUBROUTINE FFUN(N,X,AMES,ALAM,F,DF,DDF,D3F)
C **********************************************************************
C
C                                         1
C     FOURIER TRANSFORM OF  F(OMEGA)= ----------
C                                      OMEGA^{N}
C     FOR N=0,1,2,3,4
C
C     FOR FORM FACTOR TREATMENT SEE:
C     TH.A.RIJKEN, ANNALS OF PHYSICS 208, P.253 (1990).
C
C **********************************************************************
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/PIMAS/PIM

      DIMENSION XX(20),WW(20),YB(3)
      DATA PI/3.14159265D0/,SRPI/1.7724538509D0/,ICALL/0/
      DATA YB/0.D0,10.D0,50.D0/,NINT/1/,NPNT/16/,IMETH/1/
      SAVE XX,WW
C
C     POTENTIAL FUNTION DEFINITION
C
      F0(ERATH,EXH,EMH,EPH,XH)=ERATH*( EMH/EXH-EPH*EXH )/(2*XH)
      H0(ERATH,EXH,EMH,EPH,XH)=ERATH*( EMH/EXH+EPH*EXH )/(2*XH)
C
      CALL ERRSET(208,256,-1,1)
      IF(ICALL.EQ.0) THEN
        CALL GAUSS(NPNT,XX,WW,1)
        IF(IMETH.EQ.1) NINT=1
C       PRINT 52, IMETH,NPNT
C52     FORMAT(//,'  IN FFUN: IMETH=',I2,' NPNT=',I2,//)
        ICALL=1
      ENDIF
CC
      X1   = 1.D0/X
      X2   = X1*X1
      X3   = X1*X2
CC
      RATP =PIM/ALAM
      XLAM =0.5D0*X*ALAM/PIM
      XLAM2=XLAM*XLAM
      VKUA =(ALAM/PIM)*FDEXP(-XLAM2)/(2*SRPI)
      DVKUA=-0.5D0*(ALAM/PIM)**2*X*VKUA
      DDVKUA=-0.5D0*(ALAM/PIM)**2*(X*DVKUA+VKUA)
      D3VKUA=-0.5D0*(ALAM/PIM)**2*(X*DDVKUA+2*DVKUA)
      IF(N.EQ.0) THEN
      F = (ALAM/PIM)**2*VKUA
      DF = (ALAM/PIM)**2*DVKUA
      DDF = (ALAM/PIM)**2*DDVKUA
      D3F = (ALAM/PIM)**2*D3VKUA
      RETURN
      ENDIF

      IF(N.NE.1) THEN
      XA   =X*AMES/PIM
      RATA =AMES/ALAM
      ERATA=DEXP(RATA*RATA)
      EXA  =DEXP(XA)
      EMA  =FDERFC(-XLAM +RATA)
      EPA  =FDERFC( XLAM +RATA)
      FIA  =F0(ERATA,EXA ,EMA ,EPA ,X)
      HIA  =H0(ERATA,EXA ,EMA ,EPA ,X)
      DFIA =-(FIA -2*VKUA)*X1-(AMES/PIM)*HIA
      DHIA  =-(AMES/PIM)*FIA -HIA *X1
      DDFIA =-(DFIA-2*DVKUA)*X1+(FIA-2*VKUA)*X2-(AMES/PIM)*DHIA
      DDHIA =-(AMES/PIM)*DFIA-DHIA*X1+HIA*X2
      D3FIA =-(DDFIA-2*DDVKUA)*X1+(DFIA-2*DVKUA)*X2-(AMES/PIM)*DDHIA
     .       +(DFIA-2*DVKUA)*X2-2*(FIA-2*VKUA)*X3
      F = FIA
      DF = DFIA
      DDF = DDFIA
      D3F = D3FIA
      IF(N.EQ.2) RETURN
      ENDIF
      IF(N.EQ.4) THEN
      D3HIA =-(AMES/PIM)*DDFIA-DDHIA*X1+2*DHIA*X2-2*HIA*X3
      F = 0.5D0*(AMES/PIM)*X*HIA
      DF = 0.5D0*(AMES/PIM)*(HIA+X*DHIA)
      DDF = 0.5D0*(AMES/PIM)*(2*DHIA+X*DDHIA)
      D3F  = 0.5D0*(AMES/PIM)*(3*DDHIA+X*D3HIA)
      RETURN
      ENDIF
C
C     CONSTRUCTION BASE FUNCTIONS BY INTEGRATION
C
      IF(N.EQ.1.OR.N.EQ.3) THEN
      GG   =0.D0
      DGG  =0.D0
      DDGG =0.D0
      DO 100 INT=1,NINT
      ABM=0.5D0*(YB(INT+1)-YB(INT))
      ABP=0.5D0*(YB(INT+1)+YB(INT))
      DO 110 IY=1,NPNT
      IF(IMETH.EQ.0) THEN
      Y=ABM*XX(IY)+ABP
      GEW=WW(IY)*ABM*2.D0/PI
      ENDIF
      IF(IMETH.EQ.1) THEN
      Y=(1.D0+XX(IY))/(1.D0-XX(IY))
      GEW=WW(IY)*(2.D0/(1.D0-XX(IY))**2)*2.D0/PI
      ENDIF
      IF(Y.GE.50.D0) GOTO 110
      IF(N.EQ.3) GEW = GEW/Y**2
C     FACTOR FROM FORM FACTOR EFFECTS THROUGH DISP. REL. :
      FDISP =FDEXP(-Y*Y*RATP*RATP)
C
      AM=PIM*DSQRT((AMES/PIM)**2+Y*Y)
      XM=AM*X/PIM
      RATM =AM/ALAM
      ERATM=FDEXP(RATM*RATM)
      EXM  =FDEXP(XM)
      EMM  =FDERFC(-XLAM+RATM)
      EPM  =FDERFC( XLAM+RATM)
C
      FIM   = F0(ERATM,EXM,EMM,EPM,X )
      HIM   = H0(ERATM,EXM,EMM,EPM,X )
      DFIM  =-(FIM-2*VKUA)*X1-(AM/PIM)*HIM
      DHIM  =-(AM/PIM)*FIM-HIM*X1
      DDFIM =-(DFIM-2*DVKUA)*X1+(FIM-2*VKUA)*X2-(AM/PIM)*DHIM

      IF(N.EQ.1) THEN
      GG    = GG   + GEW*FIM* FDISP
      DGG   = DGG  + GEW*DFIM* FDISP
      DDGG  = DDGG + GEW*DDFIM* FDISP
      ENDIF
      IF(N.EQ.3) THEN
      GG    = GG   + GEW*(FIA-FIM* FDISP)
      DGG   = DGG  + GEW*(DFIA-DFIM* FDISP)
      DDGG  = DDGG + GEW*(DDFIA-DDFIM* FDISP)
      ENDIF
C
110   CONTINUE
100   CONTINUE
C
      F = GG
      DF = DGG
      DDF = DDGG
      ENDIF
CC
1000  CALL ERRSET(208,256,1,1)
      RETURN
      END
C **********************************************************************
      SUBROUTINE FFUNZ(N,X,AMES,AMZ,ALAM,F,DF,DDF,D3F)
C **********************************************************************
C                             1-K^2/MZ^2)
C     ZERO: FOURIER F(OMEGA)= ----------  = (1+M^2/MZ^2) PHI_C^(0)
C                              OMEGA^{2}
C
C      - (M/MZ)^2 (LAMBDA/M)^3 EXP[-1/4 LAMBDA^2 R^2]
C              
C
C     FOR N=1,2,3  
C
C     FOR FORM FACTOR TREATMENT SEE:
C     TH.A.RIJKEN, ANNALS OF PHYSICS 208, P.253 (1990).
C              
C **********************************************************************
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/PIMAS/PIM

      DIMENSION XX(20),WW(20),YB(3)
      DATA PI/3.14159265D0/,SRPI/1.7724538509D0/,ICALL/0/
      DATA YB/0.D0,10.D0,50.D0/,NINT/1/,NPNT/16/,IMETH/1/
      SAVE XX,WW
C
C     POTENTIAL FUNTION DEFINITION
C
      F0(ERATH,EXH,EMH,EPH,XH)=ERATH*( EMH/EXH-EPH*EXH )/(2*XH)
      H0(ERATH,EXH,EMH,EPH,XH)=ERATH*( EMH/EXH+EPH*EXH )/(2*XH)
C
      IF(ICALL.EQ.0) THEN
        CALL GAUSS(NPNT,XX,WW,1)
c       IF(IMETH.EQ.1) NINT=1
        IF(IMETH.LE.1) NINT=1
C       PRINT 52, IMETH,NPNT
C52     FORMAT(//,'  IN GFUN: IMETH=',I2,' NPNT=',I2,//)
        ICALL=1
      ENDIF

CC
      X1   = 1.D0/X
      X2   = X1*X1
      X3   = X1*X2
CC
      RATP =PIM/ALAM
      XLAM =0.5D0*X*ALAM/PIM
      XLAM2=XLAM*XLAM
      VKUA =(ALAM/PIM)*FDEXP(-XLAM2)/(2*SRPI)
      DVKUA=-0.5D0*(ALAM/PIM)**2*X*VKUA
      DDVKUA=-0.5D0*(ALAM/PIM)**2*(X*DVKUA+VKUA)
      D3VKUA=-0.5D0*(ALAM/PIM)**2*(X*DDVKUA+2*DVKUA)

      VKUM =(ALAM/AMES)**3*FDEXP(-XLAM2)/(2*SRPI)
      DVKUM=-0.5D0*(ALAM/PIM)**2*X*VKUM
      DDVKUM=-0.5D0*(ALAM/PIM)**2*(X*DVKUM+VKUM)
      D3VKUM=-0.5D0*(ALAM/PIM)**2*(X*DDVKUM+2*DVKUM)

      IF(N.EQ.0) THEN
      F = (ALAM/PIM)**2*VKUA
      DF = (ALAM/PIM)**2*DVKUA
      DDF = (ALAM/PIM)**2*DDVKUA
      D3F = (ALAM/PIM)**2*D3VKUA
      RETURN
      ENDIF

      IF(N.NE.1) THEN
      XA   =X*AMES/PIM
      RATA =AMES/ALAM
      ERATA=DEXP(RATA*RATA)
      EXA  =DEXP(XA)
      EMA  =FDERFC(-XLAM +RATA)
      EPA  =FDERFC( XLAM +RATA)
      FIA  =F0(ERATA,EXA ,EMA ,EPA ,X)
      HIA  =H0(ERATA,EXA ,EMA ,EPA ,X)
      DFIA =-(FIA -2*VKUA)*X1-(AMES/PIM)*HIA
      DHIA  =-(AMES/PIM)*FIA -HIA *X1
      DDFIA =-(DFIA-2*DVKUA)*X1+(FIA-2*VKUA)*X2-(AMES/PIM)*DHIA
      DDHIA =-(AMES/PIM)*DFIA-DHIA*X1+HIA*X2
      D3FIA =-(DDFIA-2*DDVKUA)*X1+(DFIA-2*DVKUA)*X2-(AMES/PIM)*DDHIA
     .       +(DFIA-2*DVKUA)*X2-2*(FIA-2*VKUA)*X3
C     WITH ZERO:
      FZERO = (AMES/AMZ)**2
      FIA = (1.D0+FZERO)*FIA - FZERO*VKUM*AMES/PIM
      DFIA = (1.D0+FZERO)*DFIA - FZERO*DVKUM*AMES/PIM
      DDFIA = (1.D0+FZERO)*DDFIA - FZERO*DDVKUM*AMES/PIM
      D3FIA = (1.D0+FZERO)*D3FIA - FZERO*D3VKUM*AMES/PIM
      IF(N.EQ.2) THEN   
      F = FIA
      DF = DFIA
      DDF = DDFIA
      D3F = D3FIA
      RETURN
      ENDIF
      ENDIF
C
C     CONSTRUCTION BASE FUNCTIONS BY INTEGRATION
C
      IF(N.EQ.1.OR.N.EQ.3) THEN
      GG   =0.D0
      DGG  =0.D0
      DDGG =0.D0
      DO 100 INT=1,NINT
      ABM=0.5D0*(YB(INT+1)-YB(INT))
      ABP=0.5D0*(YB(INT+1)+YB(INT))
      DO 110 IY=1,NPNT
      IF(IMETH.EQ.0) THEN
      Y=ABM*XX(IY)+ABP
      GEW=WW(IY)*ABM*2.D0/PI
      ENDIF
      IF(IMETH.EQ.1) THEN
      Y=(1.D0+XX(IY))/(1.D0-XX(IY))
      GEW=WW(IY)*(2.D0/(1.D0-XX(IY))**2)*2.D0/PI
      ENDIF
      IF(Y.GT.50.D0) GOTO 110
      IF(N.EQ.3) GEW = GEW/Y**2
C     FACTOR FROM FORM FACTOR EFFECTS THROUGH DISP. REL. :
      FDISP =FDEXP(-Y*Y*RATP*RATP)
C
      AM=PIM*DSQRT((AMES/PIM)**2+Y*Y)
      FZEROM=(AM/AMZ)**2
      VKUM =(ALAM/AM)**3*FDEXP(-XLAM2)/(2*SRPI)
      DVKUM=-0.5D0*(ALAM/PIM)**2*X*VKUM
      DDVKUM=-0.5D0*(ALAM/PIM)**2*(X*DVKUM+VKUM)
      D3VKUM=-0.5D0*(ALAM/PIM)**2*(X*DDVKUM+2*DVKUM)
      XM=AM*X/PIM
      RATM =AM/ALAM
      ERATM=FDEXP(RATM*RATM)
      EXM  =FDEXP(XM)
      EMM  =FDERFC(-XLAM+RATM)
      EPM  =FDERFC( XLAM+RATM)
C
      FIM   = F0(ERATM,EXM,EMM,EPM,X )
      HIM   = H0(ERATM,EXM,EMM,EPM,X )
      DFIM  =-(FIM-2*VKUA)*X1-(AM/PIM)*HIM
      DHIM  =-(AM/PIM)*FIM-HIM*X1
      DDFIM =-(DFIM-2*DVKUA)*X1+(FIM-2*VKUA)*X2-(AM/PIM)*DHIM

      FIM = (1.D0+FZEROM)*FIM - FZEROM*VKUM*AM/PIM
      DFIM = (1.D0+FZEROM)*DFIM - FZEROM*DVKUM*AM/PIM
      DDFIM = (1.D0+FZEROM)*DDFIM - FZEROM*DDVKUM*AM/PIM

      IF(N.EQ.1) THEN
      GG    = GG   + GEW*FIM* FDISP
      DGG   = DGG  + GEW*DFIM* FDISP
      DDGG  = DDGG + GEW*DDFIM* FDISP
      ENDIF
      IF(N.EQ.3) THEN
      GG    = GG   + GEW*(FIA-FIM* FDISP)
      DGG   = DGG  + GEW*(DFIA-DFIM* FDISP)
      DDGG  = DDGG + GEW*(DDFIA-DDFIM* FDISP)
      ENDIF
C
110   CONTINUE
100   CONTINUE
C
      F = GG
      DF = DGG
      DDF = DDGG
      ENDIF
CC
      RETURN
      END

C **********************************************************************
      SUBROUTINE HFUN(N,X,AM1,AM2,ALM1,ALM2,DAM,FUN)
C **********************************************************************
C
C     FOURIER TRANSFORM OF
C                                 1                  1
C     H_{N,M}(A,OM1,OM2) = ------------------ ---------------
C                          OM1^{N} OM2^{N}    (OM1+A) (OM2+A)
C                              1
C                        X ---------
C                          (OM1+OM2)
C     FOR N = -1,0,1,2
C
C     SCHEMATICALLY:
C     FUN(1) = F*G,    FUN(2) = DF*G,   FUN(3) = F*DG,
C     FUN(4) = DF*DG,  FUN(5) = DDF*G,  FUN(6) = F*DDG,
C     FUN(7) = DDF*DG, FUN(8) = DF*DDG, FUN(9) = DDF*DDG
C
C     FOR FORM FACTOR TREATMENT SEE:
C     TH.A.RIJKEN, ANNALS OF PHYSICS 208, P.253 (1990).
C
C **********************************************************************
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/PIMAS/PIM
      DIMENSION XX(20),WW(20),YB(3),HH(9),FUN(12)
      DATA PI/3.14159265D0/,SRPI/1.7724538509D0/,ICALL/0/
      DATA YB/0.D0,10.D0,50.D0/,NINT/1/,NPNT/16/,IMETH/1/
      SAVE XX,WW,AA,AA2
C
C     POTENTIAL FUNTION DEFINITION
C
      F0(ERATH,EXH,EMH,EPH,XH)=ERATH*( EMH/EXH-EPH*EXH )/(2*XH)
      H0(ERATH,EXH,EMH,EPH,XH)=ERATH*( EMH/EXH+EPH*EXH )/(2*XH)
C
      CALL ERRSET(208,256,-1,1)
      IF(ICALL.EQ.0) THEN
        AA   =DAM/PIM
        AA2  =AA*AA
        CALL GAUSS(NPNT,XX,WW,1)
        IF(IMETH.EQ.1) NINT=1
C       PRINT 52, IMETH,NPNT
C52     FORMAT(//,'  IN HFUN: IMETH=',I2,' NPNT=',I2,//)
        ICALL=1
      ENDIF
CC
      X1   = 1.D0/X
      X2   = X1*X1
CC
      RATP1=PIM/ALM1
      XLM1 =0.5D0*X*ALM1/PIM
      XLM12=XLM1*XLM1
      VKU1 =(ALM1/PIM)*FDEXP(-XLM12)/(2*SRPI)
      DVKU1=-0.5D0*(ALM1/PIM)**2*X*VKU1

      RATP2=PIM/ALM2
      XLM2 =0.5D0*X*ALM2/PIM
      XLM22=XLM2*XLM2
      VKU2 =(ALM2/PIM)*FDEXP(-XLM22)/(2*SRPI)
      DVKU2=-0.5D0*(ALM2/PIM)**2*X*VKU2

      IF(N.EQ.2) THEN
      XA   =X*AM1/PIM
      RATA =AM1/ALM1
      ERATA=DEXP(RATA*RATA)
      EXA  =DEXP(XA)
      EMA  =FDERFC(-XLM1 +RATA)
      EPA  =FDERFC( XLM1 +RATA)
      FIA  =F0(ERATA,EXA ,EMA ,EPA ,X)
      HIA  =H0(ERATA,EXA ,EMA ,EPA ,X)
      DFIA =-(FIA -2*VKU1)*X1-(AM1/PIM)*HIA
      DHIA  =-(AM1/PIM)*FIA -HIA *X1
      DDFIA =-(DFIA-2*DVKU1)*X1+(FIA-2*VKU1)*X2-(AM1/PIM)*DHIA
      FI1= FIA
      DFI1= DFIA
      DDFI1= DDFIA

      XA   =X*AM2/PIM
      RATA =AM2/ALM2
      ERATA=DEXP(RATA*RATA)
      EXA  =DEXP(XA)
      EMA  =FDERFC(-XLM2 +RATA)
      EPA  =FDERFC( XLM2 +RATA)
      FIA  =F0(ERATA,EXA ,EMA ,EPA ,X)
      HIA  =H0(ERATA,EXA ,EMA ,EPA ,X)
      DFIA =-(FIA -2*VKU2)*X1-(AM2/PIM)*HIA
      DHIA  =-(AM2/PIM)*FIA -HIA *X1
      DDFIA =-(DFIA-2*DVKU2)*X1+(FIA-2*VKU2)*X2-(AM2/PIM)*DHIA
      FI2= FIA
      DFI2= DFIA
      DDFI2= DDFIA
      ENDIF
C
C     CONSTRUCTION BASE FUNCTIONS BY INTEGRATION
C
      DO 105 IFUN=1,9
      FUN(IFUN) = 0.D0
  105 HH(IFUN)  = 0.D0
      GG1  =0.D0
      DGG1 =0.D0
      DDGG1=0.D0
      GG2  =0.D0
      DGG2 =0.D0
      DDGG2=0.D0
      DO 100 INT=1,NINT
      ABM=0.5D0*(YB(INT+1)-YB(INT))
      ABP=0.5D0*(YB(INT+1)+YB(INT))
      DO 110 IY=1,NPNT
      IF(IMETH.EQ.0) THEN
      Y=ABM*XX(IY)+ABP
      GEW=WW(IY)*ABM*2.D0/PI
      ENDIF
      IF(IMETH.EQ.1) THEN
      Y=(1.D0+XX(IY))/(1.D0-XX(IY))
      GEW=WW(IY)*(2.D0/(1.D0-XX(IY))**2)*2.D0/PI
      ENDIF
      IF(Y.GT.50.D0) GOTO 110
C     FACTOR FROM FORM FACTOR EFFECTS THROUGH DISP. REL. :
      FDISP1=FDEXP(-Y*Y*RATP1*RATP1)
      FDISP2=FDEXP(-Y*Y*RATP2*RATP2)
C
      AM=PIM*DSQRT((AM1/PIM)**2+Y*Y)
      XM=AM*X/PIM
      RATM =AM/ALM1
      ERATM=FDEXP(RATM*RATM)
      EXM  =FDEXP(XM)
      EMM  =FDERFC(-XLM1+RATM)
      EPM  =FDERFC( XLM1+RATM)
C
      FIM   = F0(ERATM,EXM,EMM,EPM,X )
      HIM   = H0(ERATM,EXM,EMM,EPM,X )
      DFIM  =-(FIM-2*VKU1)*X1-(AM/PIM)*HIM
      DHIM  =-(AM/PIM)*FIM-HIM*X1
      DDFIM =-(DFIM-2*DVKU1)*X1+(FIM-2*VKU1)*X2-(AM/PIM)*DHIM

      FIM1  = FIM
      DFIM1  = DFIM
      DDFIM1  = DDFIM
C
      AM=PIM*DSQRT((AM2/PIM)**2+Y*Y)
      XM=AM*X/PIM
      RATM =AM/ALM2
      ERATM=FDEXP(RATM*RATM)
      EXM  =FDEXP(XM)
      EMM  =FDERFC(-XLM2+RATM)
      EPM  =FDERFC( XLM2+RATM)

      FIM   = F0(ERATM,EXM,EMM,EPM,X )
      HIM   = H0(ERATM,EXM,EMM,EPM,X )
      DFIM  =-(FIM-2*VKU2)*X1-(AM/PIM)*HIM
      DHIM  =-(AM/PIM)*FIM-HIM*X1
      DDFIM =-(DFIM-2*DVKU2)*X1+(FIM-2*VKU2)*X2-(AM/PIM)*DHIM

      FIM2  = FIM
      DFIM2  = DFIM
      DDFIM2  = DDFIM
C
      IF(N.EQ.-1) THEN
      WGHTH= GEW*Y*Y * FDISP1*FDISP2
      FUN(1)  = FUN(1)  + WGHTH*FIM1*FIM2
      FUN(2)  = FUN(2)  + WGHTH*DFIM1*FIM2
      FUN(3)  = FUN(3)  + WGHTH*FIM1*DFIM2
      FUN(4)  = FUN(4)  + WGHTH*DFIM1*DFIM2
      FUN(5)  = FUN(5)  + WGHTH*DDFIM1*FIM2
      FUN(6)  = FUN(6)  + WGHTH*FIM1*DDFIM2
      FUN(7)  = FUN(7)  + WGHTH*DDFIM1*DFIM2
      FUN(8)  = FUN(8)  + WGHTH*DFIM1*DDFIM2
      FUN(9)  = FUN(9)  + WGHTH*DDFIM1*DDFIM2
       IF(AA.NE.0.D0) THEN
      WGHT= WGHTH/(Y*Y+AA2)
      HH(1)   = HH(1)  + WGHT*FIM1*FIM2
      HH(2)   = HH(2)  + WGHT*DFIM1*FIM2
      HH(3)   = HH(3)  + WGHT*FIM1*DFIM2
      HH(4)   = HH(4)  + WGHT*DFIM1*DFIM2
      HH(5)   = HH(5)  + WGHT*DDFIM1*FIM2
      HH(6)   = HH(6)  + WGHT*FIM1*DDFIM2
      HH(7)   = HH(7)  + WGHT*DDFIM1*DFIM2
      HH(8)   = HH(8)  + WGHT*DFIM1*DDFIM2
      HH(9)   = HH(9)  + WGHT*DDFIM1*DDFIM2
      WGHT= GEW*Y*Y/(Y*Y+AA2)
      GG1   = GG1  + WGHT*FIM1* FDISP1
      DGG1  = DGG1 + WGHT*DFIM1* FDISP1
      DDGG1 = DDGG1+ WGHT*DDFIM1* FDISP1
      GG2   = GG2  + WGHT*FIM2* FDISP2
      DGG2  = DGG2 + WGHT*DFIM2* FDISP2
      DDGG2 = DDGG2+ WGHT*DDFIM1* FDISP2
       ENDIF

      ENDIF
C
      IF(N.EQ.0) THEN
      WGHTH= GEW*Y*Y/(Y*Y+AA2) * FDISP1*FDISP2
      FUN(1)  = FUN(1)  + WGHTH*FIM1*FIM2
      FUN(2)  = FUN(2)  + WGHTH*DFIM1*FIM2
      FUN(3)  = FUN(3)  + WGHTH*FIM1*DFIM2
      FUN(4)  = FUN(4)  + WGHTH*DFIM1*DFIM2
      FUN(5)  = FUN(5)  + WGHTH*DDFIM1*FIM2
      FUN(6)  = FUN(6)  + WGHTH*FIM1*DDFIM2
      FUN(7)  = FUN(7)  + WGHTH*DDFIM1*DFIM2
      FUN(8)  = FUN(8)  + WGHTH*DFIM1*DDFIM2
      FUN(9)  = FUN(9)  + WGHTH*DDFIM1*DDFIM2
      ENDIF

      IF(N.EQ.1.AND.AA.NE.0.D0) THEN
      WGHTH= GEW*FDISP1*FDISP2/(Y*Y+AA2)
      FUN(1)  = FUN(1)  + WGHTH*FIM1*FIM2
      FUN(2)  = FUN(2)  + WGHTH*DFIM1*FIM2
      FUN(3)  = FUN(3)  + WGHTH*FIM1*DFIM2
      FUN(4)  = FUN(4)  + WGHTH*DFIM1*DFIM2
      FUN(5)  = FUN(5)  + WGHTH*DDFIM1*FIM2
      FUN(6)  = FUN(6)  + WGHTH*FIM1*DDFIM2
      FUN(7)  = FUN(7)  + WGHTH*DDFIM1*DFIM2
      FUN(8)  = FUN(8)  + WGHTH*DFIM1*DDFIM2
      FUN(9)  = FUN(9)  + WGHTH*DDFIM1*DDFIM2
      WGHT= AA/(Y*Y+AA2)
      GG1   = GG1  + GEW*WGHT*FIM1* FDISP1
      DGG1  = DGG1 + GEW*WGHT*DFIM1* FDISP1
      DDGG1 = DDGG1+ GEW*WGHT*DDFIM1* FDISP1
      GG2   = GG2  + GEW*WGHT*FIM2* FDISP2
      DGG2  = DGG2 + GEW*WGHT*DFIM2* FDISP2
      DDGG2 = DDGG2+ GEW*WGHT*DDFIM1* FDISP2
      ENDIF
      IF(N.EQ.1.AND.AA.EQ.0.D0) THEN
      WGHTH= 1.D0/Y**2
      FUN(1)  = FUN(1)  + WGHTH*(FI1-FIM1*FDISP1)*(FI2-FIM2*FDISP2)
      FUN(2)  = FUN(2)  + WGHTH*(DFI1-DFIM1*FDISP1)*(FI2-FIM2*FDISP2)
      FUN(3)  = FUN(3)  + WGHTH*(FI1-FIM1*FDISP1)*(DFI2-DFIM2*FDISP2)
      FUN(4)  = FUN(4)  + WGHTH*(DFI1-DFIM1*FDISP1)*(DFI2-DFIM2*FDISP2)
      FUN(5)  = FUN(5)  + WGHTH*(DDFI1-DDFIM1*FDISP1)*(FI2-FIM2*FDISP2)
      FUN(6)  = FUN(6)  + WGHTH*(FI1-FIM1*FDISP1)*(DDFI2-DDFIM2*FDISP2)
      FUN(7)  = FUN(7)  + WGHTH*(DDFI1-DDFIM1*FDISP1)
     .                         *(DFI2-DFIM2*FDISP2)
      FUN(8)  = FUN(8)  + WGHTH*(DFI1-DFIM1*FDISP1)
     .                         *(DDFI2-DDFIM2*FDISP2)
      FUN(9)  = FUN(9)  + WGHTH*(DDFI1-DDFIM1*FDISP1)
     .                         *(DDFI2-DDFIM2*FDISP2)
      ENDIF

      IF(N.EQ.2) THEN
      WGHTH= GEW/(Y*Y+AA2)/Y**2
      FUN(1)  = FUN(1)  + WGHTH*(FI1-FIM1*FDISP1)*(FI2-FIM2*FDISP2)
      FUN(2)  = FUN(2)  + WGHTH*(DFI1-DFIM1*FDISP1)*(FI2-FIM2*FDISP2)
      FUN(3)  = FUN(3)  + WGHTH*(FI1-FIM1*FDISP1)*(DFI2-DFIM2*FDISP2)
      FUN(4)  = FUN(4)  + WGHTH*(DFI1-DFIM1*FDISP1)*(DFI2-DFIM2*FDISP2)
      FUN(5)  = FUN(5)  + WGHTH*(DDFI1-DDFIM1*FDISP1)*(FI2-FIM2*FDISP2)
      FUN(6)  = FUN(6)  + WGHTH*(FI1-FIM1*FDISP1)*(DDFI2-DDFIM2*FDISP2)
      FUN(7)  = FUN(7)  + WGHTH*(DDFI1-DDFIM1*FDISP1)
     .                         *(DFI2-DFIM2*FDISP2)
      FUN(8)  = FUN(8)  + WGHTH*(DFI1-DFIM1*FDISP1)
     .                         *(DDFI2-DDFIM2*FDISP2)
      FUN(9)  = FUN(9)  + WGHTH*(DDFI1-DDFIM1*FDISP1)
     .                         *(DDFI2-DDFIM2*FDISP2)
      ENDIF
C
110   CONTINUE
100   CONTINUE

      IF(N.EQ.-1.AND.AA.NE.0.D0) THEN
      FUN(1)  = FUN(1) - AA*GG1*GG2    -AA2*HH(1)
      FUN(2)  = FUN(2) - AA*DGG1*GG2   -AA2*HH(2)
      FUN(3)  = FUN(3) - AA*GG1*DGG2   -AA2*HH(3)
      FUN(4)  = FUN(4) - AA*DGG1*DGG2  -AA2*HH(4)
      FUN(5)  = FUN(5) - AA*DDGG1*GG2  -AA2*HH(5)
      FUN(6)  = FUN(6) - AA*GG1*DDGG2  -AA2*HH(6)
      FUN(7)  = FUN(7) - AA*DDGG1*DGG2 -AA2*HH(7)
      FUN(8)  = FUN(8) - AA*DGG1*DDGG2 -AA2*HH(8)
      FUN(9)  = FUN(9) - AA*DDGG1*DDGG2-AA2*HH(9)
      ENDIF

      IF(N.EQ.1.AND.AA.NE.0.D0) THEN
      FUN(1)  = FUN(1) - GG1*GG2/AA
      FUN(2)  = FUN(2) - DGG1*GG2/AA
      FUN(3)  = FUN(3) - GG1*DGG2/AA
      FUN(4)  = FUN(4) - DGG1*DGG2/AA
      FUN(5)  = FUN(5) - DDGG1*GG2/AA
      FUN(6)  = FUN(6) - GG1*DDGG2/AA
      FUN(7)  = FUN(7) - DDGG1*DGG2/AA
      FUN(8)  = FUN(8) - DGG1*DDGG2/AA
      FUN(9)  = FUN(9) - DDGG1*DDGG2/AA
      ENDIF
CC
1000  CALL ERRSET(208,256,1,1)
      RETURN
      END
C **********************************************************************
      SUBROUTINE HDIF(N,X,AM1,AM2,ALM1,DAM,FUN)
C **********************************************************************
C
C     SECOND EXCHANGE IS DIFFRACTIVE:  (ONLY READY FOR N=0)
C     FOURIER TRANSFORM OF
C                                 1                  1
C     H_{N,M}(A,OM1,OM2) = ------------------ ---------------
C                          OM1^{N} OM2^{N}    (OM1+A) (OM2+A)
C                              1
C                        X ---------
C                          (OM1+OM2)
C     FOR N = -1,0,1,2
C
C     SCHEMATICALLY:
C     FUN(1) = F*G,    FUN(2) = DF*G,   FUN(3) = F*DG,
C     FUN(4) = DF*DG,  FUN(5) = DDF*G,  FUN(6) = F*DDG,
C     FUN(7) = DDF*DG, FUN(8) = DF*DDG, FUN(9) = DDF*DDG
C
C     FOR FORM FACTOR TREATMENT SEE:
C     TH.A.RIJKEN, ANNALS OF PHYSICS 208, P.253 (1990).
C
C **********************************************************************
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/PIMAS/PIM
      DIMENSION XX(20),WW(20),YB(3),HH(9),FUN(12)
      DATA PI/3.14159265D0/,SRPI/1.7724538509D0/,ICALL/0/
      DATA YB/0.D0,10.D0,50.D0/,NINT/1/,NPNT/16/,IMETH/1/
      DATA AMPRO/938.2796D0/
      SAVE XX,WW,AA,AA2
C
C     POTENTIAL FUNTION DEFINITION
C
      F0(ERATH,EXH,EMH,EPH,XH)=ERATH*( EMH/EXH-EPH*EXH )/(2*XH)
      H0(ERATH,EXH,EMH,EPH,XH)=ERATH*( EMH/EXH+EPH*EXH )/(2*XH)
C
      CALL ERRSET(208,256,-1,1)
      IF(ICALL.EQ.0) THEN
        AA   =DAM/PIM
        AA2  =AA*AA
        CALL GAUSS(NPNT,XX,WW,1)
        IF(IMETH.EQ.1) NINT=1
C       PRINT 52, IMETH,NPNT
C52     FORMAT(//,'  IN HFUN: IMETH=',I2,' NPNT=',I2,//)
        ICALL=1
      ENDIF
CC
      X1   = 1.D0/X
      X2   = X1*X1
CC

C     DIFFRACTIVE:
      XA   =X*AM2/PIM
      FIA  =(4.D0/SRPI)*(AM2/PIM)*(AM2/AMPRO)**2*FDEXP(-XA*XA)
      DFIA =-2*(AM2/PIM)*XA*FIA
      DDFIA =-2*(AM2/PIM)*(XA*DFIA + FIA*AM2/PIM)
      FI2= FIA
      DFI2= DFIA
      DDFI2= DDFIA

      RATP1=PIM/ALM1
      XLM1 =0.5D0*X*ALM1/PIM
      XLM12=XLM1*XLM1
      VKU1 =(ALM1/PIM)*FDEXP(-XLM12)/(2*SRPI)
      DVKU1=-0.5D0*(ALM1/PIM)**2*X*VKU1

C     DIFFRACTIVE:
      ALM2 = 2*AM2
      RATP2=PIM/ALM2
      XLM2 =0.5D0*X*ALM2/PIM
      XLM22=XLM2*XLM2
      VKU2 =(ALM2/PIM)*FDEXP(-XLM22)/(2*SRPI)
      DVKU2=-0.5D0*(ALM2/PIM)**2*X*VKU2

      IF(N.EQ.2) THEN
      XA   =X*AM1/PIM
      RATA =AM1/ALM1
      ERATA=DEXP(RATA*RATA)
      EXA  =DEXP(XA)
      EMA  =FDERFC(-XLM1 +RATA)
      EPA  =FDERFC( XLM1 +RATA)
      FIA  =F0(ERATA,EXA ,EMA ,EPA ,X)
      HIA  =H0(ERATA,EXA ,EMA ,EPA ,X)
      DFIA =-(FIA -2*VKU1)*X1-(AM1/PIM)*HIA
      DHIA  =-(AM1/PIM)*FIA -HIA *X1
      DDFIA =-(DFIA-2*DVKU1)*X1+(FIA-2*VKU1)*X2-(AM1/PIM)*DHIA
      FI1= FIA
      DFI1= DFIA
      DDFI1= DDFIA
      ENDIF
C
C     CONSTRUCTION BASE FUNCTIONS BY INTEGRATION
C
      DO 105 IFUN=1,9
      FUN(IFUN) = 0.D0
  105 HH(IFUN)  = 0.D0
      GG1  =0.D0
      DGG1 =0.D0
      DDGG1=0.D0
      GG2  =0.D0
      DGG2 =0.D0
      DDGG2=0.D0
      DO 100 INT=1,NINT
      ABM=0.5D0*(YB(INT+1)-YB(INT))
      ABP=0.5D0*(YB(INT+1)+YB(INT))
      DO 110 IY=1,NPNT
      IF(IMETH.EQ.0) THEN
      Y=ABM*XX(IY)+ABP
      GEW=WW(IY)*ABM*2.D0/PI
      ENDIF
      IF(IMETH.EQ.1) THEN
      Y=(1.D0+XX(IY))/(1.D0-XX(IY))
      GEW=WW(IY)*(2.D0/(1.D0-XX(IY))**2)*2.D0/PI
      ENDIF
      IF(Y.GT.50.D0) GOTO 110
C     FACTOR FROM FORM FACTOR EFFECTS THROUGH DISP. REL. :
      FDISP1=FDEXP(-Y*Y*RATP1*RATP1)
      FDISP2=FDEXP(-Y*Y*RATP2*RATP2)
C
      AM=PIM*DSQRT((AM1/PIM)**2+Y*Y)
      XM=AM*X/PIM
      RATM =AM/ALM1
      ERATM=FDEXP(RATM*RATM)
      EXM  =FDEXP(XM)
      EMM  =FDERFC(-XLM1+RATM)
      EPM  =FDERFC( XLM1+RATM)
C
      FIM   = F0(ERATM,EXM,EMM,EPM,X )
      HIM   = H0(ERATM,EXM,EMM,EPM,X )
      DFIM  =-(FIM-2*VKU1)*X1-(AM/PIM)*HIM
      DHIM  =-(AM/PIM)*FIM-HIM*X1
      DDFIM =-(DFIM-2*DVKU1)*X1+(FIM-2*VKU1)*X2-(AM/PIM)*DHIM

      FIM1  = FIM
      DFIM1  = DFIM
      DDFIM1  = DDFIM
C
      FIM2  = FI2
      DFIM2  = DFI2
      DDFIM2  = DDFI2
C
      IF(N.EQ.-1) THEN
      WGHTH= GEW*Y*Y * FDISP1*FDISP2
      FUN(1)  = FUN(1)  + WGHTH*FIM1*FIM2
      FUN(2)  = FUN(2)  + WGHTH*DFIM1*FIM2
      FUN(3)  = FUN(3)  + WGHTH*FIM1*DFIM2
      FUN(4)  = FUN(4)  + WGHTH*DFIM1*DFIM2
      FUN(5)  = FUN(5)  + WGHTH*DDFIM1*FIM2
      FUN(6)  = FUN(6)  + WGHTH*FIM1*DDFIM2
      FUN(7)  = FUN(7)  + WGHTH*DDFIM1*DFIM2
      FUN(8)  = FUN(8)  + WGHTH*DFIM1*DDFIM2
      FUN(9)  = FUN(9)  + WGHTH*DDFIM1*DDFIM2
       IF(AA.NE.0.D0) THEN
      WGHT= WGHTH/(Y*Y+AA2)
      HH(1)   = HH(1)  + WGHT*FIM1*FIM2
      HH(2)   = HH(2)  + WGHT*DFIM1*FIM2
      HH(3)   = HH(3)  + WGHT*FIM1*DFIM2
      HH(4)   = HH(4)  + WGHT*DFIM1*DFIM2
      HH(5)   = HH(5)  + WGHT*DDFIM1*FIM2
      HH(6)   = HH(6)  + WGHT*FIM1*DDFIM2
      HH(7)   = HH(7)  + WGHT*DDFIM1*DFIM2
      HH(8)   = HH(8)  + WGHT*DFIM1*DDFIM2
      HH(9)   = HH(9)  + WGHT*DDFIM1*DDFIM2
      WGHT= GEW*Y*Y/(Y*Y+AA2)
      GG1   = GG1  + WGHT*FIM1* FDISP1
      DGG1  = DGG1 + WGHT*DFIM1* FDISP1
      DDGG1 = DDGG1+ WGHT*DDFIM1* FDISP1
      GG2   = GG2  + WGHT*FIM2* FDISP2
      DGG2  = DGG2 + WGHT*DFIM2* FDISP2
      DDGG2 = DDGG2+ WGHT*DDFIM1* FDISP2
       ENDIF

      ENDIF
C
      IF(N.EQ.0) THEN
      WGHTH= GEW*Y*Y/(Y*Y+AA2) * FDISP1*FDISP2
      FUN(1)  = FUN(1)  + WGHTH*FIM1*FIM2
      FUN(2)  = FUN(2)  + WGHTH*DFIM1*FIM2
      FUN(3)  = FUN(3)  + WGHTH*FIM1*DFIM2
      FUN(4)  = FUN(4)  + WGHTH*DFIM1*DFIM2
      FUN(5)  = FUN(5)  + WGHTH*DDFIM1*FIM2
      FUN(6)  = FUN(6)  + WGHTH*FIM1*DDFIM2
      FUN(7)  = FUN(7)  + WGHTH*DDFIM1*DFIM2
      FUN(8)  = FUN(8)  + WGHTH*DFIM1*DDFIM2
      FUN(9)  = FUN(9)  + WGHTH*DDFIM1*DDFIM2
      ENDIF

      IF(N.EQ.1.AND.AA.NE.0.D0) THEN
      WGHTH= GEW*FDISP1*FDISP2/(Y*Y+AA2)
      FUN(1)  = FUN(1)  + WGHTH*FIM1*FIM2
      FUN(2)  = FUN(2)  + WGHTH*DFIM1*FIM2
      FUN(3)  = FUN(3)  + WGHTH*FIM1*DFIM2
      FUN(4)  = FUN(4)  + WGHTH*DFIM1*DFIM2
      FUN(5)  = FUN(5)  + WGHTH*DDFIM1*FIM2
      FUN(6)  = FUN(6)  + WGHTH*FIM1*DDFIM2
      FUN(7)  = FUN(7)  + WGHTH*DDFIM1*DFIM2
      FUN(8)  = FUN(8)  + WGHTH*DFIM1*DDFIM2
      FUN(9)  = FUN(9)  + WGHTH*DDFIM1*DDFIM2
      WGHT= AA/(Y*Y+AA2)
      GG1   = GG1  + GEW*WGHT*FIM1* FDISP1
      DGG1  = DGG1 + GEW*WGHT*DFIM1* FDISP1
      DDGG1 = DDGG1+ GEW*WGHT*DDFIM1* FDISP1
      GG2   = GG2  + GEW*WGHT*FIM2* FDISP2
      DGG2  = DGG2 + GEW*WGHT*DFIM2* FDISP2
      DDGG2 = DDGG2+ GEW*WGHT*DDFIM1* FDISP2
      ENDIF
      IF(N.EQ.1.AND.AA.EQ.0.D0) THEN
      WGHTH= 1.D0/Y**2
      FUN(1)  = FUN(1)  + WGHTH*(FI1-FIM1*FDISP1)*(FI2-FIM2*FDISP2)
      FUN(2)  = FUN(2)  + WGHTH*(DFI1-DFIM1*FDISP1)*(FI2-FIM2*FDISP2)
      FUN(3)  = FUN(3)  + WGHTH*(FI1-FIM1*FDISP1)*(DFI2-DFIM2*FDISP2)
      FUN(4)  = FUN(4)  + WGHTH*(DFI1-DFIM1*FDISP1)*(DFI2-DFIM2*FDISP2)
      FUN(5)  = FUN(5)  + WGHTH*(DDFI1-DDFIM1*FDISP1)*(FI2-FIM2*FDISP2)
      FUN(6)  = FUN(6)  + WGHTH*(FI1-FIM1*FDISP1)*(DDFI2-DDFIM2*FDISP2)
      FUN(7)  = FUN(7)  + WGHTH*(DDFI1-DDFIM1*FDISP1)
     .                         *(DFI2-DFIM2*FDISP2)
      FUN(8)  = FUN(8)  + WGHTH*(DFI1-DFIM1*FDISP1)
     .                         *(DDFI2-DDFIM2*FDISP2)
      FUN(9)  = FUN(9)  + WGHTH*(DDFI1-DDFIM1*FDISP1)
     .                         *(DDFI2-DDFIM2*FDISP2)
      ENDIF

      IF(N.EQ.2) THEN
      WGHTH= GEW/(Y*Y+AA2)/Y**2
      FUN(1)  = FUN(1)  + WGHTH*(FI1-FIM1*FDISP1)*(FI2-FIM2*FDISP2)
      FUN(2)  = FUN(2)  + WGHTH*(DFI1-DFIM1*FDISP1)*(FI2-FIM2*FDISP2)
      FUN(3)  = FUN(3)  + WGHTH*(FI1-FIM1*FDISP1)*(DFI2-DFIM2*FDISP2)
      FUN(4)  = FUN(4)  + WGHTH*(DFI1-DFIM1*FDISP1)*(DFI2-DFIM2*FDISP2)
      FUN(5)  = FUN(5)  + WGHTH*(DDFI1-DDFIM1*FDISP1)*(FI2-FIM2*FDISP2)
      FUN(6)  = FUN(6)  + WGHTH*(FI1-FIM1*FDISP1)*(DDFI2-DDFIM2*FDISP2)
      FUN(7)  = FUN(7)  + WGHTH*(DDFI1-DDFIM1*FDISP1)
     .                         *(DFI2-DFIM2*FDISP2)
      FUN(8)  = FUN(8)  + WGHTH*(DFI1-DFIM1*FDISP1)
     .                         *(DDFI2-DDFIM2*FDISP2)
      FUN(9)  = FUN(9)  + WGHTH*(DDFI1-DDFIM1*FDISP1)
     .                         *(DDFI2-DDFIM2*FDISP2)
      ENDIF
C
110   CONTINUE
100   CONTINUE

      IF(N.EQ.-1.AND.AA.NE.0.D0) THEN
      FUN(1)  = FUN(1) - AA*GG1*GG2    -AA2*HH(1)
      FUN(2)  = FUN(2) - AA*DGG1*GG2   -AA2*HH(2)
      FUN(3)  = FUN(3) - AA*GG1*DGG2   -AA2*HH(3)
      FUN(4)  = FUN(4) - AA*DGG1*DGG2  -AA2*HH(4)
      FUN(5)  = FUN(5) - AA*DDGG1*GG2  -AA2*HH(5)
      FUN(6)  = FUN(6) - AA*GG1*DDGG2  -AA2*HH(6)
      FUN(7)  = FUN(7) - AA*DDGG1*DGG2 -AA2*HH(7)
      FUN(8)  = FUN(8) - AA*DGG1*DDGG2 -AA2*HH(8)
      FUN(9)  = FUN(9) - AA*DDGG1*DDGG2-AA2*HH(9)
      ENDIF

      IF(N.EQ.1.AND.AA.NE.0.D0) THEN
      FUN(1)  = FUN(1) - GG1*GG2/AA
      FUN(2)  = FUN(2) - DGG1*GG2/AA
      FUN(3)  = FUN(3) - GG1*DGG2/AA
      FUN(4)  = FUN(4) - DGG1*DGG2/AA
      FUN(5)  = FUN(5) - DDGG1*GG2/AA
      FUN(6)  = FUN(6) - GG1*DDGG2/AA
      FUN(7)  = FUN(7) - DDGG1*DGG2/AA
      FUN(8)  = FUN(8) - DGG1*DDGG2/AA
      FUN(9)  = FUN(9) - DDGG1*DDGG2/AA
      ENDIF
CC
1000  CALL ERRSET(208,256,1,1)
      RETURN
      END
C **********************************************************************
      SUBROUTINE PRSU3TM(IV,NCASE,X,P,N3)
C **********************************************************************
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/PSBE/ VPR(5,4,4,4,4)                              
      DIMENSION VTOT(5)
C SUMMED CONTRIBUTIONS:                   
      DO 120 ICHAN=1,5
      VTOT(ICHAN)=0.D0
      DO 120 M=1,4
      DO 120 N=1,4
  120 VTOT(ICHAN)=VTOT(ICHAN)+VPR(ICHAN,IV,M,N,NCASE)
      if(iv.eq.1) write(N3,121) VTOT(1),VTOT(5),VTOT(2),VTOT(3),VTOT(4)
  121 format(' VCNN=',F10.2,3x,' VCDR=',F10.2,3x,' VCLL=',F10.2,/,
     .         ' VCLS=',F10.2,3x,' VCSS=',F10.2,/)
      if(iv.eq.2) write(N3,122) VTOT(1),VTOT(5),VTOT(2),VTOT(3),VTOT(4)
  122 format(' VSNN=',F10.2,3x,' VSDR=',F10.2,3x,' VSLL=',F10.2,/,
     .         ' VSLS=',F10.2,3x,' VSSS=',F10.2,/)
C CONTRIBUTIONS TO SU(3)-POTENTIALS:                        
      if(p.eq.1.d0) then
      V27a = VTOT(1)                                                    
      V27b = VTOT(5)                                                    
      V27c = (9*VTOT(2)-VTOT(4))/8.D0
*     V8Sa = 10*VTOT(2)-9*VTOT(5)
      V8Sa =    VTOT(2)+3*VTOT(3)
      V8Sb = (10*VTOT(4)-VTOT(5))/9.D0
      V8Sc = (9*VTOT(4)-VTOT(2))/8.D0
      VLSa = (-3*V27b+3*V8Sa)/10.D0
      VLSb = (-3*V27b+3*V8Sb)/10.D0
      VLSc = (-3*V27c+3*V8Sc)/10.D0
      write(N3,123) V27a,V27b,V27c,V8Sa,V8Sb,V8Sc,VLSa,VLSb,VLSc
  123 format(' V27a =',F10.2,3x,' V27b =',F10.2,3x,' V27c =',F10.2,/,
     .       ' V8Sa =',F10.2,3x,' V8Sb =',F10.2,3x,' V8Sc =',F10.2,/,
     .       ' VLSa =',F10.2,3x,' VLSb =',F10.2,3x,' VLSc =',F10.2,/)
      endif
      if(p.eq.-1.d0) then
      V10nn= VTOT(1)
      V10  = VTOT(5)
      V10sa= VTOT(2)+VTOT(3)                                            
      V10sb= VTOT(4)+VTOT(3)                                            
      V8Aa = VTOT(2)-VTOT(3)                                            
      V8Ab = VTOT(4)-VTOT(3)                                            
      write(N3,124) V10sa,V10sb,V10nn,V8Aa,V8Ab,V10
  124 format(' V10*a=',F10.2,3x,' V10*b=',F10.2,3x,' V10nn=',F10.2,/,
     .       ' V8Aa =',F10.2,3x,' V8Ab =',F10.2,3x,' V10  =',F10.2,/)
      endif
      RETURN
      END

