C **********************************************************************
C VERSION YNOOM.F: 15 SEPT. 1997, SU3-relations okay!
C **********************************************************************
C
C NOTICE: 1) FOR DOUBLE SCALAR/DIFFRACTIVE: ALD = 0.25!
C         2) IN OMPAIR : COMMON/CCPR/ !
C
C **********************************************************************
      SUBROUTINE OMPSPS(X,INA,IPV,IOFF,ALP,APV)
C **********************************************************************
C *
C *   DATE: AUGUST, 1995
C
C *   THIS ROUTINE: POTENTIALS FROM DOUBLE PSEUDO-SCALAR EXCHANGE
C *                 CALLED BY SUBROUTINE YNPSPS
C *
C *   1/M-CONTRIBUTIONS: 1) NON-ADIABATIC, 2) FROM THE PV-VERTEX
C *
C *        NO MASS-DIFFERENCES BETWEEN BARYONS TAKEN INTO ACCOUNT
C *
C     PS-SCAL: ALMP1 = SU(3)-SINGLET, ALMP8 = SU(3)-OCTET
C *
C **********************************************************************
C
C     INCLUDED IN ENERGY DENOMINATORS:
C     (i) L+R contributions included, 1/4 -> 1/2, the latter is
C         put into FACT.
C     INCLUDED IN COUPLING-COMBINATIONS CPANLL ETC.:
C     (ii) 1 <-> 2 interchange effects for non-identical mesons.
C
C **********************************************************************
C
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/PIMAS/PIM0
      COMMON/POTESC/VCLL,VCSS,VCLS,VCDR,VSLL,VSSS,VSLS,VSDR,
     .              VTLL,VTSS,VTLS,VTDR,VOLL,VOSS,VOLS,VODR,
     .              VALL,VASS,VALS,VADR
      COMMON/DYNMAS/REDMM,AMLN,AMSN,AMH,AMSS,AMLS,AMNN
      COMMON/FORMF/ALAM,ALMP8,ALMV8,ALMS8,ALMP1,ALMV1,ALMS1,
     .             ALMKA,ALMKS,ALMKP
      COMMON/ALLPS/AME,AMX,AMK,BMK
      COMMON/COUPL/ F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,F11,
     .              G1,G2,G3,G4,G5,G6,G7,G8,G9,G10,G11,
     .              FD1,FD2,FD3,FD4,FD5,FD6,FD7,FD8,FD9,FD10,FD11,
     .              FV1,FV2,FV3,FV4,FV5,FV6,FV7,FV8,FV9,FV10,FV11,
     .              GS1,GS2,GS3,GS4,GS5,GS6,GS7,GS8,GS9,GS10,GS11,
     .              GD1,GD2,GD3,GD4,GD5,GD6,GD7,GD8,GD9,GD10,GD11,P
      COMMON/FOOMS/FNONC,FNONS,FNONT,FNONO,FPVC,FPVS,FPVT,FPVO
     .            ,FOFFC,FOFFS,FOFFT,FOFFO,FOFFS2,FOFFT2
      COMMON/XICOUPL/XF12,XF13,XFD12,XFD13,XFV12,XFV13,XGS12,XGS13,
     .XGD12,XGD13
      COMMON/PSBEOM/
     .VPSPS(5,4,4,4),VPSVC(5,4,4,4),VPSSC(5,4,4,4),VPSDF(5,4,4,4),
     .VSCSC(5,4,4,4),VSCDF(5,4,4,4),VDFDF(5,4,4,4)
      DIMENSION F(11),G(11),FD(11),FV(11),GS(11),GD(11)
      EQUIVALENCE (F1,F(1)),(G1,G(1)),(FD1,FD(1)),(FV1,FV(1))
     . ,(GS1,GS(1)),(GD1,GD(1))
C
      DATA PI/3.14159265D0/,SRPI/1.7724538509D0/,
     . SR2/1.41421356D0/,SR6/2.44948974D0/,SR3/1.732051D0/
      DATA IPIPI/1/,IPIET/1/,IPIETP/1/,IPIKA/1/,IKAKA/1/,
     .     IETA2/1/,IETKA/1/,IETETP/1/,IETPKA/1/,IETAP2/1/
      DATA FACT/70.D0/,ICALL/0/,NSCHR/0/,POLD/-123D0/

c     character*6 typ(10)
c     data typ/'PIPI','IPIET','IPIETP','IPIKA','IKAKA',
c    .'IETA2','IETKA','IETETP','IETPKA','IETAP2'/

      SAVE FACT,AMB,BPV       
C
      CALL ERRSET(208,256,-1,1)
C
      pim=pim0
**    pim=500.d0
      IF(ICALL.EQ.0) THEN
        FACT = PIM0/2.D0
        BPV  = 2*APV-1.D0
C       AVERAGE MASS:
        AMB = 2*AMNN*AMH/(AMNN+AMH)
        FACT = (PIM0/AMB)*FACT
        PRINT 52, INA,IPV,IOFF,PIM,AMB,APV
   52   FORMAT(//,'  IN OMPSPS: INA, IPV, IOFF=',3I3,' PIM=',F7.3,
     .            ' AMB=',F10.3,' APV=',F10.3,/)
*       ICALL=1
      ENDIF

        if(pold.ne.p) then
        icall=0
        pold = p
        nschr= 1

        IF(P.EQ.+1.D0) ISFAC=+1
        IF(P.EQ.-1.D0) ISFAC=-3
        ISFLL = (1+ISFAC)/2
        ISFLS = (3-ISFAC)
        ISFSS = (9+ISFAC)/2
        endif

        if(icall.eq.20.and.nschr.eq.1) then
        DO 250 NCHAN=1,5
        DO 250 ITYPV=1,4
        DO 250 M=1,4
        DO 250 N=1,4
  250   VPSPS(NCHAN,ITYPV,M,N)=0.D0
        endif
        
        XF12=F1*(4*ALP-1.D0)/SR3
        XF13=-F1  
C
C     1/M-CORRECTIONS:
C
      DO 100 II=1,10
      PEX = 1.D0
      GOTO(10,20,30,40,50,60,70,80,90,95),II
C PION-PION EXCHANGE POTENTIALS:
   10 IF(IPIPI.EQ.1) THEN
      M = 1
      N = 1
C     PARALLEL:
      CPANN  =  1*(3-2*ISFAC)*F1**2*F1**2
      CPALL  =  3*F1*F1*F3*F3
      CPALS  =  2*SR3*F1*F1*F3*F2
      CPASS  =  F1*F1*(3*F3*F3+4*F2*F2)
      CPADR  =  +F1*F1*F2*F2
C     CROSSED:
      CCRNN  =  1*(3+2*ISFAC)*F1**2*F1**2
      CCRLL  =  3*F1*F1*F3*F3
      CCRLS  = -2*SR3*F1*F1*F3*F2
      CCRSS  =  -F1*F1*F3*F3
      CCRDR  =  F1*F1*(2*F3*F3+3*F2*F2)

      CALL FOOM(1,X,PIM,PIM,ALMP8,ALMP8)
      ENDIF
      GOTO 200

C PION-ETA EXCHANGE POTENTIALS:
   20 IF(IPIET.EQ.1) THEN
      M = 1
      N = 3
C     PARALLEL:
      CPANN  =  2*ISFAC*F1**2*F6**2
      CPALL  =  0.D0
      CPALS  =  -SR3*F1*F6*F3*(F8+F7)
      CPASS  =  -4*F1*F6*F2*F8
      CPADR  =  +2*F1*F6*F2*F8
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  0.D0
      CCRLS  =  -SR3*F1*F6*F3*(F8+F7)
      CCRSS  =  -4*F1*F6*F2*F8
      CCRDR  =  +2*F1*F6*F2*F8

      CALL FOOM(1,X,PIM,AME,ALMP8,ALMP8)
      GOTO 200
      ENDIF

C PION-ETA' EXCHANGE POTENTIALS:
   30 IF(IPIETP.EQ.1) THEN
      M = 1
      N = 4
C     PARALLEL:
      CPANN  =  2*ISFAC*F1**2*F9**2
      CPALL  =  0.D0
      CPALS  =  -SR3*F1*F9*F3*(F11+F10)
      CPASS  =  -4*F1*F9*F2*F11
      CPADR  =  +2*F1*F9*F2*F11
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  0.D0
      CCRLS  =  -SR3*F1*F9*F3*(F11+F10)
      CCRSS  =  -4*F1*F9*F2*F11
      CCRDR  =  +2*F1*F9*F2*F11

      CALL FOOM(1,X,PIM,AMX,ALMP8,ALMP1)
      ENDIF
      GOTO 200

C PION-KAON EXCHANGE POTENTIALS:
   40 IF(IPIKA.EQ.1) THEN
      PEX = P
      M = 1
      N = 2
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  6*F1*F4*F3*F5
      CPALS  =  -SR3*F1*F3*(F4**2-F5**2)
     .          +2*SR3*F1*F2*F4*F5
      CPASS  =  F1*F5*(6*F3*F4+4*F2*F5)
      CPADR  =  +4*F1*F2*F5**2
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  3*(F1*F1*F4**2+F3*F3*F5**2)
      CCRLS  =  SR3*F4*F5*(F1**2-F3**2)
     .         +2*SR3*F2*F3*F5**2
      CCRSS  =  5*F1**2*F5**2+F3**2*F4**2
     .         +4*F2*F3*F4*F5
      CCRDR  =  2*F1**2*F5**2+F3**2*F4**2
     .         +3*F2**2*F5**2-2*F2*F3*F4*F5

      CALL FOOM(1,X,PIM,AMK,ALMP8,ALMKA)
      ENDIF
      GOTO 200

C KAON-KAON EXCHANGE POTENTIALS:
   50 IF(IKAKA.EQ.1) THEN
      M = 2
      N = 2
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  (F4**2+3*F5**2)*F4**2
      CPALS  =  SR3*(F5**2-F4**2)*F4*F5
      CPASS  =  (3*F4**2+F5**2)*F5**2
      CPADR  =  4*F5**4
C     CROSSED:
      CCRNN  =  1*(ISFLL*F4**2*F4**2+ISFLS*F4*F5*F4*F5+
     .             ISFSS*F5**2*F5**2)
      CCRLL  = +(F4**2+3*F5**2)*XF12**2
      CCRLS  = +SR3*(F4**2-F5**2)*1*XF12*XF13
      CCRSS  = +(-F4**2+5*F5**2)*XF13**2
      CCRDR  =  +2*XF13**2*(F4**2+F5**2)

      CALL FOOM(1,X,AMK,AMK,ALMKA,ALMKA)
      ENDIF
      GOTO 200

C ETA-ETA EXCHANGE POTENTIALS:
   60 IF(IETA2.EQ.1) THEN
      PEX = 1.D0
      M = 3
      N = 3
C     PARALLEL:
      CPANN  =  F6**2*F6**2
      CPALL  =  F6**2*F7**2
      CPALS  =  0.D0
      CPASS  =  F6**2*F8**2
      CPADR  =  CPASS
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  F6**2*F7**2
      CCRLS  =  0.D0
      CCRSS  =  F6**2*F8**2
      CCRDR  =  CCRSS

      CALL FOOM(1,X,AMK,AMK,ALMKA,ALMKA)
      ENDIF
      GOTO 200

C ETA-KAON EXCHANGE POTENTIALS:
   70 IF(IETKA.EQ.1) THEN
      PEX = P
      M = 2
      N = 3
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  2*F6*F7*F4**2
      CPALS  =  -SR3*F6*(F7+F8)*F4*F5
      CPASS  =  -2*F6*F8*F5**2
      CPADR  =  -2*CPASS
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  (F6**2+F7**2)*F4**2
      CCRLS  =  -SR3*(F6**2+F7*F8)*F4*F5
      CCRSS  =  -1*(F6**2+F8**2)*F5**2
      CCRDR  =  -2*CCRSS

      CALL FOOM(1,X,AME,AMK,ALMP8,ALMKA)
      ENDIF
      GOTO 200

C ETA-ETA' EXCHANGE POTENTIALS:
   80 IF(IETETP.EQ.1) THEN
      PEX = 1.D0
      M = 3
      N = 4
C     PARALLEL:
      CPANN  =  2*F6**2*F9**2
      CPALL  =  2*F6*F9*F7*F10
      CPALS  =  0.D0
      CPASS  =  2*F6*F9*F8*F11
      CPADR  =  CPASS
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  2*F6*F9*F7*F10
      CCRLS  =  0.D0
      CCRSS  =  2*F6*F9*F8*F11
      CCRDR  =  CCRSS

      CALL FOOM(1,X,AME,AMX,ALMP8,ALMP1)
      ENDIF
      GOTO 200

C ETA'-KAON EXCHANGE POTENTIALS:
   90 IF(IETPKA.EQ.1) THEN
      PEX = P
      M = 2
      N = 4
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  2*F9*F10*F4**2
      CPALS  =  -SR3*F9*(F10+F11)*F4*F5
      CPASS  =  -2*F9*F11*F5**2
      CPADR  =  -2*CPASS
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  (F9**2+F10**2)*F4**2
      CCRLS  =  -SR3*(F9**2+F10*F11)*F4*F5
      CCRSS  =  -1*(F9**2+F11**2)*F5**2
      CCRDR  =  -2*CCRSS

      CALL FOOM(1,X,AMX,AMK,ALMP1,ALMKA)
      ENDIF
      GOTO 200

C ETA'-ETA' EXCHANGE POTENTIALS:
   95 IF(IETAP2.EQ.1) THEN
      PEX = 1.D0
      M = 4
      N = 4
C     PARALLEL:
      CPANN  =  F9**2*F9**2
      CPALL  =  F9**2*F10**2
      CPALS  =  0.D0
      CPASS  =  F9**2*F11**2
      CPADR  =  CPASS
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  F9**2*F10**2
      CCRLS  =  0.D0
      CCRSS  =  F9**2*F11**2
      CCRDR  =  CCRSS

      CALL FOOM(1,X,AMX,AMX,ALMP1,ALMP1)
      ENDIF
      GOTO 200

200   IF(INA.EQ.1) THEN

C     NON-ADIABATIC 1/M-CORRECTIONS:
      VCLL  =   VCLL - FACT*( CPALL-2*CCRLL )*FNONC*PEX
      VCLS  =   VCLS - FACT*( CPALS-2*CCRLS )*FNONC*PEX
      VCSS  =   VCSS - FACT*( CPASS-2*CCRSS )*FNONC*PEX
      VCDR  =   VCDR - FACT*( CPADR-2*CCRDR )*FNONC*PEX

      VSLL  =   VSLL + FACT*( CPALL+2*CCRLL )*FNONS*PEX
      VSLS  =   VSLS + FACT*( CPALS+2*CCRLS )*FNONS*PEX
      VSSS  =   VSSS + FACT*( CPASS+2*CCRSS )*FNONS*PEX
      VSDR  =   VSDR + FACT*( CPADR+2*CCRDR )*FNONS*PEX

      VTLL  =   VTLL + FACT*( CPALL+2*CCRLL )*FNONT*PEX
      VTLS  =   VTLS + FACT*( CPALS+2*CCRLS )*FNONT*PEX
      VTSS  =   VTSS + FACT*( CPASS+2*CCRSS )*FNONT*PEX
      VTDR  =   VTDR + FACT*( CPADR+2*CCRDR )*FNONT*PEX

      VPSPS(1,1,M,N)=VPSPS(1,1,M,N)-FACT*(CPANN-2*CCRNN)*FNONC*PEX
      VPSPS(2,1,M,N)=VPSPS(2,1,M,N)-FACT*(CPALL-2*CCRLL)*FNONC*PEX
      VPSPS(3,1,M,N)=VPSPS(3,1,M,N)-FACT*(CPALS-2*CCRLS)*FNONC*PEX
      VPSPS(4,1,M,N)=VPSPS(4,1,M,N)-FACT*(CPASS-2*CCRSS)*FNONC*PEX
      VPSPS(5,1,M,N)=VPSPS(5,1,M,N)-FACT*(CPADR-2*CCRDR)*FNONC*PEX

      VPSPS(1,2,M,N)=VPSPS(1,2,M,N)+FACT*(CPANN+2*CCRNN)*FNONS*PEX
      VPSPS(2,2,M,N)=VPSPS(2,2,M,N)+FACT*(CPALL+2*CCRLL)*FNONS*PEX
      VPSPS(3,2,M,N)=VPSPS(3,2,M,N)+FACT*(CPALS+2*CCRLS)*FNONS*PEX
      VPSPS(4,2,M,N)=VPSPS(4,2,M,N)+FACT*(CPASS+2*CCRSS)*FNONS*PEX
      VPSPS(5,2,M,N)=VPSPS(5,2,M,N)+FACT*(CPADR+2*CCRDR)*FNONS*PEX
      ENDIF
      IF(IPV.EQ.1) THEN
C     PV-VERTEX 1/M-CORRECTIONS:
      VCLL  =   VCLL + APV*FACT*CCRLL *FPVC*PEX
      VCLS  =   VCLS + APV*FACT*CCRLS *FPVC*PEX
      VCSS  =   VCSS + APV*FACT*CCRSS *FPVC*PEX
      VCDR  =   VCDR + APV*FACT*CCRDR *FPVC*PEX

      VOLL  =   VOLL + APV*FACT*CCRLL *FPVO*PEX
      VOLS  =   VOLS + APV*FACT*CCRLS *FPVO*PEX
      VOSS  =   VOSS + APV*FACT*CCRSS *FPVO*PEX
      VODR  =   VODR + APV*FACT*CCRDR *FPVO*PEX

      VPSPS(1,1,M,N)=VPSPS(1,1,M,N)+APV*FACT*CCRNN*FPVC*PEX
      VPSPS(2,1,M,N)=VPSPS(2,1,M,N)+APV*FACT*CCRLL*FPVC*PEX
      VPSPS(3,1,M,N)=VPSPS(3,1,M,N)+APV*FACT*CCRLS*FPVC*PEX
      VPSPS(4,1,M,N)=VPSPS(4,1,M,N)+APV*FACT*CCRSS*FPVC*PEX
      VPSPS(5,1,M,N)=VPSPS(5,1,M,N)+APV*FACT*CCRDR*FPVC*PEX
      ENDIF
      IF(IOFF.EQ.1) THEN
C     PIONIC OFF-SHELL CORRECTIONS INTMO:
      VCLL  =   VCLL + BPV*FACT*CPALL *FOFFC*PEX/3.D0
      VCLS  =   VCLS + BPV*FACT*CPALS *FOFFC*PEX/3.D0
      VCSS  =   VCSS + BPV*FACT*CPASS *FOFFC*PEX/3.D0
      VCDR  =   VCDR + BPV*FACT*CPADR *FOFFC*PEX/3.D0

      VOLL  =   VOLL + BPV*FACT*CPALL *FOFFO*PEX/3.D0
      VOLS  =   VOLS + BPV*FACT*CPALS *FOFFO*PEX/3.D0
      VOSS  =   VOSS + BPV*FACT*CPASS *FOFFO*PEX/3.D0
      VODR  =   VODR + BPV*FACT*CPADR *FOFFO*PEX/3.D0

      VPSPS(1,1,M,N)=VPSPS(1,1,M,N)+BPV*FACT*CPANN*FOFFC*PEX/3.D0
      VPSPS(2,1,M,N)=VPSPS(2,1,M,N)+BPV*FACT*CPALL*FOFFC*PEX/3.D0
      VPSPS(3,1,M,N)=VPSPS(3,1,M,N)+BPV*FACT*CPALS*FOFFC*PEX/3.D0
      VPSPS(4,1,M,N)=VPSPS(4,1,M,N)+BPV*FACT*CPASS*FOFFC*PEX/3.D0
      VPSPS(5,1,M,N)=VPSPS(5,1,M,N)+BPV*FACT*CPADR*FOFFC*PEX/3.D0
      ENDIF
c     if(icall.eq.0) then
c     write(6,*) 'OMPSPS: x=',x,' ii=',ii,' ',typ(ii),' apv=',apv
c     write(6,*) ' cpall=',cpall,' ccrll=',ccrll,' voll=',voll
c     endif
100   CONTINUE
*     if(icall.eq.0.and.nschr.eq.1) call wromtm(1,x,p)
***   if(icall.eq.20.and.nschr.eq.1) call wromtm(1,x,p)
*     if(icall.eq.40.and.nschr.eq.1) call wromtm(1,x,p)

1000  CALL ERRSET(208,256,1,1)
      ICALL=ICALL+1
      RETURN
C END OOPSPS ROUTINE ***************************************************
      END
C **********************************************************************
      SUBROUTINE OMPIBE(X,INA,IPV,IOFF,APV)
C **********************************************************************
C *
C *   DATE: AUGUST, 1995
C
C *   THIS ROUTINE: PI-MESON EXCHANGE YN-POTENTIALS
C *                 CALLED BY SUBROUTINE YNPIBE
C
C *   1/M-CONTRIBUTIONS: 1) NON-ADIABATIC, 2) FROM THE PV-VERTEX
C *
C *   NO MASS-DIFFERENCES BETWEEN BARYONS TAKEN INTO ACCOUNT
C *
C * NOTE THAT IN THE ADIABATIC APPROXIMATION THERE ARE NO CONTRIBUTIONS
C * FROM: PI-EPSILON, PI-POMERON
C
C *
C **********************************************************************
C
C     INCLUDED IN ENERGY-DENOMINATORS:
C     (i) L+R contributions included, 1/4 -> 1/2, the latter is
C         put into FACT,FACT2
C     INCLUDED IN COUPLINGCOMBINATIONS CPANLL ETC.:
C     (ii) 1 <-> 2 interchange effects for non-identical mesons.
C
C **********************************************************************
C
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/PIMAS/PIM0
      COMMON/POTESC/VCLL,VCSS,VCLS,VCDR,VSLL,VSSS,VSLS,VSDR,
     .              VTLL,VTSS,VTLS,VTDR,VOLL,VOSS,VOLS,VODR,
     .              VALL,VASS,VALS,VADR                       
      COMMON/DYNMAS/REDMM,AMLN,AMSN,AMH,AMSS,AMLS,AMNN
      COMMON/FORMF/ALAM,ALMP8,ALMV8,ALMS8,ALMP1,ALMV1,ALMS1,
     .             ALMKA,ALMKS,ALMKP
      COMMON/ALLPS/AME,AMX,AMK,BMK
      COMMON/ALLVC/AVEC(2),AMVEC(2),AMOM,AMFI,AMKS,BMKS
      COMMON/ALLSC/ASI,BSI,AM1SI,AM2SI,ASST,BSST,AMSST,AM2ST,AMD,AMSCK
      COMMON/ALLDF/AMPOM,AMF2,AMA2,AMKSS,GDA(11)
*     COMMON/ALLAX/FA1,FA9,ALPA
      COMMON/COUPL/ F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,F11,
     .              G1,G2,G3,G4,G5,G6,G7,G8,G9,G10,G11,
     .              FD1,FD2,FD3,FD4,FD5,FD6,FD7,FD8,FD9,FD10,FD11,
     .              FV1,FV2,FV3,FV4,FV5,FV6,FV7,FV8,FV9,FV10,FV11,
     .              GS1,GS2,GS3,GS4,GS5,GS6,GS7,GS8,GS9,GS10,GS11,
     .              GD1,GD2,GD3,GD4,GD5,GD6,GD7,GD8,GD9,GD10,GD11,P
      COMMON/FOOMS/FNONC,FNONS,FNONT,FNONO,FPVC,FPVS,FPVT,FPVO
     .            ,FOFFC,FOFFS,FOFFT,FOFFO,FOFFS2,FOFFT2
      COMMON/PSBEOM/
     .VPSPS(5,4,4,4),VPSVC(5,4,4,4),VPSSC(5,4,4,4),VPSDF(5,4,4,4),
     .VSCSC(5,4,4,4),VSCDF(5,4,4,4),VDFDF(5,4,4,4)
      DIMENSION F(11),G(11),FD(11),FV(11),GS(11),GD(11)
      EQUIVALENCE (F1,F(1)),(G1,G(1)),(FD1,FD(1)),(FV1,FV(1))
     . ,(GS1,GS(1)),(GD1,GD(1))
C
      DIMENSION FUN(9),AMSIG(2),ASIG(2)
      COMMON/TREATV/IPIRO,IPIOM,IPIPH,IPIKS
      COMMON/TREATS/IPIDE,IPIEP,IPIST,IPIKSC
      COMMON/TREATD/IPIA2,IPIPOM,IPIKSS
C
      DATA PI/3.14159265D0/,SRPI/1.7724538509D0/,
     . SR2/1.41421356D0/,SR6/2.44948974D0/,SR3/1.732051D0/
      DATA AMPRO/938.2796D0/,AMRO/760.D0/,AMEPS/760.D0/
      DATA ICALL/0/,ISFAC/1/,FACT/70.D0/
      SAVE FACT,AMB,BPV
C
      CALL ERRSET(208,256,-1,1)
C
      pim=pim0
**    pim=500.d0
  12  IF(ICALL.EQ.0) THEN
        BPV  = 2*APV-1.D0
        FACT = PIM0/2.D0
*       FACT = PIM0
*       AMB  = 2*AMNN*AMH/(AMNN+AMH)
        amb  = ampro
        FACT = FACT*(PIM0/AMB)
        PRINT 52, INA,IPV,IOFF,PIM,AMB
   52   FORMAT(//,'  IN OMPIBE: INA, IPV, IOFF=',3I3,' PIM=',F7.3,
     .            ' AMB=',F10.3,/)
        IF(P.EQ.+1.D0) ISFAC=+1
        IF(P.EQ.-1.D0) ISFAC=-3
        DO 750 NCHAN=1,5
        DO 750 ITYPV=1,4
        DO 750 M=1,4
        DO 750 N=1,4
        VPSVC(NCHAN,ITYPV,M,N)=0.D0
        VPSSC(NCHAN,ITYPV,M,N)=0.D0
  750   VPSDF(NCHAN,ITYPV,M,N)=0.D0
*       ICALL=1
      ENDIF
     
C
C     1/M-CORRECTIONS:
C
C A)  PION-VECTOR-MESON POTENTIALS: ******************************
C
      DO 100 II=1,4
      PEX = 1.D0
      GOTO(10,20,30,40),II
C     PI-RHO:
   10 IF(IPIRO.EQ.1) THEN
      M = 1
      N = 1
C     PARALLEL:
      CPANN  =  2*(3-2*ISFAC)*F1**2*FD1**2
      CPALL  =  6*F1*FD1*F3*FD3
      CPALS  =  +2*SR3*F1*FD1*(F3*FD2+F2*FD3)
      CPASS  =  2*F1*FD1*(3*F3*FD3+4*F2*FD2)
      CPADR  =  2*F1*FD1*F2*FD2
C     CROSSED:
      CCRNN  =  2*(3+2*ISFAC)*F1**2*FD1**2
      CCRLL  =  6*F1*FD1*F3*FD3
      CCRLS  =  -2*SR3*F1*FD1*(F3*FD2+F2*FD3)
      CCRSS  =  -2*F1*FD1*F3*FD3
      CCRDR  =  2*F1*FD1*(2*F3*FD3+3*F2*FD2)

*     CALL FOOM(2,X,PIM,AMRO,ALMP8,ALMV8)
      FNONSH=0.D0
      FPVSH =0.D0
      FOFFSH=0.D0
      FNONTH=0.D0
      FPVTH =0.D0
      FOFFTH=0.D0
      DO 710 KK=1,2
      CALL FOOM(2,X,PIM,AMVEC(KK),ALMP8,ALMV8)
      FNONSH=FNONSH+AVEC(KK)*FNONS
      FPVSH =FPVSH +AVEC(KK)*FPVS 
      FOFFSH=FOFFSH+AVEC(KK)*FOFFS
      FNONTH=FNONTH+AVEC(KK)*FNONT
      FPVTH =FPVTH +AVEC(KK)*FPVT 
  710 FOFFTH=FOFFTH+AVEC(KK)*FOFFT
      FNONS = FNONSH
      FPVS  = FPVSH
      FOFFS = FOFFSH
      FNONT = FNONTH
      FPVT  = FPVTH
      FOFFT = FOFFTH
      ENDIF
      GOTO 150
C
C PION-OMEGA EXCHANGE POTENTIALS:
C     PI-OMEGA
   20 IF(IPIOM.EQ.1) THEN
      M = 1
      N = 3
C     PARALLEL:
      CPANN  =  2*ISFAC*F1**2*FD6**2
      CPALL  =  0.D0
      CPALS  =  -SR3*F1*FD6*F3*(FD7+FD8)
      CPASS  =  -4*F1*FD6*F2*FD8
      CPADR  =  +2*F1*FD6*F2*FD8
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  0.D0
      CCRLS  =  -SR3*F1*FD6*F3*(FD7+FD8)
      CCRSS  =  -4*F1*FD6*F2*FD8
      CCRDR  =  +2*F1*FD6*F2*FD8

      CALL FOOM(2,X,PIM,AMOM,ALMP8,ALMV1)
      ENDIF
      GOTO 150

C PION-PHI EXCHANGE POTENTIALS:
   30 IF(IPIPH.EQ.1) THEN
      M = 1
      N = 4
C     PARALLEL:
      CPANN  =  2*ISFAC*F1**2*FD9**2
      CPALL  =  0.D0
      CPALS  =  -SR3*F1*FD9*F3*(FD10+FD11)
      CPASS  =  -4*F1*FD9*F2*FD11
      CPADR  =  +2*F1*FD9*F2*FD11
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  0.D0
      CCRLS  =  -SR3*F1*FD9*F3*(FD10+FD11)
      CCRSS  =  -4*F1*FD9*F2*FD11
      CCRDR  =  +2*F1*FD9*F2*FD11

      CALL FOOM(2,X,PIM,AMFI,ALMP8,ALMV1)
      ENDIF
      GOTO 150

C PION-KSTAR EXCHANGE POTENTIALS:
   40 IF(IPIKS.EQ.1) THEN
      M = 1
      N = 2
      PEX = P
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  6*F1*FD4*F3*FD5
      CPALS  =  -SR3*F1*F3*(FD4**2-FD5**2)
     .          +2*SR3*F1*F2*FD4*FD5
      CPASS  =  F1*FD5*(6*F3*FD4+4*F2*FD5)
      CPADR  =  +4*F1*F2*FD5**2
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  3*(F1*F1*FD4**2+F3*F3*FD5**2)
      CCRLS  =  SR3*(F1**2-F3**2)*FD4*FD5
     .         +2*SR3*F2*F3*FD5**2
      CCRSS  =  5*F1**2*FD5**2+F3*F3*FD4**2
     .         +4*F2*F3*FD4*FD5
      CCRDR  =  2*F1**2*FD5**2+F3**2*FD4**2
     .         +3*F2**2*FD5**2-2*F2*F3*FD4*FD5

      CALL FOOM(2,X,PIM,AMKS,ALMP8,ALMKS)
      ENDIF
      GOTO 150

  150 IF(INA.EQ.1) THEN
      VSLL  =   VSLL - FACT*( CPALL-2*CCRLL )*FNONS*PEX
      VSLS  =   VSLS - FACT*( CPALS-2*CCRLS )*FNONS*PEX
      VSSS  =   VSSS - FACT*( CPASS-2*CCRSS )*FNONS*PEX
      VSDR  =   VSDR - FACT*( CPADR-2*CCRDR )*FNONS*PEX

      VTLL  =   VTLL - FACT*( CPALL-2*CCRLL )*FNONT*PEX
      VTLS  =   VTLS - FACT*( CPALS-2*CCRLS )*FNONT*PEX
      VTSS  =   VTSS - FACT*( CPASS-2*CCRSS )*FNONT*PEX
      VTDR  =   VTDR - FACT*( CPADR-2*CCRDR )*FNONT*PEX

      VPSVC(1,2,M,N)=VPSVC(1,2,M,N)-FACT*(CPANN-2*CCRNN)*FNONS*PEX
      VPSVC(2,2,M,N)=VPSVC(2,2,M,N)-FACT*(CPALL-2*CCRLL)*FNONS*PEX
      VPSVC(3,2,M,N)=VPSVC(3,2,M,N)-FACT*(CPALS-2*CCRLS)*FNONS*PEX
      VPSVC(4,2,M,N)=VPSVC(4,2,M,N)-FACT*(CPASS-2*CCRSS)*FNONS*PEX
      VPSVC(5,2,M,N)=VPSVC(5,2,M,N)-FACT*(CPADR-2*CCRDR)*FNONS*PEX
      ENDIF
      IF(IPV.EQ.1) THEN
      VSLL  =   VSLL + APV*FACT*(      +1*CCRLL )*FPVS*PEX
      VSLS  =   VSLS + APV*FACT*(      +1*CCRLS )*FPVS*PEX
      VSSS  =   VSSS + APV*FACT*(      +1*CCRSS )*FPVS*PEX
      VSDR  =   VSDR + APV*FACT*(      +1*CCRDR )*FPVS*PEX

      VTLL  =   VTLL + APV*FACT*(      +1*CCRLL )*FPVT*PEX
      VTLS  =   VTLS + APV*FACT*(      +1*CCRLS )*FPVT*PEX
      VTSS  =   VTSS + APV*FACT*(      +1*CCRSS )*FPVT*PEX
      VTDR  =   VTDR + APV*FACT*(      +1*CCRDR )*FPVT*PEX

      VPSVC(1,2,M,N)=VPSVC(1,2,M,N)+APV*FACT*CCRNN*FPVS*PEX
      VPSVC(2,2,M,N)=VPSVC(2,2,M,N)+APV*FACT*CCRLL*FPVS*PEX
      VPSVC(3,2,M,N)=VPSVC(3,2,M,N)+APV*FACT*CCRLS*FPVS*PEX
      VPSVC(4,2,M,N)=VPSVC(4,2,M,N)+APV*FACT*CCRSS*FPVS*PEX
      VPSVC(5,2,M,N)=VPSVC(5,2,M,N)+APV*FACT*CCRDR*FPVS*PEX
      ENDIF
      IF(IOFF.EQ.1) THEN
C     PIONIC OFF-SHELL CORRECTIONS INTMO:
      VSLL  =   VSLL + BPV*FACT*CPALL *FOFFS*PEX/3.D0
      VSLS  =   VSLS + BPV*FACT*CPALS *FOFFS*PEX/3.D0
      VSSS  =   VSSS + BPV*FACT*CPASS *FOFFS*PEX/3.D0
      VSDR  =   VSDR + BPV*FACT*CPADR *FOFFS*PEX/3.D0

      VTLL  =   VTLL + BPV*FACT*CPALL *FOFFT*PEX/3.D0
      VTLS  =   VTLS + BPV*FACT*CPALS *FOFFT*PEX/3.D0
      VTSS  =   VTSS + BPV*FACT*CPASS *FOFFT*PEX/3.D0
      VTDR  =   VTDR + BPV*FACT*CPADR *FOFFT*PEX/3.D0

      VPSVC(1,2,M,N)=VPSVC(1,2,M,N)+BPV*FACT*CPANN*FOFFS*PEX/3.D0
      VPSVC(2,2,M,N)=VPSVC(2,2,M,N)+BPV*FACT*CPALL*FOFFS*PEX/3.D0
      VPSVC(3,2,M,N)=VPSVC(3,2,M,N)+BPV*FACT*CPALS*FOFFS*PEX/3.D0
      VPSVC(4,2,M,N)=VPSVC(4,2,M,N)+BPV*FACT*CPASS*FOFFS*PEX/3.D0
      VPSVC(5,2,M,N)=VPSVC(5,2,M,N)+BPV*FACT*CPADR*FOFFS*PEX/3.D0
      ENDIF
*     if(icall.eq.0.and.ii.eq.1) then
*     write(*,*) 'in ompibe, pi-ro: m,n=',m,n
*     write(*,*) 'cpann,ccrnn=',cpann,ccrnn
*     write(*,*) 'cpall,ccrll=',cpall,ccrll
*     write(*,*) 'vpsvc(1,2,m,n)=',vpsvc(1,2,m,n)
*     write(*,*) 'vpsvc(2,2,m,n)=',vpsvc(2,2,m,n)
*     write(*,*) 'vpsvc(3,2,m,n)=',vpsvc(3,2,m,n)
*     write(*,*) 'vpsvc(4,2,m,n)=',vpsvc(4,2,m,n)
*     write(*,*) 'vpsvc(5,2,m,n)=',vpsvc(5,2,m,n)
*     endif
  100 CONTINUE
C END VECTOR MESONS

C
C B) PION-SCALAR MESONS: *****************************************
C
      DO 200 II=1,5
      PEX = 1.D0
      GOTO(11,21,21,41,51),II
C PION-DELTA EXCHANGE POTENTIALS:
   11 IF(IPIDE.EQ.1) THEN
      M = 1
      N = 1
C     PARALLEL:
      CPANN  =  2*(3-2*ISFAC)*F1**2*GS1**2
      CPALL  =  6*F1*GS1*F3*GS3
      CPALS  =  +2*SR3*F1*GS1*(F3*GS2+F2*GS3)
      CPASS  =  2*F1*GS1*(3*F3*GS3+4*F2*GS2)
      CPADR  =  2*F1*GS1*F2*GS2
C     CROSSED:
      CCRNN  =  2*(3+2*ISFAC)*F1**2*GS1**2
      CCRLL  =  6*F1*GS1*F3*GS3
      CCRLS  =  -2*SR3*F1*GS1*(F3*GS2+F2*GS3)
      CCRSS  =  -2*F1*GS1*F3*GS3
      CCRDR  =  2*F1*GS1*(2*F3*GS3+3*F2*GS2)

      CALL FOOM(3,X,PIM,AMD,ALMP8,ALMS8)
      ENDIF
      GOTO 250

C PION-EPSILON EXCHANGE POTENTIALS:
   21 IF(IPIEP.EQ.1) THEN
      M = 1
      N = 3
C     PARALLEL:
      CPANN  =  2*ISFAC*F1**2*GS6**2
      CPALL  =  0.D0
      CPALS  =  -SR3*F1*GS6*F3*(GS8+GS7)
      CPASS  =  -4*F1*GS6*F2*GS8
      CPADR  =  +2*F1*GS6*F2*GS8
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  0.D0
      CCRLS  =  -SR3*F1*GS6*F3*(GS8+GS7)
      CCRSS  =  -4*F1*GS6*F2*GS8
      CCRDR  =  +2*F1*GS6*F2*GS8

      IF(II.EQ.2) THEN
      PEX = ASI
      CALL FOOM(3,X,PIM,AM1SI,ALMP8,ALMS1)
      ELSE
      PEX = BSI
      CALL FOOM(3,X,PIM,AM2SI,ALMP8,ALMS1)
      ENDIF
      ENDIF
      GOTO 250

C PION-SSTAR EXCHANGE POTENTIALS:
   41 IF(IPIST.EQ.1) THEN
      PEX = 1.D0
      M = 1
      N = 4
C     PARALLEL:
      CPANN  =  2*ISFAC*F1**2*GS9**2
      CPALL  =  0.D0
      CPALS  =  -SR3*F1*GS9*F3*(GS11+GS10)
      CPASS  =  -4*F1*GS9*F2*GS11
      CPADR  =  +2*F1*GS9*F2*GS11
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  0.D0
      CCRLS  =  -SR3*F1*GS9*F3*(GS11+GS10)
      CCRSS  =  -4*F1*GS9*F2*GS11
      CCRDR  =  +2*F1*GS9*F2*GS11

      CALL FOOM(3,X,PIM,AMSST,ALMP8,ALMS1)
      ENDIF
      GOTO 250

C PION-KAPPA EXCHANGE POTENTIALS:
   51 IF(IPIKSC.EQ.1) THEN
      PEX = P
      M = 1
      N = 2
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  6*F1*GS4*F3*GS5
      CPALS  =  -SR3*F1*F3*(GS4**2-GS5**2)
     .          +2*SR3*F1*F2*GS4*GS5
      CPASS  =  F1*GS5*(6*F3*GS4+4*F2*GS5)
      CPADR  =  +4*F1*F2*GS5**2
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  3*(F1*F1*GS4**2+F3*F3*GS5**2)
      CCRLS  =  SR3*(F1**2-F3**2)*GS4*GS5
     .         +2*SR3*F2*F3*GS5**2
      CCRSS  =  5*F1**2*GS5**2+F3*F3*GS4**2
     .         +4*F2*F3*GS4*GS5
      CCRDR  =  2*F1**2*GS5**2+F3**2*GS4**2
     .         +3*F2**2*GS5**2-2*F2*F3*GS4*GS5

      CALL FOOM(3,X,PIM,AMSCK,ALMP8,ALMS8)
      ENDIF
      GOTO 250

  250 IF(INA.EQ.1) THEN
      VSLL  =   VSLL + FACT*( CPALL-2*CCRLL )*FNONS*PEX
      VSLS  =   VSLS + FACT*( CPALS-2*CCRLS )*FNONS*PEX
      VSSS  =   VSSS + FACT*( CPASS-2*CCRSS )*FNONS*PEX
      VSDR  =   VSDR + FACT*( CPADR-2*CCRDR )*FNONS*PEX

      VTLL  =   VTLL + FACT*( CPALL-2*CCRLL )*FNONT*PEX
      VTLS  =   VTLS + FACT*( CPALS-2*CCRLS )*FNONT*PEX
      VTSS  =   VTSS + FACT*( CPASS-2*CCRSS )*FNONT*PEX
      VTDR  =   VTDR + FACT*( CPADR-2*CCRDR )*FNONT*PEX

      VPSSC(1,2,M,N)=VPSSC(1,2,M,N)+FACT*(CPANN-2*CCRNN)*FNONS*PEX
      VPSSC(2,2,M,N)=VPSSC(2,2,M,N)+FACT*(CPALL-2*CCRLL)*FNONS*PEX
      VPSSC(3,2,M,N)=VPSSC(3,2,M,N)+FACT*(CPALS-2*CCRLS)*FNONS*PEX
      VPSSC(4,2,M,N)=VPSSC(4,2,M,N)+FACT*(CPASS-2*CCRSS)*FNONS*PEX
      VPSSC(5,2,M,N)=VPSSC(5,2,M,N)+FACT*(CPADR-2*CCRDR)*FNONS*PEX
      ENDIF
      IF(IPV.EQ.1) THEN
      VSLL  =   VSLL - APV*FACT*(      +1*CCRLL )*FPVS*PEX
      VSLS  =   VSLS - APV*FACT*(      +1*CCRLS )*FPVS*PEX
      VSSS  =   VSSS - APV*FACT*(      +1*CCRSS )*FPVS*PEX
      VSDR  =   VSDR - APV*FACT*(      +1*CCRDR )*FPVS*PEX

      VTLL  =   VTLL - APV*FACT*(      +1*CCRLL )*FPVT*PEX
      VTLS  =   VTLS - APV*FACT*(      +1*CCRLS )*FPVT*PEX
      VTSS  =   VTSS - APV*FACT*(      +1*CCRSS )*FPVT*PEX
      VTDR  =   VTDR - APV*FACT*(      +1*CCRDR )*FPVT*PEX

      VPSSC(1,2,M,N)=VPSSC(1,2,M,N)-APV*FACT*CCRNN*FPVS*PEX
      VPSSC(2,2,M,N)=VPSSC(2,2,M,N)-APV*FACT*CCRLL*FPVS*PEX
      VPSSC(3,2,M,N)=VPSSC(3,2,M,N)-APV*FACT*CCRLS*FPVS*PEX
      VPSSC(4,2,M,N)=VPSSC(4,2,M,N)-APV*FACT*CCRSS*FPVS*PEX
      VPSSC(5,2,M,N)=VPSSC(5,2,M,N)-APV*FACT*CCRDR*FPVS*PEX
      ENDIF
      IF(IOFF.EQ.1) THEN
C     PIONIC OFF-SHELL CORRECTIONS INTMO:
      VSLL  =   VSLL - BPV*FACT*CPALL *FOFFS*PEX/3.D0
      VSLS  =   VSLS - BPV*FACT*CPALS *FOFFS*PEX/3.D0
      VSSS  =   VSSS - BPV*FACT*CPASS *FOFFS*PEX/3.D0
      VSDR  =   VSDR - BPV*FACT*CPADR *FOFFS*PEX/3.D0

      VTLL  =   VTLL - BPV*FACT*CPALL *FOFFT*PEX/3.D0
      VTLS  =   VTLS - BPV*FACT*CPALS *FOFFT*PEX/3.D0
      VTSS  =   VTSS - BPV*FACT*CPASS *FOFFT*PEX/3.D0
      VTDR  =   VTDR - BPV*FACT*CPADR *FOFFT*PEX/3.D0

      VPSSC(1,2,M,N)=VPSSC(1,2,M,N)-BPV*FACT*CPANN*FOFFS*PEX/3.D0
      VPSSC(2,2,M,N)=VPSSC(2,2,M,N)-BPV*FACT*CPALL*FOFFS*PEX/3.D0
      VPSSC(3,2,M,N)=VPSSC(3,2,M,N)-BPV*FACT*CPALS*FOFFS*PEX/3.D0
      VPSSC(4,2,M,N)=VPSSC(4,2,M,N)-BPV*FACT*CPASS*FOFFS*PEX/3.D0
      VPSSC(5,2,M,N)=VPSSC(5,2,M,N)-BPV*FACT*CPADR*FOFFS*PEX/3.D0
      ENDIF
  200 CONTINUE
C END SCALAR MESONS

C
C D) BEGIN DIFFRACTIVE CONTRIBUTIONS *******************
C
      DO 300 II=1,3
      PEX = 1.D0
      GOTO(31,32,33),II
C PION-A2 EXCHANGE POTENTIALS:
  31  IF(IPIA2.EQ.1) THEN
      PEX = 1.D0
      M = 1
      N = 1
C     PARALLEL:
      CPANN  =  2*(3-2*ISFAC)*F1**2*GD1**2
      CPALL  =  6*F1*GD1*F3*GD3
      CPALS  =  +2*SR3*F1*GD1*(F3*GD2+F2*GD3)
      CPASS  =  2*F1*GD1*(3*F3*GD3+4*F2*GD2)
      CPADR  =  2*F1*GD1*F2*GD2
C     CROSSED:
      CCRNN  =  2*(3+2*ISFAC)*F1**2*GD1**2
      CCRLL  =  6*F1*GD1*F3*GD3
      CCRLS  =  -2*SR3*F1*GD1*(F3*GD2+F2*GD3)
      CCRSS  =  -2*F1*GD1*F3*GD3
      CCRDR  =  2*F1*GD1*(2*F3*GD3+3*F2*GD2)

      CALL FOOM(4,X,PIM,AMPOM,ALMP8,AMPOM)
      ENDIF
      GOTO 350

C PION-POMERON:
  32  IF(IPIPOM.EQ.1) THEN
      PEX = 1.D0
      M = 1
      N = 3
C     PARALLEL:
      CPANN  =  2*ISFAC*F1**2*GD6**2
      CPALL  =  0.D0
      CPALS  =  -SR3*F1*GD6*F3*(GD8+GD7)
      CPASS  =  -4*F1*GD6*F2*GD8
      CPADR  =  +2*F1*GD6*F2*GD8
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  0.D0
      CCRLS  =  -SR3*F1*GD6*F3*(GD8+GD7)
      CCRSS  =  -4*F1*GD6*F2*GD8
      CCRDR  =  +2*F1*GD6*F2*GD8

      CALL FOOM(4,X,PIM,AMPOM,ALMP8,AMPOM)
      ENDIF
      GOTO 350

C PION-K** EXCHANGE POTENTIALS:
  33  IF(IPIKSS.EQ.1) THEN
      PEX = P
      M = 1
      N = 2
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  6*F1*GD4*F3*GD5
      CPALS  =  -SR3*F1*F3*(GD4**2-GD5**2)
     .          +2*SR3*F1*F2*GD4*GD5
      CPASS  =  F1*GD5*(6*F3*GD4+4*F2*GD5)
      CPADR  =  +4*F1*F2*GD5**2
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  3*(F1*F1*GD4**2+F3*F3*GD5**2)
      CCRLS  =  SR3*(F1**2-F3**2)*GD4*GD5
     .         +2*SR3*F2*F3*GD5**2
      CCRSS  =  5*F1**2*GD5**2+F3*F3*GD4**2
     .         +4*F2*F3*GD4*GD5
      CCRDR  =  2*F1**2*GD5**2+F3**2*GD4**2
     .         +3*F2**2*GD5**2-2*F2*F3*GD4*GD5

      CALL FOOM(4,X,PIM,AMPOM,ALMP8,AMPOM)
      ENDIF
      GOTO 350

  350 IF(INA.EQ.1) THEN
      VSLL  =   VSLL - FACT*( CPALL-2*CCRLL )*FNONS*PEX
      VSLS  =   VSLS - FACT*( CPALS-2*CCRLS )*FNONS*PEX
      VSSS  =   VSSS - FACT*( CPASS-2*CCRSS )*FNONS*PEX
      VSDR  =   VSDR - FACT*( CPADR-2*CCRDR )*FNONS*PEX

      VTLL  =   VTLL - FACT*( CPALL-2*CCRLL )*FNONT*PEX
      VTLS  =   VTLS - FACT*( CPALS-2*CCRLS )*FNONT*PEX
      VTSS  =   VTSS - FACT*( CPASS-2*CCRSS )*FNONT*PEX
      VTDR  =   VTDR - FACT*( CPADR-2*CCRDR )*FNONT*PEX

      VPSDF(1,2,M,N)=VPSDF(1,2,M,N)-FACT*(CPANN-2*CCRNN)*FNONS*PEX
      VPSDF(2,2,M,N)=VPSDF(2,2,M,N)-FACT*(CPALL-2*CCRLL)*FNONS*PEX
      VPSDF(3,2,M,N)=VPSDF(3,2,M,N)-FACT*(CPALS-2*CCRLS)*FNONS*PEX
      VPSDF(4,2,M,N)=VPSDF(4,2,M,N)-FACT*(CPASS-2*CCRSS)*FNONS*PEX
      VPSDF(5,2,M,N)=VPSDf(5,2,M,N)-FACT*(CPADR-2*CCRDR)*FNONS*PEX
      ENDIF
      IF(IPV.EQ.1) THEN
      VSLL  =   VSLL + APV*FACT*(      +1*CCRLL )*FPVS*PEX
      VSLS  =   VSLS + APV*FACT*(      +1*CCRLS )*FPVS*PEX
      VSSS  =   VSSS + APV*FACT*(      +1*CCRSS )*FPVS*PEX
      VSDR  =   VSDR + APV*FACT*(      +1*CCRDR )*FPVS*PEX

      VTLL  =   VTLL + APV*FACT*(      +1*CCRLL )*FPVT*PEX
      VTLS  =   VTLS + APV*FACT*(      +1*CCRLS )*FPVT*PEX
      VTSS  =   VTSS + APV*FACT*(      +1*CCRSS )*FPVT*PEX
      VTDR  =   VTDR + APV*FACT*(      +1*CCRDR )*FPVT*PEX

      VPSDF(1,2,M,N)=VPSDF(1,2,M,N)+APV*FACT*CCRNN*FPVS*PEX
      VPSDF(2,2,M,N)=VPSDF(2,2,M,N)+APV*FACT*CCRLL*FPVS*PEX
      VPSDF(3,2,M,N)=VPSDF(3,2,M,N)+APV*FACT*CCRLS*FPVS*PEX
      VPSDF(4,2,M,N)=VPSDF(4,2,M,N)+APV*FACT*CCRSS*FPVS*PEX
      VPSDF(5,2,M,N)=VPSDF(5,2,M,N)+APV*FACT*CCRDR*FPVS*PEX
      ENDIF
      IF(IOFF.EQ.1) THEN
C     PIONIC OFF-SHELL CORRECTIONS INTMO:
      VSLL  =   VSLL + BPV*FACT*CPALL *FOFFS*PEX/3.D0
      VSLS  =   VSLS + BPV*FACT*CPALS *FOFFS*PEX/3.D0
      VSSS  =   VSSS + BPV*FACT*CPASS *FOFFS*PEX/3.D0
      VSDR  =   VSDR + BPV*FACT*CPADR *FOFFS*PEX/3.D0

      VTLL  =   VTLL + BPV*FACT*CPALL *FOFFT*PEX/3.D0
      VTLS  =   VTLS + BPV*FACT*CPALS *FOFFT*PEX/3.D0
      VTSS  =   VTSS + BPV*FACT*CPASS *FOFFT*PEX/3.D0
      VTDR  =   VTDR + BPV*FACT*CPADR *FOFFT*PEX/3.D0

      VPSDF(1,2,M,N)=VPSDF(1,2,M,N)+BPV*FACT*CPANN*FOFFS*PEX/3.D0
      VPSDF(2,2,M,N)=VPSDF(2,2,M,N)+BPV*FACT*CPALL*FOFFS*PEX/3.D0
      VPSDF(3,2,M,N)=VPSDF(3,2,M,N)+BPV*FACT*CPALS*FOFFS*PEX/3.D0
      VPSDF(4,2,M,N)=VPSDF(4,2,M,N)+BPV*FACT*CPASS*FOFFS*PEX/3.D0
      VPSDF(5,2,M,N)=VPSDF(5,2,M,N)+BPV*FACT*CPADR*FOFFS*PEX/3.D0
      ENDIF
  300 CONTINUE
C END DIFFRACTIVE CONTRIBUTIONS

      ICALL = 1
C  1  CONTINUE

1000  CALL ERRSET(208,256,1,1)
      RETURN
C END OMPIBE ROUTINE ***************************************************
      END
C **********************************************************************
      SUBROUTINE OMPSBE(X,INA,IPV,IOFF,APV)
C **********************************************************************
C *
C *   DATE: AUGUST 1995, COMPLETED DECEMBER 96
C
C     THIS ROUTINE: KAON-MESON AND ETA(P)-MESON YN-POTENTIALS
C          +++++++  AND THE DOUBLE SCALAR/DIFFRACTIVE YN-POTENTIALS
C *   (MESON= VECTOR, SCALAR, DIFFR.)
C *                 CALLED BY SUBROUTINE YNPSBE
C *
C *   1/M-CONTRIBUTIONS: 1) NON-ADIABATIC, 2) FROMTHE PV-VERTEX
C *
C *   NO MASS-DIFFERENCES BETWEEN BARYONS TAKEN INTO ACCOUNT
C *
C * NOTE THAT IN THE ADIABATIC APPROXIMATION THERE ARE NO CONTRIBUTIONS
C * FROM: PI-EPSILON, PI-POMERON
C
C **********************************************************************
C
C     INCLUDED IN ENERGY-DENOMINATORS:
C     (i) L+R contributions included, 1/4 -> 1/2, the latter is
C         put into FACT,FACT2
C     INCLUDED IN COUPLINGCOMBINATIONS CPANLL ETC.:
C     (ii) 1 <-> 2 interchange effects for non-identical mesons.
C
C **********************************************************************
C
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/PIMAS/PIM0
      COMMON/DYNMAS/REDMM,AMLN,AMSN,AMH,AMSS,AMLS,AMNN
      COMMON/POTESC/VCLL,VCSS,VCLS,VCDR,VSLL,VSSS,VSLS,VSDR,
     .              VTLL,VTSS,VTLS,VTDR,VOLL,VOSS,VOLS,VODR,
     .              VALL,VASS,VALS,VADR                       
      COMMON/FORMF/ALAM,ALMP8,ALMV8,ALMS8,ALMP1,ALMV1,ALMS1,
     .             ALMKA,ALMKS,ALMKAP
      COMMON/COUCON/ALP,XZ1(3),ALVD,XZ2(2),ALVV,XZ3(12),ALS,XZ4,ALD,
     .ALPAX
      COMMON/ALLPS/AME,AMX,AMK,BMK
      COMMON/ALLVC/AVEC(2),AMVEC(2),AMOM,AMFI,AMKS,BMKS
      COMMON/ALLSC/ASIG(2),AMSIG(2),ASST,BSST,AMSST,AM2ST,AMD,AMSCK
      COMMON/ALLDF/AMPOM,AMF2,AMA2,AMKSS,GDA(11)
*     COMMON/ALLAX/FA1,FA9,ALPAX
      COMMON/XICOUPL/XF12,XF13,XFD12,XFD13,XFV12,XFV13,XGS12,XGS13,
     .XGD12,XGD13
      COMMON/PSBEOM/
     .VPSPS(5,4,4,4),VPSVC(5,4,4,4),VPSSC(5,4,4,4),VPSDF(5,4,4,4),
     .VSCSC(5,4,4,4),VSCDF(5,4,4,4),VDFDF(5,4,4,4)
C
      DIMENSION FUN(9)

      COMMON/COUPL/ F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,F11,
     .              G1,G2,G3,G4,G5,G6,G7,G8,G9,G10,G11,
     .              FD1,FD2,FD3,FD4,FD5,FD6,FD7,FD8,FD9,FD10,FD11,
     .              FV1,FV2,FV3,FV4,FV5,FV6,FV7,FV8,FV9,FV10,FV11,
     .              GS1,GS2,GS3,GS4,GS5,GS6,GS7,GS8,GS9,GS10,GS11,
     .              GD1,GD2,GD3,GD4,GD5,GD6,GD7,GD8,GD9,GD10,GD11,P
      COMMON/FOOMS/FNONC,FNONS,FNONT,FNONO,FPVC,FPVS,FPVT,FPVO
     .            ,FOFFC,FOFFS,FOFFT,FOFFO,FOFFS2,FOFFT2
      DIMENSION F(11),G(11),FD(11),FV(11),GS(11),GD(11)
      EQUIVALENCE (F1,F(1)),(G1,G(1)),(FD1,FD(1)),(FV1,FV(1))
     . ,(GS1,GS(1)),(GD1,GD(1))

      DATA IKARO/1/,IKAOM/1/,IKAPH/1/,IKAKS/1/,IKADE/1/,IKAEP/1/,
     .     IKAST/1/,IKAKSC/1/,IKAA2/1/,IKAPOM/1/,IKAKSS/1/,
     .     IETKSC/1/,IETPKP/1/,IETAKS/1/,IETPKS/1/,IEPEP/0/,
     .     IETRHO/1/,IETOME/1/,IETPHI/1/,IETPRH/1/,IETPOM/1/,IETPPH/1/,
     .     IETDE/1/,IETEP/1/,IETST/1/,IETPDE/1/,IETPEP/1/,IETPST/1/,
     .     IETA2/1/,IETPO/1/,IETKD/1/,IETPA2/1/,IETPPO/1/,IETPKD/1/
C
      DATA PI/3.14159265D0/,SRPI/1.7724538509D0/,
     . SR2/1.41421356D0/,SR6/2.44948974D0/,SR3/1.732051D0/
      DATA AMPRO/938.2796D0/,AMRO/760.D0/,AMEPS/760.D0/
      DATA ICALL/0/,NSCHR/1/,ISFAC/1/,FACT/70.D0/
      SAVE AMN,FACT,BPV
C
      CALL ERRSET(208,256,-1,1)
C
      pim=pim0
**    pim=500.d0
      IF(ICALL.EQ.0) THEN
        BPV = 2*APV-1.D0
        AMN = AMPRO
        FACT = PIM0/2.D0
*       FACT = PIM0
        AMB = 2*AMNN*AMH/(AMNN+AMH)
        amb=ampro
        FACT = FACT*(PIM0/AMB)
        IF(P.EQ.+1.D0) ISFAC=+1
        IF(P.EQ.-1.D0) ISFAC=-3
        ISFLL = (1+ISFAC)/2
        ISFLS = (3-ISFAC)
        ISFSS = (9+ISFAC)/2
        PRINT 52, INA,IPV,IOFF,PIM,AMB
   52   FORMAT(//,'  IN OMPSBE: INA, IPV, IOFF=',3I3,' PIM=',F7.3,
     .            ' AMB=',F10.3,/)
*       ICALL=1
      ENDIF
     
C     XI-COUPLINGS:
      XF12 = F1*(4*ALP-1.D0)/SR3
      XF13 = -F1
      XFD12 = FD1*(4*ALVD-1.D0)/SR3
      XFD13 = -FD1
      XFV12 = FV1*(4*ALVV-1.D0)/SR3
      XFV13 = -FV1
      XGS12 = GS1*(4*ALS-1.D0)/SR3
      XGS13 = -GS1
      XGD12 = GD1*(4*ALD-1.D0)/SR3
      XGD13 = -GD1
C
C     1/M-CORRECTIONS:
C
C A)  PSEUDO-SCALAR-VECTOR-MESON POTENTIALS: ********************
C
      DO 100 II=1,12
      PEX = 1.D0
      GOTO(101,102,103,104,105,106,107,108,109,110,111,112), II
*     KA-RHO:
  101 IF(IKARO.EQ.1) THEN
      PEX = P
      M = 2
      N = 1
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  6*FD1*FD3*F4*F5
      CPALS  =  +2*SR3*FD1*FD2*F4*F5-SR3*FD1*FD3*(F4**2-F5**2)
      CPASS  =  6*FD1*FD3*F4*F5+4*FD1*FD2*F5**2
      CPADR  =  4*FD1*FD2*F5**2
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  3*(FD1**2*F4**2+FD3**2*F5**2)
      CCRLS  =  SR3*(FD1**2*F4*F5-FD3**2*F4*F5+2*FD2*FD3*F5**2)
      CCRSS  =  5*FD1**2*F5**2+FD3**2*F4**2+4*FD2*FD3*F4*F5
      CCRDR  =  2*FD1**2*F5**2+FD3**2*F4**2+
     .          3*FD2**2*F5**2-2*FD2*FD3*F4*F5

      CALL FOOM(2,X,AMK,AMRO,ALMKA,ALMV8)
      ENDIF
      GOTO 150
C
C KAON-OMEGA EXCHANGE POTENTIALS:
  102 IF(IKAOM.EQ.1) THEN
      PEX = P
      M = 2
      N = 3
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  2*FD6*FD7*F4**2
      CPALS  =  -SR3*FD6*(FD7+FD8)*F4*F5
      CPASS  =  -2*FD6*FD8*F5**2
      CPADR  =  -2*CPASS
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  (FD6**2+FD7**2)*F4**2
      CCRLS  =  -SR3*(FD6**2+FD7*FD8)*F4*F5
      CCRSS  =  -(FD6**2+FD8**2)*F5**2
      CCRDR  =  -2*CCRSS
      CALL FOOM(2,X,AMK,AMOM,ALMKA,ALMV1)
      ENDIF
      GOTO 150

C KAON-PHI EXCHANGE POTENTIALS:
  103 IF(IKAPH.EQ.1) THEN
      PEX = P
      M = 2
      N = 4
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  2*FD9*FD10*F4**2
      CPALS  =  -SR3*FD9*(FD10+FD11)*F4*F5
      CPASS  =  -2*FD9*FD11*F5**2
      CPADR  =  -2*CPASS
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  (FD9**2+FD10**2)*F4**2
      CCRLS  =  -SR3*(FD9**2+FD10*FD11)*F4*F5
      CCRSS  =  -(FD9**2+FD11**2)*F5**2
      CCRDR  =  -2*CCRSS
      CALL FOOM(2,X,AMK,AMFI,ALMKA,ALMV8)
      ENDIF
      GOTO 150

C KAON-KSTAR EXCHANGE POTENTIALS:
  104 IF(IKAKS.EQ.1) THEN
      PEX = 1.D0
      M = 2
      N = 2
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  2*(FD4**2*F4**2+3*FD4*FD5*F4*F5)
      CPALS  =  SR3*(FD5**2*F4*F5+FD4*FD5*F5**2
     .          -FD4**2*F4*F5-FD4*FD5*F4**2)
      CPASS  =  2*(3*FD4*FD5*F4*F5+FD5**2*F5**2)
      CPADR  =  8*FD5**2*F5**2
C     CROSSED:
      CCRNN  =  2*(ISFLL*F4**2*FD4**2+ISFLS*F4*F5*FD4*FD5+
     .             ISFSS*F5**2*FD5**2)
      CCRLL  =  2*(FD4*XFD12*F4*XF12+3*FD5*XFD12*F5*XF12)
      CCRLS  =  SR3*(FD4*F4-FD5*F5)*(XFD13*XF12+XFD12*XF13)
      CCRSS  = -2*FD4*XFD13*F4*XF13+10*FD5*XFD13*F5*XF13
      CCRDR  =  4*(FD5*F5*XFD13*XF13+FD4*F4*XFD13*XF13)
      CALL FOOM(2,X,AMK,AMKS,ALMKA,ALMKS)
      ENDIF
      GOTO 150

C ETA-RHO EXCHANGE POTENTIALS:
  105 IF(IETRHO.EQ.1) THEN
      PEX = 1.D0
      M = 3
      N = 1
C     PARALLEL:
      CPANN  =  2*ISFAC*FD1**2*F6**2
      CPALL  =  0.D0            
      CPALS  =  -SR3*FD1*FD3*F6*(F7+F8)
      CPASS  =  -4*FD1*FD2*F6*F8
      CPADR  =  -0.5D0*CPASS
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL                  	
      CCRLS  =  CPALS                       
      CCRSS  =  CPASS                   
      CCRDR  =  CPADR     
      CALL FOOM(2,X,AME,AMRO,ALMP8,ALMV8)
      ENDIF
      GOTO 150

C ETA-KSTAR EXCHANGE POTENTIALS:
  106 IF(IETAKS.EQ.1) THEN
      PEX = P
      M = 3
      N = 2
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  2*FD4**2*F6*F7
      CPALS  =  -SR3*FD4*FD5*F6*(F7+F8)
      CPASS  =  -2*FD5**2*F6*F8
      CPADR  =  -2*CPASS
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  FD4**2*(F6**2+F7**2)
      CCRLS  =  -SR3*FD4*FD5*(F6**2+F7*F8)
      CCRSS  =  -FD5**2*(F6**2+F8**2)
      CCRDR  =  -2*CCRSS
      CALL FOOM(2,X,AME,AMKS,ALMP8,ALMKS)
      ENDIF
      GOTO 150

C ETA-OMEGA EXCHANGE POTENTIALS:
  107 IF(IETOME.EQ.1) THEN
      PEX = 1.D0
      M = 3
      N = 3
C     PARALLEL:
      CPANN  =  2*FD6*FD6*F6*F6 
      CPALL  =  2*FD6*FD7*F6*F7 
      CPALS  =  0.D0                         
      CPASS  =  2*FD6*FD8*F6*F8 
      CPADR  =  CPASS
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL                  	
      CCRLS  =  CPALS                       
      CCRSS  =  CPASS                   
      CCRDR  =  CPADR     
      CALL FOOM(2,X,AME,AMOM,ALMP8,ALMV1)
      ENDIF
      GOTO 150

C ETA-PHI EXCHANGE POTENTIALS:
  108 IF(IETPHI.EQ.1) THEN
      PEX = 1.D0
      M = 3
      N = 4
C     PARALLEL:
      CPANN  =  2*FD9*FD9*F6*F6 
      CPALL  =  2*FD9*FD10*F6*F7 
      CPALS  =  0.D0                         
      CPASS  =  2*FD9*FD11*F6*F8 
      CPADR  =  CPASS
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL                  	
      CCRLS  =  CPALS                       
      CCRSS  =  CPASS                   
      CCRDR  =  CPADR     
      CALL FOOM(2,X,AME,AMFI,ALMP8,ALMV8)
      ENDIF
      GOTO 150

C ETAP-RHO EXCHANGE POTENTIALS:
  109 IF(IETPRH.EQ.1) THEN
      PEX = 1.D0
      M = 4
      N = 1
C     PARALLEL:
      CPANN  =  2*ISFAC*FD1**2*F9**2
      CPALL  =  0.D0            
      CPALS  =  -SR3*FD1*FD3*F9*(F10+F11)
      CPASS  =  -4*FD1*FD2*F9*F11
      CPADR  =  -0.5D0*CPASS
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL                  	
      CCRLS  =  CPALS                       
      CCRSS  =  CPASS                   
      CCRDR  =  CPADR     
      CALL FOOM(2,X,AMX,AMRO,ALMP1,ALMV8)
      ENDIF
      GOTO 150

C ETAP-KSTAR EXCHANGE POTENTIALS:
  110 IF(IETPKS.EQ.1) THEN
      PEX = P
      M = 4
      N = 2
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  2*FD4**2*F9*F10
      CPALS  =  -SR3*FD4*FD5*F9*(F10+F11)
      CPASS  =  -2*FD5**2*F9*F11
      CPADR  =  -2*CPASS
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  FD4**2*(F9**2+F10**2)
      CCRLS  =  -SR3*FD4*FD5*(F9**2+F10*F11)
      CCRSS  =  -FD5**2*(F9**2+F11**2)
      CCRDR  =  -2*CCRSS
      CALL FOOM(2,X,AMX,AMKS,ALMP1,ALMKS)
      ENDIF
      GOTO 150

C ETAP-OMEGA EXCHANGE POTENTIALS:
  111 IF(IETPOM.EQ.1) THEN
      PEX = 1.D0
      M = 4
      N = 3
C     PARALLEL:
      CPANN  =  2*FD6*FD6*F9*F9 
      CPALL  =  2*FD6*FD7*F9*F10 
      CPALS  =  0.D0                         
      CPASS  =  2*FD6*FD8*F9*F11 
      CPADR  =  CPASS
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL                  	
      CCRLS  =  CPALS                       
      CCRSS  =  CPASS                   
      CCRDR  =  CPADR     
      CALL FOOM(2,X,AMX,AMOM,ALMP1,ALMV1)
      ENDIF
      GOTO 150

C ETAP-PHI EXCHANGE POTENTIALS:
  112 IF(IETPPH.EQ.1) THEN
      PEX = 1.D0
      M = 4
      N = 4
C     PARALLEL:
      CPANN  =  2*FD9*FD9*F9*F9 
      CPALL  =  2*FD9*FD10*F9*F10 
      CPALS  =  0.D0                         
      CPASS  =  2*FD9*FD11*F9*F11 
      CPADR  =  CPASS
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL                  	
      CCRLS  =  CPALS                       
      CCRSS  =  CPASS                   
      CCRDR  =  CPADR     
      CALL FOOM(2,X,AMX,AMFI,ALMP1,ALMV8)
      ENDIF
      GOTO 150

  150 IF(INA.EQ.1) THEN
      VSLL  =   VSLL - FACT*( CPALL-2*CCRLL )*FNONS*PEX
      VSLS  =   VSLS - FACT*( CPALS-2*CCRLS )*FNONS*PEX
      VSSS  =   VSSS - FACT*( CPASS-2*CCRSS )*FNONS*PEX
      VSDR  =   VSDR - FACT*( CPADR-2*CCRDR )*FNONS*PEX

      VTLL  =   VTLL - FACT*( CPALL-2*CCRLL )*FNONT*PEX
      VTLS  =   VTLS - FACT*( CPALS-2*CCRLS )*FNONT*PEX
      VTSS  =   VTSS - FACT*( CPASS-2*CCRSS )*FNONT*PEX
      VTDR  =   VTDR - FACT*( CPADR-2*CCRDR )*FNONT*PEX

      VPSVC(1,2,M,N)=VPSVC(1,2,M,N)-FACT*(CPANN-2*CCRNN)*FNONS*PEX
      VPSVC(2,2,M,N)=VPSVC(2,2,M,N)-FACT*(CPALL-2*CCRLL)*FNONS*PEX
      VPSVC(3,2,M,N)=VPSVC(3,2,M,N)-FACT*(CPALS-2*CCRLS)*FNONS*PEX
      VPSVC(4,2,M,N)=VPSVC(4,2,M,N)-FACT*(CPASS-2*CCRSS)*FNONS*PEX
      VPSVC(5,2,M,N)=VPSVC(5,2,M,N)-FACT*(CPADR-2*CCRDR)*FNONS*PEX
      ENDIF
      IF(IPV.EQ.1) THEN
      VSLL  =   VSLL + APV*FACT*(      +1*CCRLL )*FPVS *PEX
      VSLS  =   VSLS + APV*FACT*(      +1*CCRLS )*FPVS *PEX
      VSSS  =   VSSS + APV*FACT*(      +1*CCRSS )*FPVS *PEX
      VSDR  =   VSDR + APV*FACT*(      +1*CCRDR )*FPVS *PEX

      VTLL  =   VTLL + APV*FACT*(      +1*CCRLL )*FPVT *PEX
      VTLS  =   VTLS + APV*FACT*(      +1*CCRLS )*FPVT *PEX
      VTSS  =   VTSS + APV*FACT*(      +1*CCRSS )*FPVT *PEX
      VTDR  =   VTDR + APV*FACT*(      +1*CCRDR )*FPVT *PEX

      VPSVC(1,2,M,N)=VPSVC(1,2,M,N)+APV*FACT*CCRNN*FPVS*PEX
      VPSVC(2,2,M,N)=VPSVC(2,2,M,N)+APV*FACT*CCRLL*FPVS*PEX
      VPSVC(3,2,M,N)=VPSVC(3,2,M,N)+APV*FACT*CCRLS*FPVS*PEX
      VPSVC(4,2,M,N)=VPSVC(4,2,M,N)+APV*FACT*CCRSS*FPVS*PEX
      VPSVC(5,2,M,N)=VPSVC(5,2,M,N)+APV*FACT*CCRDR*FPVS*PEX
      ENDIF
      IF(IOFF.EQ.1) THEN
C     PIONIC OFF-SHELL CORRECTIONS INTMO:
      VSLL  =   VSLL + BPV*FACT*CPALL *FOFFS*PEX/3.D0
      VSLS  =   VSLS + BPV*FACT*CPALS *FOFFS*PEX/3.D0
      VSSS  =   VSSS + BPV*FACT*CPASS *FOFFS*PEX/3.D0
      VSDR  =   VSDR + BPV*FACT*CPADR *FOFFS*PEX/3.D0

      VTLL  =   VTLL + BPV*FACT*CPALL *FOFFT*PEX/3.D0
      VTLS  =   VTLS + BPV*FACT*CPALS *FOFFT*PEX/3.D0
      VTSS  =   VTSS + BPV*FACT*CPASS *FOFFT*PEX/3.D0
      VTDR  =   VTDR + BPV*FACT*CPADR *FOFFT*PEX/3.D0

      VPSVC(1,2,M,N)=VPSVC(1,2,M,N)+BPV*FACT*CPANN*FOFFS*PEX/3.D0
      VPSVC(2,2,M,N)=VPSVC(2,2,M,N)+BPV*FACT*CPALL*FOFFS*PEX/3.D0
      VPSVC(3,2,M,N)=VPSVC(3,2,M,N)+BPV*FACT*CPALS*FOFFS*PEX/3.D0
      VPSVC(4,2,M,N)=VPSVC(4,2,M,N)+BPV*FACT*CPASS*FOFFS*PEX/3.D0
      VPSVC(5,2,M,N)=VPSVC(5,2,M,N)+BPV*FACT*CPADR*FOFFS*PEX/3.D0
      ENDIF
  100 CONTINUE
c     if(icall.eq.0.and.nschr.eq.1) call wromtm(2,x,p)
**    if(icall.eq.20.and.nschr.eq.1) call wromtm(2,x,p)
C END VECTOR MESONS

C
C B) PSEUDO-SCALAR-SCALAR MESONS: ******************************
C
      DO 200 II=1,3  
      DO 200 JJ=1,5
      KK = 5*(II-1)+JJ
      GOTO(11,12,12,13,14,15,16,16,17,18,19,20,20,21,22),KK
C KAON-DELTA EXCHANGE POTENTIALS:
   11 IF(IKADE.EQ.1) THEN
      PEX = P
      M = 2
      N = 1
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  6*GS1*GS3*F4*F5
      CPALS  =  +2*SR3*GS1*GS2*F4*F5-SR3*GS1*GS3*(F4**2-F5**2)
      CPASS  =  6*GS1*GS3*F4*F5+4*GS1*GS2*F5**2
      CPADR  =  4*GS1*GS2*F5**2
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  3*(GS1**2*F4**2+GS3**2*F5**2)
      CCRLS  =  SR3*(GS1**2*F4*F5-GS3**2*F4*F5+2*GS2*GS3*F5**2)
      CCRSS  =  5*GS1**2*F5**2+GS3**2*F4**2+4*GS2*GS3*F4*F5
      CCRDR  =  2*GS1**2*F5**2+GS3**2*F4**2+
     .          3*GS2**2*F5**2-2*GS2*GS3*F4*F5
      CALL FOOM(3,X,AMK,AMD,ALMKA,ALMS8)
      ENDIF
      GOTO 250

C KAON-EPSILON EXCHANGE POTENTIALS:
   12 IF(IKAEP.EQ.1) THEN
      PEX = P
      M = 2
      N = 3
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  2*GS6*GS7*F4**2
      CPALS  =  -SR3*GS6*(GS7+GS8)*F4*F5
      CPASS  =  -2*GS6*GS8*F5**2
      CPADR  =  -2*CPASS
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  (GS6**2+GS7**2)*F4**2
      CCRLS  =  -SR3*(GS6**2+GS7*GS8)*F4*F5
      CCRSS  =  -(GS6**2+GS8**2)*F5**2
      CCRDR  =  -2*CCRSS
      IF(JJ.EQ.2) THEN
       PEX = ASIG(1)*P
       CALL FOOM(3,X,AMK,AMSIG(1),ALMKA,ALMS1)
       ELSE
       PEX = ASIG(2)*P
       CALL FOOM(3,X,AMK,AMSIG(2),ALMKA,ALMS1)
      ENDIF
      ENDIF
      GOTO 250

C KAON-SSTAR EXCHANGE POTENTIALS:
   13 IF(IKAST.EQ.1) THEN
      PEX = P
      M = 2
      N = 4
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  2*GS9*GS10*F4**2
      CPALS  =  -SR3*GS9*(GS10+GS11)*F4*F5
      CPASS  =  -2*GS9*GS11*F5**2
      CPADR  =  -2*CPASS
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  (GS9**2+GS10**2)*F4**2
      CCRLS  =  -SR3*(GS9**2+GS10*GS11)*F4*F5
      CCRSS  =  -(GS9**2+GS11**2)*F5**2
      CCRDR  =  -2*CCRSS
      CALL FOOM(3,X,AMK,AMSST,ALMKA,ALMS1)
      ENDIF
      GOTO 250

C KAON-KAPPA EXCHANGE POTENTIALS:
   14 IF(IKAKSC.EQ.1) THEN
      PEX = 1.D0
      M = 2
      N = 2
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  2*(GS4**2*F4**2+3*GS4*GS5*F4*F5)
      CPALS  =  SR3*(GS5**2*F4*F5+GS4*GS5*F5**2
     .          -GS4**2*F4*F5-GS4*GS5*F4**2)
      CPASS  =  2*(3*GS4*GS5*F4*F5+GS5**2*F5**2)
      CPADR  =  8*GS5**2*F5**2
C     CROSSED:
      CCRNN  =  2*(ISFLL*F4**2*GS4**2+ISFLS*F4*F5*GS4*GS5+
     .             ISFSS*F5**2*GS5**2)
      CCRLL  =  2*(GS4*XGS12*F4*XF12+3*GS5*XGS12*F5*XF12)
      CCRLS  =  SR3*(GS4*F4-GS5*F5)*(XGS13*XF12+XGS12*XF13)
      CCRSS  = -2*GS4*XGS13*F4*XF13+10*GS5*XGS13*F5*XF13
      CCRDR  =  4*(GS5*F5*XGS13*XF13+GS4*F4*XGS13*XF13)
      CALL FOOM(3,X,AMK,AMSCK,ALMKA,ALMS8)
      ENDIF
      GOTO 250

C ETA-DELTA EXCHANGE POTENTIALS:
   15 IF(IETDE.EQ.1) THEN
      PEX = 1.D0
      M = 3
      N = 1
C     PARALLEL:
      CPANN  =  2*ISFAC*GS1**2*F6**2
      CPALL  =  0.D0              
      CPALS  =  -SR3*GS1*GS3*F6*(F7+F8)                           
      CPASS  =  -4*GS1*GS2*F6*F8                 
      CPADR  =  -0.5D0*CPASS    
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL                           
      CCRLS  =  CPALS                                            
      CCRSS  =  CPASS                                         
      CCRDR  =  CPADR                          
      CALL FOOM(3,X,AME,AMD,ALMP8,ALMS8)
      ENDIF
      GOTO 250

C ETA-EPSILON EXCHANGE POTENTIALS:
   16 IF(IETEP.EQ.1) THEN
      PEX = 1.D0
      M = 3
      N = 3
C     PARALLEL:
      CPANN  =  2*GS6**2*F6**2
      CPALL  =  2*GS6*GS7*F6*F7 
      CPALS  =  0.D0                        
      CPASS  =  2*GS6*GS8*F6*F8  
      CPADR  =  CPASS
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL                    
      CCRLS  =  0.D0                         
      CCRSS  =  CPASS                    
      CCRDR  =  CPADR    
      IF(JJ.EQ.2) THEN
       PEX = ASIG(1)
       CALL FOOM(3,X,AME,AMSIG(1),ALMP8,ALMS1)
       ELSE
       PEX = ASIG(2)
       CALL FOOM(3,X,AME,AMSIG(2),ALMP8,ALMS1)
      ENDIF
      ENDIF
      GOTO 250

C ETA-SSTAR EXCHANGE POTENTIALS:
   17 IF(IETST.EQ.1) THEN
      PEX = 1.D0
      M = 3
      N = 4
C     PARALLEL:
      CPANN  =  2*GS9**2*F6**2
      CPALL  =  2*GS9*GS10*F6*F7 
      CPALS  =  0.D0                           
      CPASS  =  2*GS9*GS11*F6*F8 
      CPADR  =  CPASS
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL                     
      CCRLS  =  0.D0                             
      CCRSS  =  CPASS                    
      CCRDR  =  CPADR  
      CALL FOOM(3,X,AME,AMSST,ALMP8,ALMS8)
      ENDIF
      GOTO 250

C ETA-KAPPA EXCHANGE POTENTIALS:
   18 IF(IETKSC.EQ.1) THEN
      PEX = P    
      M = 3
      N = 2
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  2*GS4**2*F6*F7
      CPALS  =  -SR3*GS4*GS5*F6*(F7+F8)
      CPASS  =  -2*GS5**2*F6*F8
      CPADR  =  -2*CPASS
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  GS4**2*(F6**2+F7**2)
      CCRLS  =  -SR3*GS4*GS5*(F6**2+F7*F8)
      CCRSS  =  -GS5**2*(F6**2+F8**2)
      CCRDR  =  -2*CCRSS
      CALL FOOM(3,X,AME,AMSCK,ALMP1,ALMS8)
      ENDIF
      GOTO 250

C ETAP-DELTA EXCHANGE POTENTIALS:
   19 IF(IETPDE.EQ.1) THEN
      PEX = 1.D0 
      M = 4
      N = 1
C     PARALLEL:
      CPANN  =  2*ISFAC*GS1**2*F9**2
      CPALL  =  0.D0              
      CPALS  =  -SR3*GS1*GS3*F9*(F10+F11)                           
      CPASS  =  -4*GS1*GS2*F9*F11                 
      CPADR  =  -0.5D0*CPASS    
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL                           
      CCRLS  =  CPALS                                            
      CCRSS  =  CPASS                                         
      CCRDR  =  CPADR                          
      CALL FOOM(3,X,AMX,AMD,ALMP1,ALMS8)
      ENDIF
      GOTO 250

C ETAP-EPSILON EXCHANGE POTENTIALS:
   20 IF(IETPEP.EQ.1) THEN
      PEX = 1.D0 
      M = 4
      N = 3
C     PARALLEL:
      CPANN  =  2*GS6*GS6*F9*F9  
      CPALL  =  2*GS6*GS7*F9*F10 
      CPALS  =  0.D0                        
      CPASS  =  2*GS6*GS8*F9*F11  
      CPADR  =  CPASS
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL                    
      CCRLS  =  0.D0                         
      CCRSS  =  CPASS                    
      CCRDR  =  CPADR    
      IF(JJ.EQ.2) THEN
       PEX = ASIG(1)
       CALL FOOM(3,X,AMX,AMSIG(1),ALMP1,ALMS1)
       ELSE
       PEX = ASIG(2)
       CALL FOOM(3,X,AMX,AMSIG(2),ALMP1,ALMS1)
      ENDIF
      ENDIF
      GOTO 250

C ETAP-SSTAR EXCHANGE POTENTIALS:
   21 IF(IETPST.EQ.1) THEN
      PEX = 1.D0 
      M = 4
      N = 4
C     PARALLEL:
      CPANN  =  2*GS9*GS9*F9*F9  
      CPALL  =  2*GS9*GS10*F9*F10 
      CPALS  =  0.D0                           
      CPASS  =  2*GS9*GS11*F9*F11 
      CPADR  =  CPASS
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL                     
      CCRLS  =  0.D0                             
      CCRSS  =  CPASS                    
      CCRDR  =  CPADR  
      CALL FOOM(3,X,AMX,AMSST,ALMP1,ALMS8)
      ENDIF
      GOTO 250

C ETAP-KAPPA EXCHANGE POTENTIALS:
   22 IF(IETPKP.EQ.1) THEN
      PEX = P    
      M = 4
      N = 2
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  2*GS4**2*F9*F10
      CPALS  =  -SR3*GS4*GS5*F9*(F10+F11)
      CPASS  =  -2*GS5**2*F9*F11
      CPADR  =  -2*CPASS
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  GS4**2*(F9**2+F10**2)
      CCRLS  =  -SR3*GS4*GS5*(F9**2+F10*F11)
      CCRSS  =  -GS5**2*(F9**2+F11**2)
      CCRDR  =  -2*CCRSS
      CALL FOOM(3,X,AMX,AMSCK,ALMP1,ALMS8)
      ENDIF
      GOTO 250

  250 IF(INA.EQ.1) THEN
      VSLL  =   VSLL + FACT*( CPALL-2*CCRLL )*FNONS*PEX
      VSLS  =   VSLS + FACT*( CPALS-2*CCRLS )*FNONS*PEX
      VSSS  =   VSSS + FACT*( CPASS-2*CCRSS )*FNONS*PEX
      VSDR  =   VSDR + FACT*( CPADR-2*CCRDR )*FNONS*PEX

      VTLL  =   VTLL + FACT*( CPALL-2*CCRLL )*FNONT*PEX
      VTLS  =   VTLS + FACT*( CPALS-2*CCRLS )*FNONT*PEX
      VTSS  =   VTSS + FACT*( CPASS-2*CCRSS )*FNONT*PEX
      VTDR  =   VTDR + FACT*( CPADR-2*CCRDR )*FNONT*PEX

      VPSSC(1,2,M,N)=VPSSC(1,2,M,N)+FACT*(CPANN-2*CCRNN)*FNONS*PEX
      VPSSC(2,2,M,N)=VPSSC(2,2,M,N)+FACT*(CPALL-2*CCRLL)*FNONS*PEX
      VPSSC(3,2,M,N)=VPSSC(3,2,M,N)+FACT*(CPALS-2*CCRLS)*FNONS*PEX
      VPSSC(4,2,M,N)=VPSSC(4,2,M,N)+FACT*(CPASS-2*CCRSS)*FNONS*PEX
      VPSSC(5,2,M,N)=VPSSC(5,2,M,N)+FACT*(CPADR-2*CCRDR)*FNONS*PEX
      ENDIF
      IF(IPV.EQ.1) THEN
      VSLL  =   VSLL - APV*FACT*(      +1*CCRLL )*FPVS *PEX
      VSLS  =   VSLS - APV*FACT*(      +1*CCRLS )*FPVS *PEX
      VSSS  =   VSSS - APV*FACT*(      +1*CCRSS )*FPVS *PEX
      VSDR  =   VSDR - APV*FACT*(      +1*CCRDR )*FPVS *PEX

      VTLL  =   VTLL - APV*FACT*(      +1*CCRLL )*FPVT *PEX
      VTLS  =   VTLS - APV*FACT*(      +1*CCRLS )*FPVT *PEX
      VTSS  =   VTSS - APV*FACT*(      +1*CCRSS )*FPVT *PEX
      VTDR  =   VTDR - APV*FACT*(      +1*CCRDR )*FPVT *PEX

      VPSSC(1,2,M,N)=VPSSC(1,2,M,N)-APV*FACT*CCRNN*FPVS*PEX
      VPSSC(2,2,M,N)=VPSSC(2,2,M,N)-APV*FACT*CCRLL*FPVS*PEX
      VPSSC(3,2,M,N)=VPSSC(3,2,M,N)-APV*FACT*CCRLS*FPVS*PEX
      VPSSC(4,2,M,N)=VPSSC(4,2,M,N)-APV*FACT*CCRSS*FPVS*PEX
      VPSSC(5,2,M,N)=VPSSC(5,2,M,N)-APV*FACT*CCRDR*FPVS*PEX
      ENDIF
      IF(IOFF.EQ.1) THEN
C     PIONIC OFF-SHELL CORRECTIONS INTMO:
      VSLL  =   VSLL - BPV*FACT*CPALL *FOFFS*PEX/3.D0
      VSLS  =   VSLS - BPV*FACT*CPALS *FOFFS*PEX/3.D0
      VSSS  =   VSSS - BPV*FACT*CPASS *FOFFS*PEX/3.D0
      VSDR  =   VSDR - BPV*FACT*CPADR *FOFFS*PEX/3.D0

      VTLL  =   VTLL - BPV*FACT*CPALL *FOFFT*PEX/3.D0
      VTLS  =   VTLS - BPV*FACT*CPALS *FOFFT*PEX/3.D0
      VTSS  =   VTSS - BPV*FACT*CPASS *FOFFT*PEX/3.D0
      VTDR  =   VTDR - BPV*FACT*CPADR *FOFFT*PEX/3.D0

      VPSSC(1,2,M,N)=VPSSC(1,2,M,N)-BPV*FACT*CPANN*FOFFS*PEX/3.D0
      VPSSC(2,2,M,N)=VPSSC(2,2,M,N)-BPV*FACT*CPALL*FOFFS*PEX/3.D0
      VPSSC(3,2,M,N)=VPSSC(3,2,M,N)-BPV*FACT*CPALS*FOFFS*PEX/3.D0
      VPSSC(4,2,M,N)=VPSSC(4,2,M,N)-BPV*FACT*CPASS*FOFFS*PEX/3.D0
      VPSSC(5,2,M,N)=VPSSC(5,2,M,N)-BPV*FACT*CPADR*FOFFS*PEX/3.D0
      ENDIF
  200 CONTINUE
c     if(icall.eq.0.and.nschr.eq.1) call wromtm(3,x,p)
**    if(icall.eq.20.and.nschr.eq.1) call wromtm(3,x,p)
C END SCALAR MESONS
C
C D) BEGIN DIFFRACTIVE CONTRIBUTIONS *******************
C
      DO 300 II=1,9
      GOTO(31,32,33,34,35,36,37,38,39), II
C KAON-A2 EXCHANGE POTENTIALS:
   31 IF(IKAA2.EQ.1) THEN
      PEX = P
      M = 2
      N = 1
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  6*GD1*GD3*F4*F5
      CPALS  =  +2*SR3*GD1*GD2*F4*F5-SR3*GD1*GD3*(F4**2-F5**2)
      CPASS  =  6*GD1*GD3*F4*F5+4*GD1*GD2*F5**2
      CPADR  =  4*GD1*GD2*F5**2
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  3*(GD1**2*F4**2+GD3**2*F5**2)
      CCRLS  =  SR3*(GD1**2*F4*F5-GD3**2*F4*F5+2*GD2*GD3*F5**2)
      CCRSS  =  5*GD1**2*F5**2+GD3**2*F4**2+4*GD2*GD3*F4*F5
      CCRDR  =  2*GD1**2*F5**2+GD3**2*F4**2+
     .          3*GD2**2*F5**2-2*GD2*GD3*F4*F5
      CALL FOOM(4,X,AMK,AMPOM,ALMKA,AMPOM)
      ENDIF
      GOTO 350

C KAON-POMERON:
   32 IF(IKAPOM.EQ.1) THEN
      PEX = P
      M = 2
      N = 3
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  2*GD6*GD7*F4**2
      CPALS  =  -SR3*GD6*(GD7+GD8)*F4*F5
      CPASS  =  -2*GD6*GD8*F5**2
      CPADR  =  -2*CPASS
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  (GD6**2+GD7**2)*F4**2
      CCRLS  =  -SR3*(GD6**2+GD7*GD8)*F4*F5
      CCRSS  =  -(GD6**2+GD8**2)*F5**2
      CCRDR  =  -2*CCRSS
      CALL FOOM(4,X,AMK,AMPOM,ALMKA,AMPOM)
      ENDIF
      GOTO 350

C KAON-K** EXCHANGE POTENTIALS:
   33 IF(IKAKSS.EQ.1) THEN
      PEX = 1.D0
      M = 2
      N = 2
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  2*(GD4**2*F4**2+3*GD4*GD5*F4*F5)
      CPALS  =  SR3*(GD5**2*F4*F5+GD4*GD5*F5**2
     .          -GD4**2*F4*F5-GD4*GD5*F4**2)
      CPASS  =  2*(3*GD4*GD5*F4*F5+GD5**2*F5**2)
      CPADR  =  8*GD5**2*F5**2
C     CROSSED:
      CCRNN  =  2*(ISFLL*F4**2*GD4**2+ISFLS*F4*F5*GD4*GD5+
     .             ISFSS*F5**2*GD5**2)
      CCRLL  =  2*(GD4*XGD12*F4*XF12+3*GD5*XGD12*F5*XF12)
      CCRLS  =  SR3*(GD4*F4-GD5*F5)*(XGD13*XF12+XGD12*XF13)
      CCRSS  = -2*GD4*XGD13*F4*XF13+10*GD5*XGD13*F5*XF13
      CCRDR  =  4*(GD5*F5*XGD13*XF13+GD4*F4*XGD13*XF13)
      CALL FOOM(4,X,AMK,AMPOM,ALMKA,AMPOM)
      ENDIF
      GOTO 350

C ETA-A2 EXCHANGE POTENTIALS:
   34 IF(IETA2.EQ.1) THEN
      PEX = 1.D0
      M = 3
      N = 1
C     PARALLEL:
      CPANN  =  2*ISFAC*GD1**2*F6**2
      CPALL  =  0.D0             
      CPALS  =  -SR3*GD1*GD3*F6*(F7+F8)                         
      CPASS  =  -4*GD1*GD2*F6*F8                   
      CPADR  =  +2*GD1*GD2*F6*F8 
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  0.D0                             
      CCRLS  =  CPALS                                             
      CCRSS  =  CPASS                                          
      CCRDR  =  CPADR                          
      CALL FOOM(4,X,AME,AMPOM,ALMP8,AMPOM)
      ENDIF
      GOTO 350

C ETA-POMERON EXCHANGE POTENTIALS:
   35 IF(IETPO.EQ.1) THEN
      PEX = 1.D0
      M = 3
      N = 3
C     PARALLEL:
      CPANN  =  2*GD6**2*F6**2   
      CPALL  =  2*GD6*GD7*F6*F7   
      CPALS  =  0.D0                                            
      CPASS  =  2*GD6*GD8*F6*F8                    
      CPADR  =  CPASS                  
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL                            
      CCRLS  =  0.D0                                              
      CCRSS  =  CPASS                                          
      CCRDR  =  CPADR                          
      CALL FOOM(4,X,AME,AMPOM,ALMP8,AMPOM)
      ENDIF
      GOTO 350

C ETA-K** EXCHANGE POTENTIALS:
   36 IF(IETKD.EQ.1) THEN
      PEX = P    
      M = 3
      N = 2
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  2*GD4**2*F6*F7   
      CPALS  =  -SR3*GD4*GD5*F6*(F7+F8)                         
      CPASS  =  -2*GD5**2*F6*F8                    
      CPADR  =  -2*CPASS                  
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  GD4**2*(F6**2+F7**2)             
      CCRLS  =  -SR3*GD4*GD5*(F6**2+F7*F8)                        
      CCRSS  =  -GD5**2*(F6**2+F8**2)                          
      CCRDR  =  -2*CCRSS                           
      CALL FOOM(4,X,AME,AMPOM,ALMP8,AMPOM)
      ENDIF
      GOTO 350

C ETAP-A2 EXCHANGE POTENTIALS:
   37 IF(IETPA2.EQ.1) THEN
      PEX = 1.D0
      M = 4
      N = 2
C     PARALLEL:
      CPANN  =  2*ISFAC*GD1**2*F9**2
      CPALL  =  0.D0             
      CPALS  =  -SR3*GD1*GD3*F9*(F10+F11)                         
      CPASS  =  -4*GD1*GD2*F9*F11                   
      CPADR  =  +2*GD1*GD2*F9*F11 
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  0.D0                             
      CCRLS  =  CPALS                                             
      CCRSS  =  CPASS                                          
      CCRDR  =  CPADR                          
      CALL FOOM(4,X,AMX,AMPOM,ALMP1,AMPOM)
      ENDIF
      GOTO 350

C ETAP-POMERON EXCHANGE POTENTIALS:
   38 IF(IETPPO.EQ.1) THEN
      PEX = 1.D0
      M = 4
      N = 3
C     PARALLEL:
      CPANN  =  2*GD6**2*F9**2   
      CPALL  =  2*GD6*GD7*F9*F10  
      CPALS  =  0.D0                                            
      CPASS  =  2*GD6*GD8*F9*F11                    
      CPADR  =  CPASS                  
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL                            
      CCRLS  =  0.D0                                              
      CCRSS  =  CPASS                                          
      CCRDR  =  CPADR                          
      CALL FOOM(4,X,AMX,AMPOM,ALMP1,AMPOM)
      ENDIF
      GOTO 350

C ETAP-K** EXCHANGE POTENTIALS:
   39 IF(IETPKD.EQ.1) THEN
      PEX = P    
      M = 4
      N = 2
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  2*GD4**2*F9*F10   
      CPALS  =  -SR3*GD4*GD5*F9*(F10+F11)                         
      CPASS  =  -2*GD5**2*F9*F11                    
      CPADR  =  -2*CPASS                  
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  GD4**2*(F9**2+F10**2)             
      CCRLS  =  -SR3*GD4*GD5*(F9**2+F10*F11)                        
      CCRSS  =  -GD5**2*(F9**2+F11**2)                          
      CCRDR  =  -2*CCRSS                           
      CALL FOOM(4,X,AMX,AMPOM,ALMP1,AMPOM)
      ENDIF
      GOTO 350

  350 IF(INA.EQ.1) THEN
      VSLL  =   VSLL - FACT*( CPALL-2*CCRLL )*FNONS*PEX
      VSLS  =   VSLS - FACT*( CPALS-2*CCRLS )*FNONS*PEX
      VSSS  =   VSSS - FACT*( CPASS-2*CCRSS )*FNONS*PEX
      VSDR  =   VSDR - FACT*( CPADR-2*CCRDR )*FNONS*PEX

      VTLL  =   VTLL - FACT*( CPALL-2*CCRLL )*FNONT*PEX
      VTLS  =   VTLS - FACT*( CPALS-2*CCRLS )*FNONT*PEX
      VTSS  =   VTSS - FACT*( CPASS-2*CCRSS )*FNONT*PEX
      VTDR  =   VTDR - FACT*( CPADR-2*CCRDR )*FNONT*PEX

      VPSDF(1,2,M,N)=VPSDF(1,2,M,N)-FACT*(CPANN-2*CCRNN)*FNONS*PEX
      VPSDF(2,2,M,N)=VPSDF(2,2,M,N)-FACT*(CPALL-2*CCRLL)*FNONS*PEX
      VPSDF(3,2,M,N)=VPSDF(3,2,M,N)-FACT*(CPALS-2*CCRLS)*FNONS*PEX
      VPSDF(4,2,M,N)=VPSDF(4,2,M,N)-FACT*(CPASS-2*CCRSS)*FNONS*PEX
      VPSDF(5,2,M,N)=VPSDf(5,2,M,N)-FACT*(CPADR-2*CCRDR)*FNONS*PEX
      ENDIF
      IF(IPV.EQ.1) THEN
      VSLL  =   VSLL + APV*FACT*(      +1*CCRLL )*FPVS *PEX
      VSLS  =   VSLS + APV*FACT*(      +1*CCRLS )*FPVS *PEX
      VSSS  =   VSSS + APV*FACT*(      +1*CCRSS )*FPVS *PEX
      VSDR  =   VSDR + APV*FACT*(      +1*CCRDR )*FPVS *PEX

      VTLL  =   VTLL + APV*FACT*(      +1*CCRLL )*FPVT *PEX
      VTLS  =   VTLS + APV*FACT*(      +1*CCRLS )*FPVT *PEX
      VTSS  =   VTSS + APV*FACT*(      +1*CCRSS )*FPVT *PEX
      VTDR  =   VTDR + APV*FACT*(      +1*CCRDR )*FPVT *PEX

      VPSDF(1,2,M,N)=VPSDF(1,2,M,N)+APV*FACT*CCRNN*FPVS*PEX
      VPSDF(2,2,M,N)=VPSDF(2,2,M,N)+APV*FACT*CCRLL*FPVS*PEX
      VPSDF(3,2,M,N)=VPSDF(3,2,M,N)+APV*FACT*CCRLS*FPVS*PEX
      VPSDF(4,2,M,N)=VPSDF(4,2,M,N)+APV*FACT*CCRSS*FPVS*PEX
      VPSDF(5,2,M,N)=VPSDF(5,2,M,N)+APV*FACT*CCRDR*FPVS*PEX
      ENDIF
      IF(IOFF.EQ.1) THEN
C     PIONIC OFF-SHELL CORRECTIONS INTMO:
      VSLL  =   VSLL + BPV*FACT*CPALL *FOFFS*PEX/3.D0
      VSLS  =   VSLS + BPV*FACT*CPALS *FOFFS*PEX/3.D0
      VSSS  =   VSSS + BPV*FACT*CPASS *FOFFS*PEX/3.D0
      VSDR  =   VSDR + BPV*FACT*CPADR *FOFFS*PEX/3.D0

      VTLL  =   VTLL + BPV*FACT*CPALL *FOFFT*PEX/3.D0
      VTLS  =   VTLS + BPV*FACT*CPALS *FOFFT*PEX/3.D0
      VTSS  =   VTSS + BPV*FACT*CPASS *FOFFT*PEX/3.D0
      VTDR  =   VTDR + BPV*FACT*CPADR *FOFFT*PEX/3.D0

      VPSDF(1,2,M,N)=VPSDF(1,2,M,N)+BPV*FACT*CPANN*FOFFS*PEX/3.D0
      VPSDF(2,2,M,N)=VPSDF(2,2,M,N)+BPV*FACT*CPALL*FOFFS*PEX/3.D0
      VPSDF(3,2,M,N)=VPSDF(3,2,M,N)+BPV*FACT*CPALS*FOFFS*PEX/3.D0
      VPSDF(4,2,M,N)=VPSDF(4,2,M,N)+BPV*FACT*CPASS*FOFFS*PEX/3.D0
      VPSDF(5,2,M,N)=VPSDF(5,2,M,N)+BPV*FACT*CPADR*FOFFS*PEX/3.D0
      ENDIF
  300 CONTINUE
c     if(icall.eq.0.and.nschr.eq.1) call wromtm(4,x,p)
**    if(icall.eq.20.and.nschr.eq.1) call wromtm(4,x,p)
C END DIFFRACTIVE CONTRIBUTIONS

1000  CALL ERRSET(208,256,1,1)
        ICALL=ICALL+1
      RETURN
C END OMPSBE ROUTINE ***************************************************
      END
C **********************************************************************
      SUBROUTINE OMSCDF(X,INA)
C **********************************************************************
C *
C *   DATE: DECEMBER 1996
C
C     THIS ROUTINE: THE DOUBLE SCALAR/DIFFRACTIVE YN-POTENTIALS
C *
C *   1/M-CONTRIBUTIONS: 1) NON-ADIABATIC 
C *
C *   NO MASS-DIFFERENCES BETWEEN BARYONS TAKEN INTO ACCOUNT
C *
C **********************************************************************
C
C     INCLUDED IN ENERGY-DENOMINATORS:
C     (i) L+R contributions included, 1/4 -> 1/2, the latter is
C         put into FACT,FACT2
C     INCLUDED IN COUPLINGCOMBINATIONS CPANLL ETC.:
C     (ii) 1 <-> 2 interchange effects for non-identical mesons.
C
C **********************************************************************
C
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/PIMAS/PIM0
      COMMON/DYNMAS/REDMM,AMLN,AMSN,AMH,AMSS,AMLS,AMNN
      COMMON/POTESC/VCLL,VCSS,VCLS,VCDR,VSLL,VSSS,VSLS,VSDR,
     .              VTLL,VTSS,VTLS,VTDR,VOLL,VOSS,VOLS,VODR,
     .              VALL,VASS,VALS,VADR                      
      COMMON/FORMF/ALAM,ALMP8,ALMV8,ALMS8,ALMP1,ALMV1,ALMS1,
     .             ALMKA,ALMKS,ALMKAP
      COMMON/COUCON/ALP,XZ1(3),ALVD,XZ2(2),ALVV,XZ3(12),ALS,XZ4,ALD,
     .ALPAX
      COMMON/ALLSC/ASIG(2),AMSIG(2),ASST,BSST,AMSST,AM2ST,AMD,AMSCK
      COMMON/ALLDF/AMPOM,AMF2,AMA2,AMKSS,GDA(11)
      COMMON/XICOUPL/XF12,XF13,XFD12,XFD13,XFV12,XFV13,XGS12,XGS13,
     .XGD12,XGD13
      COMMON/PSBEOM/
     .VPSPS(5,4,4,4),VPSVC(5,4,4,4),VPSSC(5,4,4,4),VPSDF(5,4,4,4),
     .VSCSC(5,4,4,4),VSCDF(5,4,4,4),VDFDF(5,4,4,4)
C
      COMMON/COUPL/ F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,F11,
     .              G1,G2,G3,G4,G5,G6,G7,G8,G9,G10,G11,
     .              FD1,FD2,FD3,FD4,FD5,FD6,FD7,FD8,FD9,FD10,FD11,
     .              FV1,FV2,FV3,FV4,FV5,FV6,FV7,FV8,FV9,FV10,FV11,
     .              GS1,GS2,GS3,GS4,GS5,GS6,GS7,GS8,GS9,GS10,GS11,
     .              GD1,GD2,GD3,GD4,GD5,GD6,GD7,GD8,GD9,GD10,GD11,P
      COMMON/FOOMS/FNONC,FNONS,FNONT,FNONO,FPVC,FPVS,FPVT,FPVO
     .            ,FOFFC,FOFFS,FOFFT,FOFFO,FOFFS2,FOFFT2
      DIMENSION F(11),G(11),FD(11),FV(11),GS(11),GD(11)
      EQUIVALENCE (F1,F(1)),(G1,G(1)),(FD1,FD(1)),(FV1,FV(1))
     . ,(GS1,GS(1)),(GD1,GD(1))

      DATA IEPEP/1/,ICALL/0/,NSCHR/1/
C
      DATA PI/3.14159265D0/,SRPI/1.7724538509D0/,
     . SR2/1.41421356D0/,SR6/2.44948974D0/,SR3/1.732051D0/
      DATA AMPRO/938.2796D0/,AMEPS/760.D0/
      SAVE AMN,FACT
C
      CALL ERRSET(208,256,-1,1)
C
      pim=pim0
c     pim=500.d0
      IF(ICALL.EQ.0) THEN
        AMN = AMPRO
        FACT = PIM0/2.D0
*       FACT = PIM0
*       AMB = 2*AMNN*AMH/(AMNN+AMH)
        amb=ampro
        FACT = FACT*(PIM0/AMB)
        IF(P.EQ.+1.D0) ISFAC=+1
        IF(P.EQ.-1.D0) ISFAC=-3
        ISFLL = (1+ISFAC)/2
        ISFLS = (3-ISFAC)
        ISFSS = (9+ISFAC)/2
        DO 250 NCHAN=1,5
        DO 250 ITYPV=1,4
        DO 250 M=1,4
        DO 250 N=1,4
        VSCSC(NCHAN,ITYPV,M,N)=0.D0
        VSCDF(NCHAN,ITYPV,M,N)=0.D0
  250   VDFDF(NCHAN,ITYPV,M,N)=0.D0
*       ICALL=1
      ENDIF
C
C     1/M-CORRECTIONS:
C **************************************************************
C E) BEGIN DOUBLE SCALAR/DIFFRACTIVE EXCHANGE 
C **************************************************************
C
      IF(INA.EQ.1.AND.IEPEP.EQ.1) THEN
C
C     DOUBLE SCALAR CONTRIBUTIONS:
C
      DO 100 II=1,10
      CPALS = 0.D0
      CCRLS = 0.D0
      GOTO(1,2,3,4,5,6,7,8,9,10), II         
C
C DELTA-DELTA EXCHANGE POTENTIALS:
C     PARALLEL:
    1 PEX = 1.D0 
      M = 1
      N = 1
C     PARALLEL:
      CPANN  =  1*(3-2*ISFAC)*GS1**2*GS1**2
      CPALL  =  3*GS1**2*GS3**2            
      CPALS  =  1*SR3*GS1**2*(GS3*GS2+GS2*GS3)
      CPASS  =  1*GS1**2*(3*GS3**2+4*GS2**2)
      CPADR  =  1*GS1**2*GS2**2    
C     CROSSED:
      CCRNN  =  1*(3+2*ISFAC)*GS1**2*GS1**2
      CCRLL  =  3*GS1**2*GS3**2                
      CCRLS  = -1*SR3*GS1**2*(GS3*GS2+GS2*GS3)      
      CCRSS  = -1*GS1**2*GS3**2                
      CCRDR  =  1*GS1**2*(2*GS3**2+3*GS2**2)     

      CALL FOOM(5,X,AMD,AMD,ALMS8,ALMS8)
      GOTO 150
C
C DELTA-KAPPA EXCHANGE POTENTIALS:
    2 PEX = P    
      M = 1
      N = 2
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  6*GS1*GS3*GS4*GS5
      CPALS  =  2*SR3*GS1*GS2*GS4*Gs5-SR3*GS1*GS3*(GS4**2-GS5**2)
      CPASS  =  6*GS1*GS3*GS4*GS5+4*GS1*GS2*GS5**2
      CPADR  =  4*GS1*GS2*GS5**2
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  3*(GS1**2*GS4**2+GS3**2*GS5**2)
      CCRLS  =  SR3*(GS1**2*GS4*GS5-GS3**2*GS4*GS5+2*Gs2*GS3*GS5**2)
      CCRSS  =  5*GS1**2*GS5**2+GS3**2*GS4**2+4*Gs2*GS3*GS4*Gs5
      CCRDR  =  2*GS1**2*GS5**2+GS3**2*GS4**2+
     .          3*GS2**2*GS5**2-2*GS2*GS3*GS4*GS5
      CALL FOOM(5,X,AMD,AMSCK,ALMS8,ALMS8)
      GOTO 150
C
C KAPPA-KAPPA EXCHANGE POTENTIALS:
C     PARALLEL:
    3 PEX = 1.D0 
      M = 2
      N = 2
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  1*(GS4**4+3*GS4**2*GS5**2)
      CPALS  =  1*SR3*(GS5**2-GS4**2)*GS4*GS5
      CPASS  =  1*(3*GS4**2+GS5**2)*GS5**2
      CPADR  =  4*GS5**4
C     CROSSED:
      CCRNN  =  1*(ISFLL*GS4**2*GS4**2+ISFLS*GS4*GS5*GS4*GS5+
     .             ISFSS*GS5**2*GS5**2)
      CCRLL  =  1*(GS4**2+3*GS5**2)*XGS12**2
      CCRLS  =  1*SR3*(GS4*GS4-GS5*GS5)*XGS13*XGS12
      CCRSS  = -1*(GS4**2-5*GS5**2)*XGS13**2
      CCRDR  =  2*(GS5*GS5+GS4*GS4)*XGS13**2     

      CALL FOOM(5,X,AMSCK,AMSCK,ALMS8,ALMS8)
      GOTO 150
C
C S*-DELTA EXCHANGE POTENTIALS:
C     PARALLEL:
    4 PEX = 1.D0
      M = 1
      N = 4
      CPANN  =  2*ISFAC*GS1**2*GS9**2
      CPALL  =  0.D0           
      CPALS  =  -SR3*GS1*GS3*GS9*(GS10+GS11)
      CPASS  =  -4*GS1*GS2*GS9*GS11
      CPADR  =  -0.5D0*CPASS
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  0.D0     
      CCRLS  =  CPALS 
      CCRSS  =  CPASS
      CCRDR  =  CPADR
      CALL FOOM(5,X,AMSST,AMD,ALMS8,ALMS8)
      GOTO 150
C
C S*-KAPPA EXCHANGE POTENTIALS:
C     PARALLEL:
    5 PEX = P    
      M = 2
      N = 4
      CPANN  =  0.D0
      CPALL  =  2*GS4**2*GS9*GS10
      CPALS  =  -SR3*GS4*GS5*GS9*(GS10+GS11)
      CPASS  =  -2*GS5**2*GS9*GS11
      CPADR  =  -2*CPASS
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  GS4**2*(GS9**2+GS10**2)
      CCRLS  =  -SR3*GS4*GS5*(G9**2+GS10*GS11) 
      CCRSS  =  -GS5**2*(GS9**2+GS11**2)
      CCRDR  =  -2*CCRSS
      CALL FOOM(5,X,AMSST,AMSCK,ALMS8,ALMS8)
      GOTO 150
C
C S*-S* EXCHANGE POTENTIALS:
C     PARALLEL:
    6 PEX = 1.D0
      M = 4
      N = 4
      CPANN  =  GS9**2*GS9**2
      CPALL  =  GS9**2*GS10**2
      CPASS  =  GS9**2*GS11**2
      CPADR  =  CPASS
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL
      CCRSS  =  CPASS
      CCRDR  =  CPADR
      CALL FOOM(5,X,AMSST,AMSST,ALMS8,ALMS8)
      GOTO 150
C
C EPSILON-DELTA EXCHANGE POTENTIALS:
C     PARALLEL:
    7 PEX = 1.D0
      M = 1
      N = 3
      CPANN  =  2*ISFAC*GS1**2*GS6**2
      CPALL  =  0.D0           
      CPALS  =  -SR3*GS1*GS3*GS6*(GS7+GS8)
      CPASS  =  -4*GS1*GS2*GS6*GS8
      CPADR  =  -0.5D0*CPASS
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  0.D0     
      CCRLS  =  CPALS 
      CCRSS  =  CPASS
      CCRDR  =  CPADR
      FNONH = 0.D0
      DO 101 JJ=1,2
*     CALL FOOM(5,X,AMEPS,AMD,ALMS1,ALMS8)
      CALL FOOM(5,X,AMSIG(JJ),AMD,ALMS1,ALMS8)
  101 FNONH = FNONH + FNONC*ASIG(JJ)
      FNONC = FNONH
      GOTO 150
C EPSILON-KAPPA EXCHANGE POTENTIALS:
C     PARALLEL:
    8 PEX = P    
      M = 2
      N = 3
      CPANN  =  0.D0
      CPALL  =  2*GS4**2*GS6*GS7
      CPALS  =  -SR3*GS4*GS5*GS6*(GS7+GS8)
      CPASS  =  -2*GS5**2*GS6*GS8
      CPADR  =  -2*CPASS
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  GS4**2*(GS6**2+GS7**2)
      CCRLS  =  -SR3*GS4*GS5*(GS6**2+GS7*GS8) 
      CCRSS  =  -GS5**2*(GS6**2+GS8**2)
      CCRDR  =  -2*CCRSS
      FNONH = 0.D0
      DO 102 JJ=1,2
*     CALL FOOM(5,X,AMEPS,AMSCK,ALMS1,ALMS8)
      CALL FOOM(5,X,AMSIG(JJ),AMSCK,ALMS1,ALMS8)
  102 FNONH = FNONH + FNONC*ASIG(JJ)
      FNONC = FNONH
      GOTO 150
C
C EPSILON-S* EXCHANGE POTENTIALS:
C     PARALLEL:
    9 PEX = 1.D0
      M = 3
      N = 4
      CPANN  =  2*GS6**2*GS9**2
      CPALL  =  2*GS6*GS7*GS9*GS10
      CPASS  =  2*GS6*GS8*GS9*GS11
      CPADR  =  CPASS
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL
      CCRSS  =  CPASS
      CCRDR  =  CPADR
      FNONH = 0.D0
      DO 103 JJ=1,2
*     CALL FOOM(5,X,AMEPS,AMSST,ALMS1,ALMS8)
      CALL FOOM(5,X,AMSIG(JJ),AMSST,ALMS1,ALMS8)
  103 FNONH = FNONH + FNONC*ASIG(JJ)
      FNONC = FNONH
      GOTO 150
C
C EPSILON-EPSILON EXCHANGE POTENTIALS:
C     PARALLEL:
   10 PEX = 1.D0
      M = 3
      N = 3
      CPANN  =  GS6**2*GS6**2
      CPALL  =  GS6**2*GS7**2
      CPASS  =  GS6**2*GS8**2
      CPADR  =  CPASS
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL
      CCRSS  =  CPASS
      CCRDR  =  CPADR
      FNONH = 0.D0
      DO 104 JJ=1,2
      DO 104 KK=1,2
*     CALL FOOM(5,X,AMEPS,AMEPS,ALMS1,ALMS1)
      CALL FOOM(5,X,AMSIG(JJ),AMSIG(KK),ALMS1,ALMS1)
  104 FNONH = FNONH + FNONC*ASIG(JJ)*ASIG(KK)
      FNONC = FNONH
      GOTO 150

  150 VCLL  =   VSLL - FACT*( CPALL-2*CCRLL )*FNONC*PEX
      VCLS  =   VSLS - FACT*( CPALS-2*CCRLS )*FNONC*PEX
      VCSS  =   VSSS - FACT*( CPASS-2*CCRSS )*FNONC*PEX
      VCDR  =   VSDR - FACT*( CPADR-2*CCRDR )*FNONC*PEX

      VSCSC(1,1,M,N)=VSCSC(1,1,M,N)-FACT*(CPANN-2*CCRNN)*FNONC*PEX
      VSCSC(2,1,M,N)=VSCSC(2,1,M,N)-FACT*(CPALL-2*CCRLL)*FNONC*PEX
      VSCSC(3,1,M,N)=VSCSC(3,1,M,N)-FACT*(CPALS-2*CCRLS)*FNONC*PEX
      VSCSC(4,1,M,N)=VSCSC(4,1,M,N)-FACT*(CPASS-2*CCRSS)*FNONC*PEX
      VSCSC(5,1,M,N)=VSCSC(5,1,M,N)-FACT*(CPADR-2*CCRDr)*FNONC*PEX
  100 CONTINUE
c     if(icall.eq.0.and.nschr.eq.1) call wromtm(5,x,p)
**    if(icall.eq.20.and.nschr.eq.1) call wromtm(5,x,p)
C
C **************************************************************
C     DOUBLE SCALAR/DIFFRACTIVE CONTRIBUTIONS:
C **************************************************************
C
      DO 300 II=1,12 
      CPALS = 0.D0
      CCRLS = 0.D0
      GOTO(31,32,33,34,35,36,37,38,39,40,41,42),II
C DELTA-A2 EXCHANGE POTENTIALS:
   31 PEX = -1.D0
      M = 1
      N = 1
C     PARALLEL:
      CPANN  =  2*(3-2*ISFAC)*GS1**2*GD1**2
      CPALL  =  6*GS1*GS3*GD1*Gd3
      CPALS  =  +2*SR3*GS1*GD1*(GD3*GS2+GD2*GS3)
      CPASS  =  2*Gs1*GD1*(3*GD3*GS3+4*GD2*GS2)
      CPADR  =  2*GS1*GD1*GS2*GD2    
C     CROSSED:
      CCRNN  =  2*(3+2*ISFAC)*GS1**2*GD1**2
      CCRLL  =  6*GS1*GS3*GD1*Gd3         
      CCRLS  =  -2*SR3*GS1*GD1*(GS2*GD3+GS3*GD2)
      CCRSS  =  -2*GS1*GD1*GS3*GD3      
      CCRDR  =  2*GS1*GD1*(2*GS3*GD3+3*GS2*GD2)
      CALL FOOM(5,X,AMD,AMPOM,ALMS8,AMPOM)
      GOTO 350
C DELTA-K** EXCHANGE POTENTIALS:
   32 PEX = -P    
      M = 1
      N = 2
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  6*GD1*GD3*GS4*GS5
      CPALS  =  +2*SR3*GD1*GD2*GS4*GS5-SR3*GD1*GD3*(GS4**2-GS5**2)
      CPASS  =  6*GD1*GD3*GS4*GS5+4*GD1*GD2*GS5**2
      CPADR  =  4*GD1*GD2*GS5**2
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  3*(GD1**2*GS4**2+GD3**2*GS5**2)
      CCRLS  =  SR3*(GD1**2*GS4*GS5-GD3**2*GS4*GS5+2*GD2*GD3*GS5**2)
      CCRSS  =  5*GD1**2*GS5**2+GD3**2*GS4**2+4*GD2*GD3*GS4*GS5
      CCRDR  =  2*GD1**2*GS5**2+GD3**2*GS4**2+
     .          3*GD2**2*GS5**2-2*GD2*GD3*GS4*GS5
      CALL FOOM(5,X,AMD,AMPOM,ALMS8,AMPOM)
      GOTO 350
C DELTA-POMERON EXCHANGE POTENTIALS:
   33 PEX = -1.D0
      M = 1
      N = 3
C     PARALLEL:
      CPANN  =  2*ISFAC*GS1**2*GD6**2
      CPALL  =  0.D0             
      CPALS  =  -SR3*GS1*GS3*GD6*(GD7+GD8)
      CPASS  =  -4*GS1*GS2*GD6*GD8
      CPADR  =  -0.5D0*CPASS 
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  0.D0                      
      CCRLS  =  CPALS                          
      CCRSS  =  CPASS                   
      CCRDR  =  CPADR    
      CALL FOOM(5,X,AMD,AMPOM,ALMS8,AMPOM)
      GOTO 350
C KAPPA-A2 EXCHANGE POTENTIALS:
   34 PEX = -P 
      M = 2
      N = 1
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  6*GD1*GD3*GS4*GS5
      CPALS  =  2*SR3*GD1*GD2*GS4*GS5-SR3*GD1*GD3*(GS4**2-GS5**2)
      CPASS  =  6*GD1*GD3*GS4*GS5+4*GD1*GD2*GS5**2
      CPADR  =  4*GD1*GD2*GS5**2
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  3*(GD1**2*GS4**2+GD3**2*GS5**2)
      CCRLS  =  SR3*(GD1**2*GS4*GS5-GD3**2*GS4*GS5+2*GD2*GD3*GS5**2)
      CCRSS  =  5*GD1**2*GS5**2+GD3**2*GS4**2+4*GD2*GD3*GS4*Gs5
      CCRDR  =  2*GD1**2*GS5**2+GD3**2*GS4**2+
     .          3*GD2**2*GS5**2-2*GD2*GD3*GS4*GS5
      CALL FOOM(5,X,AMSCK,AMPOM,ALMS8,AMPOM)
      GOTO 350
C KAPPA-K** EXCHANGE POTENTIALS:
   35 PEX = -1.D0
      M = 2
      N = 2
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  2*(GD4**2*GS4**2+3*GD4*GD5*GS4*GS5)
      CPALS  =  SR3*(GD5**2*GS4*GS5+GD4*GD5*GS5**2
     .          -GD4**2*GS4*GS5-GD4*GD5*GS4**2)
      CPASS  =  2*(3*GD4*GD5*GS4*GS5+GD5**2*GS5**2)
      CPADR  =  8*GD5**2*GS5**2
C     CROSSED:
      CCRNN  =  2*(ISFLL*GS4**2*GD4**2+ISFLS*GS4*GS5*GD4*GD5+
     .             ISFSS*GS5**2*GD5**2)
      CCRLL  =  2*(GD4*XGD12*GS4*XGS12+3*GD5*XGD12*GS5*XGS12)
      CCRLS  =  SR3*(GD4*GS4-GD5*GS5)*(XGD13*XGS12+XGD12*XGs13)
      CCRSS  = -2*GD4*XGD13*GS4*XGS13+10*GD5*XGD13*GS5*XGS13
      CCRDR  =  4*(GD5*GS5*XGD13*XGS13+GD4*GS4*XGD13*XGS13)
      CALL FOOM(5,X,AMSCK,AMPOM,ALMS8,AMPOM)
      GOTO 350
C KAPPA-POMERON EXCHANGE POTENTIALS:
   36 PEX = -P 
      M = 2
      N = 3
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  2*GS4*GD6*GD7    
      CPALS  =  -SR3*GS4*GS5*GD6*(GD7+GD8)
      CPASS  =  -2*GS5**2*GD6*GD8 
      CPADR  =  -2*CPASS
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  GS4**2*(GD6**2+GD7**2)
      CCRLS  =  -SR3*GS4*GS5*(GD6**2+GD7*GD8)
      CCRSS  =  -GS5*2*(GD6**2+GD8**2)
      CCRDR  =  -2*CCRSS
      CALL FOOM(5,X,AMSCK,AMPOM,ALMS8,AMPOM)
      GOTO 350
C S*-A2 EXCHANGE POTENTIALS:
   37 PEX = -1.D0
      M = 4
      N = 1
C     PARALLEL:
      CPANN  =  2*ISFAC*GS9**2*GD1**2
      CPALL  =  0.D0
      CPALS  =  -SR3*GD1*GS9*GD3*(GS10+GS11)
      CPASS  =  -4*GD1*GS9*GD2*GS11
      CPADR  =  +2*GD1*GS9*GD2*GS11
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  0.D0  
      CCRLS  =  CPALS
      CCRSS  =  CPASS
      CCRDR  =  CPADR
      CALL FOOM(5,X,AMSST,AMPOM,ALMS8,AMPOM)
      GOTO 350
C S*-K** EXCHANGE POTENTIALS:
   38 PEX = -P   
      M = 4
      N = 2
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  2*GD4**2*GS9*GS10
      CPALS  =  -SR3*GD4*GD5*GS9*(GS10+GS11)
      CPASS  =  -2*GD5**2*GS9*GS11 
      CPADR  =  -2*CPASS            
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  GD4**2*(GS9**2+GS10**2)
      CCRLS  =  -SR3*GD4*GD5*(GS9**2+GD10*GD11)
      CCRSS  =  -GD5**2*(GS9**2+GS11**2)
      CCRDR  =  CPADR
      CALL FOOM(5,X,AMSST,AMPOM,ALMS8,AMPOM)
      GOTO 350
C S*-POMERON EXCHANGE POTENTIALS:
   39 PEX = -1.D0
      M = 4
      N = 3
C     PARALLEL:
      CPANN  =  2*GS9**2*GD6**2
      CPALL  =  2*GS9*GD6*GS10*GD7
      CPASS  =  2*GS9*GD6*GS11*GD8
      CPADR  =  CPASS
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL
      CCRSS  =  CPASS
      CCRDR  =  CPADR
      CALL FOOM(5,X,AMSST,AMPOM,ALMS8,AMPOM)
      GOTO 350
C EPSILON-POMERON EXCHANGE POTENTIALS:
   40 PEX = -1.D0
      M = 3
      N = 3
C     PARALLEL:
      CPANN  =  2*GS6**2*GD6**2
      CPALL  =  2*GS6*GD6*GS7*GD7
      CPASS  =  2*GS6*GD6*GS8*GD8
      CPADR  =  CPASS
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL
      CCRSS  =  CPASS
      CCRDR  =  CPADR
      HNONC = 0.D0
      DO 241 JJ=1,2
      CALL FOOM(5,X,AMSIG(JJ),AMPOM,ALMS1,AMPOM)
*     CALL FOOM(5,X,AMEPS,AMPOM,ALMS1,AMPOM)
  241 HNONC = HNONC + ASIG(JJ)*FNONC
      FNONC = HNONC
      GOTO 350
C EPSILON-A2 EXCHANGE POTENTIALS:
   41 PEX = -1.D0
      M = 3
      N = 1
C     PARALLEL:
      CPANN  =  2*ISFAC*GS6**2*GD1**2
      CPALL  =  0.D0
      CPALS  =  -SR3*GD1*GS6*GD3*(GS7+GS8)
      CPASS  =  -4*GD1*GS6*GD2*GS8
      CPADR  =  +2*GD1*GS6*GD2*GS8
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL
      CCRLS  =  CPALS
      CCRSS  =  CPASS
      CCRDR  =  CPADR
      HNONC = 0.D0
      DO 341 JJ=1,2
      CALL FOOM(5,X,AMSIG(JJ),AMPOM,ALMS1,AMPOM)
*     CALL FOOM(5,X,AMEPS,AMPOM,ALMS1,AMPOM)
  341 HNONC = HNONC + ASIG(JJ)*FNONC
      FNONC = HNONC
      GOTO 350
C EPSILON-K** EXCHANGE POTENTIALS:
   42 PEX = -P   
      M = 3
      N = 2
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  2*GD4**2*GS6*GS7
      CPALS  =  -SR3*GD4*GD5*GS6*(GS7+GS8)
      CPASS  =  -2*GD5**2*GS6*GS8 
      CPADR  =  -2*CPASS            
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  GD4**2*(GS6**2+GS7**2)
      CCRLS  =  -SR3*GD4*GD5*(GS6**2+GD7*GD8)
      CCRSS  =  -GD5**2*(GS6**2+GS8**2)
      CCRDR  =  CPADR
      HNONC = 0.D0
      DO 441 JJ=1,2
      CALL FOOM(5,X,AMSIG(JJ),AMPOM,ALMS1,AMPOM)
*     CALL FOOM(5,X,AMEPS,AMPOM,ALMS1,AMPOM)
  441 HNONC = HNONC + ASIG(JJ)*FNONC
      FNONC = HNONC
      GOTO 350
  350 VCLL  =   VCLL - FACT*( CPALL-2*CCRLL )*FNONC*PEX
      VCLS  =   VCLS - FACT*( CPALS-2*CCRLS )*FNONC*PEX
      VCSS  =   VCSS - FACT*( CPASS-2*CCRSS )*FNONC*PEX
      VCDR  =   VCDR - FACT*( CPADR-2*CCRDR )*FNONC*PEX

      VSCDF(1,1,M,N)=VSCDF(1,1,M,N)-FACT*(CPANN-2*CCRNN)*FNONC*PEX
      VSCDF(2,1,M,N)=VSCDF(2,1,M,N)-FACT*(CPALL-2*CCRLL)*FNONC*PEX
      VSCDF(3,1,M,N)=VSCDF(3,1,M,N)-FACT*(CPALS-2*CCRLS)*FNONC*PEX
      VSCDF(4,1,M,N)=VSCDF(4,1,M,N)-FACT*(CPASS-2*CCRSS)*FNONC*PEX
      VSCDF(5,1,M,N)=VSCDF(5,1,M,N)-FACT*(CPADR-2*CCRDr)*FNONC*PEX
  300 CONTINUE
c     if(icall.eq.0.and.nschr.eq.1) call wromtm(6,x,p)
**    if(icall.eq.20.and.nschr.eq.1) call wromtm(6,x,p)
C
C **************************************************************
C     DOUBLE DIFFRACTIVE CONTRIBUTIONS:
C **************************************************************
C
      DO 400 II=1,6  
      CPALS = 0.D0
      CCRLS = 0.D0
      GOTO(44,54,64,74,84,94), II            
C POMERON-POMERON EXCHANGE POTENTIALS:
   44 PEX = +1.D0
      M = 3
      N = 3
C     PARALLEL:
      CPANN  =  GD6**2*GD6**2
      CPALL  =  GD6**2*GD7**2
      CPASS  =  GD6**2*GD8**2
      CPADR  =  CPASS
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  CPALL
      CCRSS  =  CPASS
      CCRDR  =  CPADR
      CALL FOOM(5,X,AMPOM,AMPOM,AMPOM,AMPOM)
      GOTO 450
C POMERON-A2 EXCHANGE POTENTIALS:
   54 PEX = +1.D0
      M = 1
      N = 3
C     PARALLEL:
      CPANN  =  2*ISFAC*GD6**2*GD1**2
      CPALL  =  0.D0
      CPALS  =  -SR3*GD1*GD6*GD3*(GD7+GD8)
      CPASS  =  -4*GD1*GD6*GD2*GD8
      CPADR  =  +2*GD1*GD6*GD2*GD8
C     CROSSED:
      CCRNN  =  CPANN
      CCRLL  =  0.D0
      CCRLS  =  CPALS
      CCRSS  =  CPASS
      CCRDR  =  CPADR
      CALL FOOM(5,X,AMPOM,AMPOM,AMPOM,AMPOM)
      GOTO 450
C POMERON-K** EXCHANGE POTENTIALS:
   64 PEX = +P
      M = 2
      N = 3
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  2*GD6*GD7*GD4**2
      CPALS  =  -SR3*GD6*(GD7+GD8)*GD4*GD5
      CPASS  =  -2*GD6*GD8*GD5**2
      CPADR  =  -2*CPASS
C     CROSSED:
      CCRNN  =  0.D0
      CCRLS  =  CPALS
      CCRSS  =  CPASS
      CCRDR  =  CPADR
      CALL FOOM(5,X,AMPOM,AMPOM,AMPOM,AMPOM)
      GOTO 450
C A2-A2 EXCHANGE POTENTIALS:
   74 PEX = +1.D0
      M = 1
      N = 1
C     PARALLEL:
      CPANN  =  1*(3-2*ISFAC)*GD1**2*GD1**2
      CPALL  =  3*GD1**2*GD3**2
      CPALS  =  2*SR3*GD1**2*GD3*GD2
      CPASS  =  GD1**2*(3*GD3**2+4*GD2**2)
      CPADR  =  GD1**2*GD2**2
C     CROSSED:
      CCRNN  =  1*(3+2*ISFAC)*GD1**2*GD1**2
      CCRLL  =  CPALL
      CCRLS  =  -CPALS
      CCRSS  =  -GD1**2*GD2**2
      CCRDR  =  GD1**2*(2*GD3**2+2*GD2**2)
      CALL FOOM(5,X,AMPOM,AMPOM,AMPOM,AMPOM)
      GOTO 450
C A2-K** EXCHANGE POTENTIALS:
   84 PEX = +P
      M = 1
      N = 2
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  6*GD1*GD4*GD3*GD5
      CPALS  =  -SR3*GD1*GD3*(GD4**2-GD5**2)
     .          +2*SR3*GD1*GD2*GD4*GD5
      CPASS  =  GD1*GD5*(6*GD3*GD4+4*GD2*GD5)
      CPADR  =  +4*GD1*GD2*GD5**2
C     CROSSED:
      CCRNN  =  0.D0
      CCRLL  =  3*(GD1**2*GD4**2+GD3**2*GD5**2)
      CCRLS  =  SR3*GD4*GD5*(GD1**2-GD3**2)
     .          +2*SR3*GD2*GD3*GD5**2
      CCRSS  =  5*GD1**2*GD5**2+GD3**2*GD4**2
     .          +4*GD2*GD3*GD4*GD5
      CCRDR  =  2*GD1**2*GD5**2+GD3**2*GD4**2
     .          +3*GD2**2*GD5**2-2*GD2*GD3*GD4*GD5
      CALL FOOM(5,X,AMPOM,AMPOM,AMPOM,AMPOM)
      GOTO 450
C K**-K** EXCHANGE POTENTIALS:
   94 PEX = +1.D0
      M = 2
      N = 2
C     PARALLEL:
      CPANN  =  0.D0
      CPALL  =  (GD4**2+3*GD5**2)*GD4**2
      CPALS  =  SR3*(GD5**2-GD4**2)*GD4*GD5
      CPASS  =  (3*GD4**2+GD5**2)*GD5**2
      CPADR  =  +4*GD5**4
C     CROSSED:
      CCRNN  =  1*(ISFLL*GD4**2*GD4**2+ISFLS*GD4*GD5*GD4*GD5+
     .             ISFSS*GD5**2*GD5**2)
      CCRLL  =  (GD4**2*XGD12**2+3*GD5**2*XGD12**2)
      CCRLS  =  SR3*(GD4**2-GD5**2)*(XGD13*XGD12)
      CCRSS  =  -1*GD4**2*XGD13**2+5*GD5**2*XGD13**2
      CCRDR  =  2*(GD5*GD5*XGD13*XGD13+GD4*GD4*XGD13*XGD13)
      CALL FOOM(5,X,AMPOM,AMPOM,AMPOM,AMPOM)
      GOTO 450

  450 VCLL  =   VSLL - FACT*( CPALL-2*CCRLL )*FNONC*PEX
      VCLS  =   VSLS - FACT*( CPALS-2*CCRLS )*FNONC*PEX
      VCSS  =   VSSS - FACT*( CPASS-2*CCRSS )*FNONC*PEX
      VCDR  =   VSDR - FACT*( CPADR-2*CCRDR )*FNONC*PEX

      VDFDF(1,1,M,N)=VDFDF(1,1,M,N)-FACT*(CPANN-2*CCRNN)*FNONC*PEX
      VDFDF(2,1,M,N)=VDFDF(2,1,M,N)-FACT*(CPALL-2*CCRLL)*FNONC*PEX
      VDFDF(3,1,M,N)=VDFDF(3,1,M,N)-FACT*(CPALS-2*CCRLS)*FNONC*PEX
      VDfDF(4,1,M,N)=VDFDF(4,1,M,N)-FACT*(CPASS-2*CCRSS)*FNONC*PEX
      VDFDF(5,1,M,N)=VDFDF(5,1,M,N)-FACT*(CPADR-2*CCRDr)*FNONC*PEX
  400 CONTINUE
c     if(icall.eq.0.and.nschr.eq.1) call wromtm(7,x,p)
**    if(icall.eq.20.and.nschr.eq.1) call wromtm(7,x,p)
      ENDIF
C     END DOUBLE SCALAR/DIFFRACTIVE EXCHANGE

1000  CALL ERRSET(208,256,1,1)
      ICALL = ICALL + 1
      RETURN
C END OMSCDF ROUTINE ***************************************************
      END
C **********************************************************************
      SUBROUTINE OMPAIR(X,INA,IPV,APV)
C **********************************************************************
C *
C *   DATE AUGUST 1995
C
C *   PHENOMENOLOGICAL PION-MESON PAIR YN-POTENTIALS
C     CALLED BY SUBROUTINE YNPAIR.FORTRAN
C *
C *   1/M-CONTRIBUTIONS: 1) NON-ADIABATIC, 2) FROM THE PV-VERTEX
C
C     IN COUPLING COMBINATIONS CENLL1 ETC.:
C     (i) YNCCPR: L+R contributions included,
C     (ii) YNCCPR: 1 <-> 2 interchange factor included (extra diagrams)
C
C     PISI and PIRO1 A LA paper II
C
C **********************************************************************
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/PIMAS/PIM0
      COMMON/DYNMAS/REDMM,AMLN,AMSN,AMH,AMSS,AMLS,AMNN
      COMMON/FORMF/ALAM,ALMP8,ALMV8,ALMS8,ALMP1,ALMV1,ALMS1,
     .             ALMKA,ALMKS,ALMKP
      COMMON/POTESC/VCLL,VCSS,VCLS,VCDR,VSLL,VSSS,VSLS,VSDR,
     .              VTLL,VTSS,VTLS,VTDR,VOLL,VOSS,VOLS,VODR,
     .              VALL,VASS,VALS,VADR                     
      COMMON/ALLPS/AME,AMX,AMK,BMK
      COMMON/ALLVC/AVEC(2),AMVEC(2),AMOM,AMFI,AMKS,BMKS
      COMMON/ALLSC/ASIG(2),AMSIG(2),ASST,BSST,AMSST,AM2ST,AMD,AMSCK
      COMMON/ALLDF/AMPOM,AMF2,AMA2,AMKSS,GDA(11)
      COMMON/FOOMS/FNONC,FNONS,FNONT,FNONO,FPVC,FPVS,FPVT,FPVO
     .            ,FOFFC,FOFFS,FOFFT,FOFFO,FOFFS2,FOFFT2
      COMMON/COUPL/ F(11),G(11),FD(11),FV(11),GS(11),GD(11),P
      COMMON/ALLPR/GSPAIR,GVPAIR,FVPAIR,GPIRO1,GPIRO0,GPISI,HOPAIR
     .,GSISI,GPIET,GPIETP,GPIPOM,ALPVPR,ALVDPR,ALVVPR,ALSCPR,ALPAPR
      COMMON/PAIRON/IPIPI0,IPIPI1,IPIRO1,IPIRO0,IPIOM,IPISI
     .,ISISI,IPIET,IPIETP,IPIPOM,IPIROV,IPIOMV,IKKB0,IKKB1,IPIA1
C
*     DIMENSION FUN(9)
C
C     COMMUNICATION WITH ROUTINE YNPAIRS:
      COMMON/CCPR/ CCPR1(3,10),CCPR2(10,10),CCPRG(9,10),CCPRF(9,10),
     .CCPR4(9,10),CCPR4F(9,10),CCPR5(6 ,10),CCPR6(10)  ,CCPR7(3,10),
     .CCPR10(13,10)

C     COMMUNICATION WITH ROUTINE WROMPR:
      COMMON/PROMPR/VPRA(5,3,4,4),VPRB(5,3,4,4),VPRC(5,3,4,4),
     .              VPRD(5,3,4,4),VPRE(5,3,4,4),VPRF(5,3,4,4)

      DATA PI/3.14159265D0/,SRPI/1.7724538509D0/,ICALL/0/
      DATA FACID/0.5D0/,SR2/1.4142136D0/,SR3/1.732051D0/,NSCHR/0/
      DATA AMPRO/938.2796D0/,AMRO/760.D0/,AMEPS/760.D0/,
     .     AMN/938.2796D0/,FACT/138.041D0/,POLD/-12345.D0/
      SAVE FACT,AMN,DAM,AA,AMB
*     SAVE CCPR1,CCPR2,CCPRG,CCPRF,CCPR4,CCPR4F,CCPR5,CCPR6,CCPR7
C
cc    CALL ERRSET(208,256,-1,1)

      pim=pim0
**    pim=500.d0
      IF(ICALL.EQ.0) THEN
        FACT  = PIM0
        AMB  = 2*AMNN*AMH/(AMNN+AMH)
*       AMB  = AMPRO
        FACT = FACT*(PIM0/AMB)/4.D0
        PRINT 52, INA,IPV,PIM,AMB
   52   FORMAT(//,'  IN OMPAIR: INA, IPV=',2I3,' PIM=',F7.3,
     .  ' AMB=',F10.3,/)
*       ICALL=1
      ENDIF

      if(p.ne.pold) then
      icall=0
      pold=p
****  nschr=1
      nschr=0
      endif

*     IF(ICALL.EQ.0) THEN
      IF(ICALL.EQ.20.AND.NSCHR.EQ.1) THEN
        DO 250 NCHAN=1,5
        DO 250 ITYPV=1,3
        DO 250 M=1,4
        DO 250 N=1,4
        VPRA(NCHAN,ITYPV,M,N)=0.D0
        VPRB(NCHAN,ITYPV,M,N)=0.D0
        VPRC(NCHAN,ITYPV,M,N)=0.D0
        VPRD(NCHAN,ITYPV,M,N)=0.D0
        VPRE(NCHAN,ITYPV,M,N)=0.D0
  250   VPRF(NCHAN,ITYPV,M,N)=0.D0
      ENDIF
C
C     CONSTRUCTION 1/M-CORRECTIONS TO THE POTENTIALS:
C
C A)  SCALAR SU(3)-SINGLET PAIR TERMS, {1}->{8}x{8} :
C
      IF(IPIPI0.NE.0) THEN
      ITYPE=1
      DO 10 II=1,3
      GOTO(11,12,13),II

C     PI-PI(I=0):
11    CALL FOOMPR(ITYPE,X,PIM,PIM,ALMP8,ALMP8)
      M = 1
      GOTO 14

C     ETA-ETA:
12    CALL FOOMPR(ITYPE,X,AME,AME,ALMP8,ALMP8)
      M = 3
      GOTO 14

C     KA-KA(I=0):
13    CALL FOOMPR(ITYPE,X,AMK,AMK,ALMKA,ALMKA)
      M = 2
      GOTO 14

14    IF(INA.EQ.1) THEN
      VCLL     =   VCLL    - FACT*CCPR1(II,2)*FNONC        
      VCSS     =   VCSS    - FACT*CCPR1(II,4)*FNONC        
      VCDR     =   VCDR    - FACT*CCPR1(II,5)*FNONC         
      VOLL     =   VOLL    - FACT*CCPR1(II,2)*FNONO         
      VOSS     =   VOSS    - FACT*CCPR1(II,4)*FNONO         
      VODR     =   VODR    - FACT*CCPR1(II,5)*FNONO        
      VPRA(1,1,M,M)=VPRA(1,1,M,M)-FACT*CCPR1(II,1)*FNONC        
      VPRA(2,1,M,M)=VPRA(2,1,M,M)-FACT*CCPR1(II,2)*FNONC        
      VPRA(4,1,M,M)=VPRA(4,1,M,M)-FACT*CCPR1(II,4)*FNONC        
      VPRA(5,1,M,M)=VPRA(5,1,M,M)-FACT*CCPR1(II,5)*FNONC        
      ENDIF
      IF(IPV.EQ.1) THEN
      VCLL     =   VCLL    - APV*FACT*CCPR1(II,2)*FPVC        
      VCSS     =   VCSS    - APV*FACT*CCPR1(II,4)*FPVC        
      VCDR     =   VCDR    - APV*FACT*CCPR1(II,5)*FPVC        
      VOLL     =   VOLL    - APV*FACT*CCPR1(II,2)*FPVO        
      VOSS     =   VOSS    - APV*FACT*CCPR1(II,4)*FPVO        
      VODR     =   VODR    - APV*FACT*CCPR1(II,5)*FPVO        
      VPRA(1,1,M,M)=VPRA(1,1,M,M)-APV*FACT*CCPR1(II,1)*FPVC         
      VPRA(2,1,M,M)=VPRA(2,1,M,M)-APV*FACT*CCPR1(II,2)*FPVC         
      VPRA(4,1,M,M)=VPRA(4,1,M,M)-APV*FACT*CCPR1(II,4)*FPVC         
      VPRA(5,1,M,M)=VPRA(5,1,M,M)-APV*FACT*CCPR1(II,5)*FPVC         
      ENDIF
10    CONTINUE
*     if(icall.eq.0.and.nschr.eq.1) call wrompr(1,x,p)
**    if(icall.eq.20.and.nschr.eq.1) call wrompr(1,x,p)
      ENDIF
C
C B)  SCALAR SU(3)-OCTET PAIR TERMS,  {8s}->{8}x{8} :
C
      IF(IPIET.NE.0) THEN
      ITYPE = 5
      DO 20 II=1,10
      PEX = 1.D0
      GOTO(21,22,23,24,25,26,27,21,23,24),II
C     PI-ETA:
21    CALL FOOMPR(ITYPE,X,PIM,AME,ALMP8,ALMP8)
      IF(II.EQ.1) THEN
      M = 1
      N = 3
      ENDIF
      IF(II.EQ.8) THEN
      M = 3
      N = 1
      ENDIF
      GOTO 28

C     KA-KA(8S)(I=1):
22    CALL FOOMPR(ITYPE,X,AMK,AMK,ALMKA,ALMKA)
      M = 2
      N = 2
      GOTO 28

C     PI-KA(8s):
23    CALL FOOMPR(ITYPE,X,PIM,AMK,ALMP8,ALMKA)
      PEX = P
      IF(II.EQ.3) THEN
      M = 1
      N = 2
      ENDIF
      IF(II.EQ.9) THEN
      M = 2
      N = 1
      ENDIF
      GOTO 28

C     ETA-KA(8s):
24    CALL FOOMPR(ITYPE,X,AME,AMK,ALMP8,ALMKA)
      PEX = P
      IF(II.EQ.4) THEN
      M = 2
      N = 3
      ENDIF
      IF(II.EQ.10) THEN
      M = 3
      N = 2
      ENDIF
      GOTO 28

C     PI-PI(8S)(I=0):
25    CALL FOOMPR(ITYPE,X,PIM,PIM,ALMP8,ALMP8)
      M = 1
      N = 1
      GOTO 28

C     ETA-ETA(8s):
26    CALL FOOMPR(ITYPE,X,AME,AME,ALMP8,ALMP8)
      M = 3
      N = 3
      GOTO 28

C     KA-KA(8S)(I=0):
27    CALL FOOMPR(ITYPE,X,AMK,AMK,ALMKA,ALMKA)
      M = 2
      N = 2
      GOTO 28

28    IF(INA.EQ.1) THEN
      VCLL   =   VCLL    - FACT*CCPR2(II,2)*FNONC*PEX
      VCLS   =   VCLS    - FACT*CCPR2(II,3)*FNONC*PEX
      VCSS   =   VCSS    - FACT*CCPR2(II,4)*FNONC*PEX
      VCDR   =   VCDR    - FACT*CCPR2(II,5)*FNONC*PEX
      VOLL   =   VOLL    - FACT*CCPR2(II,2)*FNONO*PEX
      VOLS   =   VOLS    - FACT*CCPR2(II,3)*FNONO*PEX
      VOSS   =   VOSS    - FACT*CCPR2(II,4)*FNONO*PEX
      VODR   =   VODR    - FACT*CCPR2(II,5)*FNONO*PEX
      VPRB(1,1,M,N)=VPRB(1,1,M,N)-FACT*CCPR2(II,1)*FNONC*PEX    
      VPRB(2,1,M,N)=VPRB(2,1,M,N)-FACT*CCPR2(II,2)*FNONC*PEX    
      VPRB(3,1,M,N)=VPRB(3,1,M,N)-FACT*CCPR2(II,3)*FNONC*PEX    
      VPRB(4,1,M,N)=VPRB(4,1,M,N)-FACT*CCPR2(II,4)*FNONC*PEX    
      VPRB(5,1,M,N)=VPRB(5,1,M,N)-FACT*CCPR2(II,5)*FNONC*PEX    
      ENDIF
      IF(IPV.EQ.1) THEN
      VCLL   =   VCLL    - APV*FACT*CCPR2(II,2)*FPVC*PEX
      VCLS   =   VCLS    - APV*FACT*CCPR2(II,3)*FPVC*PEX
      VCSS   =   VCSS    - APV*FACT*CCPR2(II,4)*FPVC*PEX
      VCDR   =   VCDR    - APV*FACT*CCPR2(II,5)*FPVC*PEX
      VOLL   =   VOLL    - APV*FACT*CCPR2(II,2)*FPVO*PEX
      VOLS   =   VOLS    - APV*FACT*CCPR2(II,3)*FPVO*PEX
      VOSS   =   VOSS    - APV*FACT*CCPR2(II,4)*FPVO*PEX
      VODR   =   VODR    - APV*FACT*CCPR2(II,5)*FPVO*PEX
      VPRB(1,1,M,N)=VPRB(2,1,M,N)-APV*FACT*CCPR2(II,1)*FPVC*PEX    
      VPRB(2,1,M,N)=VPRB(2,1,M,N)-APV*FACT*CCPR2(II,2)*FPVC*PEX    
      VPRB(3,1,M,N)=VPRB(3,1,M,N)-APV*FACT*CCPR2(II,3)*FPVC*PEX    
      VPRB(4,1,M,N)=VPRB(4,1,M,N)-APV*FACT*CCPR2(II,4)*FPVC*PEX    
      VPRB(5,1,M,N)=VPRB(5,1,M,N)-APV*FACT*CCPR2(II,5)*FPVC*PEX    
      ENDIF
20    CONTINUE
*     if(icall.eq.0.and.nschr.eq.1) call wrompr(2,x,p)
**    if(icall.eq.20.and.nschr.eq.1) call wrompr(2,x,p)
      ENDIF

C     PI-ETA':
*     IF(IPIETP.EQ.1) THEN
*     VC    =   VC + FACT*ISFAC*GPIETP*(
*    .               2*FP*FETAP*DFI*DFIETP-0.5D0*GPIETP*FIPEP2)
*     ENDIF
C
C C)  VECTOR SU(3)-OCTET PAIR TERMS, {8a}->{8}x{8} :
C
C     NOTE: for identical mesons: FACID=1/2 is included for 1-pair's!!
C
      IF(IPIPI1.NE.0) THEN
      ITYPE = 2
*     DO 30 II=1,9
      DO 30 II=1,6
      PEX = 1.D0
      GOTO(31,32,33,34,341,35,33,34,341),II
C     PI-PI(I=1):
31    CALL FOOMPR(ITYPE,X,PIM,PIM,ALMP8,ALMP8)
      PEX = FACID
      M = 1
      N = 1
      GOTO 36

C     KA-KA(8A)(I=1):
32    CALL FOOMPR(ITYPE,X,AMK,AMK,ALMKA,ALMKA)
      PEX = FACID
      M = 2
      N = 2
      GOTO 36

C     PI-KA(8a):
33    CALL FOOMPR(ITYPE,X,PIM,AMK,ALMP8,ALMKA)
      PEX = P*2
      IF(II.EQ.3) THEN
      M = 1
      N = 2
      ENDIF
      IF(II.EQ.7) THEN
      M = 2
      N = 1
      ENDIF
      GOTO 36

C     ETA-KA(8a):
34    CALL FOOMPR(ITYPE,X,AME,AMK,ALMP8,ALMKA)
      PEX = P*2
      IF(II.EQ.4) THEN
      M = 3
      N = 2
      ENDIF
      IF(II.EQ.8) THEN
      M = 2
      N = 3
      ENDIF
      GOTO 36

C     ETAP-KA(8a):
341   CALL FOOMPR(ITYPE,X,AMX,AMK,ALMP8,ALMKA)
      PEX = P*2
      IF(II.EQ.5) THEN
      M = 4
      N = 2
      ENDIF
      IF(II.EQ.9) THEN
      M = 2
      N = 4
      ENDIF
      GOTO 36

C     KA-KA(8A)(I=0):
35    CALL FOOMPR(ITYPE,X,AMK,AMK,ALMKA,ALMKA)
      PEX = FACID
      M = 2
      N = 2
      GOTO 36

36    IF(INA.EQ.1) THEN
      VCLL   =   VCLL    - FACT*CCPRG(II,2)*FNONC*PEX
      VCLS   =   VCLS    - FACT*CCPRG(II,3)*FNONC*PEX
      VCSS   =   VCSS    - FACT*CCPRG(II,4)*FNONC*PEX
      VCDR   =   VCDR    - FACT*CCPRG(II,5)*FNONC*PEX
      VOLL   =   VOLL    - FACT*CCPRG(II,2)*FNONO*PEX
      VOLS   =   VOLS    - FACT*CCPRG(II,3)*FNONO*PEX
      VOSS   =   VOSS    - FACT*CCPRG(II,4)*FNONO*PEX
      VODR   =   VODR    - FACT*CCPRG(II,5)*FNONO*PEX
      VPRC(1,1,M,N)=VPRC(1,1,M,N)-FACT*CCPRG(II,1)*FNONC*PEX    
      VPRC(2,1,M,N)=VPRC(2,1,M,N)-FACT*CCPRG(II,2)*FNONC*PEX    
      VPRC(3,1,M,N)=VPRC(3,1,M,N)-FACT*CCPRG(II,3)*FNONC*PEX    
      VPRC(4,1,M,N)=VPRC(4,1,M,N)-FACT*CCPRG(II,4)*FNONC*PEX    
      VPRC(5,1,M,N)=VPRC(5,1,M,N)-FACT*CCPRG(II,5)*FNONC*PEX    
      ENDIF
      IF(IPV.EQ.1) THEN
      VCLL   =   VCLL    - APV*FACT*CCPRG(II,2)*FPVC*PEX
      VCLS   =   VCLS    - APV*FACT*CCPRG(II,3)*FPVC*PEX
      VCSS   =   VCSS    - APV*FACT*CCPRG(II,4)*FPVC*PEX
      VCDR   =   VCDR    - APV*FACT*CCPRG(II,5)*FPVC*PEX
      VOLL   =   VOLL    - APV*FACT*CCPRG(II,2)*FPVO*PEX
      VOLS   =   VOLS    - APV*FACT*CCPRG(II,3)*FPVO*PEX
      VOSS   =   VOSS    - APV*FACT*CCPRG(II,4)*FPVO*PEX
      VODR   =   VODR    - APV*FACT*CCPRG(II,5)*FPVO*PEX
      VPRC(1,1,M,N)=VPRC(1,1,M,N)-APV*FACT*CCPRG(II,1)*FPVC*PEX    
      VPRC(2,1,M,N)=VPRC(2,1,M,N)-APV*FACT*CCPRG(II,2)*FPVC*PEX    
      VPRC(3,1,M,N)=VPRC(3,1,M,N)-APV*FACT*CCPRG(II,3)*FPVC*PEX    
      VPRC(4,1,M,N)=VPRC(4,1,M,N)-APV*FACT*CCPRG(II,4)*FPVC*PEX    
      VPRC(5,1,M,N)=VPRC(5,1,M,N)-APV*FACT*CCPRG(II,5)*FPVC*PEX    
      ENDIF
30    CONTINUE
*     if(icall.eq.0.and.nschr.eq.1) call wrompr(3,x,p)
**    if(icall.eq.20.and.nschr.eq.1) call wrompr(3,x,p)
      ENDIF
C
C 3)  AXIAL PAIR TERMS OF THE FIRST CLASS:
C
*     ITYPE=3
*     NO EXTRA 1/M-CORRECTIONS (ADIABATIC TERMS ARE 1/M!)
*     IF(GPIRO1.NE.0.D0) THEN
*     ENDIF

C
C 4)  AXIAL PAIR TERMS OF THE SECOND CLASS:
C
*     ITYPE=4
*     NOT INCLUDED IN YNPAIRS
*     IF(IPIRO0.EQ.1) THEN
*     ENDIF
C
C 5)  AXIAL SECOND CLASS PAIR TERMS (I=1, PION-OMEGA) :
*     ITYPE=5
*     NOT INCLUDED IN YNPAIRS
*     IF(IPIOM.EQ.1) THEN
*     ENDIF
C
C 6)  PSEUDO SCALAR (PION-EPSILON) PAIR TERMS:
      IF(IPISI.NE.0) THEN
      ITYPE = 6
      DO 50 II=1,6
      PEX = 1.D0
      GOTO(51,51,51,54,55,56),II

C     PI-EPSILON:
C     KA-EPSILON:
C     ETA-EPSILON:

51    HNONS = 0.D0
      HNONT = 0.D0
      HPVS  = 0.D0
      HPVT  = 0.D0
      DO 510 JJ=1,2
      IF(II.EQ.1) CALL FOOMPR(ITYPE,X,PIM,AMSIG(JJ),ALMP8,ALMS1)
      IF(II.EQ.2) CALL FOOMPR(ITYPE,X,AMK,AMSIG(JJ),ALMKA,ALMS1)
      IF(II.EQ.3) CALL FOOMPR(ITYPE,X,AME,AMSIG(JJ),ALMP8,ALMS1)
      HNONS = HNONS + ASIG(JJ)*FNONS
      HNONT = HNONT + ASIG(JJ)*FNONT
      HPVS  = HPVS  + ASIG(JJ)*FPVS
510   HPVT  = HPVT  + ASIG(JJ)*FPVT
      FNONS = HNONS
      FNONT = HNONT
      FPVS  = HPVS
      FPVT  = HPVT
      IF(II.EQ.2) PEX = P
      M = II
      N = 4
      GOTO 57

C     PI-SSTAR:
54    CALL FOOMPR(ITYPE,X,PIM,AMSST,ALMP8,ALMS8)
      M = 1 
      N = 3
      GOTO 57

C     KA-SSTAR:
55    CALL FOOMPR(ITYPE,X,AMK,AMSST,ALMKA,ALMS8)
      PEX = P
      M = 2 
      N = 3
      GOTO 57

C     ETA-SSTAR:
56    CALL FOOMPR(ITYPE,X,AME,AMSST,ALMP8,ALMS8)
      M = 3 
      N = 3
      GOTO 57

57    IF(INA.EQ.1) THEN
      VSLL   =   VSLL    - FACT*CCPR5(II,2)*FNONS*PEX/3.D0
      VSLS   =   VSLS    - FACT*CCPR5(II,3)*FNONS*PEX/3.D0
      VSSS   =   VSSS    - FACT*CCPR5(II,4)*FNONS*PEX/3.D0
      VSDR   =   VSDR    - FACT*CCPR5(II,5)*FNONS*PEX/3.D0
      VTLL   =   VTLL    - FACT*CCPR5(II,2)*FNONT*PEX/3.D0
      VTLS   =   VTLS    - FACT*CCPR5(II,3)*FNONT*PEX/3.D0
      VTSS   =   VTSS    - FACT*CCPR5(II,4)*FNONT*PEX/3.D0
      VTDR   =   VTDR    - FACT*CCPR5(II,5)*FNONT*PEX/3.D0
      VPRE(1,2,M,N)=VPRE(1,2,M,N)-FACT*CCPR5(II,1)*FNONS*PEX/3.D0
      VPRE(2,2,M,N)=VPRE(2,2,M,N)-FACT*CCPR5(II,2)*FNONS*PEX/3.D0
      VPRE(3,2,M,N)=VPRE(3,2,M,N)-FACT*CCPR5(II,3)*FNONS*PEX/3.D0
      VPRE(4,2,M,N)=VPRE(4,2,M,N)-FACT*CCPR5(II,4)*FNONS*PEX/3.D0
      VPRE(5,2,M,N)=VPRE(5,2,M,N)-FACT*CCPR5(II,5)*FNONS*PEX/3.D0
      ENDIF
      IF(IPV.EQ.1) THEN
      VSLL   =   VSLL    + APV*FACT*CCPR5(II,2)*FPVS*PEX/3.D0
      VSLS   =   VSLS    + APV*FACT*CCPR5(II,3)*FPVS*PEX/3.D0
      VSSS   =   VSSS    + APV*FACT*CCPR5(II,4)*FPVS*PEX/3.D0
      VSDR   =   VSDR    + APV*FACT*CCPR5(II,5)*FPVS*PEX/3.D0
      VTLL   =   VTLL    + APV*FACT*CCPR5(II,2)*FPVT*PEX/3.D0
      VTLS   =   VTLS    + APV*FACT*CCPR5(II,3)*FPVT*PEX/3.D0
      VTSS   =   VTSS    + APV*FACT*CCPR5(II,4)*FPVT*PEX/3.D0
      VTDR   =   VTDR    + APV*FACT*CCPR5(II,5)*FPVT*PEX/3.D0
      VPRE(1,2,M,N)=VPRE(1,2,M,N)+APV*FACT*CCPR5(II,1)*FPVS*PEX/3.D0
      VPRE(2,2,M,N)=VPRE(2,2,M,N)+APV*FACT*CCPR5(II,2)*FPVS*PEX/3.D0
      VPRE(3,2,M,N)=VPRE(3,2,M,N)+APV*FACT*CCPR5(II,3)*FPVS*PEX/3.D0
      VPRE(4,2,M,N)=VPRE(4,2,M,N)+APV*FACT*CCPR5(II,4)*FPVS*PEX/3.D0
      VPRE(5,2,M,N)=VPRE(5,2,M,N)+APV*FACT*CCPR5(II,5)*FPVS*PEX/3.D0
      ENDIF
50    CONTINUE
*     if(icall.eq.0.and.nschr.eq.1) call wrompr(5,x,p)
**    if(icall.eq.20.and.nschr.eq.1) call wrompr(5,x,p)
      ENDIF
C
C     PSEUDO SCALAR (PS-POMERON) PAIR TERMS:
      IF(IPIPOM.NE.0) THEN
      ITYPE = 7
      DO 70 II=1,3
      PEX = 1.D0
      GOTO(71,72,73),II

C     PI-POMERON:
71    CALL FOOMPR(ITYPE,X,PIM,AMPOM,ALMP8,AMPOM)
      M = 1
      N = 4
      GOTO 74

C     KA-POMERON:
72    CALL FOOMPR(ITYPE,X,AMK,AMPOM,ALMKA,AMPOM)
      PEX = P
      M = 2
      N = 4
      GOTO 74

C     ETA-POMERON:
73    CALL FOOMPR(ITYPE,X,AME,AMPOM,ALMP8,AMPOM)
      M = 3
      N = 4
      GOTO 74

74    IF(INA.EQ.1) THEN
      VSLL   =   VSLL    + FACT*CCPR7(II,2)*FNONS*PEX/3.D0
      VSLS   =   VSLS    + FACT*CCPR7(II,3)*FNONS*PEX/3.D0
      VSSS   =   VSSS    + FACT*CCPR7(II,4)*FNONS*PEX/3.D0
      VSDR   =   VSDR    + FACT*CCPR7(II,5)*FNONS*PEX/3.D0
      VTLL   =   VTLL    + FACT*CCPR7(II,2)*FNONT*PEX/3.D0
      VTLS   =   VTLS    + FACT*CCPR7(II,3)*FNONT*PEX/3.D0
      VTSS   =   VTSS    + FACT*CCPR7(II,4)*FNONT*PEX/3.D0
      VTDR   =   VTDR    + FACT*CCPR7(II,5)*FNONT*PEX/3.D0
      VPRF(1,2,M,N)=VPRF(1,2,M,N)+FACT*CCPR7(II,1)*FNONS*PEX/3.D0
      VPRF(2,2,M,N)=VPRF(2,2,M,N)+FACT*CCPR7(II,2)*FNONS*PEX/3.D0
      VPRF(3,2,M,N)=VPRF(3,2,M,N)+FACT*CCPR7(II,3)*FNONS*PEX/3.D0
      VPRF(4,2,M,N)=VPRF(4,2,M,N)+FACT*CCPR7(II,4)*FNONS*PEX/3.D0
      VPRF(5,2,M,N)=VPRF(5,2,M,N)+FACT*CCPR7(II,5)*FNONS*PEX/3.D0
      ENDIF
      IF(IPV.EQ.1) THEN
      VSLL   =   VSLL    - APV*FACT*CCPR7(II,2)*FPVS*PEX/3.D0
      VSLS   =   VSLS    - APV*FACT*CCPR7(II,3)*FPVS*PEX/3.D0
      VSSS   =   VSSS    - APV*FACT*CCPR7(II,4)*FPVS*PEX/3.D0
      VSDR   =   VSDR    - APV*FACT*CCPR7(II,5)*FPVS*PEX/3.D0
      VTLL   =   VTLL    - APV*FACT*CCPR7(II,2)*FPVT*PEX/3.D0
      VTLS   =   VTLS    - APV*FACT*CCPR7(II,3)*FPVT*PEX/3.D0
      VTSS   =   VTSS    - APV*FACT*CCPR7(II,4)*FPVT*PEX/3.D0
      VTDR   =   VTDR    - APV*FACT*CCPR7(II,5)*FPVT*PEX/3.D0
      VPRF(1,2,M,N)=VPRF(1,2,M,N)-APV*FACT*CCPR7(II,1)*FPVS*PEX/3.D0
      VPRF(2,2,M,N)=VPRF(2,2,M,N)-APV*FACT*CCPR7(II,2)*FPVS*PEX/3.D0
      VPRF(3,2,M,N)=VPRF(3,2,M,N)-APV*FACT*CCPR7(II,3)*FPVS*PEX/3.D0
      VPRF(4,2,M,N)=VPRF(4,2,M,N)-APV*FACT*CCPR7(II,4)*FPVS*PEX/3.D0
      VPRF(5,2,M,N)=VPRF(5,2,M,N)-APV*FACT*CCPR7(II,5)*FPVS*PEX/3.D0
      ENDIF
70    CONTINUE
*     if(icall.eq.0.and.nschr.eq.1) call wrompr(6,x,p)
**    if(icall.eq.20.and.nschr.eq.1) call wrompr(6,x,p)
      ENDIF
C
C D)  SCALAR SU(3)-SINGLET PAIR TERMS, {1}->{1}x{1} :
C

C 7)  SCALAR (EPSILON-EPSILON) PAIR TERMS:
      IF(ISISI.NE.0) THEN
      ITYPE = 8
C     EPSILON-EPSILON:
*     if(icall.eq.0.and.nschr.eq.1) then
c     if(icall.eq.20.and.nschr.eq.1) then
c     vprgnn = 0.d0
c     vprgll = 0.d0
c     vprgls = 0.d0
c     vprgss = 0.d0
c     vprgdr = 0.d0
c     endif
      DO 710 JJ=1,2
      DO 710 KK=1,2
      CALL FOOMPR(ITYPE,X,AMSIG(JJ),AMSIG(KK),ALMS1,ALMS1)
      AJK = ASIG(JJ)*ASIG(KK)

      IF(INA.EQ.1) THEN
      VCLL    = VCLL    -AJK*FACT*CCPR6(2)*FNONC
      VCSS    = VCSS    -AJK*FACT*CCPR6(4)*FNONC
      VCDR    = VCDR    -AJK*FACT*CCPR6(5)*FNONC
      ENDIF
*     if(icall.eq.0.and.nschr.eq.1) then                 
**    if(icall.eq.20.and.nschr.eq.1) then
c     VPRGNN  = VPRGNN  -AJK*FACT*CCPR6(1)*FNONC
c     VPRGLL  = VPRGLL  -AJK*FACT*CCPR6(2)*FNONC
c     VPRGLS  = VPRGLS  -AJK*FACT*CCPR6(3)*FNONC
c     VPRGSS  = VPRGSS  -AJK*FACT*CCPR6(4)*FNONC
c     VPRGDR  = VPRGDR  -AJK*FACT*CCPR6(5)*FNONC
**    endif
  710 CONTINUE
*     if(icall.eq.0.and.nschr.eq.1) then                 
**    if(icall.eq.-20.and.nschr.eq.1) then
*     write(*,*) ' OMPAIR: EPSILON-EPSILON:'
*     write(*,*) ' ccpr6=',ccpr6                 
*     write(*,*) ' VCNN=',vprgnn,' VCDR=',vprgdr
*     write(*,*) ' VCLL=',vprgll,' VCLS=',vprgls,' VCSS=',vprgss
*     endif
      ENDIF
C
C 8)  VECTOR (PION-A1) PAIR TERMS:
C
*     IF(IPIA1.EQ.1) THEN
*     ENDIF
C
CC

1000  CALL ERRSET(208,256,1,1)
        ICALL=ICALL+1
      RETURN
      END
C **********************************************************************
      SUBROUTINE FOOM(ITYP,X,AM1,AM2,ALM1,ALM2)
C **********************************************************************
C
C     COMPUTATION FUNTIONS FOR 1/M-CONTRIBUTIONS TWO PS-EXCHANGE
C
C     ITYP = 1 : PS-PS, ITYP = 2 : PS-VCT, ITYP = 3 : PS-SCA,
C     ITYP = 4 : PS-DIF
C
C **********************************************************************
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/PIMAS/PIM
      COMMON/FOOMS/FNONC,FNONS,FNONT,FNONO,FPVC,FPVS,FPVT,FPVO
     .            ,FOFFC,FOFFS,FOFFT,FOFFO,FOFFS2,FOFFT2

      DATA PI/3.14159265D0/,SRPI/1.7724538509D0/,AMPRO/938.2796D0/
C
C     POTENTIAL FUNTION DEFINITION
C
      F0(ERATH,EXH,EMH,EPH,XH)=ERATH*( EMH/EXH-EPH*EXH )/(2*XH)
      H0(ERATH,EXH,EMH,EPH,XH)=ERATH*( EMH/EXH+EPH*EXH )/(2*XH)
C
      CALL ERRSET(208,256,-1,1)
CC
      X1   = 1.D0/X
      X2   = X1*X1
      X3   = X1*X2
CC
      DO 1 IMES=1,2
      IF(IMES.EQ.1) THEN
      AMES = AM1
      ALAM = ALM1
      ENDIF
      IF(IMES.EQ.2) THEN
      AMES = AM2
      ALAM = ALM2
      ENDIF
C     NORMAL (I.E. NON-DIFFRACTIVE) CASE:
      IF(ALAM.NE.AMES) THEN
      RATP =PIM/ALAM
      RATPM=PIM/AMES
      XLAM =0.5D0*X*ALAM/PIM
      XLAM2=XLAM*XLAM
      VKUA =(ALAM/PIM)*FDEXP(-XLAM2)/(2*SRPI)
      DVKUA=-0.5D0*(ALAM/PIM)**2*X*VKUA
      DDVKUA=-0.5D0*(ALAM/PIM)**2*(X*DVKUA+VKUA)
      D3VKUA=-0.5D0*(ALAM/PIM)**2*(X*DDVKUA+2*DVKUA)

      XA   =X*AMES/PIM
      RATA =AMES/ALAM
      ERATA=DEXP(RATA*RATA)
      EXA  =DEXP(XA)
      EMA  =FDERFC(-XLAM +RATA)
      EPA  =FDERFC( XLAM +RATA)
      FIA   =F0(ERATA,EXA ,EMA ,EPA ,X)
      HIA   =H0(ERATA,EXA ,EMA ,EPA ,X)
      DFIA  =-(FIA -2*VKUA)*X1-(AMES/PIM)*HIA
      DHIA  =-(AMES/PIM)*FIA -HIA *X1
      DDFIA =-(DFIA-2*DVKUA)*X1+(FIA-2*VKUA)*X2-(AMES/PIM)*DHIA
      DDHIA =-(AMES/PIM)*DFIA-DHIA*X1+HIA*X2
      D3FIA =-(DDFIA-2*DDVKUA)*X1+(DFIA-2*DVKUA)*X2-(AMES/PIM)*DDHIA
     .       +(DFIA-2*DVKUA)*X2-2*(FIA-2*VKUA)*X3
      D3HIA =-(AMES/PIM)*DDFIA-DDHIA*X1+2*DHIA*X2-2*HIA*X3

      F4A   = 0.5D0*(PIM/AMES)*X*HIA
      DF4A  = 0.5D0*(PIM/AMES)*(HIA+X*DHIA)
      DDF4A = 0.5D0*(PIM/AMES)*(2*DHIA+X*DDHIA)
      D3F4A  = 0.5D0*(PIM/AMES)*(3*DDHIA+X*D3HIA)
C     NAIVELY:
C     F4A   = 0.5D0*RATPM*(X*HIA -2*RATA**2*FIA)
C     DF4A  = 0.5D0*RATPM*(HIA+X*DHIA -2*RATA**2*DFIA*RATPM)
C     DDF4A = 0.5D0*RATPM*(2*DHIA+X*DDHIA -2*RATA**2*DDFIA*RATPM)
C     D3F4A  = 0.5D0*RATPM*(3*DDHIA+X*D3HIA -2*RATA**2*D3FIA*RATPM)
      ENDIF
C     DIFFRACTIVE CASE:
      IF(ALAM.EQ.AMES) THEN
      AMPOM = AMES
      RATD  = 0.5D0*PIM/AMPOM
      XPOM = X*AMPOM/PIM
      FIPO = (4.D0/SRPI)*(AMPOM/PIM)*(AMPOM/AMPRO)**2*
     .       FDEXP(-XPOM*XPOM)
      DFIPO = -2*(AMPOM/PIM)*XPOM*FIPO
      DDFIPO= -2*(AMPOM/PIM)*(XPOM*DFIPO + FIPO*AMPOM/PIM)
      D3FIPO= -2*(AMPOM/PIM)*(XPOM*DDFIPO + 2*DFIPO*AMPOM/PIM)
      FIA  = FIPO
      DFIA = DFIPO
      DDFIA= DDFIPO
      D3FIA= D3FIPO
      F4A  = FIA*RATD**2
      DF4A = DFIA*RATD**2
      DDF4A= DDFIA*RATD**2
      D3F4A= D3FIA*RATD**2
      ENDIF
      IF(IMES.EQ.1) THEN
C     N=2:
C     F2 = FIA
      DF2 = DFIA
      DDF2 = DDFIA
      D3F2 = D3FIA
C     N=4:
C     F4 = F4A
      DF4 = DF4A
      DDF4 = DDF4A
      D3F4  = D3F4A
      DVKU1  = DVKUA*(ALAM/PIM)**2
      ENDIF
      IF(IMES.EQ.2) THEN
C     N=2:
      DG2 = DFIA
      DDG2 = DDFIA
      D3G2 = D3FIA
C     N=4:
C     G4 = F4A
      DG4 = DF4A
      DDG4 = DDF4A
      D3G4  = D3F4A
      DVKU2  = DVKUA*(ALAM/PIM)**2
      ENDIF
    1 CONTINUE
C
C     CONSTRUCTION BASE FUNCTIONS
C
      GOTO(100,200,200,200,500), ITYP

  100 FNONC = +0.5D0*(
     .         6*X2*(DDF4-X1*DF4)*(DDG2-X1*DG2)+D3F4*D3G2
     .        +6*X2*(DDG4-X1*DG4)*(DDF2-X1*DF2)+D3G4*D3F2 )
      FNONS = -(1.D0/3.D0)*(
     .  X2*(DDF4-X1*DF4-X*D3F4)*(DDG2-X1*DG2-X*D3G2)-D3F4*D3G2
     . +X2*(DDG4-X1*DG4-X*D3G4)*(DDF2-X1*DF2-X*D3F2)-D3G4*D3F2 )
      FNONT = +(1.D0/6.D0)*(
     .        4*X2*(DDF4-X1*DF4-X*D3F4/4)*(DDG2-X1*DG2-X*D3G2/4)
     .       +4*X2*(DDG4-X1*DG4-X*D3G4/4)*(DDF2-X1*DF2-X*D3F2/4)
     .       -D3F4*D3G2/4-D3G4*D3F2/4    )

      FPVC  = +( (-2*X2*DF2+2*X1*DDF2+D3F2)*DG2
     .                    +(-2*X2*DG2+2*X1*DDG2+D3G2)*DF2 )
      FPVO  = +(2*X1*(DF2*DDG2+DDF2*DG2)+4*X2*DF2*DG2)

      FOFFC = 0.5D0*( ((AM1/PIM)**2+(AM2/PIM)**2)*DF2*DG2
     .                -DVKU1*DG2-DF2*DVKU2 )
      FOFFO = 0.5D0*( 2*X1*( DDF2*DG2+DF2*DDG2-4*X2*DF2*DG2 )
     .                -DVKU1*DG2-DF2*DVKU2 )
      RETURN
  200 FNONS = 0.5D0*( (D3F2+2*X1*DDF2-2*X2*DF2)*DG4
     .               +(D3F4+2*X1*DDF4-2*X2*DF4)*DG2 )/3.D0
      FNONT = 0.5D0*( (D3F2-  X1*DDF2+  X2*DF2)*DG4
     .               +(D3F4-  X1*DDF4+  X2*DF4)*DG2 )/3.D0
      FPVS  = + DF2*DG2/3.D0
      FPVT  =   FPVS
      FOFFS = 0.5D0*DF2*DG2
      FOFFT = FOFFS
      RETURN
  500 FNONC = 0.5D0*( DF2*DG4 + DF4*DG2 )
      RETURN
CC
      END
C **********************************************************************
      SUBROUTINE FOOMPR(ITYP,X,AM1,AM2,ALM1,ALM2)
C **********************************************************************
C
C     COMPUTATION FUNTIONS FOR 1/M-CONTRIBUTIONS TWO PS-EXCHANGE
C
C     ITYP = 1 : (PIPI)_0  ITYP = 2 : (PIPI)_1,
C     ITYP = 3 : (PIRHO)_0 ITYP = 4 : (PIRHO)_1,
C     ITYP = 5 : (PI-PS)   ITYP = 6 : (PISIG)
C     ITYP = 7 : (PIPOM)   ITYP = 8 : (SI SI_)
C
C **********************************************************************
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/PIMAS/PIM
      COMMON/FOOMS/FNONC,FNONS,FNONT,FNONO,FPVC,FPVS,FPVT,FPVO
     .            ,FOFFC,FOFFS,FOFFT,FOFFO,FOFFS2,FOFFT2
      DIMENSION XX(20),WW(20),YB(3),FUN(10),FUNPV(10)
      DATA PI/3.14159265D0/,SRPI/1.7724538509D0/,AMPRO/938.2796D0/
      DATA YB/0.D0,10.D0,50.D0/,NINT/1/,NPNT/16/,IMETH/1/,ICALL/0/
*     DATA YB/0.D0,5.D0,20.D0/,NINT/2/,NPNT/16/,IMETH/0/,ICALL/0/
      DATA AKMAX/0000.D0/,XKMAX/2.D0/
      SAVE XX,WW
C
C     POTENTIAL FUNTION DEFINITION
C
      F0(ERATH,EXH,EMH,EPH,XH)=ERATH*( EMH/EXH-EPH*EXH )/(2*XH)
      H0(ERATH,EXH,EMH,EPH,XH)=ERATH*( EMH/EXH+EPH*EXH )/(2*XH)
C
      CALL ERRSET(208,256,-1,1)
C
      IF(ICALL.EQ.0) THEN
        CALL GAUSS(NPNT,XX,WW,1)
        IF(IMETH.EQ.1) NINT=1
        ICALL=1
      ENDIF
CC
      X1   = 1.D0/X
      X2   = X1*X1
      X3   = X1*X2
CC
      DO 1 IMES=1,2
      IF(IMES.EQ.1) THEN
      AMES = AM1
      ALAM = ALM1
      RATP1=PIM/ALAM
      ENDIF
      IF(IMES.EQ.2) THEN
      AMES = AM2
      ALAM = ALM2
      RATP2=PIM/ALAM
      ENDIF
C     NORMAL CASE (I.E. NON-DIFFRACTIVE)
      IF(ALAM.NE.AMES) THEN
      RATP =PIM/ALAM
      XLAM =0.5D0*X*ALAM/PIM
      XLAM2=XLAM*XLAM
      VKUA =(ALAM/PIM)*FDEXP(-XLAM2)/(2*SRPI)
      DVKUA=-0.5D0*(ALAM/PIM)**2*X*VKUA
      DDVKUA=-0.5D0*(ALAM/PIM)**2*(X*DVKUA+VKUA)

      XA   =X*AMES/PIM
      RATA =AMES/ALAM
      ERATA=DEXP(RATA*RATA)
      EXA  =DEXP(XA)
      EMA  =FDERFC(-XLAM +RATA)
      EPA  =FDERFC( XLAM +RATA)
      FIA  =F0(ERATA,EXA ,EMA ,EPA ,X)
      HIA  =H0(ERATA,EXA ,EMA ,EPA ,X)
      DFIA =-(FIA -2*VKUA)*X1-(AMES/PIM)*HIA
      DHIA  =-(AMES/PIM)*FIA -HIA *X1
      DDFIA =-(DFIA-2*DVKUA)*X1+(FIA-2*VKUA)*X2-(AMES/PIM)*DHIA
      DDHIA =-(AMES/PIM)*DFIA-DHIA*X1+HIA*X2
      D3FIA =-(DDFIA-2*DDVKUA)*X1+(DFIA-2*DVKUA)*X2-(AMES/PIM)*DDHIA
     .       +(DFIA-2*DVKUA)*X2-2*(FIA-2*VKUA)*X3
      ENDIF

C     DIFFRACTIVE CASE:
      IF(ALAM.EQ.AMES) THEN
      AMPOM = AMES
      RATP2 = 0.5D0*PIM/AMPOM
      XLAM  = X*AMPOM
      XPOM = X*AMPOM/PIM
      FIPO = (4.D0/SRPI)*(AMPOM/PIM)*(AMPOM/AMPRO)**2*
     .       FDEXP(-XPOM*XPOM)
      DFIPO = -2*(AMPOM/PIM)*XPOM*FIPO
      DDFIPO= -2*(AMPOM/PIM)*(XPOM*DFIPO + FIPO*AMPOM/PIM)
      D3FIPO= -2*(AMPOM/PIM)*(XPOM*DDFIPO + 2*DFIPO*AMPOM/PIM)
      FIA  = FIPO
      DFIA = DFIPO
      DDFIA= DDFIPO
      D3FIA= D3FIPO
      VKUA = FIPO
      DVKUA= DFIPO
      DDVKUA= DDFIPO
      ENDIF

      IF(IMES.EQ.1) THEN
C     N=2:
C     FINITE CUT-OFF CORRECTIONS:
      IF(ITYP.LE.7.AND.AMES.NE.ALAM.AND.
     .AKMAX.NE.0.D0.AND.X.LT.XKMAX) THEN
      CALL DCOFUN(X,AMES,ALAM,AKMAX,DFIC0,DFIC1,DFIC2,DFIC3)
      FIA = FIA + DFIC0*AMES/PIM
      DFIA = DFIA + DFIC1*AMES/PIM
      DDFIA = DDFIA + DFIC2*AMES/PIM
      D3FIA  = D3FIA + DFIC3*AMES/PIM
      ENDIF
      XLM1 = XLAM
      FI1 = FIA
      DFI1 = DFIA
      DDFI1 = DDFIA
      D3FI1 = D3FIA
      VKU1  = VKUA
      DVKU1 = DVKUA
      DDVKU1= DDVKUA
      ENDIF

      IF(IMES.EQ.2) THEN
C     N=2:
C     FINITE CUT-OFF CORRECTIONS:
      IF((ITYP.LE.2.OR.ITYP.EQ.5).AND.AKMAX.NE.0.D0.AND.X.LT.XKMAX) THEN
      CALL DCOFUN(X,AMES,ALAM,AKMAX,DFIC0,DFIC1,DFIC2,DFIC3)
      FIA = FIA + DFIC0*AMES/PIM
      DFIA = DFIA + DFIC1*AMES/PIM
      DDFIA = DDFIA + DFIC2*AMES/PIM
      D3FIA  = D3FIA + DFIC3*AMES/PIM
      ENDIF
      XLM2 = XLAM
      FI2 = FIA
      DFI2 = DFIA
      DDFI2 = DDFIA
      D3FI2 = D3FIA
      VKU2  = VKUA
      DVKU2 = DVKUA
      ENDIF
    1 CONTINUE
C
C     CONSTRUCTION BASE FUNCTIONS BY INTEGRATION
C
      IF(ITYP.EQ.2) GOTO 200
      DO 105 II=1,10
      FUN(II) = 0.D0
  105 FUNPV(II) = 0.D0
      DO 100 INT=1,NINT
      ABM=0.5D0*(YB(INT+1)-YB(INT))
      ABP=0.5D0*(YB(INT+1)+YB(INT))
      DO 110 IY=1,NPNT 
      IF(IMETH.EQ.0) THEN
      Y=ABM*XX(IY)+ABP
      GEW=WW(IY)*ABM*2.D0/PI
      ENDIF
      IF(IMETH.EQ.1) THEN
      Y=(1.D0+XX(IY))/(1.D0-XX(IY))
      GEW=WW(IY)*(2.D0/(1.D0-XX(IY))**2)*2.D0/PI
      ENDIF
      IF(Y.GT.50.D0) GOTO 110
      GEWNA = GEW/Y/Y
C     FACTOR FROM FORM FACTOR EFFECTS THROUGH DISP. REL. :
      FDISP1=FDEXP(-Y*Y*RATP1*RATP1)
      FDISP2=FDEXP(-Y*Y*RATP2*RATP2)
C
      AM=PIM*DSQRT((AM1/PIM)**2+Y*Y)
      XM=AM*X/PIM
      RATM =AM/ALM1
      ERATM=FDEXP(RATM*RATM)
      EXM  =FDEXP(XM)
      EMM  =FDERFC(-XLM1+RATM)
      EPM  =FDERFC( XLM1+RATM)
C
      FIM   = F0(ERATM,EXM,EMM,EPM,X )
      HIM   = H0(ERATM,EXM,EMM,EPM,X )
      DFIM  =-(FIM-2*VKU1)*X1-(AM/PIM)*HIM
      DHIM  =-(AM/PIM)*FIM-HIM*X1
      DDFIM =-(DFIM-2*DVKU1)*X1+(FIM-2*VKU1)*X2-(AM/PIM)*DHIM
      DDHIM =-(AM/PIM)*DFIM-DHIM*X1+HIM*X2
      D3FIM =-(DDFIM-2*DDVKU1)*X1+(DFIM-2*DVKU1)*X2-(AM/PIM)*DDHIM
     .       +(DFIM-2*DVKU1)*X2-2*(FIM-2*VKU1)*X3

C     FINITE CUT-OFF CORRECTIONS:
      IF(ITYP.LE.7.AND.AKMAX.NE.0.D0.AND.X.LT.XKMAX) THEN
      CALL DCOFUN(X,AM,ALM1,AKMAX,DFIC0,DFIC1,DFIC2,DFIC3)
      FIM = FIM + DFIC0*AM/PIM
      DFIM = DFIM + DFIC1*AM/PIM
      DDFIM = DDFIM + DFIC2*AM/PIM
      D3FIM  = D3FIM + DFIC3*AM/PIM
      ENDIF

      FIM1  = FIM
      DFIM1  = DFIM
      DDFIM1  = DDFIM
      D3FIM1  = D3FIM
C
      IF(ITYP.NE.7) THEN
      AM=PIM*DSQRT((AM2/PIM)**2+Y*Y)
      XM=AM*X/PIM
      RATM =AM/ALM2
      ERATM=FDEXP(RATM*RATM)
      EXM  =FDEXP(XM)
      EMM  =FDERFC(-XLM2+RATM)
      EPM  =FDERFC( XLM2+RATM)

      FIM   = F0(ERATM,EXM,EMM,EPM,X )
      HIM   = H0(ERATM,EXM,EMM,EPM,X )
      DFIM  =-(FIM-2*VKU2)*X1-(AM/PIM)*HIM
      DHIM  =-(AM/PIM)*FIM-HIM*X1
      DDFIM =-(DFIM-2*DVKU2)*X1+(FIM-2*VKU2)*X2-(AM/PIM)*DHIM

C     FINITE CUT-OFF CORRECTIONS:
      IF((ITYP.LE.2.OR.ITYP.EQ.5).AND.AKMAX.NE.0.D0.AND.X.LT.XKMAX) THEN
      CALL DCOFUN(X,AM,ALM2,AKMAX,DFIC0,DFIC1,DFIC2,DFIC3)
      FIM = FIM + DFIC0*AM/PIM
      DFIM = DFIM + DFIC1*AM/PIM
      DDFIM = DDFIM + DFIC2*AM/PIM
**    D3FIM  = D3FIM + DFIC3*AM/PIM
      ENDIF
      ENDIF
      IF(ITYP.EQ.7) THEN
      FIM = FI2
      DFIM = DFI2
      DDFIM = DDFI2
      ENDIF
      FIM2  = FIM
      DFIM2  = DFIM
      DDFIM2  = DDFIM
C
      FDISP  = FDISP1*FDISP2
      FUN(1) = FUN(1) + GEWNA*(  FI1*  FI2-  FIM1*  FIM2*FDISP)
      FUN(2) = FUN(2) + GEWNA*( DFI1*  FI2- DFIM1*  FIM2*FDISP)
      FUN(3) = FUN(3) + GEWNA*(  FI1* DFI2-  FIM1* DFIM2*FDISP)
      FUN(4) = FUN(4) + GEWNA*( DFI1* DFI2- DFIM1* DFIM2*FDISP)
      FUN(5) = FUN(5) + GEWNA*(DDFI1*  FI2-DDFIM1*  FIM2*FDISP)
      FUN(6) = FUN(6) + GEWNA*(  FI1*DDFI2-  FIM1*DDFIM2*FDISP)
      FUN(7) = FUN(7) + GEWNA*(DDFI1* DFI2-DDFIM1* DFIM2*FDISP)
      FUN(8) = FUN(8) + GEWNA*( DFI1*DDFI2- DFIM1*DDFIM2*FDISP)
      FUN(9) = FUN(9) + GEWNA*(DDFI1*DDFI2-DDFIM1*DDFIM2*FDISP)
      FUN(10)= FUN(10)+ GEWNA*(D3FI1* DFI2-D3FIM1* DFIM2*FDISP)

      FUNPV(2)= FUNPV(2)+ GEW*( DFIM1*  FIM2*FDISP)
      FUNPV(3)= FUNPV(3)+ GEW*(  FIM1* DFIM2*FDISP)
      FUNPV(4)= FUNPV(4)+ GEW*( DFIM1* DFIM2*FDISP)
      FUNPV(5)= FUNPV(5)+ GEW*(DDFIM1*  FIM2*FDISP)
      FUNPV(6)= FUNPV(6)+ GEW*(  FIM1*DDFIM2*FDISP)
110   CONTINUE
100   CONTINUE
C
C     CONSTRUCTION BASE FUNCTIONS
C
C     (PIPI)_{0}:
      IF(ITYP.EQ.1) THEN
      FNONC = FUN(9) + 2*X2*FUN(4)
      FNONO = 2*X2*FUN(4)
      FPVC  = (FUNPV(5)+2*X1*FUNPV(2)) + (FUNPV(6)+2*X1*FUNPV(3))
      FPVO  = 2*X1*( FUNPV(2) + FUNPV(3) )
      RETURN
      ENDIF
C     (PIPI)_{1}:
200   IF(ITYP.EQ.2) THEN
      FNONC = 2*(DDFI1*DDFI2+2*X2*DFI1*DFI2)
      FNONO = 4*X2*DFI1*DFI2
      FPVC  = (DDFI1+2*X1*DFI1)*VKU2/RATP2**2
     .      + (DDFI2+2*X1*DFI2)*VKU1/RATP1**2
      FPVO  = 2*X1*(DFI1*VKU2/RATP2**2 + DFI2*VKU1/RATP1**2)
      RETURN
      ENDIF
C     {PI-SIGM}, {PI-POM}:
      IF(ITYP.EQ.6.OR.ITYP.EQ.7) THEN
      FNONS = -(+4*X2*FUN(4)-2*X1*FUN(7)-FUN(10)+FUN(9) )
      FNONT = -(-2*X2*FUN(4)+  X1*FUN(7)-FUN(10)+FUN(9) )

      FPVS  =  2*X1*FUNPV(3)+FUNPV(6)-FUNPV(4)
      FPVT  =   -X1*FUNPV(3)+FUNPV(6)-FUNPV(4)
      RETURN
      ENDIF
      IF(ITYP.EQ.8) THEN
      FNONC = FUN(4)
      RETURN
      ENDIF
CC
1000  CALL ERRSET(208,256,1,1)
      RETURN
      END
C **********************************************************************
      SUBROUTINE WROMPR(NCASE,X,P)
C **********************************************************************
C
C     NCASE = 1,2,7 : VC ; NCASE = 3 : VC,VS,VT ; NCASE = 4,5,6 : VS,VT
C
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/PROMPR/VPR(5,3,4,4,6)
      CHARACTER *4 NTYPM(4,4)
      DATA N3/27/,NTYPM/
     .'PI  ','KA  ','ETA ','ETAP','RHO ','K*  ','PHI ','OM  ',
     .'DE  ','KAP ','S*  ','EPS ','A2  ','K** ','POMP','POM '/
C
      write(n3,*)'CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC'
      if(ncase.eq.1) write(n3,101)
      if(ncase.eq.2) write(n3,102)
      if(ncase.eq.3) write(n3,103)
      if(ncase.eq.4) write(n3,104)
      if(ncase.eq.5) write(n3,105)
      if(ncase.eq.6) write(n3,106)
      if(ncase.le.3) JJ=1
      if(ncase.eq.4) JJ=2
      if(ncase.eq.5) JJ=3
      if(ncase.eq.6) JJ=4

*     if(ncase.le.3 .OR. ncase.eq.7) then
      write(n3,100) x
      write(n3,110) (NTYPM(KK,JJ),KK=1,4)
  110 format(10x,4(3x,a4,5x))
      write(n3,*)'-----------------------------------------------------'
      DO 111 II=1,4
  111 write(n3,1) NTYPM(II,1),(VPR(1,1,II,KK,NCASE),KK=1,4)
      write(n3,*)'====================================================='
      DO 112 II=1,4
  112 write(n3,2) NTYPM(II,1),(VPR(2,1,II,KK,NCASE),KK=1,4)
      write(n3,*)'====================================================='
      DO 113 II=1,4
  113 write(n3,3) NTYPM(II,1),(VPR(3,1,II,KK,NCASE),KK=1,4)
      write(n3,*)'====================================================='
      DO 114 II=1,4
  114 write(n3,4) NTYPM(II,1),(VPR(4,1,II,KK,NCASE),KK=1,4)
      write(n3,*)'====================================================='
      DO 115 II=1,4
  115 write(n3,5) NTYPM(II,1),(VPR(5,1,II,KK,NCASE),KK=1,4)
      call wrsu3pr(1,ncase,x,p)
*     endif

      if(ncase.ge.3 .AND. ncase.ne.7) then
      write(n3,200) x
      write(n3,110) (NTYPM(KK,JJ),KK=1,4)
      write(n3,*)'-----------------------------------------------------'
      DO 211 II=1,4
  211 write(n3,1) NTYPM(II,1),(VPR(1,2,II,KK,NCASE),KK=1,4)
      write(n3,*)'====================================================='
      DO 212 II=1,4
  212 write(n3,2) NTYPM(II,1),(VPR(2,2,II,KK,NCASE),KK=1,4)
      write(n3,*)'====================================================='
      DO 213 II=1,4
  213 write(n3,3) NTYPM(II,1),(VPR(3,2,II,KK,NCASE),KK=1,4)
      write(n3,*)'====================================================='
      DO 214 II=1,4
  214 write(n3,4) NTYPM(II,1),(VPR(4,2,II,KK,NCASE),KK=1,4)
      write(n3,*)'====================================================='
      DO 215 II=1,4
  215 write(n3,5) NTYPM(II,1),(VPR(5,2,II,KK,NCASE),KK=1,4)
      write(n3,*)'*****************************************************'
      call wrsu3pr(2,ncase,x,p)
      endif
      return              

  101 format(/,' SCALAR SU(3)-SINGLET PAIR TERMS, {1}->{8}x{8} :',/)
  102 format(/,' SCALAR SU(3)-OCTET PAIR TERMS,  {8s}->{8}x{8} :',/)
  103 format(/,' VECTOR SU(3)-OCTET PAIR TERMS,  {8a}->{8}x{8} :',/)
  104 format(/,' AXIAL (PION-RHO) PAIR TERMS OF THE FIRST CLASS:',/)
  105 format(/,' PSEUDO SCALAR (PION-EPSILON) PAIR TERMS:',/)
  106 format(/,' PSEUDO SCALAR (PS-POMERON) PAIR TERMS:',/)
  107 format(/,' SCALAR SU(3)-SINGLET PAIR TERMS, {1}->{1}x{1} :',/)

  100 format(55('*'),/,' OMPAIR: CENTRAL POTENTIALS: x=',f7.3,/,55('*'))    
  200 format(55('*'),/,' OMPAIR: SPIN-SPIN POTENTIALS: x=',f7.3,/,    
     .55('*'))
    1 FORMAT(1x,'NN: ',A4,4(F10.2,2X))
    2 FORMAT(1x,'LL: ',A4,4(F10.2,2X))
    3 FORMAT(1x,'LS: ',A4,4(F10.2,2X))
    4 FORMAT(1x,'SS: ',A4,4(F10.2,2X))
    5 FORMAT(1x,'DR: ',A4,4(F10.2,2X))
      end
C **********************************************************************
      SUBROUTINE WROMTM(NCASE,X,P)
C **********************************************************************
C
C     NCASE = 1: PSEUDO-SCALAR-PSEUDO POTENTIALS,
C     NCASE = 2: PSEUDO-SCALAR-VECTOR POTENTIALS,
C     NCASE = 3: PSEUDO-SCALAR-SCALAR POTENTIALS,
C     NCASE = 4: PSEUDO-SCALAR-DIFFR. POTENTIALS.
C     NCASE = 5: SCALAR-SCALAR        POTENTIALS.
C     NCASE = 6: SCALAR-DIFFRACTIVE   POTENTIALS.
C     NCASE = 7: DIFFRA-DIFFRACTIVE   POTENTIALS.
C
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/PSBEOM/ VPSBE(5,4,4,4,7)                              
      CHARACTER*4 NTYPM(4,4)
      DATA N3/27/,NTYPM/
     .'PI  ','KA  ','ETA ','ETAP','RHO ','K*  ','OM  ','PHI ',
     .'DE  ','KAP ','EPS ','S*  ','A2  ','K** ','POM ','POMP'/
C
      if(ncase.le.4) i1=1
      if(ncase.le.4) i2=ncase
      if(ncase.eq.5) i1=3
      if(ncase.eq.5) i2=3
      if(ncase.eq.6) i1=3
      if(ncase.eq.6) i2=4
      if(ncase.eq.7) i1=4
      if(ncase.eq.7) i2=4
      write(n3,*)'CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC'
C     write(n3,*)'*****************************************************'
      if(ncase.eq.1) write(n3,*) ' OMPSPS: CENTRAL POTENTIALS: x=',x
      if(ncase.ge.2.and.ncase.le.4)
     .write(n3,*) ' OMPSBE: CENTRAL POTENTIALS: x=',x
      if(ncase.eq.5) write(n3,*) ' OMSCSC: CENTRAL POTENTIALS: x=',x
      if(ncase.eq.6) write(n3,*) ' OMSCDF: CENTRAL POTENTIALS: x=',x
      if(ncase.eq.7) write(n3,*) ' OMDFDF: CENTRAL POTENTIALS: x=',x
      write(n3,*)'*****************************************************'
      write(n3,110) (NTYPM(KK,I2),KK=1,4)
  110 format(10x,4(3x,a4,5x))
      write(n3,*)'-----------------------------------------------------'
      DO 111 II=1,4
  111 write(n3,112) NTYPM(II,I1),(VPSBE(1,1,II,KK,NCASE),KK=1,4)
      write(n3,*)'====================================================='
      DO 113 II=1,4
  113 write(n3,114) NTYPM(II,I1),(VPSBE(5,1,II,KK,NCASE),KK=1,4)
      write(n3,*)'====================================================='
      DO 123 II=1,4
  123 write(n3,124) NTYPM(II,I1),(VPSBE(2,1,II,KK,NCASE),KK=1,4)
      write(n3,*)'====================================================='
      DO 125 II=1,4
  125 write(n3,126) NTYPM(II,I1),(VPSBE(3,1,II,KK,NCASE),KK=1,4)
      write(n3,*)'====================================================='
      DO 127 II=1,4
  127 write(n3,128) NTYPM(II,I1),(VPSBE(4,1,II,KK,NCASE),KK=1,4)
      write(n3,*)'*****************************************************'
      call wrsu3tm(1,ncase,x,p)
      if(ncase.ge.5) return
      if(ncase.eq.1) write(n3,*) ' OMPSPS: SPIN-SPIN POTENTIALS: x=',x
      if(ncase.ge.2.and.ncase.le.4)
     .write(n3,*) ' OMPSBE: SPIN-SPIN POTENTIALS: x=',x
      if(ncase.eq.5) write(n3,*) ' OMSCSC: SPIN-SPIN POTENTIALS: x=',x
      if(ncase.eq.6) write(n3,*) ' OMSCDF: SPIN-SPIN POTENTIALS: x=',x
      if(ncase.eq.7) write(n3,*) ' OMDFDF: SPIN-SPIN POTENTIALS: x=',x
      write(n3,*)'*****************************************************'
      write(n3,115) (NTYPM(KK,I2),KK=1,4)
  115 format(10x,4(3x,a4,5x))
      write(n3,*)'-----------------------------------------------------'
      DO 116 II=1,4
  116 write(n3,112) NTYPM(II,I1),(VPSBE(1,2,II,KK,NCASE),KK=1,4)
      write(n3,*)'====================================================='
      DO 118 II=1,4
  118 write(n3,114) NTYPM(II,I1),(VPSBE(5,2,II,KK,NCASE),KK=1,4)
      write(n3,*)'====================================================='
      DO 120 II=1,4
  120 write(n3,124) NTYPM(II,I1),(VPSBE(2,2,II,KK,NCASE),KK=1,4)
      write(n3,*)'====================================================='
      DO 129 II=1,4
  129 write(n3,126) NTYPM(II,I1),(VPSBE(3,2,II,KK,NCASE),KK=1,4)
      write(n3,*)'====================================================='
      DO 131 II=1,4
  131 write(n3,128) NTYPM(II,I1),(VPSBE(4,2,II,KK,NCASE),KK=1,4)
      write(n3,*)'*****************************************************'
      call wrsu3tm(2,ncase,x,p)
      RETURN
  112 FORMAT(1x,'NN: ',A4,4(F10.2,2X))
  114 FORMAT(1x,'DR: ',A4,4(F10.2,2X))
  124 FORMAT(1x,'LL: ',A4,4(F10.2,2X))
  126 FORMAT(1x,'LS: ',A4,4(F10.2,2X))
  128 FORMAT(1x,'SS: ',A4,4(F10.2,2X))
C END WROMTM ROUTINE **************************************************
      END
C **********************************************************************
      SUBROUTINE WRSU3TM(IV,NCASE,X,P)
C **********************************************************************
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/PSBEOM/ VPR(5,4,4,4,7)                              
      DIMENSION VTOT(5)
      DATA N3/27/
C SUMMED CONTRIBUTIONS:                   
      DO 120 ICHAN=1,5
      VTOT(ICHAN)=0.D0
      DO 120 M=1,4
      DO 120 N=1,4
  120 VTOT(ICHAN)=VTOT(ICHAN)+VPR(ICHAN,IV,M,N,NCASE)
      if(iv.eq.1) write(N3,121) VTOT(1),VTOT(5),VTOT(2),VTOT(3),VTOT(4)
  121 format(' VCNN=',F10.2,3x,' VCDR=',F10.2,3x,' VCLL=',F10.2,/,
     .       ' VCLS=',F10.2,3x,' VCSS=',F10.2,/)
      if(iv.eq.2) write(N3,122) VTOT(1),VTOT(5),VTOT(2),VTOT(3),VTOT(4)
  122 format(' VSNN=',F10.2,3x,' VSDR=',F10.2,3x,' VSLL=',F10.2,/,
     .       ' VSLS=',F10.2,3x,' VSSS=',F10.2,/)
C CONTRIBUTIONS TO SU(3)-POTENTIALS:                        
      if(p.eq.1.d0) then
      V27a = VTOT(1)                                                    
      V27b = VTOT(5)                                                    
      V27c = (9*VTOT(2)-VTOT(4))/8.D0
*     V8Sa = 10*VTOT(2)-9*VTOT(5)
      V8Sa =    VTOT(2)+3*VTOT(3)
      V8Sb = (10*VTOT(4)-VTOT(5))/9.D0
      V8Sc = (9*VTOT(4)-VTOT(2))/8.D0
      VLSa = (-3*V27b+3*V8Sa)/10.D0
      VLSb = (-3*V27b+3*V8Sb)/10.D0
      VLSc = (-3*V27c+3*V8Sc)/10.D0
      write(N3,123) V27a,V27b,V27c,V8Sa,V8Sb,V8Sc,VLSa,VLSb,VLSc
  123 format(/,' V27a =',F10.2,3x,' V27b =',F10.2,3x,' V27c =',F10.2,/,
     .         ' V8Sa =',F10.2,3x,' V8Sb =',F10.2,3x,' V8Sc =',F10.2,/,
     .         ' VLSa =',F10.2,3x,' VLSb =',F10.2,3x,' VLSc =',F10.2)
      endif
      if(p.eq.-1.d0) then
      V10  = VTOT(5)
      V10sa= VTOT(2)+VTOT(3)                                            
      V10sb= VTOT(4)+VTOT(3)                                            
      V8Aa = VTOT(2)-VTOT(3)                                            
      V8Ab = VTOT(4)-VTOT(3)                                            
      write(n3,124) V10sa,V10sb,V8Aa,V8Ab,V10
  124 format(' V10*a=',F10.2,3x,' V10*b=',F10.2,/,
     .       ' V8Aa =',F10.2,3x,' V8Ab =',F10.2,' V10 =',F10.2,/)
      endif
      write(n3,*)'*****************************************************'
      RETURN
      END
C **********************************************************************
      SUBROUTINE WRSU3PR(IV,NCASE,X,P)
C **********************************************************************
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/PROMPR/VPR(5,3,4,4,6)
      DIMENSION VTOT(5)
      DATA N3/27/
C SUMMED CONTRIBUTIONS:                   
      DO 120 ICHAN=1,5
      VTOT(ICHAN)=0.D0
      DO 120 M=1,4
      DO 120 N=1,4
  120 VTOT(ICHAN)=VTOT(ICHAN)+VPR(ICHAN,IV,M,N,NCASE)
      if(iv.eq.1) write(n3,121) VTOT(1),VTOT(5),VTOT(2),VTOT(3),VTOT(4)
  121 format(' VCNN=',F10.2,3x,' VCDR=',F10.2,3x,' VCLL=',F10.2,/,
     .       ' VCLS=',F10.2,3x,' VCSS=',F10.2,/)
      if(iv.eq.2) write(n3,122) VTOT(1),VTOT(5),VTOT(2),VTOT(3),VTOT(4)
  122 format(' VSNN=',F10.2,3x,' VSDR=',F10.2,3x,' VSLL=',F10.2,/,
     .       ' VSLS=',F10.2,3x,' VSSS=',F10.2,/)
C CONTRIBUTIONS TO SU(3)-POTENTIALS:                        
      if(p.eq.1.d0) then
      V27a = VTOT(1)                                                    
      V27b = VTOT(5)                                                    
      V27c = (9*VTOT(2)-VTOT(4))/8.D0
*     V8Sa = 10*VTOT(2)-9*VTOT(5)
      V8Sa =    VTOT(2)+3*VTOT(3)
      V8Sb = (10*VTOT(4)-VTOT(5))/9.D0
      V8Sc = (9*VTOT(4)-VTOT(2))/8.D0
      VLSa = (-3*V27b+3*V8Sa)/10.D0
      VLSb = (-3*V27b+3*V8Sb)/10.D0
      VLSc = (-3*V27c+3*V8Sc)/10.D0
      write(n3,123) V27a,V27b,V27c,V8Sa,V8Sb,V8Sc,VLSa,VLSb,VLSc
  123 format(' V27a =',F10.2,3x,' V27b =',F10.2,3x,' V27c =',F10.2,/,
     .       ' V8Sa =',F10.2,3x,' V8Sb =',F10.2,3x,' V8Sc =',F10.2,/,
     .       ' VLSa =',F10.2,3x,' VLSb =',F10.2,3x,' VLSc =',F10.2,/)
      endif
      if(p.eq.-1.d0) then
      V10  = VTOT(5)
      V10sa= VTOT(2)+VTOT(3)                                            
      V10sb= VTOT(4)+VTOT(3)                                            
      V8Aa = VTOT(2)-VTOT(3)                                            
      V8Ab = VTOT(4)-VTOT(3)                                            
      write(n3,124) V10sa,V10sb,V8Aa,V8Ab,V10
  124 format(' V10*a=',F10.2,3x,' V10*b=',F10.2,/,
     .       ' V8Aa =',F10.2,3x,' V8Ab =',F10.2,3x,' V10 =',F10.2,/)
      endif
      write(n3,*)'*****************************************************'
      RETURN
      END

